/*
 AVKit.m
 
 Bernie Wylde 20180312
 */

#import "AVKit.h"

#if __LP64__
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
#ifdef AVKIT_EXTERN


#pragma mark - AVAsset
///////////////////////////////////////////////////
//                   AVAsset                     //
///////////////////////////////////////////////////
// Create
AVAssetRef AVAssetWithURL( CFURLRef url )
{ return [AVAsset assetWithURL:(NSURL *)url]; }

// Load data
void AVAssetCancelLoading( AVAssetRef ref )
{ [ref cancelLoading]; }

// Inspect
CMTime AVAssetDuration( AVAssetRef ref )
{ return [ref duration]; }

Boolean AVAssetProvidesPreciseDurationAndTiming( AVAssetRef ref )
{ return [ref providesPreciseDurationAndTiming]; }

AVMetadataItemRef AVAssetCreationDate( AVAssetRef ref )
{ return [ref creationDate]; }

float AVAssetPreferredRate( AVAssetRef ref )
{ return [ref preferredRate]; }

CGAffineTransform AVAssetPreferredTransform( AVAssetRef ref )
{ return [ref preferredTransform]; }

float AVAssetPreferredVolume( AVAssetRef ref )
{ return [ref preferredVolume]; }

// Usability
Boolean AVAssetIsPlayable( AVAssetRef ref )
{ return [ref isPlayable]; }

Boolean AVAssetIsExportable( AVAssetRef ref )
{ return [ref isExportable]; }

Boolean AVAssetIsReadable( AVAssetRef ref )
{ return [ref isReadable]; }

Boolean AVAssetIsComposable( AVAssetRef ref )
{ return [ref isComposable]; }

Boolean AVAssetHasProtectedContent( AVAssetRef ref )
{ return [ref hasProtectedContent]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
Boolean AVAssetIsCompatibleWithAirPlayVideo( AVAssetRef ref )
{ return [ref isCompatibleWithAirPlayVideo]; }
#endif

// Tracks
CFArrayRef AVAssetTracks( AVAssetRef ref )
{ return (CFArrayRef)[ref tracks]; }

CFArrayRef AVAssetTrackGroups( AVAssetRef ref )
{ return (CFArrayRef)[ref trackGroups]; }

AVAssetTrackRef AVAssetTrackWithID( AVAssetRef ref, CMPersistentTrackID trackID )
{ return [ref trackWithTrackID:trackID]; }

CFArrayRef AVAssetTracksWithMediaType( AVAssetRef ref, CFStringRef type )
{ return (CFArrayRef)[ref tracksWithMediaType:(NSString *)type]; }

CFArrayRef AVAssetTracksWithMediaCharacteristic( AVAssetRef ref, CFStringRef characteristic )
{ return (CFArrayRef)[ref tracksWithMediaCharacteristic:(NSString *)characteristic]; }

CMPersistentTrackID AVAssetUnusedTrackID( AVAssetRef ref )
{ return [ref unusedTrackID]; }

// Accessing metadata
CFStringRef AVAssetLyrics( AVAssetRef ref )
{ return (CFStringRef)[ref lyrics]; }

CFArrayRef AVAssetMetadata( AVAssetRef ref )
{ return (CFArrayRef)[ref metadata]; }

CFArrayRef AVAssetCommonMetadata( AVAssetRef ref )
{ return (CFArrayRef)[ref commonMetadata]; }

CFArrayRef AVAssetAvailableMetadataFormats( AVAssetRef ref )
{ return (CFArrayRef)[ref availableMetadataFormats]; }

CFArrayRef AVAssetMetadataForFormat( AVAssetRef ref, CFStringRef format )
{ return (CFArrayRef)[ref metadataForFormat:(NSString *)format]; }

// Chapter metadata
CFArrayRef AVAssetAvailableChapterLocales( AVAssetRef ref )
{ return (CFArrayRef)[ref availableChapterLocales]; }

CFArrayRef AVAssetChapterMetadataGroupsWithTitleLocale( AVAssetRef ref, CFLocaleRef locale, CFArrayRef commonKeys )
{ return (CFArrayRef)[ref chapterMetadataGroupsWithTitleLocale:(NSLocale *)locale containingItemsWithCommonKeys:(NSArray *)commonKeys]; }

CFArrayRef AVAssetChapterMetadataGroupsBestMatchingPreferredLanguages( AVAssetRef ref, CFArrayRef languages )
{ return (CFArrayRef)[ref chapterMetadataGroupsBestMatchingPreferredLanguages:(NSArray *)languages]; }

// Find media selections
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
AVMediaSelectionRef AVAssetPreferredMediaSelection( AVAssetRef ref )
{ return [ref preferredMediaSelection]; }
#endif

CFArrayRef AVAssetAvailableMediaCharacteristicsWithMediaSelectionOptions( AVAssetRef ref )
{ return (CFArrayRef)[ref availableMediaCharacteristicsWithMediaSelectionOptions]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300 && __MAC_OS_X_VERSION_MIN_REQUIRED >= 101300
CFArrayRef AVAssetAllMediaSelections( AVAssetRef ref )
{ return (CFArrayRef)[ref allMediaSelections]; }
#endif

// Reference restrictions
AVAssetReferenceRestrictions avAssetReferenceRestrictions( AVAssetRef ref )
{ return [ref referenceRestrictions]; }

// Fragmented movies
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
Boolean AVAssetCanContainFragments( AVAssetRef ref )
{ return [ref canContainFragments]; }

Boolean AVAssetContainsFragments( AVAssetRef ref )
{ return [ref containsFragments]; }
#endif

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101202
CMTime AVAssetOverallDurationHint( AVAssetRef ref )
{ return [ref overallDurationHint]; }
#endif




#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
#pragma mark - AVAssetCache
///////////////////////////////////////////////////
//                AVAssetCache                   //
///////////////////////////////////////////////////
Boolean AVAssetCacheIsPlayableOffline( AVAssetCacheRef ref )
{ return [ref isPlayableOffline]; }

//CFArrayRef AVAssetCacheMediaSelectionOptionsInMediaSelectionGroup( AVAssetCacheRef ref )
//{
//    return (CFArrayRef)[ref mediaSelectionOptionsInMediaSelectionGroup];
//}
#endif



#pragma mark - AVAssetResourceLoader
///////////////////////////////////////////////////
//           AVAssetResourceLoader               //
///////////////////////////////////////////////////





#pragma mark - AVAssetTrack
///////////////////////////////////////////////////
//                 AVAssetTrack                  //
///////////////////////////////////////////////////
// Info
AVAssetRef AVAssetTrackAsset( AVAssetTrackRef ref )
{ return [ref asset]; }

CMPersistentTrackID AVAssetTrackID( AVAssetTrackRef ref )
{ return [ref trackID]; }

CFStringRef AVAssetTrackMediaType( AVAssetTrackRef ref )
{ return (CFStringRef)[ref mediaType]; }

Boolean AVAssetTrackHasMediaCharacteristic( AVAssetTrackRef ref, CFStringRef characteristic )
{ return [ref hasMediaCharacteristic:(NSString *)characteristic]; }

CFArrayRef AVAssetTrackFormatDescriptions( AVAssetTrackRef ref )
{ return (CFArrayRef)[ref formatDescriptions]; }

Boolean AVAssetTrackIsEnabled( AVAssetTrackRef ref )
{ return [ref isEnabled]; }

Boolean AVAssetTrackIsPlayable( AVAssetTrackRef ref )
{ return [ref isPlayable]; }

Boolean AVAssetTrackIsSelfContained( AVAssetTrackRef ref )
{ return [ref isSelfContained]; }

float AVAssetTrackEstimatedDataRate( AVAssetTrackRef ref )
{ return [ref estimatedDataRate]; }

long long AVAssetTrackTotalSampleDataLength( AVAssetTrackRef ref )
{ return [ref totalSampleDataLength]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300 && __MAC_OS_X_VERSION_MIN_REQUIRED >= 101300
Boolean AVAssetTrackIsDecodable( AVAssetTrackRef ref )
{ return [ref isDecodable]; }
#endif

// Temporal properties
CMTimeRange AVAssetTrackTimeRange( AVAssetTrackRef ref )
{ return [ref timeRange]; }

CMTimeScale AVAssetTrackNaturalTimeScale( AVAssetTrackRef ref )
{ return [ref naturalTimeScale]; }

// Language properties
CFStringRef AVAssetTrackLanguageCode( AVAssetTrackRef ref )
{ return (CFStringRef)[ref languageCode]; }

CFStringRef AVAssetTrackExtendedLanguageTag( AVAssetTrackRef ref )
{ return (CFStringRef)[ref extendedLanguageTag]; }

// Visual characteristics
CGSize AVAssetTrackNaturalSize( AVAssetTrackRef ref )
{ return NSSizeToCGSize([ref naturalSize]); }

CGAffineTransform AVAssetTrackPreferredTransform( AVAssetTrackRef ref )
{ return [ref preferredTransform]; }

// Audible characteristics
float AVAssetTrackPreferredVolume( AVAssetTrackRef ref )
{ return [ref preferredVolume]; }

// Frame-based characteristics
float AVAssetTrackNominalFrameRate( AVAssetTrackRef ref )
{ return [ref nominalFrameRate]; }

CMTime AVAssetTrackMinFrameDuration( AVAssetTrackRef ref )
{ return [ref minFrameDuration]; }

Boolean AVAssetTrackRequiresFrameReordering( AVAssetTrackRef ref )
{ return [ref requiresFrameReordering]; }

// Track segments
CFArrayRef AVAssetTrackSegments( AVAssetTrackRef ref )
{ return (CFArrayRef)[ref segments]; }

AVAssetTrackSegmentRef AVAssetTrackSegmentForTrackTime( AVAssetTrackRef ref, CMTime time )
{ return [ref segmentForTrackTime:time]; }

CMTime AVAssetTrackSamplePresentationTimeForTrackTime( AVAssetTrackRef ref, CMTime time )
{ return [ref samplePresentationTimeForTrackTime:time]; }

// Metadata
CFArrayRef AVAssetTrackMetadata( AVAssetTrackRef ref )
{ return (CFArrayRef)[ref metadata]; }

CFArrayRef AVAssetTrackCommonMetadata( AVAssetTrackRef ref )
{ return (CFArrayRef)[ref commonMetadata]; }

CFArrayRef AVAssetTrackAvailableMetadataFormats( AVAssetTrackRef ref )
{ return (CFArrayRef)[ref availableMetadataFormats]; }

CFArrayRef AVAssetTrackMetadataForFormat( AVAssetTrackRef ref, CFStringRef format )
{ return (CFArrayRef)[ref metadataForFormat:(NSString *)format]; }

// Associated tracks
CFArrayRef AVAssetTrackAvailableTrackAssociationTypes( AVAssetTrackRef ref )
{ return (CFArrayRef)[ref availableTrackAssociationTypes]; }

CFArrayRef AVAssetTrackAssociatedTracksOfType( AVAssetTrackRef ref, CFStringRef type )
{ return (CFArrayRef)[ref associatedTracksOfType:(NSString *)type]; }

// Simple cursors
Boolean AVAssetTrackCanProvideSampleCursors( AVAssetTrackRef ref )
{ return [ref canProvideSampleCursors]; }

AVSampleCursorRef AVAssetTrackMakeSampleCursorWithPresentationTimeStamp( AVAssetTrackRef ref, CMTime time )
{ return [ref makeSampleCursorWithPresentationTimeStamp:time]; }

AVSampleCursorRef AVAssetTrackMakeSampleCursorAtFirstSampleInDecodeOrder( AVAssetTrackRef ref )
{ return [ref makeSampleCursorAtFirstSampleInDecodeOrder]; }

AVSampleCursorRef AVAssetTrackMakeSampleCursorAtLastSampleInDecodeOrder( AVAssetTrackRef ref )
{ return [ref makeSampleCursorAtLastSampleInDecodeOrder]; }



#pragma mark - AVAssetTrackGroup
///////////////////////////////////////////////////
//              AVAssetTrackGroup                //
///////////////////////////////////////////////////
// Track ID values
CFArrayRef AVAssetTrackGroupTrackIDs( AVAssetTrackGroupRef ref )
{ return (CFArrayRef)[ref trackIDs]; }




#pragma mark - AVAssetTrackSegment
///////////////////////////////////////////////////
//            AVAssetTrackSegment                //
///////////////////////////////////////////////////
// Info
CMTimeMapping AVAssetTrackSegmentTimeMapping( AVAssetTrackSegmentRef ref )
{ return [ref timeMapping]; }

Boolean AVAssetTrackSegmentIsEmpty( AVAssetTrackSegmentRef ref )
{ return [ref isEmpty]; }



#pragma mark - AVCompositionTrack
///////////////////////////////////////////////////
//            AVCompositionTrack                 //
///////////////////////////////////////////////////





#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
#pragma mark - AVMediaSelection
///////////////////////////////////////////////////
//            AVMediaSelection                   //
///////////////////////////////////////////////////


#endif


#pragma mark - AVMetadataItem
///////////////////////////////////////////////////
//            AVMetadataItem                     //
///////////////////////////////////////////////////




#pragma mark - AVPlayer
///////////////////////////////////////////////////
//                  AVPlayer                     //
///////////////////////////////////////////////////
@implementation AVPlayer (Additions)
@dynamic tagNumber;

- (NSInteger)tag {
    return [objc_getAssociatedObject(self, @selector(tagNumber)) integerValue];
}

- (void)setTag:(NSInteger)tag {
    objc_setAssociatedObject(self, @selector(tagNumber), [NSNumber numberWithInteger:tag], OBJC_ASSOCIATION_RETAIN_NONATOMIC);
}
@end

// Init
AVPlayerRef AVPlayerWithURL( CFURLRef url )
{ return [[[AVPlayer alloc] initWithURL:(NSURL *)url] autorelease]; }

AVPlayerRef AVPlayerWithPlayerItem( AVPlayerItemRef item )
{ return [AVPlayer playerWithPlayerItem:item]; }

// Playback
void AVPlayerPlay( AVPlayerRef player )
{ [player play]; }

void AVPlayerPause( AVPlayerRef player )
{ [player pause]; }

float AVPlayerRate( AVPlayerRef player )
{ return [player rate]; }

void AVPlayerSetRate( AVPlayerRef player, float rate )
{ [player setRate:rate]; }

AVPlayerActionAtItemEnd avPlayerActionAtItemEnd( AVPlayerRef player )
{ return [player actionAtItemEnd]; }

void AVPlayerSetActionAtItemEnd( AVPlayerRef player, AVPlayerActionAtItemEnd action )
{ [player setActionAtItemEnd:action]; }

void AVPlayerReplaceCurrentItemWithPlayerItem( AVPlayerRef player, AVPlayerItemRef item )
{ [player replaceCurrentItemWithPlayerItem:item]; }

// Waiting behavior
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
Boolean AVPlayerAutomaticallyWaitsToMinimizeStalling( AVPlayerRef player )
{ return [player automaticallyWaitsToMinimizeStalling]; }

void AVPlayerSetAutomaticallyWaitsToMinimizeStalling( AVPlayerRef player, Boolean flag )
{ [player setAutomaticallyWaitsToMinimizeStalling:flag]; }

CFStringRef AVPlayerReasonForWaitingToPlay( AVPlayerRef player )
{ return (CFStringRef)[player reasonForWaitingToPlay]; }

AVPlayerTimeControlStatus avPlayerTimeControlStatus( AVPlayerRef player )
{ return [player timeControlStatus]; }

void AVPlayerPlayImmediatelyAtRate( AVPlayerRef player, float rate )
{ [player playImmediatelyAtRate:rate]; }
#endif

// Managing time
CMTime AVPlayerCurrentTime( AVPlayerRef player )
{ return [player currentTime]; }

void AVPlayerSeekToTime( AVPlayerRef player, CMTime tm )
{ [player seekToTime:tm]; }

void AVPlayerSeekToDate( AVPlayerRef player, CFDateRef dt )
{ [player seekToDate:(NSDate *)dt]; }

void AVPlayerSeekToTimeWithTolerance( AVPlayerRef player, CMTime tm, CMTime toleranceBefore, CMTime toleranceAfter )
{ [player seekToTime:tm toleranceBefore:toleranceBefore toleranceAfter:toleranceAfter]; }

// Observing time

// Media selection

// External playback

// Synch playback to external source

// Audio output
Boolean AVPlayerIsMuted( AVPlayerRef player )
{ return [player isMuted]; }

void AVPlayerSetMuted( AVPlayerRef player, Boolean flag )
{ [player setMuted:flag]; }

float AVPlayerVolume( AVPlayerRef player )
{ return [player volume]; }

void AVPlayerSetVolume( AVPlayerRef player, float volume )
{ [player setVolume:volume]; }

// AVPlayer properties
AVPlayerStatus avPlayerStatus( AVPlayerRef player )
{ return [player status]; }

ErrorRef AVPlayerError( AVPlayerRef player )
{ return [player error]; }

AVPlayerItemRef AVPlayerCurrentItem( AVPlayerRef player )
{ return [player currentItem]; }

// Instance properties

// Type properties

// Convenience
Boolean AVPlayerIsPlaying( AVPlayerRef ref )
{ return ( [ref rate] != 0 && [ref error] == nil ); }







#pragma mark - AVPlayerItem
///////////////////////////////////////////////////
//               AVPlayerItem                    //
///////////////////////////////////////////////////
// Create
AVPlayerItemRef AVPlayerItemWithURL( CFURLRef url )
{ return [AVPlayerItem playerItemWithURL:(NSURL *)url]; }

// Inspecting
AVAssetRef AVPlayerItemAsset( AVPlayerItemRef item )
{ return [item asset]; }

AVPlayerItemStatus avPlayerItemStatus( AVPlayerItemRef item )
{ return [item status]; }

CMTime AVPlayerItemDuration( AVPlayerItemRef item )
{ return [item duration]; }

//CMTimebaseRef AVPlayerItemTimebase( AVPlayerItemRef item );
CGSize AVPlayerItemPresentationSize( AVPlayerItemRef item )
{ return [item presentationSize]; }

// Moving the playhead
void AVPlayerItemStepByCount( AVPlayerItemRef item, NSInteger count )
{ [item stepByCount:count]; }

// Playback info
Boolean AVPlayerItemCanPlayReverse( AVPlayerItemRef item )
{ return [item canPlayReverse]; }

Boolean AVPlayerItemCanPlayFastForward( AVPlayerItemRef item )
{ return [item canPlayFastForward]; }

Boolean AVPlayerItemCanPlayFastReverse( AVPlayerItemRef item )
{ return [item canPlayFastReverse]; }

Boolean AVPlayerItemCanPlaySlowForward( AVPlayerItemRef item )
{ return [item canPlaySlowForward]; }

Boolean AVPlayerItemCanPlaySlowReverse( AVPlayerItemRef item )
{ return [item canPlaySlowReverse]; }

Boolean AVPlayerItemCanStepBackward( AVPlayerItemRef item )
{ return [item canStepBackward]; }

Boolean AVPlayerItemCanStepForward( AVPlayerItemRef item )
{ return [item canStepForward]; }

// Timing info
CMTime AVPlayerItemCurrentTime( AVPlayerItemRef item )
{ return [item currentTime]; }

CFDateRef AVPlayerItemCurrentDate( AVPlayerItemRef item )
{ return (CFDateRef)[item currentDate]; }

CMTime AVPlayerItemForwardPlaybackEndTime( AVPlayerItemRef item )
{ return [item forwardPlaybackEndTime]; }

CMTime AVPlayerItemReversePlaybackEndTime( AVPlayerItemRef item )
{ return [item reversePlaybackEndTime]; }

// Network behavior

// Settings

// Logs

// Authorization

// Media options

// Text style rules

// Outputs

// Data collectors

// Metadata

// Notifications



#pragma mark - AVPlayerLayer
///////////////////////////////////////////////////
//               AVPlayerLayer                   //
///////////////////////////////////////////////////
// Create
AVPlayerLayerRef AVPlayerLayerWithPlayer( AVPlayerRef player )
{ return [AVPlayerLayer playerLayerWithPlayer:player]; }

// Configure
AVPlayerRef AVPlayerLayerPlayer( AVPlayerLayerRef ref )
{ return [ref player]; }

Boolean AVPlayerLayerIsReadyForDisplay( AVPlayerLayerRef ref )
{ return [ref isReadyForDisplay]; }

CFStringRef AVPlayerLayerVideoGravity( AVPlayerLayerRef ref )
{ return (CFStringRef)[ref videoGravity]; }

CGRect AVPlayerLayerVideoRect( AVPlayerLayerRef ref )
{ return [ref videoRect]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
CFDictionaryRef AVPlayerLayerPixelBufferAttributes( AVPlayerLayerRef ref )
{ return (CFDictionaryRef)[ref pixelBufferAttributes]; }
#endif



#pragma mark - AVPlayerView
///////////////////////////////////////////////////
//                  AVPlayerView                 //
///////////////////////////////////////////////////
@implementation AVPlayerViewSC
- (void)drawRect:(NSRect)dirtyRect {
    CocoaSubclassDrawRect( self, dirtyRect );
    if ( !DialogEventBool() ) [super drawRect:dirtyRect];
}

- (BOOL)acceptsFirstResponder {
    DialogEventSetBool(NO);
    CocoaSubclassAcceptsFirstResponder( self );
    return DialogEventBool();
}

- (void)mouseDown:(NSEvent *)event {
    CocoaSubclassMouseDown( self, event );
    if ( !DialogEventBool() ) [super mouseDown:event];
}

- (void)mouseUp:(NSEvent *)event {
    CocoaSubclassMouseUp( self, event );
}

- (void)mouseEntered:(NSEvent *)event {
    DialogEventSetBool(NO);
    CocoaSubclassMouseEntered( self, event );
    if ( !DialogEventBool() ) [super mouseEntered:event];
}

- (void)mouseExited:(NSEvent *)event {
    CocoaSubclassMouseExited( self, event );
}

- (void)mouseDragged:(NSEvent *)event {
    CocoaSubclassMouseDragged( self, event );
}

- (void)mouseMoved:(NSEvent *)event {
    CocoaSubclassMouseMoved( self, event );
}

- (void)rightMouseDown:(NSEvent *)event {
    CocoaSubclassRightMouseDown( self, event );
    if ( !DialogEventBool() ) [super rightMouseDown:event];
}

- (void)rightMouseUp:(NSEvent *)event {
    CocoaSubclassRightMouseUp( self, event );
}

- (void)rightMouseDragged:(NSEvent *)event {
    CocoaSubclassRightMouseDragged( self, event );
}

- (void)keyDown:(NSEvent *)event {
    CocoaSubclassKeyDown( self, event );
    if ( !DialogEventBool() ) [super keyDown:event];
}

- (void)keyUp:(NSEvent *)event {
    CocoaSubclassKeyUp( self, event );
}

- (void)flagsChanged:(NSEvent *)event {
    CocoaSubclassFlagsChanged( self, event );
}
@end

@implementation AVPlayerView (Additions)
@dynamic tagNumber;

- (NSInteger)tag {
    return [objc_getAssociatedObject(self, @selector(tagNumber)) integerValue];
}

- (void)setTag:(NSInteger)tag {
    objc_setAssociatedObject(self, @selector(tagNumber), [NSNumber numberWithInteger:tag], OBJC_ASSOCIATION_RETAIN_NONATOMIC);
}
@end

AVPlayerView *AVPlayerViewWithTag( NSInteger tag )
{
    AVPlayerView *view = (AVPlayerView *)CocoaViewWithTag( tag );
    if ( [view isKindOfClass:[AVPlayerView class]] ) return view;
    CocoaShowAlert( NSWarningAlertStyle, @"Error.", [NSString stringWithFormat:@"Can't find playerview with tag: %ld.",(long)tag] );
    return nil;
}

// AVPlayer
AVPlayerRef AVPlayerViewPlayer( NSInteger tag )
{
    AVPlayerView *view = AVPlayerViewWithTag( tag );
    if ( view ) return [view player];
    return nil;
}

void AVPlayerViewSetPlayer( NSInteger tag, AVPlayerRef player )
{
    AVPlayerView *view = AVPlayerViewWithTag( tag );
    if ( view ) [view setPlayer:player];
}

// Customization
AVPlayerViewControlsStyle avPlayerViewControlsStyle( NSInteger tag )
{
    AVPlayerView *view = AVPlayerViewWithTag( tag );
    if ( view ) return [view controlsStyle];
    return 0;
}

void AVPlayerViewSetControlsStyle( NSInteger tag, AVPlayerViewControlsStyle style )
{
    AVPlayerView *view = AVPlayerViewWithTag( tag );
    if ( view ) [view setControlsStyle:style];
}

Boolean AVPlayerViewShowsFrameSteppingButtons( NSInteger tag )
{
    AVPlayerView *view = AVPlayerViewWithTag( tag );
    if ( view ) return [view showsFrameSteppingButtons];
    return NO;
}

void AVPlayerViewSetShowsFrameSteppingButtons( NSInteger tag, Boolean flag )
{
    AVPlayerView *view = AVPlayerViewWithTag( tag );
    if ( view ) [view setShowsFrameSteppingButtons:flag];
}

Boolean AVPlayerViewShowsSharingServiceButton( NSInteger tag )
{
    AVPlayerView *view = AVPlayerViewWithTag( tag );
    if ( view ) return [view showsSharingServiceButton];
    return NO;
}

void AVPlayerViewSetShowsSharingServiceButton( NSInteger tag, Boolean flag )
{
    AVPlayerView *view = AVPlayerViewWithTag( tag );
    if ( view ) [view setShowsSharingServiceButton:flag];
}

Boolean AVPlayerViewShowsFullScreenToggleButton( NSInteger tag )
{
    AVPlayerView *view = AVPlayerViewWithTag( tag );
    if ( view ) return [view showsFullScreenToggleButton];
    return NO;
}

void AVPlayerViewSetShowsFullScreenToggleButton( NSInteger tag, Boolean flag )
{
    AVPlayerView *view = AVPlayerViewWithTag( tag );
    if ( view ) [view setShowsFullScreenToggleButton:flag];
}

ViewRef AVPlayerViewContentOverlayView( NSInteger tag )
{
    AVPlayerView *view = AVPlayerViewWithTag( tag );
    if ( view ) return [view contentOverlayView];
    return nil;
}

CocoaMenuRef AVPlayerViewActionPopUpButtonMenu( NSInteger tag )
{
    AVPlayerView *view = AVPlayerViewWithTag( tag );
    if ( view ) return [view actionPopUpButtonMenu];
    return nil;
}

void AVPlayerViewSetActionPopUpButtonMenu( NSInteger tag, CocoaMenuRef m )
{
    AVPlayerView *view = AVPlayerViewWithTag( tag );
    if ( view ) [view setActionPopUpButtonMenu:m];
}

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300 && __MAC_OS_X_VERSION_MIN_REQUIRED >= 101300
Boolean AVPlayerViewUpdatesNowPlayingInfoCenter( NSInteger tag )
{
    AVPlayerView *view = AVPlayerViewWithTag( tag );
    if ( view ) return [view updatesNowPlayingInfoCenter];
    return NO;
}

void AVPlayerViewSetUpdatesNowPlayingInfoCenter( NSInteger tag, Boolean flag )
{
    AVPlayerView *view = AVPlayerViewWithTag( tag );
    if ( view ) [view setUpdatesNowPlayingInfoCenter:flag];
}
#endif

// Configure video
Boolean AVPlayerViewIsReadyForDisplay( NSInteger tag )
{
    AVPlayerView *view = AVPlayerViewWithTag( tag );
    if ( view ) return [view isReadyForDisplay];
    return NO;
}

CGRect AVPlayerViewVideoBounds( NSInteger tag )
{
    AVPlayerView *view = AVPlayerViewWithTag( tag );
    if ( view ) return NSRectToCGRect([view videoBounds]);
    return CGRectZero;
}

CFStringRef AVPlayerViewVideoGravity( NSInteger tag )
{
    AVPlayerView *view = AVPlayerViewWithTag( tag );
    if ( view ) return (CFStringRef)[view videoGravity];
    return nil;
}

void AVPlayerViewSetVideoGravity( NSInteger tag, CFStringRef gravity )
{
    AVPlayerView *view = AVPlayerViewWithTag( tag );
    if ( view ) [view setVideoGravity:(NSString *)gravity];
}

// Trimming playback content
Boolean AVPlayerViewCanBeginTrimming( NSInteger tag )
{
    AVPlayerView *view = AVPlayerViewWithTag( tag );
    if ( view ) return [view canBeginTrimming];
    return NO;
}

//void AVPlayerViewBeginTrimmingWithCallback( NSInteger tag, void *callback, void *userData );

// Display chapter and title
void AVPlayerViewFlashChapterNumber( NSInteger tag, NSUInteger number, CFStringRef title )
{
    AVPlayerView *view = AVPlayerViewWithTag( tag );
    if ( view ) [view flashChapterNumber:number chapterTitle:(NSString *)title];
}


// Convenience
Boolean AVPlayerViewPlayerIsPlaying( NSInteger tag )
{
    AVPlayerView *view = AVPlayerViewWithTag( tag );
    if ( view ) return AVPlayerIsPlaying( [view player] );
    return NO;
}


// Init
AVPlayerViewRef AVPlayerViewInit( NSInteger inTag, CGRect inRect )
{
    // rect
    NSRect rect = NSRectFromCGRect( inRect );
    if ( NSIsEmptyRect( rect ) ) rect = NSMakeRect( 20, 20, 480, 270 );

    // subclass
    BOOL subclass = IsSubclassFlag();
    
    // init
    AVPlayerView *view;
    if ( subclass ) {
        view = [[[AVPlayerViewSC alloc] initWithFrame:rect] autorelease];
    } else {
        view = [[[AVPlayerView alloc] initWithFrame:rect] autorelease];
    }

    // tag
    [view setTag:inTag];

    
    
    return view;
}

// Statement
void CocoaAVPlayerView( NSInteger inTag, CGRect inRect, NSInteger inControlsStyle, NSInteger inWndTag )
{
    BOOL show = ( inTag > 0 );
    inTag = ABS(inTag);
    
    NSRect rect = NSRectFromCGRect( inRect );
    
    // target window
    id w = CocoaTargetWindow( &inWndTag );
    
    if ( w ) {
        NSView *contentView = CocoaTargetContentView( w );
        AVPlayerView *view = CocoaViewSubviewWithTag( contentView, inTag );
        
        if ( !view ) {
            view = TitlebarAccessoryViewWithTag( inTag );
        }
        
        if ( view ) {    // already exists
            
            // make sure it's same view class
//            if ( !CocoaValidateViewClass( inWndTag, inTag, [view class], [AVPlayerView class] ) ) {
//                return;
//            }
            
            if ( !CocoaValidateViewClass( inWndTag, inTag, view, [AVPlayerView class] ) ) {
                return;
            }

            // rect
            if ( !NSIsEmptyRect( rect ) ) [view setFrame:rect];
            
        } else {            // create
            // rect
//            if ( NSIsEmptyRect( rect ) ) {
//                rect = NSMakeRect( 20, 20, 480, 270 );
//            }
            
            // init
//            if ( inSubclass ) {
//                view = [[AVPlayerViewSC alloc] initWithFrame:rect];
//            } else {
//                view = [[AVPlayerView alloc] initWithFrame:rect];
//            }
            view = AVPlayerViewInit( inTag, inRect );
            
            // style
            if ( inControlsStyle != kFBParamMissing ) [view setControlsStyle:inControlsStyle];
            
            // default autoresizing
            [(NSView *)view setAutoresizingMask:NSViewMinYMargin];
            
            // tag
//            [view setTag:inTag];
            
            // add to superview
            [contentView addSubview:view];
            
            // wndTag
            [view setWndTag:inWndTag];
            
//            [view release];
        }
        [view setHidden:!show];
    } else {
        CocoaShowAlert( NSWarningAlertStyle, @"Window error.", [NSString stringWithFormat:@"Cocoa window %ld does not exist.",(long)inWndTag] );
    }
}



#pragma mark - AVSampleCursor
///////////////////////////////////////////////////
//               AVSampleCursor                  //
///////////////////////////////////////////////////



#pragma mark - AVURLAsset
///////////////////////////////////////////////////
//                  AVURLAsset                   //
///////////////////////////////////////////////////
// Create
AVURLAssetRef AVURLAssetWithURL( CFURLRef url, CFDictionaryRef options )
{ return [AVURLAsset URLAssetWithURL:(NSURL *)url options:(NSDictionary *)options]; }

// URL
CFURLRef AVURLAssetURL( AVURLAssetRef ref )
{ return (CFURLRef)[ref URL]; }

// Resource loading
AVAssetResourceLoaderRef AVURLAssetResourceLoader( AVURLAssetRef ref )
{ return [ref resourceLoader]; }

// Compatible tracks
AVAssetTrackRef AVURLAssetCompatibleTrackForCompositionTrack( AVURLAssetRef ref, AVCompositionTrackRef compTrack );

// Supported media types
CFArrayRef AVURLAssetAudiovisualMIMETypes( void );

CFArrayRef AVURLAssetAudiovisualTypes( void )
{ return (CFArrayRef)[AVURLAsset audiovisualTypes]; }

Boolean AVURLAssetIsPlayableExtendedMIMEType( CFStringRef type )
{ return [AVURLAsset isPlayableExtendedMIMEType:(NSString *)type]; }

// Offline assets
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
AVAssetCacheRef AVURLAssetCache( AVURLAssetRef ref )
{ return [ref assetCache]; }

#endif

// Encrypted content
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101204
Boolean AVURLAssetMayRequireContentKeysForMediaDataProcessing( AVURLAssetRef ref )
{ return [ref mayRequireContentKeysForMediaDataProcessing]; }
#endif


#endif// #ifdef AVKIT_EXTERN
#endif// #if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
#endif// #if __LP64__



