/*
 CocoaUI.h
 
 Bernie Wylde 20170712 
 */

#import <AppKit/AppKit.h>
#import <Quartz/Quartz.h>
#import <objc/runtime.h>

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
#import <GameplayKit/GameplayKit.h>
#endif

//#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
//#import <Intents/Intents.h>
//#endif

#include "FBtoC.h"
#include "Runtime.h"

void CocoaAppRun( void );
BOOL IsCocoaApplication( void );


// subclass flag
BOOL IsSubclassFlag( void );
void SetSubclassFlag( BOOL flag );


@class OutlineItem;
@class TableRowView;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1070

typedef Class ClassRef;
typedef SEL SELRef;
typedef Protocol *ProtocolRef;

typedef NSActionCell *ActionCellRef;
typedef NSAffineTransform *AffineTransformRef;
typedef NSAlert *AlertRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
typedef NSAppearance *AppearanceRef;
#endif
typedef NSAppleEventDescriptor *AppleEventDescriptorRef;
typedef NSAppleEventManager *AppleEventManagerRef;
typedef NSAppleScript *AppleScriptRef;
typedef NSApplication *ApplicationRef;
typedef NSArray *ArrayRef;

typedef NSBezierPath *BezierPathRef;
typedef NSBitmapImageRep *BitmapImageRepRef;
typedef NSBox *BoxRef;
typedef NSBundle *BundleRef;
typedef NSButton *ButtonRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1080
typedef NSByteCountFormatter *ByteCountFormatterRef;
#endif

typedef CAAnimation *CAAnimationRef;
typedef CABasicAnimation *CABasicAnimationRef;
typedef CAKeyframeAnimation *CAKeyframeAnimationRef;
typedef CAGradientLayer *CAGradientLayerRef;
typedef CALayer *CALayerRef;
typedef id<CAMediaTiming> CAMediaTimingRef;
typedef CAMediaTimingFunction *CAMediaTimingFunctionRef;
typedef CAPropertyAnimation *CAPropertyAnimationRef;
typedef CAReplicatorLayer *CAReplicatorLayerRef;
typedef CAScrollLayer *CAScrollLayerRef;
typedef CAShapeLayer *CAShapeLayerRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
typedef CASpringAnimation *CASpringAnimationRef;
#endif

typedef CATextLayer *CATextLayerRef;
typedef CATiledLayer *CATiledLayerRef;
typedef CATransformLayer *CATransformLayerRef;
typedef CATransition *CATransitionRef;
typedef CAValueFunction *CAValueFunctionRef;
//typedef NSCalendar *CalendarRef;
typedef NSCell *CellRef;
//typedef void *CGNSColorRef;
typedef CIColor *CIColorRef;
typedef CIContext *CIContextRef;
typedef CIDetector *CIDetectorRef;
typedef CIFeature *CIFeatureRef;
typedef CIFilter *CIFilterRef;
typedef CIImage *CIImageRef;
typedef NSCIImageRep *CIImageRepRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300 && __MAC_OS_X_VERSION_MIN_REQUIRED >= 101300
typedef CIQRCodeDescriptor *CIQRCodeDescriptorRef;
#endif

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef CIQRCodeFeature *CIQRCodeFeatureRef;
#endif

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300 && __MAC_OS_X_VERSION_MIN_REQUIRED >= 101300
typedef CIRenderDestination *CIRenderDestinationRef;
typedef CIRenderTask *CIRenderTaskRef;
#endif

typedef IKCameraDeviceView *IKCameraDeviceViewRef;
typedef IKDeviceBrowserView *IKDeviceBrowserViewRef;
typedef IKFilterBrowserPanel *IKFilterBrowserPanelRef;
typedef IKFilterBrowserView *IKFilterBrowserViewRef;
typedef IKFilterUIView *IKFilterUIViewRef;
typedef IKImageBrowserCell *IKImageBrowserCellRef;
typedef IKImageEditPanel *IKImageEditPanelRef;
typedef id<IKImageEditPanelDataSource> IKImageEditPanelDataSourceRef;
typedef IKImageView *IKImageViewRef;
typedef IKPictureTaker *IKPictureTakerRef;
typedef IKSaveOptions *IKSaveOptionsRef;
typedef IKScannerDeviceView *IKScannerDeviceViewRef;
typedef IKSlideshow *IKSlideshowRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSClickGestureRecognizer *ClickGestureRecognizerRef;
#endif

typedef NSClipView *ClipViewRef;
typedef NSCoder *CoderRef;
typedef NSColor *ColorRef;
typedef NSColorList *ColorListRef;
typedef NSColorPanel *ColorPanelRef;
typedef NSColorSpace *ColorSpaceRef;
typedef NSColorWell *ColorWellRef;
typedef NSComboBox *ComboBoxRef;
typedef NSComparisonPredicate *ComparisonPredicateRef;
typedef NSCompoundPredicate *CompoundPredicateRef;
typedef NSControl *CocoaControlRef;
typedef NSCountedSet *CountedSetRef;
typedef NSCursor *CursorRef;

typedef NSDataDetector *DataDetectorRef;
typedef NSDate *DateRef;
typedef NSDateComponents *DateComponentsRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSDateComponentsFormatter *DateComponentsFormatterRef;
#endif
typedef NSDateFormatter *DateFormatterRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
typedef NSDateInterval *DateIntervalRef;
#endif
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSDateIntervalFormatter *DateIntervalFormatterRef;
#endif
typedef NSDatePicker *DatePickerRef;
typedef NSDecimalNumber *DecimalNumberRef;
typedef id<NSDecimalNumberBehaviors> DecimalNumberBehaviorsRef;
typedef NSDecimalNumberHandler *DecimalNumberHandlerRef;
typedef NSDirectoryEnumerator *DirectoryEnumeratorRef;
typedef NSDistributedNotificationCenter *DistributedNotificationCenterRef;
typedef NSDockTile *DockTileRef;
typedef NSDocument *DocumentRef;
typedef NSDocumentController *DocumentControllerRef;
typedef id<NSDraggingInfo> DraggingInfoRef;
typedef NSDraggingItem *DraggingItemRef;
typedef NSDraggingSession *DraggingSessionRef;

typedef NSEnumerator *EnumeratorRef;
typedef NSError *ErrorRef;
typedef NSEvent *CocoaEventRef;
typedef NSExpression *ExpressionRef;

typedef NSFileHandle *FileHandleRef;
typedef NSFileManager *FileManagerRef;
typedef NSFileWrapper *FileWrapperRef;
typedef NSFont *FontRef;
typedef CFTypeRef CTNSFontRef;
typedef NSFontDescriptor *FontDescriptorRef;
typedef NSFontManager *FontManagerRef;
typedef NSFontPanel *FontPanelRef;
typedef NSFormatter *FormatterRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSGestureRecognizer *GestureRecognizerRef;
#endif
typedef NSGlyphGenerator *GlyphGeneratorRef;
typedef id<NSGlyphStorage> GlyphStorageRef;
typedef NSGradient *GradientRef;
typedef NSGraphicsContext *GraphicsContextRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
typedef NSGridCell *GridCellRef;
typedef NSGridColumn *GridColumnRef;
typedef NSGridRow *GridRowRef;
typedef NSGridView *GridViewRef;
#endif

typedef NSHelpManager *HelpManagerRef;
typedef NSHTTPCookieStorage *HTTPCookieStorageRef;

typedef NSImage *ImageRef;
typedef NSImageRep *ImageRepRef;
typedef NSImageView *ImageViewRef;
typedef NSIndexPath *IndexPathRef;
typedef NSIndexSet *IndexSetRef;
typedef NSMutableIndexSet *MutableIndexSetRef;
typedef NSInvocation *InvocationRef;
typedef NSInvocationOperation *InvocationOperationRef;

typedef NSJSONSerialization *JSONSerializationRef;

typedef NSKeyedArchiver *KeyedArchiverRef;
typedef NSKeyedUnarchiver *KeyedUnarchiverRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
typedef NSLayoutAnchor *LayoutAnchorRef;
typedef NSLayoutDimension *LayoutDimensionRef;
typedef NSLayoutGuide *LayoutGuideRef;
typedef NSLayoutXAxisAnchor *LayoutXAxisAnchorRef;
typedef NSLayoutYAxisAnchor *LayoutYAxisAnchorRef;
#endif

typedef NSLayoutConstraint *LayoutConstraintRef;
typedef NSLayoutManager *LayoutManagerRef;
typedef NSLevelIndicator *LevelIndicatorRef;
typedef NSLinguisticTagger *LinguisticTaggerRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSMagnificationGestureRecognizer *MagnificationGestureRecognizerRef;
#endif
typedef NSMenu *CocoaMenuRef;
typedef NSMenuItem *MenuItemRef;
typedef NSMethodSignature *MethodSignatureRef;

typedef NSNetService *NetServiceRef;
typedef NSNotification *NotificationRef;
typedef NSNotificationCenter *NotificationCenterRef;
typedef NSNotificationQueue *NotificationQueueRef;
typedef NSNumberFormatter *NumberFormatterRef;

typedef NSObject *ObjectRef;
typedef NSOpenPanel *OpenPanelRef;
typedef NSOperation *OperationRef;
typedef NSOperationQueue *OperationQueueRef;
typedef NSOrderedSet *OrderedSetRef;
typedef NSMutableOrderedSet *MutableOrderedSetRef;
typedef NSOutlineView *OutlineViewRef;
typedef OutlineItem *OutlineItemRef;
typedef NSOrthography *OrthographyRef;

typedef NSPageLayout *PageLayoutRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSPanGestureRecognizer *PanGestureRecognizerRef;
#endif
typedef NSPanel *PanelRef;
typedef NSParagraphStyle *ParagraphStyleRef;

typedef NSMutableParagraphStyle *MutableParagraphStyleRef;

typedef NSPasteboard *CocoaPasteboardRef;
typedef id<NSPasteboardWriting> PasteboardWritingRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
typedef NSPDFInfo *PDFInfoRef;
typedef NSPDFPanel *PDFPanelRef;
#endif

typedef NSPipe *PipeRef;
typedef NSPointerFunctions *PointerFunctionsRef;
typedef NSPointerArray *PointerArrayRef;
typedef NSPopover *PopoverRef;
typedef NSPopUpButton *PopUpButtonRef;
typedef NSPort *PortRef;
typedef NSPredicate *PredicateRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSPressGestureRecognizer *PressGestureRecognizerRef;
#endif
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
typedef NSPressureConfiguration *PressureConfigurationRef;
#endif
typedef NSPrinter *PrinterRef;
typedef NSPrintInfo *PrintInfoRef;
typedef NSPrintOperation *PrintOperationRef;
typedef NSPrintPanel *PrintPanelRef;
typedef NSProcessInfo *ProcessInfoRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
typedef NSProgress *ProgressRef;
#endif
typedef NSProgressIndicator *ProgressIndicatorRef;

typedef NSRegularExpression *RegularExpressionRef;
typedef NSResponder *ResponderRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSRotationGestureRecognizer *RotationGestureRecognizerRef;
#endif
typedef NSRulerMarker *RulerMarkerRef;
typedef NSRulerView *RulerViewRef;
typedef NSRunLoop *RunLoopRef;
typedef NSRunningApplication *RunningApplicationRef;

typedef NSSavePanel *SavePanelRef;
typedef NSScanner *ScannerRef;
typedef NSScreen *ScreenRef;
typedef NSScroller *ScrollerRef;
typedef NSScrollView *ScrollViewRef;
typedef NSSearchField *SearchFieldRef;
typedef NSSecureTextField *SecureTextFieldRef;
typedef NSSegmentedControl *SegmentedControlRef;
typedef NSShadow *ShadowRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1080
typedef NSSharingServicePicker *SharingServicePickerRef;
#endif

typedef NSSlider *SliderRef;
typedef NSSortDescriptor *SortDescriptorRef;
typedef NSSound *SoundRef;
typedef NSSplitView *SplitViewRef;
typedef NSStatusBar *StatusBarRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSStatusBarButton *StatusBarButtonRef;
#endif
typedef NSStatusItem *StatusItemRef;
typedef NSStepper *StepperRef;
//typedef CFTypeRef CFNSStringRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
typedef NSStringDrawingContext *StringDrawingContextRef;
#endif

typedef NSTableCellView *TableCellViewRef;
typedef NSTableColumn *TableColumnRef;
typedef NSTableHeaderCell *TableHeaderCellRef;
typedef NSTableHeaderView *TableHeaderViewRef;
typedef NSTableRowView *TableRowViewRef;
typedef NSTableView *TableViewRef;
typedef NSTabView *TabViewRef;
typedef NSTask *TaskRef;
typedef NSTextAttachment *TextAttachmentRef;
typedef id<NSTextAttachmentCell> TextAttachmentCellRef;
typedef NSTextBlock *TextBlockRef;
typedef NSTextCheckingResult *TextCheckingResultRef;
typedef NSTextContainer *TextContainerRef;
typedef NSTextField *TextFieldRef;
typedef NSTextField *TextLabelRef;
typedef NSTextFieldCell *TextFieldCellRef;
typedef NSTextList *TextListRef;
typedef NSTextFinder *TextFinderRef;
typedef NSTextStorage *TextStorageRef;
typedef NSTextTab *TextTabRef;
typedef NSTextTable *TextTableRef;
typedef NSTextTableBlock *TextTableBlockRef;
typedef NSTextView *TextViewRef;
typedef NSThread *ThreadRef;
typedef NSTokenField *TokenFieldRef;
typedef NSToolbar *ToolbarRef;
typedef NSToolbarItem *ToolbarItemRef;
typedef NSTouch *TouchRef;
typedef NSTrackingArea *TrackingAreaRef;

typedef NSUndoManager *UndoManagerRef;
typedef NSURLCache *URLCacheRef;
typedef NSURLCredentialStorage *URLCredentialStorageRef;
typedef NSURLRequest *URLRequestRef;
typedef NSURLResponse *URLResponseRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSURLSession *URLSessionRef;
typedef NSURLSessionConfiguration *URLSessionConfigurationRef;
typedef NSURLSessionTask *URLSessionTaskRef;
typedef NSURLSessionDataTask *URLSessionDataTaskRef;
typedef NSURLSessionDownloadTask *URLSessionDownloadTaskRef;
#endif

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
typedef NSURLSessionStreamTask *URLSessionStreamTaskRef;
#endif

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSURLSessionUploadTask *URLSessionUploadTaskRef;
#endif

typedef NSUserDefaults *UserDefaultsRef;
typedef NSUserDefaultsController *UserDefaultsControllerRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1080
typedef NSUserNotification *UserNotificationRef;
#endif

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSUserNotificationAction *UserNotificationActionRef;
#endif

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1080
typedef NSUserNotificationCenter *UserNotificationCenterRef;
#endif

typedef NSValue *ValueRef;
typedef NSViewController *ViewControllerRef;
typedef NSView *ViewRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSVisualEffectView *VisualEffectViewRef;
#endif

typedef NSWindow *CocoaWindowRef;
typedef NSWindowController *WindowControllerRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300 && __MAC_OS_X_VERSION_MIN_REQUIRED >= 101300
typedef NSWindowTab *WindowTabRef;
typedef NSWindowTabGroup *WindowTabGroupRef;
#endif

typedef NSWorkspace *WorkspaceRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101400 && __MAC_OS_X_VERSION_MIN_REQUIRED >= 101400
typedef NSWorkspaceAuthorization *WorkspaceAuthorizationRef;
#endif

#import "AffineTransform.h"
#import "Alert.h"
#import "Appearance.h"
#import "AppleEventDescriptor.h"
#import "AppleEventManager.h"
#import "AppleScript.h"
#import "Application.h"
#import "Array.h"
#import "AttributedString.h"

#import "BezierPath.h"
#import "BitmapImageRep.h"
#import "Box.h"
#import "Bundle.h"
#import "Button.h"
#import "ByteCountFormatter.h"

#import "CAAnimation.h"
#import "CAGradientLayer.h"
#import "CALayer.h"
#import "Calendar.h"
#import "CAMediaTiming.h"
#import "CAMediaTimingFunction.h"
#import "CAReplicatorLayer.h"
#import "CAScrollLayer.h"
#import "CAShapeLayer.h"
#import "CATextLayer.h"
#import "CATiledLayer.h"
#import "CATransformLayer.h"
#import "CAValueFunction.h"
#import "Cell.h"
#import "CharacterSet.h"
#import "CIColor.h"
#import "CIContext.h"
#import "CIDetector.h"
#import "CIFeature.h"
#import "CIFilter.h"
#import "CIImage.h"
#import "CIImageRep.h"
#import "CIQRCodeFeature.h"
#import "CIRenderDestination.h"
#import "CIRenderTask.h"
#import "ClickGestureRecognizer.h"
#import "ClipView.h"
#import "Coder.h"
#import "Color.h"
#import "ColorList.h"
#import "ColorPanel.h"
#import "ColorSpace.h"
#import "ColorWell.h"
#import "ComboBox.h"
#import "ComparisonPredicate.h"
#import "Compiler.h"
#import "CompoundPredicate.h"
#import "Control.h"
#import "CountedSet.h"
#import "Cursor.h"

#import "Data.h"
#import "Date.h"
#import "DateComponents.h"
#import "DateComponentsFormatter.h"
#import "DateFormatter.h"
#import "DateInterval.h"
#import "DateIntervalFormatter.h"
#import "DatePicker.h"
#import "DecimalNumber.h"
#import "DialogEvent.h"
#import "Dictionary.h"
#import "DirectoryEnumerator.h"
#import "DistributedNotificationCenter.h"
#import "DockTile.h"
#import "Document.h"
#import "DocumentController.h"
#import "DraggingInfo.h"
#import "DraggingItem.h"
#import "DraggingSession.h"

#import "Enumerator.h"
#import "Error.h"
#import "Event.h"
#import "Expression.h"

#import "FileHandle.h"
#import "FileManager.h"
#import "FileWrapper.h"
#import "Font.h"
#import "FontDescriptor.h"
#import "FontManager.h"

#import "Geometry.h"
#import "GestureRecognizer.h"
#import "GlyphGenerator.h"
#import "Gradient.h"
#import "Graphics.h"
#import "GraphicsContext.h"
#import "GridView.h"

#import "HelpManager.h"

#import "IKCameraDeviceView.h"
#import "IKDeviceBrowserView.h"
#import "IKFilterBrowserPanel.h"
#import "IKFilterBrowserView.h"
#import "IKFilterUIView.h"
#import "IKImageBrowserCell.h"
#import "IKImageEditPanel.h"
#import "IKImageView.h"
#import "IKPictureTaker.h"
#import "IKSaveOptions.h"
#import "IKScannerDeviceView.h"
#import "IKSlideshow.h"
#import "Image.h"
#import "ImageRep.h"
#import "ImageView.h"
#import "IndexPath.h"
#import "IndexSet.h"
#import "Invocation.h"
#import "InvocationOperation.h"

#import "JSONSerialization.h"

#import "KeyedArchiver.h"

#import "LayoutAnchor.h"
#import "LayoutConstraint.h"
#import "LayoutGuide.h"
#import "LayoutManager.h"
#import "LevelIndicator.h"
#import "LinguisticTagger.h"
#import "Locale.h"

#import "MagnificationGestureRecognizer.h"
#import "Menu.h"
#import "MenuItem.h"
#import "MethodSignature.h"

#import "Nib.h"
#import "Notification.h"
#import "NotificationQueue.h"
#import "Number.h"
#import "NumberFormatter.h"

#import "ObjCRuntime.h"
#import "Object.h"
#import "OpenPanel.h"
#import "Operation.h"
#import "OperationQueue.h"
#import "OrderedSet.h"
#import "Orthography.h"

#import "PageLayout.h"
#import "Panel.h"
#import "PanGestureRecognizer.h"
#import "ParagraphStyle.h"
#import "Pasteboard.h"
#import "PDFInfo.h"
#import "PDFPanel.h"
#import "Pipe.h"
#import "PointerArray.h"
#import "PointerFunctions.h"
#import "Popover.h"
#import "PopUpButton.h"
#import "Port.h"
#import "Predicate.h"
#import "PressGestureRecognizer.h"
#import "PressureConfiguration.h"
#import "Printer.h"
#import "PrintInfo.h"
#import "PrintOperation.h"
#import "PrintPanel.h"
#import "ProcessInfo.h"
#import "Progress.h"
#import "ProgressIndicator.h"
#import "PropertyList.h"

#import "Range.h"
#import "RegularExpression.h"
#import "Responder.h"
#import "RotationGestureRecognizer.h"
#import "RulerMarker.h"
#import "RulerView.h"
#import "RunLoop.h"
#import "RunningApplication.h"

#import "SavePanel.h"
#import "Scanner.h"
#import "Screen.h"
#import "Scroller.h"
#import "ScrollView.h"
#import "SearchField.h"
#import "SecureTextField.h"
#import "SegmentedControl.h"
#import "Set.h"
#import "Shadow.h"
#import "SharingService.h"
#import "Slider.h"
#import "SortDescriptor.h"
#import "Sound.h"
#import "SplitView.h"
#import "StatusBar.h"
#import "StatusBarButton.h"
#import "StatusItem.h"
#import "Stepper.h"
#import "String.h"
#import "StringDrawing.h"

#import "TableCellView.h"
#import "TableColumn.h"
#import "TableHeaderCell.h"
#import "TableHeaderView.h"
#import "TableRowView.h"
#import "TableView.h"

#import "OutlineView.h"

#import "TabView.h"
#import "Task.h"
#import "Text.h"
#import "TextAttachment.h"
#import "TextCheckingResult.h"
#import "TextContainer.h"
#import "TextField.h"
#import "TextFieldCell.h"
#import "TextLabel.h"
#import "TextList.h"
#import "TextStorage.h"
#import "TextTab.h"
#import "TextTable.h"
#import "TextView.h"
#import "Thread.h"
#import "Timer.h"
#import "TimeZone.h"
#import "TokenField.h"
#import "Toolbar.h"
#import "ToolbarItem.h"
#import "Touch.h"
#import "TrackingArea.h"

#import "UndoManager.h"
#import "URL.h"
#import "URLCache.h"
#import "URLRequest.h"
#import "URLResponse.h"
#import "URLSession.h"
#import "UserDefaults.h"
#import "UserDefaultsController.h"
#import "UserNotification.h"
#import "UserNotificationAction.h"
#import "UserNotificationCenter.h"

#import "Value.h"
#import "View.h"
#import "ViewController.h"
#import "VisualEffectView.h"

#import "Window.h"
#import "WindowController.h"
#import "WindowTab.h"
#import "WindowTabGroup.h"
#import "Workspace.h"

CGPathRef NSBezierPathToCGPath( NSBezierPath *bezierPath );
NSImage *CocoaImageResource( NSString *path );
NSImage *FixImageValue( void *inImage );
NSFont *FixFont( void *inFont );


#pragma mark - runtime alert
void CocoaShowAlert( NSAlertStyle style, NSString *msg, NSString *info );
void CocoaShowWindowDoesNotExistAlert( NSInteger tag );


#if __LP64__

// menu
long FBMenuFunction( long val );
void InstallFBAppCommandProcessHandler( void );// FBtoC generates a call to this function but we don't use it

// dialog
long FBDialogFunction( long val );
void CallUserDefinedOnDialogFunction(long fbEventKind, long fbEventID, long fbWndNum, CFTypeRef obj);
void InstallFBAppDialogHandler( void ); // FBtoC generates a call to this function but we don't use it

#endif  // __LP64__

id CocoaFindViewWithTagInAnyOpenPanelAccessoryView( NSInteger tag, Class cls );
id CocoaFindViewWithTagInAnySavePanelAccessoryView( NSInteger tag, Class cls );

id CocoaFindViewWithTagInWindow( NSInteger tag, Class cls, NSWindow *w );
id CocoaFindViewWithTagInAnyWindow( NSInteger tag, Class cls );
id CocoaFindViewWithTag( NSInteger tag, Class cls );
BOOL CocoaViewWithKindOfClassExists( NSInteger tag, Class cls );
id CocoaValidateViewKindOfClass( NSInteger tag, Class cls );
//BOOL CocoaValidateViewClass( NSInteger wndTag, NSInteger viewTag, Class actualClass, Class requiredClass );
BOOL CocoaValidateViewClass( NSInteger wndTag, NSInteger viewTag, id obj, Class requiredClass );



/*
 Subclassed windows
 */
void CocoaWindowSubclassMouseDown( NSWindow *w, NSEvent *event );
void CocoaWindowSubclassMouseUp( NSWindow *w, NSEvent *event );
void CocoaWindowSubclassKeyDown( NSWindow *w, NSEvent *event );
void CocoaWindowSubclassKeyUp( NSWindow *w, NSEvent *event );
void CocoaWindowSubclassFlagsChanged( NSWindow *w, NSEvent *event );
void CocoaWindowSubclassMouseEntered( NSWindow *w, NSEvent *event );
void CocoaWindowSubclassMouseExited( NSWindow *w, NSEvent *event );



/*
 Subclassed views
 */
void CocoaSubclassDrawRect( id view, NSRect dirtyRect );

void CocoaSubclassAcceptsFirstResponder( id view );

void CocoaSubclassMouseDown( NSView *view, NSEvent *event );
void CocoaSubclassMouseUp( NSView *view, NSEvent *event );
void CocoaSubclassMouseEntered( NSView *view, NSEvent *event );
void CocoaSubclassMouseExited( NSView *view, NSEvent *event );
void CocoaSubclassMouseDragged( NSView *view, NSEvent *event );
void CocoaSubclassMouseMoved( NSView *view, NSEvent *event );
void CocoaSubclassRightMouseDown( NSView *view, NSEvent *event );
void CocoaSubclassRightMouseUp( NSView *view, NSEvent *event );
void CocoaSubclassRightMouseDragged( NSView *view, NSEvent *event );

void CocoaSubclassKeyDown( NSView *view, NSEvent *event );
void CocoaSubclassKeyUp( NSView *view, NSEvent *event );
void CocoaSubclassFlagsChanged( NSView *view, NSEvent *event );

void CocoaSubclassUpdateTrackingAreas( NSView *view );
void CocoaSubclassResetCursorRects( NSView *view );

NSDragOperation CocoaSubclassDraggingEntered( NSView *view, id<NSDraggingInfo>sender );
void CocoaSubclassDraggingExited( NSView *view, id <NSDraggingInfo>sender );
BOOL CocoaSubclassPerformDragOperation( NSView *view, id <NSDraggingInfo>sender );

void CocoaSubclassViewDidChangeEffectiveAppearance( id view );





/*
 NSRangeToCFRange
 NSRangeFromCFRange
 */
CFRange NSRangeToCFRange( NSRange range );
NSRange NSRangeFromCFRange( CFRange range );

#endif //__MAC_OS_X_VERSION_MAX_ALLOWED >= 1070

