/*
 AffineTransform.h
 
 Bernie Wylde
 */

#import <AppKit/AppKit.h>

AffineTransformRef AffineTransformInit( void );
AffineTransformRef AffineTransformWithTransform( AffineTransformRef ref );

void AffineTransformRotateByDegrees( AffineTransformRef tx, CGFloat angle );
void AffineTransformRotateByRadians( AffineTransformRef tx, CGFloat angle );
void AffineTransformScale( AffineTransformRef tx, CGFloat scale );
void AffineTransformScaleXY( AffineTransformRef tx, CGFloat xScale, CGFloat yScale );
void AffineTransformTranslate( AffineTransformRef tx, CGFloat x, CGFloat y );
void AffineTransformAppend( AffineTransformRef tx1, AffineTransformRef tx2 );
void AffineTransformPrepend( AffineTransformRef tx1, AffineTransformRef tx2 );
void AffineTransformInvert( AffineTransformRef tx );
CGPoint AffineTransformPoint( AffineTransformRef tx, CGPoint pt );
CGSize AffineTransformSize( AffineTransformRef tx, CGSize size );
BezierPathRef AffineTransformBezierPath( AffineTransformRef tx, BezierPathRef path );

NSAffineTransformStruct AffineTransformStruct( AffineTransformRef tx );

void AffineTransformSet( AffineTransformRef tx );
void AffineTransformConcat( AffineTransformRef tx );
