/*
 Alert.h
 
 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// dialog events
enum {
    alertDidEnd = 1000,
    alertShowHelp
};

@interface CocoaAlertDelegate : NSObject <NSAlertDelegate> {
    BOOL boolVal;
    NSInteger lastSuppressionButtonState;
}
@property (assign) BOOL boolVal;
@property (assign) NSInteger lastSuppressionButtonState;
@end

CocoaAlertDelegate *CocoaAlertDelegateGet( void );
NSAlert *CocoaAlertWithTag( NSInteger tag );
void CocoaAlertAdd( NSAlert *alert );
void CocoaAlertRemove( NSAlert *alert );

@interface NSAlert (Additions)
@property (nonatomic,retain) NSNumber *tagNumber;
@property (nonatomic,retain) NSNumber *sheetNumber;

- (NSInteger)tag;
- (void)setTag:(NSInteger)tag;
- (BOOL)sheet;
- (void)setSheet:(BOOL)sheet;

@end

NSAlert *AlertWithTag( NSInteger tag );
BOOL AlertExists( NSInteger tag );

// Configure
void AlertLayout( NSInteger tag );
NSAlertStyle AlertStyle( NSInteger tag );
void AlertSetStyle( NSInteger tag, NSAlertStyle style );

void AlertSetAccessoryView( NSInteger alertTag, NSInteger viewTag );
void AlertSetShowsHelp( NSInteger tag, Boolean flag );
CFStringRef AlertHelpAnchor( NSInteger tag );
void AlertSetHelpAnchor( NSInteger tag, CFStringRef anchorName );
void AlertSetShowsSuppressionButton( NSInteger tag, Boolean flag );
NSCellStateValue AlertSuppressionButtonState( NSInteger tag );
void AlertSuppressionButtonSetState( NSInteger tag, NSCellStateValue value );
void AlertSuppressionButtonSetTitle( NSInteger tag, CFStringRef title );

CFStringRef AlertInformativeText( NSInteger tag );
void AlertSetInformativeText( NSInteger tag, CFStringRef string );
CFStringRef AlertMessageText( NSInteger tag );
void AlertSetMessageText( NSInteger tag, CFStringRef string );

void AlertSetIcon( NSInteger tag, void *inImage );
void AlertSetIconNamed( NSInteger tag, CFStringRef imageName );

// Buttons
CFArrayRef AlertButtons( NSInteger tag );
void AlertAddButtonWithTitle( NSInteger tag, CFStringRef title );

// Window
CocoaWindowRef AlertWindow( NSInteger tag );


// custom
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
void AlertClose( NSInteger tag );
#endif
void AlertRemove( NSInteger tag );
void AlertButtonSetKeyEquivalent( NSInteger alertTag, NSUInteger btnIndex, CFStringRef key );
void AlertButtonSetKeyEquivalentModifierMask( NSInteger alertTag, NSUInteger btnIndex, NSUInteger mask );


NSInteger CocoaAlert( NSInteger inTag, NSInteger inStyle, CFStringRef inMsg, CFStringRef inInfo, CFTypeRef inButtonTitles, NSInteger inSheetFlag );
