/*
 Appearance.m
 
 Bernie Wylde
 */

#import "Appearance.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000

// Name
CFStringRef AppearanceName( AppearanceRef ref )
{ return (CFStringRef)[ref name]; }

// Appearance
AppearanceRef AppearanceNamed( CFStringRef name )
{ return [NSAppearance appearanceNamed:(NSString *)name]; }

// Most appropriate appearance
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101400 && __MAC_OS_X_VERSION_MIN_REQUIRED >= 101400
CFStringRef AppearanceBestMatchFromAppearancesWithNames( AppearanceRef ref, CFArrayRef names )
{ return (CFStringRef)[ref bestMatchFromAppearancesWithNames:(NSArray *)names]; }
#endif

// Current appearance
AppearanceRef AppearanceCurrent( void )
{ return [NSAppearance currentAppearance]; }

void AppearanceSetCurrent( AppearanceRef ref )
{ [NSAppearance setCurrentAppearance:ref]; }

// Vibrancy
Boolean AppearanceAllowsVibrancy( AppearanceRef ref )
{ return [ref allowsVibrancy]; }

#endif
