/*
 AppleScript.m
 
 Bernie Wylde
 */

#import "AppleScript.h"

// -- init --
AppleScriptRef AppleScriptWithContentsOfURL( CFURLRef url, CFDictionaryRef *errInfo )
{ return [[[NSAppleScript alloc] initWithContentsOfURL:(NSURL *)url error:(NSDictionary **)errInfo] autorelease]; }

AppleScriptRef AppleScriptWithSource( CFStringRef source )
{ return [[[NSAppleScript alloc] initWithSource:(NSString *)source] autorelease]; }

// -- info --
Boolean AppleScriptIsCompiled( AppleScriptRef script )
{ return [script isCompiled]; }

CFStringRef AppleScriptSource( AppleScriptRef script )
{ return (CFStringRef)[script source]; }

CFAttributedStringRef AppleScriptRichTextSource( AppleScriptRef script )
{ return (CFAttributedStringRef)[script richTextSource]; }

// -- compile and execute --
Boolean AppleScriptCompile( AppleScriptRef script, CFDictionaryRef *errInfo )
{ return [script compileAndReturnError:(NSDictionary **)errInfo]; }

NSAppleEventDescriptor *AppleScriptExecute( AppleScriptRef script, CFDictionaryRef *errInfo )
{ return [script executeAndReturnError:(NSDictionary **)errInfo]; }

//NSAppleEventDescriptor *AppleScriptExecuteAppleEvent( AppleScriptRef script, NSAppleEventDescriptor *aeDesc, CFDictionaryRef *errorInfo );

