/*
 Box.h
 
 Bernie Wylde
 */

#import <AppKit/AppKit.h>

#pragma mark - subclass
@interface BoxSC : NSBox
@end


@interface NSBox (Additions)
@property (nonatomic,retain) NSNumber *tagNumber;
- (NSInteger)tag;
- (void)setTag:(NSInteger)tag;
@end

#pragma mark - functions
NSBox *BoxWithTag( NSInteger tag );
BOOL BoxExists( NSInteger tag );

CGRect BoxBorderRect( NSInteger tag );
NSBoxType BoxType( NSInteger tag );
void BoxSetType( NSInteger tag, NSBoxType type );
NSBorderType BoxBorderType( NSInteger tag );
void BoxSetBorderType( NSInteger tag, NSBorderType type );

CFStringRef BoxTitle( NSInteger tag );
void BoxSetTitle( NSInteger tag, CFStringRef title );

NSTitlePosition BoxTitlePosition( NSInteger tag );
void BoxSetTitlePosition( NSInteger tag, NSTitlePosition position );
CGRect BoxTitleRect( NSInteger tag );
ColorRef BoxBorderColor( NSInteger tag );
void BoxSetBorderColor( NSInteger tag, ColorRef col );
ColorRef BoxFillColor( NSInteger tag );
void BoxSetFillColor( NSInteger tag, ColorRef col );
CGFloat BoxBorderWidth( NSInteger tag );
void BoxSetBorderWidth( NSInteger tag, CGFloat width );
CGFloat BoxCornerRadius( NSInteger tag );
void BoxSetCornerRadius( NSInteger tag, CGFloat radius );
Boolean BoxIsTransparent( NSInteger tag );
void BoxSetTransparent( NSInteger tag, Boolean flag );
CTNSFontRef BoxTitleFont( NSInteger tag );
void BoxSetTitleFont( NSInteger tag, CTNSFontRef inFont );
void BoxSizeToFit( NSInteger tag );
CGSize BoxContentViewMargins( NSInteger tag );
void BoxSetContentViewMargins( NSInteger tag, CGSize size );
void BoxSetFrameFromContentFrame( NSInteger tag, CGRect contentFrame );

// custom
void BoxSetTitleFontWithName( NSInteger tag, CFStringRef inName, CGFloat size );

// Init
BoxRef BoxInit( NSInteger tag, CGRect r );

// statement
void CocoaBox( NSInteger inTag, CFStringRef inTitle, CGRect inRect, NSInteger inType, NSInteger inWndTag );

