/*
 Bundle.h
 
 Bernie Wylde
 */

#import <AppKit/AppKit.h>

///////////////////////////////////////////////////
// -- standard objects --
BundleRef BundleMain( void );

// -- init --
BundleRef BundleWithURL( CFURLRef url );

// -- loading nib files --

// -- resource files --
CFURLRef BundleURLForResource( BundleRef bundle, CFStringRef name, CFStringRef extension, CFStringRef subdirectory );
CFArrayRef BundleURLsForResources( BundleRef bundle, CFStringRef extension, CFStringRef subdirectory );

// -- image --
CFURLRef BundleURLForImageResource( BundleRef bundle, CFStringRef name );
ImageRef BundleImageForResource( BundleRef bundle, CFStringRef name );

// -- sound --
CFURLRef BundleURLForSoundResource( BundleRef bundle, CFStringRef name );

// -- localized strings --
CFStringRef BundleLocalizedString( BundleRef bundle, CFStringRef key, CFStringRef value, CFStringRef table );

// -- context help --
CFAttributedStringRef BundleContextHelp( BundleRef bundle, CFStringRef key );

// -- standard bundle directories --
CFURLRef BundleResourceURL( BundleRef bundle );
CFURLRef BundleExecutableURL( BundleRef bundle );
CFURLRef BundlePrivateFrameworksURL( BundleRef bundle );
CFURLRef BundleSharedFrameworksURL( BundleRef bundle );
CFURLRef BundleBuiltInPlugInsURL( BundleRef bundle );
CFURLRef BundleURLForAuxiliaryExecutable( BundleRef bundle, CFStringRef name );
CFURLRef BundleSharedSupportURL( BundleRef bundle );
CFURLRef BundleAppStoreReceiptURL( BundleRef bundle );

// -- bundle info --
CFURLRef BundleURL( BundleRef bundle );
CFStringRef BundleIdentifier( BundleRef bundle );
CFDictionaryRef BundleInfoDictionary( BundleRef bundle );
CFTypeRef BundleObjectForInfoDictionaryKey( BundleRef bundle, CFStringRef key );

// -- localization info --
CFArrayRef BundleLocalizations( BundleRef bundle );
CFArrayRef BundlePreferredLocalizations( BundleRef bundle );
CFStringRef BundleDevelopmentLocalization( BundleRef bundle );
CFDictionaryRef BundleLocalizedInfoDictionary( BundleRef bundle );
CFArrayRef BundlePreferredLocalizationsFromArray( CFArrayRef localizationsArray );
CFArrayRef BundlePreferredLocalizationsFromArrayForPreferences( CFArrayRef localizationsArray, CFArrayRef preferencesArray );

// -- preservation priority --

// -- classes --

// -- loading code from bundle --

// -- convenience --
