/*
 Button.h
 
 Bernie Wylde
 */

#import <AppKit/AppKit.h>

#pragma mark - subclass
@interface ButtonSC : NSButton
@end

#pragma mark - functions
NSButton *ButtonWithTag( NSInteger tag );
BOOL ButtonExists( NSInteger tag );

void ButtonSetType( NSInteger tag, NSButtonType type );
void ButtonGetPeriodicDelay( NSInteger tag, float *delay, float *interval );
void ButtonSetPeriodicDelay( NSInteger tag, float delay, float interval );
CFStringRef ButtonAlternateTitle( NSInteger tag );
void ButtonSetAlternateTitle( NSInteger tag, CFStringRef title );
CFAttributedStringRef ButtonAttributedTitle( NSInteger tag );
void ButtonSetAttributedTitle( NSInteger tag, CFAttributedStringRef title );
CFAttributedStringRef ButtonAttributedAlternateTitle( NSInteger tag );
void ButtonSetAttributedAlternateTitle( NSInteger tag, CFAttributedStringRef title );
CFStringRef ButtonTitle( NSInteger tag );
void ButtonSetTitle( NSInteger tag, CFStringRef title );
SoundRef ButtonSound( NSInteger tag);
void ButtonSetSound( NSInteger tag, SoundRef snd );
void ButtonSetSoundNamed( NSInteger tag, CFStringRef sndName );

ImageRef ButtonImage( NSInteger tag );
void ButtonSetImage( NSInteger tag, void *inImage );
void ButtonSetImageNamed( NSInteger tag, CFStringRef imageName );
ImageRef ButtonAlternateImage( NSInteger tag );
void ButtonSetAlternateImage( NSInteger tag, void *inImage );
void ButtonSetAlternateImageNamed( NSInteger tag, CFStringRef imageName );
NSCellImagePosition ButtonImagePosition( NSInteger tag );
void ButtonSetImagePosition( NSInteger tag, NSCellImagePosition position );
Boolean ButtonIsBordered( NSInteger tag );
void ButtonSetBordered( NSInteger tag, Boolean flag );
Boolean ButtonIsTransparent( NSInteger tag );
void ButtonSetTransparent( NSInteger tag, Boolean flag );
NSBezelStyle ButtonBezelStyle( NSInteger tag );
void ButtonSetBezelStyle( NSInteger tag, NSBezelStyle style );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101201
ColorRef ButtonBezelColor( NSInteger tag );
void ButtonSetBezelColor( NSInteger tag, ColorRef col );
#endif

Boolean ButtonShowsBorderOnlyWhileMouseInside( NSInteger tag );
void ButtonSetShowsBorderOnlyWhileMouseInside( NSInteger tag, Boolean flag );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
Boolean ButtonImageHugsTitle( NSInteger tag );
void ButtonSetImageHugsTitle( NSInteger tag, Boolean flag );
#endif

NSImageScaling ButtonImageScaling( NSInteger tag );
void ButtonSetImageScaling( NSInteger tag, NSImageScaling scaling );

Boolean ButtonAllowsMixedState( NSInteger tag );
void ButtonSetAllowsMixedState( NSInteger tag, Boolean flag );
NSCellStateValue ButtonState( NSInteger tag );
void ButtonSetState( NSInteger tag, NSCellStateValue state );
void ButtonSetNextState( NSInteger tag );
void ButtonHighlight( NSInteger tag, Boolean flag );

CFStringRef ButtonKeyEquivalent( NSInteger tag );
void ButtonSetKeyEquivalent( NSInteger tag, CFStringRef key );
NSUInteger ButtonKeyEquivalentModifierMask( NSInteger tag );
void ButtonSetKeyEquivalentModifierMask( NSInteger tag, NSUInteger mask );

// -- NSButtonCell methods --
CTNSFontRef ButtonKeyEquivalentFont( NSInteger tag );
void ButtonSetKeyEquivalentFont( NSInteger tag, CTNSFontRef font );

void ButtonSetBackgroundColor( NSInteger tag, ColorRef col );
Boolean ButtonImageDimsWhenDisabled( NSInteger tag );
void ButtonSetImageDimsWhenDisabled( NSInteger tag, Boolean flag );
Boolean ButtonIsOpaque( NSInteger tag );
void ButtonSetHighlightsBy( NSInteger tag, NSUInteger mask );
void ButtonPerformClick( NSInteger tag );

// custom
void ButtonClose( NSInteger tag );
void ButtonSetTitleColor( NSInteger tag, ColorRef col );


// Init
ButtonRef ButtonInit( NSInteger tag, CGRect r );

#pragma mark - button statement
void CocoaButton( NSInteger inTag, NSInteger inEnabled, NSInteger inState, CFStringRef inTitle, CGRect inRect, NSInteger inType, NSInteger inStyle, NSInteger inWndTag );

