/*
 ByteCountFormatter.h
 
 Bernie Wylde
 */

#import <AppKit/AppKit.h>

#if __MAC_OS_X_VERSION_MAX_ALLOWED > 1080

// - create -
ByteCountFormatterRef ByteCountFormatterInit( void );

// - string from byte count -
CFStringRef ByteCountFormatterStringFromByteCount( SInt64 byteCount, NSByteCountFormatterCountStyle style );

// - formatting styles -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
NSFormattingContext ByteCountFormatterFormattingContext( ByteCountFormatterRef ref );
void ByteCountFormatterSetFormattingContext( ByteCountFormatterRef ref, NSFormattingContext ctx );
#endif
NSByteCountFormatterCountStyle ByteCountFormatterCountStyle( ByteCountFormatterRef ref );
void ByteCountFormatterSetCountStyle( ByteCountFormatterRef ref, NSByteCountFormatterCountStyle style );
Boolean ByteCountFormatterAllowsNonnumericFormatting( ByteCountFormatterRef ref );
void ByteCountFormatterSetAllowsNonnumericFormatting( ByteCountFormatterRef ref, Boolean flag );
Boolean ByteCountFormatterIncludesActualByteCount( ByteCountFormatterRef ref );
void ByteCountFormatterSetIncludesActualByteCount( ByteCountFormatterRef ref, Boolean flag );
Boolean ByteCountFormatterIsAdaptive( ByteCountFormatterRef ref );
void ByteCountFormatterSetAdaptive( ByteCountFormatterRef ref, Boolean flag );
NSByteCountFormatterUnits ByteCountFormatterAllowedUnits( ByteCountFormatterRef ref );
void ByteCountFormatterSetAllowedUnits( ByteCountFormatterRef ref, NSByteCountFormatterUnits units );
Boolean ByteCountFormatterIncludesCount( ByteCountFormatterRef ref );
void ByteCountFormatterSetIncludesCount( ByteCountFormatterRef ref, Boolean flag );
Boolean ByteCountFormatterZeroPadsFractionDigits( ByteCountFormatterRef ref );
void ByteCountFormatterSetZeroPadsFractionDigits( ByteCountFormatterRef ref, Boolean flag );
#endif

