/*
 ByteCountFormatter.M
 
 Bernie Wylde
 */

#import "ByteCountFormatter.h"


#if __MAC_OS_X_VERSION_MAX_ALLOWED > 1080

// - create -
ByteCountFormatterRef ByteCountFormatterInit( void )
{ return [[[NSByteCountFormatter alloc] init] autorelease]; }

// - string from byte count -
CFStringRef ByteCountFormatterStringFromByteCount( SInt64 byteCount, NSByteCountFormatterCountStyle style )
{ return (CFStringRef)[NSByteCountFormatter stringFromByteCount:byteCount countStyle:style]; }

// - formatting styles -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
NSFormattingContext ByteCountFormatterFormattingContext( ByteCountFormatterRef ref )
{ return [ref formattingContext]; }

void ByteCountFormatterSetFormattingContext( ByteCountFormatterRef ref, NSFormattingContext ctx )
{ [ref setFormattingContext:ctx]; }
#endif

NSByteCountFormatterCountStyle ByteCountFormatterCountStyle( ByteCountFormatterRef ref )
{ return [ref countStyle]; }

void ByteCountFormatterSetCountStyle( ByteCountFormatterRef ref, NSByteCountFormatterCountStyle style )
{ [ref setCountStyle:style]; }

Boolean ByteCountFormatterAllowsNonnumericFormatting( ByteCountFormatterRef ref )
{ return [ref allowsNonnumericFormatting]; }

void ByteCountFormatterSetAllowsNonnumericFormatting( ByteCountFormatterRef ref, Boolean flag )
{ [ref setAllowsNonnumericFormatting:flag]; }

Boolean ByteCountFormatterIncludesActualByteCount( ByteCountFormatterRef ref )
{ return [ref includesActualByteCount]; }

void ByteCountFormatterSetIncludesActualByteCount( ByteCountFormatterRef ref, Boolean flag )
{ [ref setIncludesActualByteCount:flag]; }

Boolean ByteCountFormatterIsAdaptive( ByteCountFormatterRef ref )
{ return [ref isAdaptive]; }

void ByteCountFormatterSetAdaptive( ByteCountFormatterRef ref, Boolean flag )
{ [ref setAdaptive:flag]; }

NSByteCountFormatterUnits ByteCountFormatterAllowedUnits( ByteCountFormatterRef ref )
{ return [ref allowedUnits]; }

void ByteCountFormatterSetAllowedUnits( ByteCountFormatterRef ref, NSByteCountFormatterUnits units )
{ [ref setAllowedUnits:units]; }

Boolean ByteCountFormatterIncludesCount( ByteCountFormatterRef ref )
{ return [ref includesCount]; }

void ByteCountFormatterSetIncludesCount( ByteCountFormatterRef ref, Boolean flag )
{ [ref setIncludesCount:flag]; }

Boolean ByteCountFormatterZeroPadsFractionDigits( ByteCountFormatterRef ref )
{ return [ref zeroPadsFractionDigits]; }

void ByteCountFormatterSetZeroPadsFractionDigits( ByteCountFormatterRef ref, Boolean flag )
{ [ref setZeroPadsFractionDigits:flag]; }
#endif

