/*
  CAAnimation.h

  Bernie Wylde 20180828
*/
// Create
CAAnimationRef CAAnimationInit( void );

// Attributes
Boolean CAAnimationIsRemovedOnCompletion( CAAnimationRef ref );
void CAAnimationSetRemovedOnCompletion( CAAnimationRef ref, Boolean value );
CAMediaTimingFunctionRef CAAnimationTimingFunction( CAAnimationRef ref );
void CAAnimationSetTimingFunction( CAAnimationRef ref, CAMediaTimingFunctionRef value );

// Default values
CFTypeRef CAAnimationDefaultValueForKey( void );
void CAAnimationSetDefaultValueForKey( CFTypeRef value );

// Delegate
//CFTypeRef CAAnimationDelegate( CAAnimationRef ref );
//void CAAnimationSetDelegate( CAAnimationRef ref, CFTypeRef value );

// Archiving
Boolean CAAnimationShouldArchiveValueForKey( CAAnimationRef ref, CFStringRef key );

/*
 CABasicAnimation.h 
 */
// Create
CABasicAnimationRef CABasicAnimationWithKeyPath( CFStringRef path );

// Interpolation values
CFTypeRef CABasicAnimationFromValue( CABasicAnimationRef ref );
void CABasicAnimationSetFromValue( CABasicAnimationRef ref, CFTypeRef value );
CFTypeRef CABasicAnimationToValue( CABasicAnimationRef ref );
void CABasicAnimationSetToValue( CABasicAnimationRef ref, CFTypeRef value );
CFTypeRef CABasicAnimationByValue( CABasicAnimationRef ref );
void CABasicAnimationSetByValue( CABasicAnimationRef ref, CFTypeRef value );

/*
 CAKeyframeAnimation.h
 */
// Create
CAKeyframeAnimationRef CAKeyframeAnimationWithKeyPath( CFStringRef path );

// Values
CFArrayRef CAKeyframeAnimationValues( CAKeyframeAnimationRef ref );
void CAKeyframeAnimationSetValues( CAKeyframeAnimationRef ref, CFArrayRef value );
CGPathRef CAKeyframeAnimationPath( CAKeyframeAnimationRef ref );
void CAKeyframeAnimationSetPath( CAKeyframeAnimationRef ref, CGPathRef value );

// Timing
CFArrayRef CAKeyframeAnimationKeyTimes( CAKeyframeAnimationRef ref );
void CAKeyframeAnimationSetKeyTimes( CAKeyframeAnimationRef ref, CFArrayRef value );
CFArrayRef CAKeyframeAnimationTimingFunctions( CAKeyframeAnimationRef ref );
void CAKeyframeAnimationSetTimingFunctions( CAKeyframeAnimationRef ref, CFArrayRef value );
CFStringRef CAKeyframeAnimationCalculationMode( CAKeyframeAnimationRef ref );
void CAKeyframeAnimationSetCalculationMode( CAKeyframeAnimationRef ref, CFStringRef value );

// Rotation mode
CFStringRef CAKeyframeAnimationRotationMode( CAKeyframeAnimationRef ref );
void CAKeyframeAnimationSetRotationMode( CAKeyframeAnimationRef ref, CFStringRef value );

// Cubic mode
CFArrayRef CAKeyframeAnimationTensionValues( CAKeyframeAnimationRef ref );
void CAKeyframeAnimationSetTensionValues( CAKeyframeAnimationRef ref, CFArrayRef value );
CFArrayRef CAKeyframeAnimationContinuityValues( CAKeyframeAnimationRef ref );
void CAKeyframeAnimationSetContinuityValues( CAKeyframeAnimationRef ref, CFArrayRef value );
CFArrayRef CAKeyframeAnimationBiasValues( CAKeyframeAnimationRef ref );
void CAKeyframeAnimationSetBiasValues( CAKeyframeAnimationRef ref, CFArrayRef value );

/*
 CAPropertyAnimation.h
 */
// Create
CAPropertyAnimationRef CAPropertyAnimationWithKeyPath( CFStringRef path );

// Key path
CFStringRef CAPropertyAnimationKeyPath( CAPropertyAnimationRef ref );
void CAPropertyAnimationSetKeyPath( CAPropertyAnimationRef ref, CFStringRef value );

// Property value calculation behavior
Boolean CAPropertyAnimationIsCumulative( CAPropertyAnimationRef ref );
void CAPropertyAnimationSetCumulative( CAPropertyAnimationRef ref, Boolean value );
Boolean CAPropertyAnimationIsAdditive( CAPropertyAnimationRef ref );
void CAPropertyAnimationSetAdditive( CAPropertyAnimationRef ref, Boolean value );
CAValueFunction *CAPropertyAnimationValueFunction( CAPropertyAnimationRef ref );
void CAPropertyAnimationSetValueFunction( CAPropertyAnimationRef ref, CAValueFunctionRef value );

/*
 CASpringAnimation.h
 */
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
// Create
CASpringAnimationRef CASpringAnimationWithKeyPath( CFStringRef path );

// Attributes
CGFloat CASpringAnimationDamping( CASpringAnimationRef ref );
void CASpringAnimationSetDamping( CASpringAnimationRef ref, CGFloat value );
CGFloat CASpringAnimationInitialVelocity( CASpringAnimationRef ref );
void CASpringAnimationSetInitialVelocity( CASpringAnimationRef ref, CGFloat value );
CGFloat CASpringAnimationMass( CASpringAnimationRef ref );
void CASpringAnimationSetMass( CASpringAnimationRef ref, CGFloat value );
CFTimeInterval CASpringAnimationSettlingDuration( CASpringAnimationRef ref );
CGFloat CASpringAnimationStiffness( CASpringAnimationRef ref );
void CASpringAnimationSetStiffness( CASpringAnimationRef ref, CGFloat value );
#endif

/*
 CATransition
 */
// Create
CATransitionRef CATransitionAnimation( void );

// Start and end point
float CATransitionStartProgress( CATransitionRef ref );
void CATransitionSetStartProgress( CATransitionRef ref, float value );
float CATransitionEndProgress( CATransitionRef ref );
void CATransitionSetEndProgress( CATransitionRef ref, float value );

// Properties
CFStringRef CATransitiontype( CATransitionRef ref );// lowercase 't' to avoid clash with var type in macOS 10.14+
void CATransitionSetType( CATransitionRef ref, CFStringRef type );
CFStringRef CATransitionsubtype( CATransitionRef ref );// lowercase 's' to avoid clash with var type in macOS 10.14+
void CATransitionSetSubtype( CATransitionRef ref, CFStringRef subtype );

// Filter
CFTypeRef CATransitionFilter( CATransitionRef ref );
void CATransitionSetFilter( CATransitionRef ref, CFTypeRef filter );
