/*
  CAAnimation.m

  Bernie Wylde 20180828
*/
#import "CAAnimation.h"

// Create
CAAnimationRef CAAnimationInit( void )
{ return [CAAnimation animation]; }

// Attributes
Boolean CAAnimationIsRemovedOnCompletion( CAAnimationRef ref )
{ return [ref isRemovedOnCompletion]; }

void CAAnimationSetRemovedOnCompletion( CAAnimationRef ref, Boolean value )
{ [ref setRemovedOnCompletion:value]; }

CAMediaTimingFunctionRef CAAnimationTimingFunction( CAAnimationRef ref )
{ return [ref timingFunction]; }

void CAAnimationSetTimingFunction( CAAnimationRef ref, CAMediaTimingFunctionRef value )
{ [ref setTimingFunction:value]; }

// Delegate
//CFTypeRef CAAnimationDelegate( CAAnimationRef ref )
//{ return (CFTypeRef)[ref delegate]; }
//
//void CAAnimationSetDelegate( CAAnimationRef ref, CFTypeRef value )
//{ [ref setDelegate:(id)value]; }

// Archiving
Boolean CAAnimationShouldArchiveValueForKey( CAAnimationRef ref, CFStringRef key )
{ return [ref shouldArchiveValueForKey:(NSString *)key]; }

/*
 CABasicAnimation.m
 */
// Create
CABasicAnimationRef CABasicAnimationWithKeyPath( CFStringRef path )
{ return [CABasicAnimation animationWithKeyPath:(NSString *)path]; }

// Interpolation values
CFTypeRef CABasicAnimationFromValue( CABasicAnimationRef ref )
{ return (CFTypeRef)[ref fromValue]; }

void CABasicAnimationSetFromValue( CABasicAnimationRef ref, CFTypeRef value )
{ [ref setFromValue:(id)value]; }

CFTypeRef CABasicAnimationToValue( CABasicAnimationRef ref )
{ return (CFTypeRef)[ref toValue]; }

void CABasicAnimationSetToValue( CABasicAnimationRef ref, CFTypeRef value )
{ [ref setToValue:(id)value]; }

CFTypeRef CABasicAnimationByValue( CABasicAnimationRef ref )
{ return (CFTypeRef)[ref byValue]; }

void CABasicAnimationSetByValue( CABasicAnimationRef ref, CFTypeRef value )
{ [ref setByValue:(id)value]; }



/*
 CAKeyframeAnimation.m
 */
// Create
CAKeyframeAnimationRef CAKeyframeAnimationWithKeyPath( CFStringRef path )
{ return [CAKeyframeAnimation animationWithKeyPath:(NSString *)path]; }

// Values
CFArrayRef CAKeyframeAnimationValues( CAKeyframeAnimationRef ref )
{ return (CFArrayRef)[ref values]; }

void CAKeyframeAnimationSetValues( CAKeyframeAnimationRef ref, CFArrayRef value )
{ [ref setValues:(NSArray *)value]; }

CGPathRef CAKeyframeAnimationPath( CAKeyframeAnimationRef ref )
{ return [ref path]; }

void CAKeyframeAnimationSetPath( CAKeyframeAnimationRef ref, CGPathRef value )
{ [ref setPath:value]; }

// Timing
CFArrayRef CAKeyframeAnimationKeyTimes( CAKeyframeAnimationRef ref )
{ return (CFArrayRef)[ref keyTimes]; }

void CAKeyframeAnimationSetKeyTimes( CAKeyframeAnimationRef ref, CFArrayRef value )
{ [ref setKeyTimes:(NSArray *)value]; }

CFArrayRef CAKeyframeAnimationTimingFunctions( CAKeyframeAnimationRef ref )
{ return (CFArrayRef)[ref timingFunctions]; }

void CAKeyframeAnimationSetTimingFunctions( CAKeyframeAnimationRef ref, CFArrayRef value )
{ [ref setTimingFunctions:(NSArray *)value]; }

CFStringRef CAKeyframeAnimationCalculationMode( CAKeyframeAnimationRef ref )
{ return (CFStringRef)[ref calculationMode]; }

void CAKeyframeAnimationSetCalculationMode( CAKeyframeAnimationRef ref, CFStringRef value )
{ [ref setCalculationMode:(NSString *)value]; }

// Rotation mode
CFStringRef CAKeyframeAnimationRotationMode( CAKeyframeAnimationRef ref )
{ return (CFStringRef)[ref rotationMode]; }

void CAKeyframeAnimationSetRotationMode( CAKeyframeAnimationRef ref, CFStringRef value )
{ [ref setRotationMode:(NSString *)value]; }

// Cubic mode
CFArrayRef CAKeyframeAnimationTensionValues( CAKeyframeAnimationRef ref )
{ return (CFArrayRef)[ref tensionValues]; }

void CAKeyframeAnimationSetTensionValues( CAKeyframeAnimationRef ref, CFArrayRef value )
{ [ref setTensionValues:(NSArray *)value]; }

CFArrayRef CAKeyframeAnimationContinuityValues( CAKeyframeAnimationRef ref )
{ return (CFArrayRef)[ref continuityValues]; }

void CAKeyframeAnimationSetContinuityValues( CAKeyframeAnimationRef ref, CFArrayRef value )
{ [ref setContinuityValues:(NSArray *)value]; }

CFArrayRef CAKeyframeAnimationBiasValues( CAKeyframeAnimationRef ref )
{ return (CFArrayRef)[ref biasValues]; }

void CAKeyframeAnimationSetBiasValues( CAKeyframeAnimationRef ref, CFArrayRef value )
{ [ref setBiasValues:(NSArray *)value]; }

/*
 CAPropertyAnimation.m
 */
// Create
CAPropertyAnimationRef CAPropertyAnimationWithKeyPath( CFStringRef path )
{ return [CAPropertyAnimation animationWithKeyPath:(NSString *)path]; }

// Key path
CFStringRef CAPropertyAnimationKeyPath( CAPropertyAnimationRef ref )
{ return (CFStringRef)[ref keyPath]; }

void CAPropertyAnimationSetKeyPath( CAPropertyAnimationRef ref, CFStringRef value )
{ [ref setKeyPath:(NSString *)value]; }

// Property value calculation behavior
Boolean CAPropertyAnimationIsCumulative( CAPropertyAnimationRef ref )
{ return [ref isCumulative]; }

void CAPropertyAnimationSetCumulative( CAPropertyAnimationRef ref, Boolean value )
{ [ref setCumulative:value]; }

Boolean CAPropertyAnimationIsAdditive( CAPropertyAnimationRef ref )
{ return [ref isAdditive]; }

void CAPropertyAnimationSetAdditive( CAPropertyAnimationRef ref, Boolean value )
{ [ref setAdditive:value]; }

CAValueFunction *CAPropertyAnimationValueFunction( CAPropertyAnimationRef ref )
{ return [ref valueFunction]; }

void CAPropertyAnimationSetValueFunction( CAPropertyAnimationRef ref, CAValueFunctionRef value )
{ [ref setValueFunction:value]; }

/*
 CASpringAnimation.m
 */
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
// Create
CASpringAnimationRef CASpringAnimationWithKeyPath( CFStringRef path )
{ return [CASpringAnimation animationWithKeyPath:(NSString *)path]; }

// Attributes
CGFloat CASpringAnimationDamping( CASpringAnimationRef ref )
{ return [ref damping]; }

void CASpringAnimationSetDamping( CASpringAnimationRef ref, CGFloat value )
{ [ref setDamping:value]; }

CGFloat CASpringAnimationInitialVelocity( CASpringAnimationRef ref )
{ return [ref initialVelocity]; }

void CASpringAnimationSetInitialVelocity( CASpringAnimationRef ref, CGFloat value )
{ [ref setInitialVelocity:value]; }

CGFloat CASpringAnimationMass( CASpringAnimationRef ref )
{ return [ref mass]; }

void CASpringAnimationSetMass( CASpringAnimationRef ref, CGFloat value )
{ [ref setMass:value]; }

CFTimeInterval CASpringAnimationSettlingDuration( CASpringAnimationRef ref )
{ return [ref settlingDuration]; }

CGFloat CASpringAnimationStiffness( CASpringAnimationRef ref )
{ return [ref stiffness]; }

void CASpringAnimationSetStiffness( CASpringAnimationRef ref, CGFloat value )
{ [ref setStiffness:value]; }
#endif  // __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100

/*
 CATransition
 */
// Create
CATransitionRef CATransitionAnimation( void )
{ return [CATransition animation]; }

// Start and end point
float CATransitionStartProgress( CATransitionRef ref )
{ return [ref startProgress]; }

void CATransitionSetStartProgress( CATransitionRef ref, float value )
{ [ref setStartProgress:value]; }

float CATransitionEndProgress( CATransitionRef ref )
{ return [ref endProgress]; }

void CATransitionSetEndProgress( CATransitionRef ref, float value )
{ [ref setEndProgress:value]; }

// Properties
CFStringRef CATransitiontype( CATransitionRef ref )// lowercase 't' to avoid clash with var type in macOS 10.14+
{ return (CFStringRef)[ref type]; }

void CATransitionSetType( CATransitionRef ref, CFStringRef type )
{ [ref setType:(NSString *)type]; }

CFStringRef CATransitionsubtype( CATransitionRef ref )// lowercase 's' to avoid clash with var type in macOS 10.14+
{ return (CFStringRef)[ref subtype]; }

void CATransitionSetSubtype( CATransitionRef ref, CFStringRef subtype )
{ [ref setSubtype:(NSString *)subtype]; }

// Filter
CFTypeRef CATransitionFilter( CATransitionRef ref )
{ return (CFTypeRef)[ref filter]; }

void CATransitionSetFilter( CATransitionRef ref, CFTypeRef filter )
{ [ref setFilter:(id)filter]; }
