/*
 CAGradientLayer.h
 
 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// - init -
CAGradientLayerRef CAGradientLayerInit( void );

// - style -
CFArrayRef CAGradientLayerColors( CAGradientLayerRef layer );
void CAGradientLayerSetColors( CAGradientLayerRef layer, CFArrayRef cols );
CFArrayRef CAGradientLayerLocations( CAGradientLayerRef layer );
void CAGradientLayerSetLocations( CAGradientLayerRef layer, CFArrayRef locations );
CGPoint CAGradientEndPoint( CAGradientLayerRef layer );
void CAGradientLayerSetEndPoint( CAGradientLayerRef layer, CGPoint pt );
CGPoint CAGradientStartPoint( CAGradientLayerRef layer );
void CAGradientLayerSetStartPoint( CAGradientLayerRef layer, CGPoint pt );
CFStringRef CAGradientType( CAGradientLayerRef layer );
void CAGradientLayerSetType( CAGradientLayerRef layer, CFStringRef type );

// - convenience -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1080
CAGradientLayerRef CAGradientLayerWithStartEndColors( CGRect r, ColorRef startColor, CGPoint startPt, ColorRef endColor, CGPoint endPt );
#endif

