/*
 CALayer.h
 
 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// delegate method events
//enum {
//    CALayerDisplay = 2500,
//    CALayerDraw,
//    CALayerWillDraw,
//    CALayerLayoutSublayers,
//    CALayerAction
//};

//typedef void (*CocoaCALayerDelegateCallbackType)(NSInteger,CALayerRef,CGContextRef,void *);
//
//@interface CocoaCALayerDelegate : NSObject// <CALayerDelegate>
//@end

//CocoaCALayerDelegate *CocoaCALayerDelegateGet( void );

//@interface CALayer (Additions)
//@property (nonatomic,retain) NSValue *callbackValue;
//@property (nonatomic,retain) NSValue *userDataValue;
//
//- (CocoaCALayerDelegateCallbackType)cocoaCALayerCallback;
//- (void *)cocoaCALayerUserData;
//- (void)setCocoaCALayerCallback:(CocoaCALayerDelegateCallbackType)cb;
//- (void)setCocoaCALayerUserData:(void *)ud;
//@end


// - create -
CALayerRef CALayerInit( void );

// - related layer objects -

// - delegate -
//void CALayerSetDelegateCallback( CALayerRef layer, void *callback, void *userData );

// - content -
void *CALayerContents( CALayerRef layer );
void CALayerSetContents( CALayerRef layer, void *contents );
CGRect CALayerContentsRect( CALayerRef layer );
void CALayerSetContentsRect( CALayerRef layer, CGRect r );
CGRect CALayerContentsCenter( CALayerRef layer );
void CALayerSetContentsCenter( CALayerRef layer, CGRect r );

// - appearance -
CFStringRef caLayerContentsGravity( CALayerRef layer );
void CALayerSetContentsGravity( CALayerRef layer, CFStringRef gravity );

float CALayerOpacity( CALayerRef layer );
void CALayerSetOpacity( CALayerRef layer, float opacity );
Boolean CALayerIsHidden( CALayerRef layer );
void CALayerSetHidden( CALayerRef layer, Boolean flag );

Boolean CALayerMasksToBounds( CALayerRef layer );
void CALayerSetMasksToBounds( CALayerRef layer, Boolean flag );
CALayerRef CALayerMask( CALayerRef layer );
void CALayerSetMask( CALayerRef layer, CALayerRef mask );
Boolean CALayerIsDoubleSided( CALayerRef layer );
void CALayerSetDoubleSided( CALayerRef layer, Boolean flag );

CGFloat CALayerCornerRadius( CALayerRef layer );
void CALayerSetCornerRadius( CALayerRef layer, CGFloat radius );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300
CACornerMask CALayerMaskedCorners( CALayerRef layer );
void CALayerSetMaskedCorners( CALayerRef layer, CACornerMask mask );
#endif

CGFloat CALayerBorderWidth( CALayerRef layer );
void CALayerSetBorderWidth( CALayerRef layer, CGFloat width );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1080
ColorRef CALayerBorderColor( CALayerRef layer );
void CALayerSetBorderColor( CALayerRef layer, ColorRef col );

ColorRef CALayerBackgroundColor( CALayerRef layer );
void CALayerSetBackgroundColor( CALayerRef layer, ColorRef col );
#endif

float CALayerShadowOpacity( CALayerRef layer );
void CALayerSetShadowOpacity( CALayerRef layer, float opacity );
CGFloat CALayerShadowRadius( CALayerRef layer );
void CALayerSetShadowRadius( CALayerRef layer, CGFloat radius );
CGSize CALayerShadowOffset( CALayerRef layer );
void CALayerSetShadowOffset( CALayerRef layer, CGSize offset );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1080
ColorRef CALayerShadowColor( CALayerRef layer );
void CALayerSetShadowColor( CALayerRef layer, ColorRef col );
#endif

CGPathRef CALayerShadowPath( CALayerRef layer );
void CALayerSetShadowPath( CALayerRef layer, CGPathRef path );
CFDictionaryRef CALayerStyle( CALayerRef layer );
void CALayerSetStyle( CALayerRef layer, CFDictionaryRef style );

// - filters -

// - rendering behavior -
Boolean CALayerIsOpaque( CALayerRef layer );
void CALayerSetOpaque( CALayerRef layer, Boolean flag );
Boolean CALayerContentsAreFlipped( CALayerRef layer );

// - geometry -
CGRect CALayerFrame( CALayerRef layer );
void CALayerSetFrame( CALayerRef layer, CGRect frame );
CGRect CALayerBounds( CALayerRef layer );
void CALayerSetBounds( CALayerRef layer, CGRect bounds );
CGPoint CALayerPosition( CALayerRef layer );
void CALayerSetPosition( CALayerRef layer, CGPoint pt );
CGFloat CALayerZPosition( CALayerRef layer );
void CALayerSetZPosition( CALayerRef layer, CGFloat position );
CGFloat CALayerAnchorPointZ( CALayerRef layer );
void CALayerSetAnchorPointZ( CALayerRef layer, CGFloat position );
CGPoint CALayerAnchorPoint( CALayerRef layer );
void CALayerSetAnchorPoint( CALayerRef layer, CGPoint pt );
CGFloat CALayerContentsScale( CALayerRef layer );
void CALayerSetContentsScale( CALayerRef layer, CGFloat scale );

// - transform -
CATransform3D CALayerTransform( CALayerRef layer );
void CALayerSetTransform( CALayerRef layer, CATransform3D t );
CATransform3D CALayerSublayerTransform( CALayerRef layer );
void CALayerSetSublayerTransform( CALayerRef layer, CATransform3D t );
CGAffineTransform CALayerAffineTransform( CALayerRef layer );
void CALayerSetAffineTransform( CALayerRef layer, CGAffineTransform t );

// - hierarchy -
CFArrayRef CALayerSublayers( CALayerRef layer );
void CALayerSetSublayers( CALayerRef layer, CFArrayRef sublayers );
CALayerRef CALayerSuperlayer( CALayerRef layer );
void CALayerAddSublayer( CALayerRef layer, CALayerRef sublayer );
void CALayerRemoveFromSuperlayer( CALayerRef layer );
void CALayerInsertSublayer( CALayerRef layer, CALayerRef otherLayer, unsigned long index );
void CALayerInsertSublayerBelow( CALayerRef layer, CALayerRef subLayer, CALayerRef sibling );
void CALayerInsertSublayerAbove( CALayerRef layer, CALayerRef subLayer, CALayerRef sibling );
void CALayerReplaceSublayer( CALayerRef layer, CALayerRef subLayer, CALayerRef otherLayer );

// - display -
void CALayerSetNeedsDisplay( CALayerRef layer );

// Animations
void CALayerAddAnimation( CALayerRef layer, CAAnimationRef anim, CFStringRef key );
CAAnimationRef CALayerAnimation( CALayerRef layer, CFStringRef key );
void CALayerRemoveAllAnimations( CALayerRef layer );
void CALayerRemoveAnimation( CALayerRef layer, CFStringRef key );
CFArrayRef CALayerAnimationKeys( CALayerRef layer );

// - resizing and layout -
NSUInteger CALayerAutoresizingMask( CALayerRef layer );
void CALayerSetAutoresizingMask( CALayerRef layer, NSUInteger mask );

// - constraints -

// - actions -

// - mapping between coordinate and time spaces -

// - hit testing -
CALayerRef CALayerHitTest( CALayerRef layer, CGPoint pt );
Boolean CALayerContainsPoint( CALayerRef layer, CGPoint pt );

// - scrolling -
CGRect CALayerVisibleRect( CALayerRef layer );
void CALayerScrollPoint( CALayerRef layer, CGPoint pt );
void CALayerScrollRectToVisible( CALayerRef layer, CGRect r );

// - identifying -
CFStringRef CALayerName( CALayerRef layer );
void CALayerSetName( CALayerRef layer, CFStringRef name );

// - key-value coding extensions -

// - initializers -

