/*
 CALayer.m
 
 Bernie Wylde
 */

#import "CALayer.h"

//@implementation CocoaCALayerDelegate

//- (void)displayLayer:(CALayer *)layer {
//    CocoaCALayerDelegateCallbackType callback = [layer cocoaCALayerCallback];
//    if ( callback ) {
//        void *userData = [layer cocoaCALayerUserData];
//        (*callback)(CALayerDisplay,layer,NULL,userData);
//    }
//}
//
//- (void)drawLayer:(CALayer *)layer inContext:(CGContextRef)ctx {
//    CocoaCALayerDelegateCallbackType callback = [layer cocoaCALayerCallback];
//    if ( callback ) {
//        void *userData = [layer cocoaCALayerUserData];
//        (*callback)(CALayerDraw,layer,ctx,userData);
//    }
//}
//
//- (void)layerWillDraw:(CALayer *)layer {
//    CocoaCALayerDelegateCallbackType callback = [layer cocoaCALayerCallback];
//    if ( callback ) {
//        void *userData = [layer cocoaCALayerUserData];
//        (*callback)(CALayerWillDraw,layer,NULL,userData);
//    }
//}
//
//- (void)layoutSublayersOfLayer:(CALayer *)layer {
//    CocoaCALayerDelegateCallbackType callback = [layer cocoaCALayerCallback];
//    if ( callback ) {
//        void *userData = [layer cocoaCALayerUserData];
//        (*callback)(CALayerLayoutSublayers,layer,NULL,userData);
//    }
//}

//- (id<CAAction>)actionForLayer:(CALayer *)layer forKey:(NSString *)event {
//
//}
//@end

//CocoaCALayerDelegate *CocoaCALayerDelegateGet( void )
//{
//    static CocoaCALayerDelegate *sCocoaCALayerDelegate = nil;
//    if ( !sCocoaCALayerDelegate ) sCocoaCALayerDelegate = [[CocoaCALayerDelegate alloc] init];
//    return sCocoaCALayerDelegate;
//}

//@implementation CALayer (Additions)
//@dynamic callbackValue;
//@dynamic userDataValue;
//
//- (CocoaCALayerDelegateCallbackType)cocoaCALayerCallback {
//    return [objc_getAssociatedObject(self, @selector(callbackValue)) pointerValue];
//}
//
//- (void *)cocoaCALayerUserData {
//    return [objc_getAssociatedObject(self, @selector(userDataValue)) pointerValue];
//}
//
//- (void)setCocoaCALayerCallback:(CocoaCALayerDelegateCallbackType)callback {
//    objc_setAssociatedObject(self, @selector(callbackValue), [NSValue valueWithPointer:callback], OBJC_ASSOCIATION_RETAIN_NONATOMIC);
//}
//
//- (void)setCocoaCALayerUserData:(void *)userData {
//    objc_setAssociatedObject(self, @selector(userDataValue), [NSValue valueWithPointer:userData], OBJC_ASSOCIATION_RETAIN_NONATOMIC);
//}
//@end


// - create -
CALayerRef CALayerInit( void )
{ return [CALayer layer]; }

// - related layer objects -

// - delegate -
//void CALayerSetDelegateCallback( CALayerRef layer, void *callback, void *userData )
//{
//    [layer setCocoaCALayerCallback:callback];
//    [layer setCocoaCALayerUserData:userData];
//    CocoaCALayerDelegate *delegate = CocoaCALayerDelegateGet();
//    [layer setDelegate:delegate];
//}

// - content -
void *CALayerContents( CALayerRef layer )
{ return (void *)[layer contents]; }

void CALayerSetContents( CALayerRef layer, void *contents )
{ [layer setContents:(id)contents]; }

CGRect CALayerContentsRect( CALayerRef layer )
{ return [layer contentsRect]; }

void CALayerSetContentsRect( CALayerRef layer, CGRect r )
{ [layer setContentsRect:r]; }

CGRect CALayerContentsCenter( CALayerRef layer )
{ return [layer contentsCenter]; }

void CALayerSetContentsCenter( CALayerRef layer, CGRect r )
{ [layer setContentsCenter:r]; }

// - appearance -
CFStringRef caLayerContentsGravity( CALayerRef layer )
{ return (CFStringRef)[layer contentsGravity]; }

void CALayerSetContentsGravity( CALayerRef layer, CFStringRef gravity )
{ [layer setContentsGravity:(NSString *)gravity]; }

float CALayerOpacity( CALayerRef layer )
{ return [layer opacity]; }

void CALayerSetOpacity( CALayerRef layer, float opacity )
{ [layer setOpacity:opacity]; }

Boolean CALayerIsHidden( CALayerRef layer )
{ return [layer isHidden]; }

void CALayerSetHidden( CALayerRef layer, Boolean flag )
{ [layer setHidden:flag]; }

Boolean CALayerMasksToBounds( CALayerRef layer )
{ return [layer masksToBounds]; }

void CALayerSetMasksToBounds( CALayerRef layer, Boolean flag )
{ [layer setMasksToBounds:flag]; }

CALayerRef CALayerMask( CALayerRef layer )
{ return [layer mask]; }

void CALayerSetMask( CALayerRef layer, CALayerRef mask )
{ [layer setMask:mask]; }

Boolean CALayerIsDoubleSided( CALayerRef layer )
{ return [layer isDoubleSided]; }

void CALayerSetDoubleSided( CALayerRef layer, Boolean flag )
{ [layer setDoubleSided:flag]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1080
ColorRef CALayerBorderColor( CALayerRef layer )
{ return [NSColor colorWithCGColor:[layer borderColor]]; }

void CALayerSetBorderColor( CALayerRef layer, ColorRef col )
{ [layer setBorderColor:[col CGColor]]; }

ColorRef CALayerBackgroundColor( CALayerRef layer )
{ return [NSColor colorWithCGColor:[layer backgroundColor]]; }

void CALayerSetBackgroundColor( CALayerRef layer, ColorRef col )
{ [layer setBackgroundColor:[col CGColor]]; }
#endif

CGFloat CALayerCornerRadius( CALayerRef layer )
{ return [layer cornerRadius]; }

void CALayerSetCornerRadius( CALayerRef layer, CGFloat radius )
{ [layer setCornerRadius:radius]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300 && __MAC_OS_X_VERSION_MIN_REQUIRED >= 101300
CACornerMask CALayerMaskedCorners( CALayerRef layer )
{ return [layer maskedCorners]; }

void CALayerSetMaskedCorners( CALayerRef layer, CACornerMask mask )
{ [layer setMaskedCorners:mask]; }
#endif

CGFloat CALayerBorderWidth( CALayerRef layer )
{ return [layer borderWidth]; }

void CALayerSetBorderWidth( CALayerRef layer, CGFloat width )
{ [layer setBorderWidth:width]; }

float CALayerShadowOpacity( CALayerRef layer )
{ return [layer shadowOpacity]; }

void CALayerSetShadowOpacity( CALayerRef layer, float opacity )
{ [layer setShadowOpacity:opacity]; }

CGFloat CALayerShadowRadius( CALayerRef layer )
{ return [layer shadowRadius]; }

void CALayerSetShadowRadius( CALayerRef layer, CGFloat radius )
{ [layer setShadowRadius:radius]; }

CGSize CALayerShadowOffset( CALayerRef layer )
{ return [layer shadowOffset]; }

void CALayerSetShadowOffset( CALayerRef layer, CGSize offset )
{ [layer setShadowOffset:offset]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1080
ColorRef CALayerShadowColor( CALayerRef layer )
{ return [NSColor colorWithCGColor:[layer shadowColor]]; }

void CALayerSetShadowColor( CALayerRef layer, ColorRef col )
{ [layer setShadowColor:[col CGColor]]; }
#endif

CGPathRef CALayerShadowPath( CALayerRef layer )
{ return [layer shadowPath]; }

void CALayerSetShadowPath( CALayerRef layer, CGPathRef path )
{ [layer setShadowPath:path]; }

CFDictionaryRef CALayerStyle( CALayerRef layer )
{ return (CFDictionaryRef)[layer style]; }

void CALayerSetStyle( CALayerRef layer, CFDictionaryRef style )
{ [layer setStyle:(NSDictionary *)style]; }

// - filters -

// - rendering behavior -
Boolean CALayerIsOpaque( CALayerRef layer )
{ return [layer isOpaque]; }

void CALayerSetOpaque( CALayerRef layer, Boolean flag )
{ [layer setOpaque:flag]; }

Boolean CALayerContentsAreFlipped( CALayerRef layer )
{ return [layer contentsAreFlipped]; }

// - geometry -
CGRect CALayerFrame( CALayerRef layer )
{ return [layer frame]; }

void CALayerSetFrame( CALayerRef layer, CGRect frame )
{ [layer setFrame:frame]; }

CGRect CALayerBounds( CALayerRef layer )
{ return [layer bounds]; }

void CALayerSetBounds( CALayerRef layer, CGRect bounds )
{ [layer setBounds:bounds]; }

CGPoint CALayerPosition( CALayerRef layer )
{ return [layer position]; }

void CALayerSetPosition( CALayerRef layer, CGPoint pt )
{ [layer setPosition:pt]; }

CGFloat CALayerZPosition( CALayerRef layer )
{ return [layer zPosition]; }

void CALayerSetZPosition( CALayerRef layer, CGFloat position )
{ [layer setZPosition:position]; }

CGFloat CALayerAnchorPointZ( CALayerRef layer )
{ return [layer anchorPointZ]; }

void CALayerSetAnchorPointZ( CALayerRef layer, CGFloat position )
{ [layer setAnchorPointZ:position]; }

CGPoint CALayerAnchorPoint( CALayerRef layer )
{ return [layer anchorPoint]; }

void CALayerSetAnchorPoint( CALayerRef layer, CGPoint pt )
{ [layer setAnchorPoint:pt]; }

CGFloat CALayerContentsScale( CALayerRef layer )
{ return [layer contentsScale]; }

void CALayerSetContentsScale( CALayerRef layer, CGFloat scale )
{ [layer setContentsScale:scale]; }

// - transform -
CATransform3D CALayerTransform( CALayerRef layer )
{ return [layer transform]; }

void CALayerSetTransform( CALayerRef layer, CATransform3D t )
{ [layer setTransform:t]; }

CATransform3D CALayerSublayerTransform( CALayerRef layer )
{ return [layer sublayerTransform]; }

void CALayerSetSublayerTransform( CALayerRef layer, CATransform3D t )
{ [layer setSublayerTransform:t]; }

CGAffineTransform CALayerAffineTransform( CALayerRef layer )
{ return [layer affineTransform]; }

void CALayerSetAffineTransform( CALayerRef layer, CGAffineTransform t )
{ [layer setAffineTransform:t]; }

// - hierarchy -
CFArrayRef CALayerSublayers( CALayerRef layer )
{ return (CFArrayRef)[layer sublayers]; }

void CALayerSetSublayers( CALayerRef layer, CFArrayRef sublayers )
{ [layer setSublayers:(NSArray *)sublayers]; }

CALayerRef CALayerSuperlayer( CALayerRef layer )
{ return [layer superlayer]; }

void CALayerAddSublayer( CALayerRef layer, CALayerRef sublayer )
{ [layer addSublayer:sublayer]; }

void CALayerRemoveFromSuperlayer( CALayerRef layer )
{ [layer removeFromSuperlayer]; }

void CALayerInsertSublayer( CALayerRef layer, CALayerRef otherLayer, unsigned long index )
{ [layer insertSublayer:otherLayer atIndex:index]; }

void CALayerInsertSublayerBelow( CALayerRef layer, CALayerRef subLayer, CALayerRef sibling )
{ [layer insertSublayer:subLayer below:sibling]; }

void CALayerInsertSublayerAbove( CALayerRef layer, CALayerRef subLayer, CALayerRef sibling )
{ [layer insertSublayer:subLayer above:sibling]; }

void CALayerReplaceSublayer( CALayerRef layer, CALayerRef subLayer, CALayerRef otherLayer )
{ [layer replaceSublayer:subLayer with:otherLayer]; }

// - display -
void CALayerSetNeedsDisplay( CALayerRef layer )
{ [layer setNeedsDisplay]; }

// Animations
void CALayerAddAnimation( CALayerRef layer, CAAnimationRef anim, CFStringRef key )
{ [layer addAnimation:anim forKey:(NSString *)key]; }

CAAnimationRef CALayerAnimation( CALayerRef layer, CFStringRef key )
{ return [layer animationForKey:(NSString *)key]; }

void CALayerRemoveAllAnimations( CALayerRef layer )
{ [layer removeAllAnimations]; }

void CALayerRemoveAnimation( CALayerRef layer, CFStringRef key )
{ [layer removeAnimationForKey:(NSString *)key]; }

CFArrayRef CALayerAnimationKeys( CALayerRef layer )
{ return (CFArrayRef)[layer animationKeys]; }

// - resizing and layout -
NSUInteger CALayerAutoresizingMask( CALayerRef layer )
{ return [layer autoresizingMask]; }

void CALayerSetAutoresizingMask( CALayerRef layer, NSUInteger mask )
{ [layer setAutoresizingMask:mask]; }

// - constraints -

// - actions -

// - mapping between coordinate and time spaces -

// - hit testing -
CALayerRef CALayerHitTest( CALayerRef layer, CGPoint pt )
{ return [layer hitTest:pt]; }

Boolean CALayerContainsPoint( CALayerRef layer, CGPoint pt )
{ return [layer containsPoint:pt]; }

// - scrolling -
CGRect CALayerVisibleRect( CALayerRef layer )
{ return [layer visibleRect]; }

void CALayerScrollPoint( CALayerRef layer, CGPoint pt )
{ [layer scrollPoint:pt]; }

void CALayerScrollRectToVisible( CALayerRef layer, CGRect r )
{ [layer scrollRectToVisible:r]; }

// - identifying -
CFStringRef CALayerName( CALayerRef layer )
{ return (CFStringRef)[layer name]; }

void CALayerSetName( CALayerRef layer, CFStringRef name )
{ [layer setName:(NSString *)name]; }

// - key-value coding extensions -

// - initializers -


