/*
  CAMediaTiming.h

  Bernie Wylde 20180828
*/

// Animation start time
CFTimeInterval CAMediaTimingBeginTime( CAMediaTimingRef ref );
void CAMediaTimingSetBeginTime( CAMediaTimingRef ref, CFTimeInterval ti );
CFTimeInterval CAMediaTimingTimeOffset( CAMediaTimingRef ref );
void CAMediaTimingSetTimeOffset( CAMediaTimingRef ref, CFTimeInterval ti );

// Repeating animations
float CAMediaTimingRepeatCount( CAMediaTimingRef ref );
void CAMediaTimingSetRepeatCount( CAMediaTimingRef ref, float count );
CFTimeInterval CAMediaTimingRepeatDuration( CAMediaTimingRef ref );
void CAMediaTimingSetRepeatDuration( CAMediaTimingRef ref, CFTimeInterval ti );

// Duration and speed
CFTimeInterval CAMediaTimingDuration( CAMediaTimingRef ref );
void CAMediaTimingSetDuration( CAMediaTimingRef ref, CFTimeInterval ti );
float CAMediaTimingSpeed( CAMediaTimingRef ref );
void CAMediaTimingSetSpeed( CAMediaTimingRef ref, float speed );

// Playback modes
Boolean CAMediaTimingAutoreverses( CAMediaTimingRef ref );
void CAMediaTimingSetAutoreverses( CAMediaTimingRef ref, Boolean flag );
CFStringRef CAMediaTimingFillmode( CAMediaTimingRef ref );// lowercase 'm' to avoid clash with var type in macOS 10.14+
void CAMediaTimingSetFillMode( CAMediaTimingRef ref, CFStringRef mode );
