/*
  CAMediaTiming.m

  Bernie Wylde 20180828
*/

#import "CAMediaTiming.h"

// Animation start time
CFTimeInterval CAMediaTimingBeginTime( CAMediaTimingRef ref )
{ return [ref beginTime]; }

void CAMediaTimingSetBeginTime( CAMediaTimingRef ref, CFTimeInterval ti )
{ [ref setBeginTime:ti]; }

CFTimeInterval CAMediaTimingTimeOffset( CAMediaTimingRef ref )
{ return [ref timeOffset]; }

void CAMediaTimingSetTimeOffset( CAMediaTimingRef ref, CFTimeInterval ti )
{ [ref setTimeOffset:ti]; }

// Repeating animations
float CAMediaTimingRepeatCount( CAMediaTimingRef ref )
{ return [ref repeatCount]; }

void CAMediaTimingSetRepeatCount( CAMediaTimingRef ref, float count )
{ [ref setRepeatCount:count]; }

CFTimeInterval CAMediaTimingRepeatDuration( CAMediaTimingRef ref )
{ return [ref repeatDuration]; }

void CAMediaTimingSetRepeatDuration( CAMediaTimingRef ref, CFTimeInterval ti )
{ [ref setRepeatDuration:ti]; }

// Duration and speed
CFTimeInterval CAMediaTimingDuration( CAMediaTimingRef ref )
{ return [ref duration]; }

void CAMediaTimingSetDuration( CAMediaTimingRef ref, CFTimeInterval ti )
{ [ref setDuration:ti]; }

float CAMediaTimingSpeed( CAMediaTimingRef ref )
{ return [ref speed]; }

void CAMediaTimingSetSpeed( CAMediaTimingRef ref, float speed )
{ [ref setSpeed:speed]; }

// Playback modes
Boolean CAMediaTimingAutoreverses( CAMediaTimingRef ref )
{ return [ref autoreverses]; }

void CAMediaTimingSetAutoreverses( CAMediaTimingRef ref, Boolean flag )
{ [ref setAutoreverses:flag]; }

CFStringRef CAMediaTimingFillmode( CAMediaTimingRef ref )// lowercase 'm' to avoid clash with var type in macOS 10.14+
{ return (CFStringRef)[ref fillMode]; }

void CAMediaTimingSetFillMode( CAMediaTimingRef ref, CFStringRef mode )
{ [ref setFillMode:(NSString *)mode]; }

