/*
 CAReplicatorLayer.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// - init -
CAReplicatorLayerRef CAReplicatorLayerInit( void );

// - display -
NSInteger CAReplicatorLayerInstanceCount( CAReplicatorLayerRef layer );
void CAReplicatorLayerSetInstanceCount( CAReplicatorLayerRef layer, NSInteger count );
CFTimeInterval CAReplicatorLayerInstanceDelay( CAReplicatorLayerRef layer );
void CAReplicatorLayerSetInstanceDelay( CAReplicatorLayerRef layer, CFTimeInterval delay );
CATransform3D CAReplicatorLayerInstanceTransform( CAReplicatorLayerRef layer );
void CAReplicatorLayerSetInstanceTransform( CAReplicatorLayerRef layer, CATransform3D t );

// - geometry -
Boolean CAReplicatorLayerPreservesDepth( CAReplicatorLayerRef layer );
void CAReplicatorLayerSetPreservesDepth( CAReplicatorLayerRef layer, Boolean flag );

// - color -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1080
ColorRef CAReplicatorLayerInstanceColor( CAReplicatorLayerRef layer );
void CAReplicatorLayerSetInstanceColor( CAReplicatorLayerRef layer, ColorRef col );
#endif
float CAReplicatorLayerInstanceRedOffset( CAReplicatorLayerRef layer );
void CAReplicatorLayerSetInstanceRedOffset( CAReplicatorLayerRef layer, float offset );
float CAReplicatorLayerInstanceGreenOffset( CAReplicatorLayerRef layer );
void CAReplicatorLayerSetInstanceGreenOffset( CAReplicatorLayerRef layer, float offset );
float CAReplicatorLayerInstanceBlueOffset( CAReplicatorLayerRef layer );
void CAReplicatorLayerSetInstanceBlueOffset( CAReplicatorLayerRef layer, float offset );
float CAReplicatorLayerInstanceAlphaOffset( CAReplicatorLayerRef layer );
void CAReplicatorLayerSetInstanceAlphaOffset( CAReplicatorLayerRef layer, float offset );
