/*
 CAReplicatorLayer.m

 Bernie Wylde
 */

#import "CAReplicatorLayer.h"

// - init -
CAReplicatorLayerRef CAReplicatorLayerInit( void )
{ return [CAReplicatorLayer layer]; }

// - display -
NSInteger CAReplicatorLayerInstanceCount( CAReplicatorLayerRef layer )
{ return [layer instanceCount]; }

void CAReplicatorLayerSetInstanceCount( CAReplicatorLayerRef layer, NSInteger count )
{ [layer setInstanceCount:count]; }

CFTimeInterval CAReplicatorLayerInstanceDelay( CAReplicatorLayerRef layer )
{ return [layer instanceDelay]; }

void CAReplicatorLayerSetInstanceDelay( CAReplicatorLayerRef layer, CFTimeInterval delay )
{ [layer setInstanceDelay:delay]; }

CATransform3D CAReplicatorLayerInstanceTransform( CAReplicatorLayerRef layer )
{ return [layer instanceTransform]; }

void CAReplicatorLayerSetInstanceTransform( CAReplicatorLayerRef layer, CATransform3D t )
{ [layer setInstanceTransform:t]; }

// - geometry -
Boolean CAReplicatorLayerPreservesDepth( CAReplicatorLayerRef layer )
{ return [layer preservesDepth]; }

void CAReplicatorLayerSetPreservesDepth( CAReplicatorLayerRef layer, Boolean flag )
{ [layer setPreservesDepth:flag]; }

// - color -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1080
ColorRef CAReplicatorLayerInstanceColor( CAReplicatorLayerRef layer )
{ return [NSColor colorWithCGColor:[layer instanceColor]]; }

void CAReplicatorLayerSetInstanceColor( CAReplicatorLayerRef layer, ColorRef col )
{ [layer setInstanceColor:[col CGColor]]; }
#endif

float CAReplicatorLayerInstanceRedOffset( CAReplicatorLayerRef layer )
{ return [layer instanceRedOffset]; }

void CAReplicatorLayerSetInstanceRedOffset( CAReplicatorLayerRef layer, float offset )
{ [layer setInstanceRedOffset:offset]; }

float CAReplicatorLayerInstanceGreenOffset( CAReplicatorLayerRef layer )
{ return [layer instanceGreenOffset]; }

void CAReplicatorLayerSetInstanceGreenOffset( CAReplicatorLayerRef layer, float offset )
{ [layer setInstanceGreenOffset:offset]; }

float CAReplicatorLayerInstanceBlueOffset( CAReplicatorLayerRef layer )
{ return [layer instanceBlueOffset]; }

void CAReplicatorLayerSetInstanceBlueOffset( CAReplicatorLayerRef layer, float offset )
{ [layer setInstanceBlueOffset:offset]; }

float CAReplicatorLayerInstanceAlphaOffset( CAReplicatorLayerRef layer )
{ return [layer instanceAlphaOffset]; }

void CAReplicatorLayerSetInstanceAlphaOffset( CAReplicatorLayerRef layer, float offset )
{ [layer setInstanceAlphaOffset:offset]; }

