/*
 CAShapeLayer.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// - init -
CAShapeLayerRef CAShapeLayerInit( void );

// - path -
//CGPathRef CAShapeLayerPath( CAShapeLayerRef layer );
void CAShapeLayerSetPath( CAShapeLayerRef layer, BezierPathRef path );

// - properties -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1080
ColorRef CAShapeLayerFillColor( CAShapeLayerRef layer );
void CAShapeLayerSetFillColor( CAShapeLayerRef layer, ColorRef fillColor );
#endif
CFStringRef caShapeLayerFillRule( CAShapeLayerRef layer );
void CAShapeLayerSetFillRule( CAShapeLayerRef layer, CFStringRef fillRule );
CFStringRef caShapeLayerLineCap( CAShapeLayerRef layer );
void CAShapeLayerSetLineCap( CAShapeLayerRef layer, CFStringRef lineCap );
CFArrayRef CAShapeLayerLineDashPattern( CAShapeLayerRef layer );
void CAShapeLayerSetLineDashPattern( CAShapeLayerRef layer, CFArrayRef lineDashPattern );
CGFloat CAShapeLayerLineDashPhase( CAShapeLayerRef layer );
void CAShapeLayerSetLineDashPhase( CAShapeLayerRef layer, CGFloat lineDashPhase );
CFStringRef caShapeLayerLineJoin( CAShapeLayerRef layer );
void CAShapeLayerSetLineJoin( CAShapeLayerRef layer, CFStringRef lineJoin );
CGFloat CAShapeLayerLineWidth( CAShapeLayerRef layer );
void CAShapeLayerSetLineWidth( CAShapeLayerRef layer, CGFloat lineWidth );
CGFloat CAShapeLayerMiterLimit( CAShapeLayerRef layer );
void CAShapeLayerSetMiterLimit( CAShapeLayerRef layer, CGFloat miterLimit );
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1080
ColorRef CAShapeLayerStrokeColor( CAShapeLayerRef layer );
void CAShapeLayerSetStrokeColor( CAShapeLayerRef layer, ColorRef strokeColor );
#endif
CGFloat CAShapeLayerStrokeStart( CAShapeLayerRef layer );
void CAShapeLayerSetStrokeStart( CAShapeLayerRef layer, CGFloat strokeStart );
CGFloat CAShapeLayerStrokeEnd( CAShapeLayerRef layer );
void CAShapeLayerSetStrokeEnd( CAShapeLayerRef layer, CGFloat strokeEnd );

