/*
 CAShapeLayer.m

 Bernie Wylde
 */

#import "CAShapeLayer.h"

// - init -
CAShapeLayerRef CAShapeLayerInit( void )
{ return [CAShapeLayer layer]; }

// - path -
//CGPathRef CAShapeLayerPath( CAShapeLayerRef layer )
//{
//    ?????
//}

void CAShapeLayerSetPath( CAShapeLayerRef layer, BezierPathRef path )
{
    CGPathRef cgPath = NSBezierPathToCGPath( path );
    if ( cgPath ) [layer setPath:cgPath];
}

// - properties -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1080
ColorRef CAShapeLayerFillColor( CAShapeLayerRef layer )
{ return [NSColor colorWithCGColor:[layer fillColor]]; }

void CAShapeLayerSetFillColor( CAShapeLayerRef layer, ColorRef fillColor )
{ [layer setFillColor:[fillColor CGColor]]; }
#endif

CFStringRef caShapeLayerFillRule( CAShapeLayerRef layer )
{ return (CFStringRef)[layer fillRule]; }

void CAShapeLayerSetFillRule( CAShapeLayerRef layer, CFStringRef fillRule )
{ [layer setFillRule:(NSString *)fillRule]; }

CFStringRef caShapeLayerLineCap( CAShapeLayerRef layer )
{ return (CFStringRef)[layer lineCap]; }

void CAShapeLayerSetLineCap( CAShapeLayerRef layer, CFStringRef lineCap )
{ [layer setLineCap:(NSString *)lineCap]; }

CFArrayRef CAShapeLayerLineDashPattern( CAShapeLayerRef layer )
{ return (CFArrayRef)[layer lineDashPattern]; }

void CAShapeLayerSetLineDashPattern( CAShapeLayerRef layer, CFArrayRef lineDashPattern )
{ [layer setLineDashPattern:(NSArray *)lineDashPattern]; }

CGFloat CAShapeLayerLineDashPhase( CAShapeLayerRef layer )
{ return [layer lineDashPhase]; }

void CAShapeLayerSetLineDashPhase( CAShapeLayerRef layer, CGFloat lineDashPhase )
{ [layer setLineDashPhase:lineDashPhase]; }

CFStringRef caShapeLayerLineJoin( CAShapeLayerRef layer )
{ return (CFStringRef)[layer lineJoin]; }

void CAShapeLayerSetLineJoin( CAShapeLayerRef layer, CFStringRef lineJoin )
{ [layer setLineJoin:(NSString *)lineJoin]; }

CGFloat CAShapeLayerLineWidth( CAShapeLayerRef layer )
{ return [layer lineWidth]; }

void CAShapeLayerSetLineWidth( CAShapeLayerRef layer, CGFloat lineWidth )
{ [layer setLineWidth:lineWidth]; }

CGFloat CAShapeLayerMiterLimit( CAShapeLayerRef layer )
{ return [layer miterLimit]; }

void CAShapeLayerSetMiterLimit( CAShapeLayerRef layer, CGFloat miterLimit )
{ [layer setMiterLimit:miterLimit]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1080
ColorRef CAShapeLayerStrokeColor( CAShapeLayerRef layer )
{ return [NSColor colorWithCGColor:[layer strokeColor]]; }

void CAShapeLayerSetStrokeColor( CAShapeLayerRef layer, ColorRef strokeColor )
{ [layer setStrokeColor:[strokeColor CGColor]]; }
#endif

CGFloat CAShapeLayerStrokeStart( CAShapeLayerRef layer )
{ return [layer strokeStart]; }

void CAShapeLayerSetStrokeStart( CAShapeLayerRef layer, CGFloat strokeStart )
{ [layer setStrokeStart:strokeStart]; }

CGFloat CAShapeLayerStrokeEnd( CAShapeLayerRef layer )
{ return [layer strokeEnd]; }

void CAShapeLayerSetStrokeEnd( CAShapeLayerRef layer, CGFloat strokeEnd )
{ [layer setStrokeEnd:strokeEnd]; }


