/*
 CATextLayer.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// - init -
CATextLayerRef CATextLayerInit( void );

// - get/set -
CFTypeRef CATextLayerString( CATextLayerRef layer );
void CATextLayerSetString( CATextLayerRef layer, CFTypeRef string );

// - properties -
CFTypeRef CATextLayerFont( CATextLayerRef layer );
void CATextLayerSetFont( CATextLayerRef layer, CFTypeRef font );
CGFloat CATextLayerFontSize( CATextLayerRef layer );
void CATextLayerSetFontSize( CATextLayerRef layer, CGFloat size );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1080
ColorRef CATextLayerForegroundColor( CATextLayerRef layer );
void CATextLayerSetForegroundColor( CATextLayerRef layer, ColorRef col );
#endif

// - alignment/truncation
Boolean CATextLayerIsWrapped( CATextLayerRef layer );
void CATextLayerSetWrapped( CATextLayerRef layer, Boolean flag );
CFStringRef caTextLayerAlignmentMode( CATextLayerRef layer );
void CATextLayerSetAlignmentMode( CATextLayerRef layer, CFStringRef alignment );
CFStringRef caTextLayerTruncationMode( CATextLayerRef layer );
void CATextLayerSetTruncationMode( CATextLayerRef layer, CFStringRef truncation );

// - instance properties -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
Boolean CATextLayerAllowsFontSubpixelQuantization( CATextLayerRef layer );
void CATextLayerSetAllowsFontSubpixelQuantization( CATextLayerRef layer, Boolean flag );
#endif

