/*
 CATextLayer.m

 Bernie Wylde
 */

#import "CATextLayer.h"

// - init -
CATextLayerRef CATextLayerInit( void )
{ return [CATextLayer layer]; }

// - get/set -
CFTypeRef CATextLayerString( CATextLayerRef layer )
{ return [layer string]; }

void CATextLayerSetString( CATextLayerRef layer, CFTypeRef string )
{ [layer setString:string]; }

// - properties -
CFTypeRef CATextLayerFont( CATextLayerRef layer )
{ return [layer font]; }

void CATextLayerSetFont( CATextLayerRef layer, CFTypeRef font )
{ [layer setFont:font]; }

CGFloat CATextLayerFontSize( CATextLayerRef layer )
{ return [layer fontSize]; }

void CATextLayerSetFontSize( CATextLayerRef layer, CGFloat size )
{ [layer setFontSize:size]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1080
ColorRef CATextLayerForegroundColor( CATextLayerRef layer )
{ return [NSColor colorWithCGColor:[layer foregroundColor]]; }

void CATextLayerSetForegroundColor( CATextLayerRef layer, ColorRef col )
{ [layer setForegroundColor:[col CGColor]]; }
#endif

// - alignment/truncation
Boolean CATextLayerIsWrapped( CATextLayerRef layer )
{ return [layer isWrapped]; }

void CATextLayerSetWrapped( CATextLayerRef layer, Boolean flag )
{ [layer setWrapped:flag]; }

CFStringRef caTextLayerAlignmentMode( CATextLayerRef layer )
{ return (CFStringRef)[layer alignmentMode]; }

void CATextLayerSetAlignmentMode( CATextLayerRef layer, CFStringRef alignment )
{ [layer setAlignmentMode:(NSString *)alignment]; }

CFStringRef caTextLayerTruncationMode( CATextLayerRef layer )
{ return (CFStringRef)[layer truncationMode]; }

void CATextLayerSetTruncationMode( CATextLayerRef layer, CFStringRef truncation )
{ [layer setTruncationMode:(NSString *)truncation]; }

// - instance properties -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
Boolean CATextLayerAllowsFontSubpixelQuantization( CATextLayerRef layer )
{ return [layer allowsFontSubpixelQuantization]; }

void CATextLayerSetAllowsFontSubpixelQuantization( CATextLayerRef layer, Boolean flag )
{ [layer setAllowsFontSubpixelQuantization:flag]; }
#endif

