/*
 CIColor.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// Create
CIColorRef CIColorWithCGColor( CGColorRef cgColor );
CIColorRef CIColorWithRGB( CGFloat red, CGFloat green, CGFloat blue );
CIColorRef CIColorWithRGBA( CGFloat red, CGFloat green, CGFloat blue, CGFloat alpha );
CIColorRef CIColorWithString( CFStringRef representation );
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
CIColorRef CIColorWithRGBColorSpace( CGFloat red, CGFloat green, CGFloat blue, CGColorSpaceRef cs );
CIColorRef CIColorWithRGBAColorSpace( CGFloat red, CGFloat green, CGFloat blue, CGFloat alpha, CGColorSpaceRef cs );
#endif

// Color components
CGColorSpaceRef CIColorColorSpace( CIColorRef ref );
CGFloat *CIColorComponents( CIColorRef ref );
SInt32 CIColorNumberOfComponents( CIColorRef ref );
CGFloat CIColorRed( CIColorRef ref );
CGFloat CIColorGreen( CIColorRef ref );
CGFloat CIColorBlue( CIColorRef ref );
CGFloat CIColorAlpha( CIColorRef ref );
CFStringRef CIColorStringRepresentation( CIColorRef ref );

// Create with preset components
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
CIColorRef CIColorBlackColor( void );
CIColorRef CIColorBlueColor( void );
CIColorRef CIColorClearColor( void );
CIColorRef CIColorCyanColor( void );
CIColorRef CIColorGrayColor( void );
CIColorRef CIColorGreenColor( void );
CIColorRef CIColorMagentaColor( void );
CIColorRef CIColorRedColor( void );
CIColorRef CIColorWhiteColor( void );
CIColorRef CIColorYellowColor( void );
#endif
