/*
 CIColor.m

 Bernie Wylde
 */

#import "CIColor.h"

// Create
CIColorRef CIColorWithCGColor( CGColorRef cgColor )
{ return [CIColor colorWithCGColor:cgColor]; }

CIColorRef CIColorWithRGB( CGFloat red, CGFloat green, CGFloat blue )
{ return [CIColor colorWithRed:red green:green blue:blue]; }

CIColorRef CIColorWithRGBA( CGFloat red, CGFloat green, CGFloat blue, CGFloat alpha )
{ return [CIColor colorWithRed:red green:green blue:blue alpha:alpha]; }

CIColorRef CIColorWithString( CFStringRef representation )
{ return [CIColor colorWithString:(NSString *)representation]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
CIColorRef CIColorWithRGBColorSpace( CGFloat red, CGFloat green, CGFloat blue, CGColorSpaceRef cs )
{ return [CIColor colorWithRed:red green:green blue:blue colorSpace:cs]; }

CIColorRef CIColorWithRGBAColorSpace( CGFloat red, CGFloat green, CGFloat blue, CGFloat alpha, CGColorSpaceRef cs )
{ return [CIColor colorWithRed:red green:green blue:blue alpha:alpha colorSpace:cs]; }
#endif

// Color components
CGColorSpaceRef CIColorColorSpace( CIColorRef ref )
{ return [ref colorSpace]; }

CGFloat *CIColorComponents( CIColorRef ref )
{ return (CGFloat *)[ref components]; }

SInt32 CIColorNumberOfComponents( CIColorRef ref )
{ return [ref numberOfComponents]; }

CGFloat CIColorRed( CIColorRef ref )
{ return [ref red]; }

CGFloat CIColorGreen( CIColorRef ref )
{ return [ref green]; }

CGFloat CIColorBlue( CIColorRef ref )
{ return [ref blue]; }

CGFloat CIColorAlpha( CIColorRef ref )
{ return [ref alpha]; }

CFStringRef CIColorStringRepresentation( CIColorRef ref )
{ return (CFStringRef)[ref stringRepresentation]; }

// Create with preset components
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
CIColorRef CIColorBlackColor( void )
{ return [CIColor blackColor]; }

CIColorRef CIColorBlueColor( void )
{ return [CIColor blueColor]; }

CIColorRef CIColorClearColor( void )
{ return [CIColor clearColor]; }

CIColorRef CIColorCyanColor( void )
{ return [CIColor cyanColor]; }

CIColorRef CIColorGrayColor( void )
{ return [CIColor grayColor]; }

CIColorRef CIColorGreenColor( void )
{ return [CIColor greenColor]; }

CIColorRef CIColorMagentaColor( void )
{ return [CIColor magentaColor]; }

CIColorRef CIColorRedColor( void )
{ return [CIColor redColor]; }

CIColorRef CIColorWhiteColor( void )
{ return [CIColor whiteColor]; }

CIColorRef CIColorYellowColor( void )
{ return [CIColor yellowColor]; }
#endif
