/*
 CIFilter.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// - create -
CIFilterRef CIFilterWithName( CFStringRef name );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
CIFilterRef CIFilterWithNameAndInputParamters( CFStringRef name, CFDictionaryRef params );
#endif

// - create from raw image
CIFilterRef CIFilterWithImageData( CFDataRef dta, CFDictionaryRef options );
CIFilterRef CIFilterWithImageURL( CFURLRef url, CFDictionaryRef options );

// - registered filters -
CFArrayRef CIFilterFilterNamesInCategories( CFArrayRef categories );
CFArrayRef CIFilterFilterNamesInCategory( CFStringRef category );

// - registering a filter -

// - parameters and attributes -
void CIFilterSetName( CIFilterRef ref, CFStringRef name );
Boolean CIFilterIsEnabled( CIFilterRef ref );
CFDictionaryRef CIFilterAttributes( CIFilterRef ref );
CFArrayRef CIFilterInputKeys( CIFilterRef ref );
CFArrayRef CIFilterOutputKeys( CIFilterRef ref );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
CIImageRef CIFilterOutputImage( CIFilterRef ref );
#endif

// - default values -
void CIFilterSetDefaults( CIFilterRef ref );

// - apply -

// - localized info for registered filters -
CFStringRef CIFilterLocalizedNameForFilterName( CFStringRef filterName );
CFStringRef CIFilterLocalizedNameForCategory( CFStringRef category );
CFStringRef CIFilterLocalizedDescriptionForFilterName( CFStringRef filterName );
CFURLRef CIFilterLocalizedReferenceDocumentationForFilterName( CFStringRef filterName );

// - create configuration view -

// - serialize and deserialize -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
CFDataRef CIFilterSerializedXMPFromFilters( CFArrayRef filters, CGRect extent );
CFArrayRef CIFilterFilterArrayFromSerializedXMP( CFDataRef xmpData, CGRect extent, ErrorRef *err );
#endif

