/*
 Cell.m

 Bernie Wylde
 */

#import "Cell.h"

@implementation CellSC
- (NSFont *)font {
    CellEventSetFont( [self font] );
    CallUserDefinedOnDialogFunction( cellFont, 0, 0, self );
    return CellEventFont();
}
@end


@implementation CellEvent
@synthesize fontObj;
@end

CellEvent *CellEventObj( void )
{
    static CellEvent *sCellEvent = nil;
    if ( !sCellEvent ) sCellEvent = [[CellEvent alloc] init];
    return sCellEvent;
}

NSFont *CellEventFont( void )
{
    CellEvent *obj = CellEventObj();
    return [obj fontObj];
}

void CellEventSetFont( FontRef font )
{
    CellEvent *obj = CellEventObj();
    [obj setFontObj:font];
}



// Textual attributes
CFStringRef CellTitle( CellRef ref )
{ return (CFStringRef)[ref title]; }

void CellSetTitle( CellRef ref, CFStringRef title )
{ [ref setTitle:(NSString *)title]; }

// Multipart images
void nsDrawThreePartImage( CGRect frame, ImageRef startCap, ImageRef centerFill, ImageRef endCap, Boolean vertical, NSCompositingOperation op, CGFloat alphaFraction, Boolean flipped )
{ NSDrawThreePartImage( NSRectFromCGRect(frame), startCap, centerFill, endCap, vertical, op, alphaFraction, flipped ); }

void nsDrawNinePartImage( CGRect frame, ImageRef tl, ImageRef t, ImageRef tr, ImageRef l, ImageRef c, ImageRef r, ImageRef bl, ImageRef b, ImageRef br, NSCompositingOperation op, CGFloat alphaFraction, Boolean flipped )
{ NSDrawNinePartImage( NSRectFromCGRect(frame),tl, t, tr, l, c, r, bl, b, br, op, alphaFraction, flipped ); }
