/*
 ClickGestureRecognizer.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000

/*
 Subclass
 */
@interface CocoaClickGestureRecognizer : NSClickGestureRecognizer
@end

// - init -
ClickGestureRecognizerRef ClickGestureRecognizerInit( void *callback, void *userData );

// - configure -
NSUInteger ClickGestureRecognizerButtonMask( ClickGestureRecognizerRef ref );
void ClickGestureRecognizerSetButtonMask( ClickGestureRecognizerRef ref, NSUInteger mask );
NSInteger ClickGestureRecognizerNumberOfClicksRequired( ClickGestureRecognizerRef ref );
void ClickGestureRecognizerSetNumberOfClicksRequired( ClickGestureRecognizerRef ref, NSInteger clicks );

// - instance properties -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101202
NSInteger ClickGestureRecognizerNumberOfTouchesRequired( ClickGestureRecognizerRef ref );
void ClickGestureRecognizerSetNumberOfTouchesRequired( ClickGestureRecognizerRef ref, NSInteger touches );
#endif

#endif
