/*
 ClickGestureRecognizer.m

 Bernie Wylde
 */

#import "ClickGestureRecognizer.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000

/*
 Subclass
 */
@implementation CocoaClickGestureRecognizer
@end

// - init -
ClickGestureRecognizerRef ClickGestureRecognizerInit( void *callback, void *userData )
{
    GestureRecognizerTarget *target = [[[GestureRecognizerTarget alloc] initWithCallback:callback userData:userData] autorelease];
    return [[[NSClickGestureRecognizer alloc] initWithTarget:target action:@selector(action:)] autorelease];
}

// - configure -
NSUInteger ClickGestureRecognizerButtonMask( ClickGestureRecognizerRef ref )
{ return [ref buttonMask]; }

void ClickGestureRecognizerSetButtonMask( ClickGestureRecognizerRef ref, NSUInteger mask )
{ [ref setButtonMask:mask]; }

NSInteger ClickGestureRecognizerNumberOfClicksRequired( ClickGestureRecognizerRef ref )
{ return [ref numberOfClicksRequired]; }

void ClickGestureRecognizerSetNumberOfClicksRequired( ClickGestureRecognizerRef ref, NSInteger clicks )
{ [ref setNumberOfClicksRequired:clicks]; }

// - instance properties -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101202
NSInteger ClickGestureRecognizerNumberOfTouchesRequired( ClickGestureRecognizerRef ref )
{ return [ref numberOfTouchesRequired]; }

void ClickGestureRecognizerSetNumberOfTouchesRequired( ClickGestureRecognizerRef ref, NSInteger touches )
{ [ref setNumberOfTouchesRequired:touches]; }
#endif

#endif

