/*
 ClipView.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// Document view
ViewRef ClipViewDocumentView( ClipViewRef ref );
void ClipViewSetDocumentView( ClipViewRef ref, ViewRef docView );

// Scrolling
void ClipViewScrollToPoint( ClipViewRef ref, CGPoint pt );
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
void ClipViewConstrainBoundsRect( ClipViewRef ref, CGRect r );
#endif

// Scrolling efficiency
Boolean ClipViewCopiesOnScroll( ClipViewRef ref );
void ClipViewSetCopiesOnScroll( ClipViewRef ref, Boolean flag );

// Content insets
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
NSEdgeInsets ClipViewContentInsets( ClipViewRef ref );
void ClipViewSetContentInsets( ClipViewRef ref, NSEdgeInsets insets );
Boolean ClipViewAutomaticallyAdjustsContentInsets( ClipViewRef ref );
void ClipViewSetAutomaticallyAdjustsContentInsets( ClipViewRef ref, Boolean flag );
#endif

// Visible portion
CGRect ClipViewDocumentRect( ClipViewRef ref );
CGRect ClipViewDocumentVisibleRect( ClipViewRef ref );

// Document cursor
CursorRef ClipViewDocumentCursor( ClipViewRef ref );
void ClipViewSetDocumentCursor( ClipViewRef ref, CursorRef curs );

// Background color
Boolean ClipViewDrawsBackground( ClipViewRef ref );
void ClipViewSetDrawsBackground( ClipViewRef ref, Boolean flag );
ColorRef ClipViewBackgroundColor( ClipViewRef ref );
void ClipViewSetBackgroundColor( ClipViewRef ref, ColorRef col );


// Custom
CGRect ClipViewBounds( ClipViewRef ref );
void ClipViewSetBounds( ClipViewRef ref, CGRect r );


