/*
 ClipView.m

 Bernie Wylde
 */

#import "ClipView.h"

// Document view
ViewRef ClipViewDocumentView( ClipViewRef ref )
{ return [ref documentView]; }

void ClipViewSetDocumentView( ClipViewRef ref, ViewRef docView )
{ [ref setDocumentView:docView]; }

// Scrolling
void ClipViewScrollToPoint( ClipViewRef ref, CGPoint pt )
{ [ref scrollToPoint:NSPointFromCGPoint(pt)]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
void ClipViewConstrainBoundsRect( ClipViewRef ref, CGRect r )
{ [ref constrainBoundsRect:NSRectFromCGRect(r)]; }
#endif

// Scrolling efficiency
Boolean ClipViewCopiesOnScroll( ClipViewRef ref )
{ return [ref copiesOnScroll]; }

void ClipViewSetCopiesOnScroll( ClipViewRef ref, Boolean flag )
{ [ref setCopiesOnScroll:flag]; }

// Content insets
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
NSEdgeInsets ClipViewContentInsets( ClipViewRef ref )
{ return [ref contentInsets]; }

void ClipViewSetContentInsets( ClipViewRef ref, NSEdgeInsets insets )
{ [ref setContentInsets:insets]; }

Boolean ClipViewAutomaticallyAdjustsContentInsets( ClipViewRef ref )
{ return [ref automaticallyAdjustsContentInsets]; }

void ClipViewSetAutomaticallyAdjustsContentInsets( ClipViewRef ref, Boolean flag )
{ [ref setAutomaticallyAdjustsContentInsets:flag]; }
#endif

// Visible portion
CGRect ClipViewDocumentRect( ClipViewRef ref )
{ return NSRectToCGRect([ref documentRect]); }

CGRect ClipViewDocumentVisibleRect( ClipViewRef ref )
{ return NSRectToCGRect([ref documentVisibleRect]); }

// Document cursor
CursorRef ClipViewDocumentCursor( ClipViewRef ref )
{ return [ref documentCursor]; }

void ClipViewSetDocumentCursor( ClipViewRef ref, CursorRef curs )
{ [ref setDocumentCursor:curs]; }

// Background color
Boolean ClipViewDrawsBackground( ClipViewRef ref )
{ return [ref drawsBackground]; }

void ClipViewSetDrawsBackground( ClipViewRef ref, Boolean flag )
{ [ref setDrawsBackground:flag]; }

ColorRef ClipViewBackgroundColor( ClipViewRef ref )
{ return [ref backgroundColor]; }

void ClipViewSetBackgroundColor( ClipViewRef ref, ColorRef col )
{ [ref setBackgroundColor:col]; }


// Custom
CGRect ClipViewBounds( ClipViewRef ref )
{ return NSRectToCGRect([ref bounds]); }

void ClipViewSetBounds( ClipViewRef ref, CGRect r )
{ [ref setBounds:NSRectFromCGRect(r)]; }


