/*
 ColorList.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// Init
ColorListRef ColorListWithName( CFStringRef name );
ColorListRef ColorListFromFileAtURL( CFStringRef name, CFURLRef url );

// Lists
CFArrayRef ColorListAvailableColorLists( void );
ColorListRef ColorListNamed( CFStringRef name );

// Properties
CFStringRef ColorListName( ColorListRef cl );
Boolean ColorListIsEditable( ColorListRef cl );

// Managing colors
CFArrayRef ColorListAllKeys( ColorListRef cl );
ColorRef ColorListColorWithKey( ColorListRef cl, CFStringRef key );
void ColorListInsertColor( ColorListRef cl, ColorRef col, CFStringRef key, NSUInteger index );
void ColorListRemoveColorWithKey( ColorListRef cl, CFStringRef key );
void ColorListSetColor( ColorListRef cl, ColorRef col, CFStringRef key );

// Write and remove ColorList files
void ColorListRemoveFile( ColorListRef cl );
Boolean ColorListWriteToURL( ColorListRef cl, CFURLRef url, ErrorRef *err );

// Custom
ColorListRef ColorListByAddingColor( ColorListRef cl, ColorRef col, CFStringRef key );
ColorListRef ColorListByAddingColorList( ColorListRef cl1, ColorListRef cl2 );
