/*
 ColorPanel.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// dialog events
enum {
    colorPanelChangeColor = 2600
};

typedef void (*CocoaColorPanelCallbackType)(ColorRef,void*);

@interface CocoaColorPanelTarget : NSObject {
    CocoaColorPanelCallbackType callback;
    void *userData;
}
@property (assign) CocoaColorPanelCallbackType callback;
@property (assign) void *userData;
@end

void CocoaColorPanelSetTarget( void );

// - shared color panel
ColorPanelRef ColorPanelShared( void );

// - configure -
ViewRef ColorPanelAccessoryView( void );
void ColorPanelSetAccessoryView( ViewRef ref );
Boolean ColorPanelIsContinuous( void );
void ColorPanelSetContinuous( Boolean flag );
NSColorPanelMode ColorPanelMode( void );
void ColorPanelSetMode( NSColorPanelMode mode );
void ColorPanelSetActionCallback( void *callback, void *userData );
Boolean ColorPanelShowsAlpha( void );
void ColorPanelSetShowsAlpha( Boolean flag );

// Color lists
void ColorPanelAttachColorList( ColorListRef cl );
void ColorPanelDetachColorList( ColorListRef cl );

// - picker modes
void ColorPanelSetPickerMode( NSInteger mode );
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
void ColorPanelSetPickerMask( NSColorPanelOptions mask );
#endif

// - setting color -
ColorRef ColorPanelColor( void );
void ColorPanelSetColor( ColorRef col );

// - color info -
CGFloat ColorPanelAlpha( void );

// custom
void ColorPanelShow( void );
void ColorPanelClose( void );

