/*
 ColorSpace.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// Named spaces
ColorSpaceRef ColorSpaceDeviceRGBSpace( void );
ColorSpaceRef ColorSpaceGenericRGBSpace( void );
ColorSpaceRef ColorSpaceDeviceCMYKSpace( void );
ColorSpaceRef ColorSpaceGenericCMYKSpace( void );
ColorSpaceRef ColorSpaceDeviceGraySpace( void );
ColorSpaceRef ColorSpaceGenericGraySpace( void );
ColorSpaceRef ColorSpaceSRGBSpace( void );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
ColorSpaceRef ColorSpaceExtendedSRGBSpace( void );
ColorSpaceRef ColorSpaceP3Space( void );
#endif

ColorSpaceRef ColorSpaceGenericGamma22GraySpace( void );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
ColorSpaceRef ColorSpaceExtendedGenericGamma22GraySpace( void );
#endif

ColorSpaceRef ColorSpaceAdobeRGB1998Space( void );

// Available system spaces
CFArrayRef ColorSpaceAvailableSpacesWithModel( NSColorSpaceModel model );

// Custom spaces
ColorSpaceRef ColorSpaceWithCGColorSpace( CGColorSpaceRef cgColorSpace );
ColorSpaceRef ColorSpaceWithColorSyncProfile( void *prof );
ColorSpaceRef ColorSpaceWithICCProfileData( CFDataRef dta );

// Data and attributes
CGColorSpaceRef ColorSpaceCGColorSpace( ColorSpaceRef ref );
NSColorSpaceModel ColorSpaceModel( ColorSpaceRef ref );
void *ColorSpaceColorSyncProfile( ColorSpaceRef ref );
CFDataRef ColorSpaceICCProfileData( ColorSpaceRef ref );
CFStringRef ColorSpaceLocalizedName( ColorSpaceRef ref );
NSInteger ColorSpaceNumberOfColorComponents( ColorSpaceRef ref );
