/*
 ColorSpace.m

 Bernie Wylde
 */

#import "ColorSpace.h"

// Named spaces
ColorSpaceRef ColorSpaceDeviceRGBSpace( void )
{ return [NSColorSpace deviceRGBColorSpace]; }

ColorSpaceRef ColorSpaceGenericRGBSpace( void )
{ return [NSColorSpace genericRGBColorSpace]; }

ColorSpaceRef ColorSpaceDeviceCMYKSpace( void )
{ return [NSColorSpace deviceCMYKColorSpace]; }

ColorSpaceRef ColorSpaceGenericCMYKSpace( void )
{ return [NSColorSpace genericCMYKColorSpace]; }

ColorSpaceRef ColorSpaceDeviceGraySpace( void )
{ return [NSColorSpace deviceGrayColorSpace]; }

ColorSpaceRef ColorSpaceGenericGraySpace( void )
{ return [NSColorSpace genericGrayColorSpace]; }

ColorSpaceRef ColorSpaceSRGBSpace( void )
{ return [NSColorSpace sRGBColorSpace]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
ColorSpaceRef ColorSpaceExtendedSRGBSpace( void )
{ return [NSColorSpace extendedSRGBColorSpace]; }

ColorSpaceRef ColorSpaceP3Space( void )
{ return [NSColorSpace displayP3ColorSpace]; }
#endif

ColorSpaceRef ColorSpaceGenericGamma22GraySpace( void )
{ return [NSColorSpace genericGamma22GrayColorSpace]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
ColorSpaceRef ColorSpaceExtendedGenericGamma22GraySpace( void )
{ return [NSColorSpace extendedGenericGamma22GrayColorSpace]; }
#endif

ColorSpaceRef ColorSpaceAdobeRGB1998Space( void )
{ return [NSColorSpace adobeRGB1998ColorSpace]; }

// Available system spaces
CFArrayRef ColorSpaceAvailableSpacesWithModel( NSColorSpaceModel model )
{ return (CFArrayRef)[NSColorSpace availableColorSpacesWithModel:model]; }

// Custom spaces
ColorSpaceRef ColorSpaceWithCGColorSpace( CGColorSpaceRef cgColorSpace )
{ return [[[NSColorSpace alloc] initWithCGColorSpace:cgColorSpace] autorelease]; }

ColorSpaceRef ColorSpaceWithColorSyncProfile( void *prof )
{ return [[[NSColorSpace alloc] initWithColorSyncProfile:prof] autorelease]; }

ColorSpaceRef ColorSpaceWithICCProfileData( CFDataRef dta )
{ return [[[NSColorSpace alloc] initWithICCProfileData:(NSData *)dta] autorelease]; }

// Data and attributes
CGColorSpaceRef ColorSpaceCGColorSpace( ColorSpaceRef ref )
{ return [ref CGColorSpace]; }

NSColorSpaceModel ColorSpaceModel( ColorSpaceRef ref )
{ return [ref colorSpaceModel]; }

void *ColorSpaceColorSyncProfile( ColorSpaceRef ref )
{ return [ref colorSyncProfile]; }

CFDataRef ColorSpaceICCProfileData( ColorSpaceRef ref )
{ return (CFDataRef)[ref ICCProfileData]; }

CFStringRef ColorSpaceLocalizedName( ColorSpaceRef ref )
{ return (CFStringRef)[ref localizedName]; }

NSInteger ColorSpaceNumberOfColorComponents( ColorSpaceRef ref )
{ return [ref numberOfColorComponents]; }

