/*
 ComboBox.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

#pragma mark - subclass
@interface ComboBoxSC : NSComboBox
@end

// dialog events
enum {
    comboBoxSelectionDidChange = 1100,
    comboBoxSelectionIsChanging,
    comboBoxWillDismiss,
    comboBoxWillPopUp
};

@interface CocoaComboBoxDelegate : NSObject <NSComboBoxDelegate,NSComboBoxDataSource> {
    NSMutableArray *comboBoxData;
}
@property (assign) NSMutableArray *comboBoxData;
@end

CocoaComboBoxDelegate *CocoaComboBoxDelegateGet( void );

NSComboBox *ComboBoxWithTag( NSInteger tag );
BOOL ComboBoxExists( NSInteger tag );

// - attributes -
Boolean ComboBoxHasVerticalScroller( NSInteger tag );
void ComboBoxSetHasVerticalScroller( NSInteger tag, Boolean flag );
CGSize ComboBoxIntercellSpacing( NSInteger tag );
void ComboBoxSetIntercellSpacing( NSInteger tag, CGSize size );
Boolean ComboBoxIsBordered( NSInteger tag );
void ComboBoxSetBordered( NSInteger tag, Boolean flag );
CGFloat ComboBoxItemHeight( NSInteger tag );
void ComboBoxSetItemHeight( NSInteger tag, CGFloat height );
NSInteger ComboBoxNumberOfVisibleItems( NSInteger tag );
void ComboBoxSetNumberOfVisibleItems( NSInteger tag, NSInteger value );

// - data source -
void ComboBoxSetUsesDataSource( NSInteger tag, Boolean flag );

// - items -
void ComboBoxAddItems( NSInteger tag, CFArrayRef items );
void ComboBoxAddItem( NSInteger tag, CFTypeRef item );
void ComboBoxInsertItem( NSInteger tag, CFTypeRef item, NSInteger index );
CFArrayRef ComboBoxValues( NSInteger tag );
void ComboBoxRemoveAllItems( NSInteger tag );
void ComboBoxRemoveItemAtIndex( NSInteger tag, NSInteger index );
void ComboBoxRemoveItemWithValue( NSInteger tag, CFTypeRef value );
NSInteger ComboBoxNumberOfItems( NSInteger tag );

// - display list -
NSInteger ComboBoxIndexOfItemWithValue( NSInteger tag, CFTypeRef value );
CFTypeRef ComboBoxItemValueAtIndex( NSInteger tag, NSInteger index );
void ComboBoxScrollItemAtIndexToTop( NSInteger tag, NSInteger index );
void ComboBoxScrollItemAtIndexToVisible( NSInteger tag, NSInteger index );
void ComboBoxReloadData( NSInteger tag );

// - selection -
void ComboBoxDeselectItemAtIndex( NSInteger tag, NSInteger index );
NSInteger ComboBoxIndexOfSelectedItem( NSInteger tag );
CFTypeRef ComboBoxValueOfSelectedItem( NSInteger tag );
void ComboBoxSelectItemAtIndex( NSInteger tag, NSInteger index );
void ComboBoxSelectItemWithValue( NSInteger tag, CFTypeRef value );
void ComboBoxNoteNumberOfItemsChanged( NSInteger tag );

// - completing the text field -
void ComboBoxSetCompletes( NSInteger tag, Boolean flag );

// custom
CFMutableArrayRef ComboBoxData( NSInteger tag );
void ComboBoxSetData( NSInteger tag, CFMutableArrayRef array );

// Init
ComboBoxRef ComboBoxInit( NSInteger inTag, CGRect inRect );

// statement
void CocoaComboBox( NSInteger inTag, NSInteger inEnabled, CFTypeRef inItems, CFStringRef inText, CGRect inRect, NSInteger inWndTag );

