/*
 ComparisonPredicate.m
 
 Bernie Wylde
 */

#import "ComparisonPredicate.h"

// Create
ComparisonPredicateRef ComparisonPredicateWithCustomSelector( ExpressionRef leftExpression, ExpressionRef rightExpression, CFStringRef customSelector )
{ return (ComparisonPredicateRef)[NSComparisonPredicate predicateWithLeftExpression:leftExpression rightExpression:rightExpression customSelector:NSSelectorFromString((NSString *)customSelector)]; }

ComparisonPredicateRef ComparisonPredicateWithModifier( ExpressionRef leftExpression, ExpressionRef rightExpression, NSComparisonPredicateModifier modifier, NSPredicateOperatorType type, NSComparisonPredicateOptions options )
{ return (ComparisonPredicateRef)[NSComparisonPredicate predicateWithLeftExpression:leftExpression rightExpression:rightExpression modifier:modifier type:type options:options]; }

// Info
NSComparisonPredicateModifier ComparisonPredicateModifier( ComparisonPredicateRef ref )
{ return [ref comparisonPredicateModifier]; }

// customSelector

ExpressionRef ComparisonPredicateRightExpression( ComparisonPredicateRef ref )
{ return [ref rightExpression]; }

ExpressionRef ComparisonPredicateLeftExpression( ComparisonPredicateRef ref )
{ return [ref leftExpression]; }

NSComparisonPredicateOptions ComparisonPredicateOptions( ComparisonPredicateRef ref )
{ return [ref options]; }

NSPredicateOperatorType ComparisonPredicateOperatorType( ComparisonPredicateRef ref )
{ return [ref predicateOperatorType]; }
