/*
 CompoundPredicate.m
 
 Bernie Wylde
 */

#import "CompoundPredicate.h"

// Constructors
CompoundPredicateRef CompoundPredicateAndPredicateWithSubpredicates( CFArrayRef subpredicates )
{ return (CompoundPredicateRef)[NSCompoundPredicate andPredicateWithSubpredicates:(NSArray *)subpredicates]; }

CompoundPredicateRef CompoundPredicateNotPredicateWithSubpredicate( PredicateRef predicate )
{ return (CompoundPredicateRef)[NSCompoundPredicate notPredicateWithSubpredicate:predicate]; }

CompoundPredicateRef CompoundPredicateOrPredicateWithSubpredicates( CFArrayRef subpredicates )
{ return (CompoundPredicateRef)[NSCompoundPredicate orPredicateWithSubpredicates:(NSArray *)subpredicates]; }

CompoundPredicateRef CompoundPredicateWithType( NSCompoundPredicateType type, CFArrayRef subpredicates )
{ return [[[NSCompoundPredicate alloc] initWithType:type subpredicates:(NSArray *)subpredicates] autorelease]; }

// Info
NSCompoundPredicateType CompoundPredicateType( CompoundPredicateRef ref )
{ return [ref compoundPredicateType]; }

CFArrayRef CompoundPredicateSubpredicates( CompoundPredicateRef ref )
{ return (CFArrayRef)[ref subpredicates]; }
