/*
 CountedSet.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// - init -
CountedSetRef CountedSetWithArray( CFArrayRef array );
CountedSetRef CountedSetWithSet( CFSetRef set );
CountedSetRef CountedSetWithCapacity( NSUInteger length );

// - add/remove -
void CountedSetAddObject( CountedSetRef cs, CFTypeRef obj );
void CountedSetRemoveObject( CountedSetRef cs, CFTypeRef obj );

// - combine/recombine
void CountedSetUnionSet( CountedSetRef cs, CFSetRef set );
void CountedSetMinusSet( CountedSetRef cs, CFSetRef set );
void CountedSetIntersectSet( CountedSetRef cs, CFSetRef set );

// - examine -
NSUInteger CountedSetCountForObject( CountedSetRef cs, CFTypeRef obj );

// - accessing members -
EnumeratorRef CountedSetObjectEnumerator( CountedSetRef cs );

