/*
 CountedSet.m

 Bernie Wylde
 */

#import "CountedSet.h"

// - init -
CountedSetRef CountedSetWithArray( CFArrayRef array )
{ return [[[NSCountedSet alloc] initWithArray:(NSArray *)array] autorelease]; }

CountedSetRef CountedSetWithSet( CFSetRef set )
{ return [[[NSCountedSet alloc] initWithSet:(NSSet *)set] autorelease]; }

CountedSetRef CountedSetWithCapacity( NSUInteger length )
{ return [[[NSCountedSet alloc] initWithCapacity:length] autorelease]; }

// - add/remove -
void CountedSetAddObject( CountedSetRef cs, CFTypeRef obj )
{ [cs addObject:(id)obj]; }

void CountedSetRemoveObject( CountedSetRef cs, CFTypeRef obj )
{ [cs removeObject:(id)obj]; }

// - combine/recombine
void CountedSetUnionSet( CountedSetRef cs, CFSetRef set )
{ [cs unionSet:(NSSet *)set]; }

void CountedSetMinusSet( CountedSetRef cs, CFSetRef set )
{ [cs minusSet:(NSSet *)set]; }

void CountedSetIntersectSet( CountedSetRef cs, CFSetRef set )
{ [cs intersectSet:(NSSet *)set]; }

// - examine -
NSUInteger CountedSetCountForObject( CountedSetRef cs, CFTypeRef obj )
{ return [cs countForObject:(id)obj]; }

// - accessing members -
EnumeratorRef CountedSetObjectEnumerator( CountedSetRef cs )
{ return [cs objectEnumerator]; }

