/*
 Cursor.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

@interface CocoaUICursorAnimator : NSObject {
    NSTimer *timer;
    long counter;
    NSString *name;
    NSString *extension;
    NSSize size;
    NSPoint hotSpot;
    long numImages;
}
@property (assign) NSTimer *timer;
@property (assign) long counter;
@property (assign) NSString *name;
@property (assign) NSString *extension;
@property (assign) NSSize size;
@property (assign) NSPoint hotSpot;
@property (assign) long numImages;

- (void)timerFireMethod:(NSTimer *)t;
@end

CursorRef CursorWithImage( ImageRef image, CGPoint hotSpot );

ImageRef CursorImage( CursorRef cursor );
CGPoint CursorHotSpot( CursorRef cursor );
void CursorHide( void );
void CursorUnhide( void );
void CursorSetHiddenUntilMouseMoves( Boolean flag );

void CursorPop( void );
void CursorPush( CursorRef cursor );
void CursorSet( CursorRef cursor );

CursorRef CursorCurrent( void );
CursorRef CursorCurrentSystem( void );
CursorRef CursorArrow( void );
CursorRef CursorContextualMenu( void );
CursorRef CursorClosedHand( void );
CursorRef CursorCrosshair( void );
CursorRef CursorDisappearingItem( void );
CursorRef CursorDragCopy( void );
CursorRef CursorDragLink( void );
CursorRef CursorIBeam( void );
CursorRef CursorOpenHand( void );
CursorRef CursorOperationNotAllowed( void );
CursorRef CursorPointingHand( void );
CursorRef CursorResizeDown( void );
CursorRef CursorResizeLeft( void );
CursorRef CursorResizeRight( void );
CursorRef CursorResizeUp( void );
CursorRef CursorResizeUpDown( void );
CursorRef CursorIBeamForVerticalLayout( void );

// -- convenience --
void CursorSetImage( void *inImage, CGPoint hotSpot );
void CursorSetImageNamed( CFStringRef imageName, CGPoint hotSpot );
void CursorSetArrow( void );
void CursorSetContextualMenu( void );
void CursorSetClosedHand( void );
void CursorSetCrosshair( void );
void CursorSetDisappearingItem( void );
void CursorSetDragCopy( void );
void CursorSetDragLink( void );
void CursorSetIBeam( void );
void CursorSetOpenHand( void );
void CursorSetOperationNotAllowed( void );
void CursorSetPointingHand( void );
void CursorSetResizeDown( void );
void CursorSetResizeLeft( void );
void CursorSetResizeRight( void );
void CursorSetResizeUp( void );
void CursorSetResizeUpDown( void );
void CursorSetIBeamForVerticalLayout( void );

// Custom
void CursorAnimatorStart( CFTimeInterval ti, CFStringRef inFirstImageName, CGSize size, CGPoint hotSpot, long numImages );
void CursorAnimatorStop( void );

