/*
 Data.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// - create -
CFDataRef DataWithBytes( void *bytes, NSUInteger length );

// - read -
CFDataRef DataWithContentsOfURL( CFURLRef url, NSDataReadingOptions options, ErrorRef *err );

// - write -
Boolean DataWriteToURL( CFDataRef dta, CFURLRef url, NSDataWritingOptions options, ErrorRef *err );

// - encoding/decoding Base64 representation -
//CFDataRef DataBase64EncodedData( CFStringRef string, NSDataBase64EncodingOptions options );

// - access bytes -
const void *DataBytes( CFDataRef dta );
void DataGetBytes( CFDataRef dta, void *buffer, NSUInteger length );
void DataGetBytesInRange( CFDataRef dta, void *buffer, CFRange range );

// - find -
CFDataRef DataSubdata( CFDataRef dta, CFRange range );
CFRange DataRangeOfData( CFDataRef dta, CFDataRef dataToFind, NSDataSearchOptions searchOptions, CFRange searchRange );

// - test -
Boolean DataIsEqualToData( CFDataRef dta1, CFDataRef dta2 );
NSUInteger DataLength( CFDataRef dta );

// - description -
CFStringRef DataDescription( CFDataRef dta );


// -- mutable data --
// - create -
CFMutableDataRef DataWithCapacity( NSUInteger size );
CFMutableDataRef DataWithLength( NSUInteger length );

// - access -
void *DataMutableBytes( CFMutableDataRef dta );

// - length -
void DataSetLength( CFMutableDataRef dta, NSUInteger length );

// - add -
void DataAppendBytes( CFMutableDataRef dta, void *bytes, NSUInteger length );
void DataAppendData( CFMutableDataRef dta1, CFDataRef dta2 );
void DataIncreaseLengthBy( CFMutableDataRef dta, NSUInteger extraLength );

// - modify -
void DataReplaceBytesInRange( CFMutableDataRef dta, void *replacementBytes, CFRange range, NSUInteger length );
void DataResetBytesInRange( CFMutableDataRef dta, CFRange range );
void DataSetData( CFMutableDataRef dta1, CFDataRef dta2 );

