/*
 Date.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// - init -
CFDateRef DateInit( void );
CFDateRef DateWithTimeIntervalSinceNow( CFTimeInterval secs );
CFDateRef DateWithTimeIntervalSinceDate( CFTimeInterval secs, CFDateRef date );
CFDateRef DateWithTimeIntervalSinceReferenceDate( CFTimeInterval secs );
CFDateRef DateWithTimeIntervalSince1970( CFTimeInterval secs );

// - temporal boundaries -
CFDateRef DateDistantFuture( void );
CFDateRef DateDistantPast( void );

// - comparing -
Boolean DateIsEqualToDate( CFDateRef dt1, CFDateRef dt2 );
CFDateRef DateEarlierDate( CFDateRef dt1, CFDateRef dt2 );
CFDateRef DateLaterDate( CFDateRef dt1, CFDateRef dt2 );
NSComparisonResult DateCompare( CFDateRef dt1, CFDateRef dt2 );

// - get time intervals -
CFTimeInterval DateTimeIntervalSinceDate( CFDateRef dt1, CFDateRef dt2 );
CFTimeInterval DateTimeIntervalSinceNow( CFDateRef dt );
CFTimeInterval DateTimeIntervalSinceReferenceDate( CFDateRef dt );
CFTimeInterval DateTimeIntervalSince1970( CFDateRef dt );

// - add time intervals -
CFDateRef DateByAddingTimeInterval( CFDateRef dt, CFTimeInterval secs );

// - description -
CFStringRef DateDescription( CFDateRef dt );
CFStringRef DateDescriptionWithLocale( CFDateRef dt, CFLocaleRef locale );

// Custom
CFStringRef DateStringWithFormat( CFStringRef format );

