/*
 Date.m

 Bernie Wylde
 */

#import "Date.h"

// - init -
CFDateRef DateInit( void )
{ return (CFDateRef)[NSDate date]; }

CFDateRef DateWithTimeIntervalSinceNow( CFTimeInterval secs )
{ return (CFDateRef)[NSDate dateWithTimeIntervalSinceNow:secs]; }

CFDateRef DateWithTimeIntervalSinceDate( CFTimeInterval secs, CFDateRef date )
{ return (CFDateRef)[NSDate dateWithTimeInterval:secs sinceDate:(NSDate *)date]; }

CFDateRef DateWithTimeIntervalSinceReferenceDate( CFTimeInterval secs )
{ return (CFDateRef)[NSDate dateWithTimeIntervalSinceReferenceDate:secs]; }

CFDateRef DateWithTimeIntervalSince1970( CFTimeInterval secs )
{ return (CFDateRef)[NSDate dateWithTimeIntervalSince1970:secs]; }

// - temporal boundaries -
CFDateRef DateDistantFuture( void )
{ return (CFDateRef)[NSDate distantFuture]; }

CFDateRef DateDistantPast( void )
{ return (CFDateRef)[NSDate distantPast]; }

// - comparing -
Boolean DateIsEqualToDate( CFDateRef dt1, CFDateRef dt2 )
{ return [(NSDate *)dt1 isEqualToDate:(NSDate *)dt2]; }

CFDateRef DateEarlierDate( CFDateRef dt1, CFDateRef dt2 )
{ return (CFDateRef)[(NSDate *)dt1 earlierDate:(NSDate *)dt2]; }

CFDateRef DateLaterDate( CFDateRef dt1, CFDateRef dt2 )
{ return (CFDateRef)[(NSDate *)dt1 laterDate:(NSDate *)dt2]; }

NSComparisonResult DateCompare( CFDateRef dt1, CFDateRef dt2 )
{ return [(NSDate *)dt1 compare:(NSDate *)dt2]; }

// - get time intervals -
CFTimeInterval DateTimeIntervalSinceDate( CFDateRef dt1, CFDateRef dt2 )
{ return [(NSDate *)dt1 timeIntervalSinceDate:(NSDate *)dt2]; }

CFTimeInterval DateTimeIntervalSinceNow( CFDateRef dt )
{ return [(NSDate *)dt timeIntervalSinceNow]; }

CFTimeInterval DateTimeIntervalSinceReferenceDate( CFDateRef dt )
{ return [(NSDate *)dt timeIntervalSinceReferenceDate]; }

CFTimeInterval DateTimeIntervalSince1970( CFDateRef dt )
{ return [(NSDate *)dt timeIntervalSince1970]; }

// - add time intervals -
CFDateRef DateByAddingTimeInterval( CFDateRef dt, CFTimeInterval secs )
{ return (CFDateRef)[(NSDate *)dt dateByAddingTimeInterval:secs]; }

// - description -
CFStringRef DateDescription( CFDateRef dt )
{ return (CFStringRef)[(NSDate *)dt description]; }

CFStringRef DateDescriptionWithLocale( CFDateRef dt, CFLocaleRef locale )
{ return (CFStringRef)[(NSDate *)dt descriptionWithLocale:(NSLocale *)locale]; }

// Custom
CFStringRef DateStringWithFormat( CFStringRef format )
{
    NSDateFormatter *df = [[[NSDateFormatter alloc] init] autorelease];
    if ( format ) {
        [df setDateFormat:(NSString *)format];
    } else {
        [df setDateStyle:NSDateFormatterShortStyle];
    }
    return (CFStringRef)[df stringFromDate:[NSDate date]];
}

