/*
 DateComponentsFormatter.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000

// Formatting values
CFStringRef DateComponentsFormatterStringFromDateComponents( DateComponentsFormatterRef formatter, DateComponentsRef dc );
CFStringRef DateComponentsFormatterStringForObjectValue( DateComponentsFormatterRef formatter, CFTypeRef obj );
CFStringRef DateComponentsFormatterStringFromDate( DateComponentsFormatterRef formatter, CFDateRef startDate, CFDateRef endDate );
CFStringRef DateComponentsFormatterStringFromTimeInterval( DateComponentsFormatterRef formatter, CFTimeInterval interval );
CFStringRef DateComponentsFormatterLocalizedStringFromDateComponents( DateComponentsRef dc, NSDateComponentsFormatterUnitsStyle style );

// Configure formatter options
NSCalendarUnit DateComponentsFormatterAllowedUnits( DateComponentsFormatterRef formatter );
void DateComponentsFormatterSetAllowedUnits( DateComponentsFormatterRef formatter, NSCalendarUnit units );
Boolean DateComponentsFormatterAllowsFractionalUnits( DateComponentsFormatterRef formatter );
void DateComponentsFormatterSetAllowsFractionalUnits( DateComponentsFormatterRef formatter, Boolean flag );
CFCalendarRef DateComponentsFormatterCalendar( DateComponentsFormatterRef formatter );
void DateComponentsFormatterSetCalendar( DateComponentsFormatterRef formatter, CFCalendarRef cal );
Boolean DateComponentsFormatterCollapsesLargstUnit( DateComponentsFormatterRef formatter );
void DateComponentsFormatterSetCollapsesLargstUnit( DateComponentsFormatterRef formatter, Boolean flag );
Boolean DateComponentsFormatterIncludesApproximationPhrase( DateComponentsFormatterRef formatter );
void DateComponentsFormatterSetIncludesApproximationPhrase( DateComponentsFormatterRef formatter, Boolean flag );
Boolean DateComponentsFormatterIncludesTimeRemainingPhrase( DateComponentsFormatterRef formatter );
void DateComponentsFormatterSetIncludesTimeRemainingPhrase( DateComponentsFormatterRef formatter, Boolean flag );
NSInteger DateComponentsFormatterMaximumUnitCount( DateComponentsFormatterRef formatter );
void DateComponentsFormatterSetMaximumUnitCount( DateComponentsFormatterRef formatter, NSInteger count );
NSDateComponentsFormatterUnitsStyle DateComponentsFormatterUnitsStyle( DateComponentsFormatterRef formatter );
void DateComponentsFormatterSetUnitsStyle( DateComponentsFormatterRef formatter, NSDateComponentsFormatterUnitsStyle style );
NSDateComponentsFormatterZeroFormattingBehavior DateComponentsFormatterZeroFormattingBehavior( DateComponentsFormatterRef formatter );
void DateComponentsFormatterSetZeroFormattingBehavior( DateComponentsFormatterRef formatter, NSDateComponentsFormatterZeroFormattingBehavior behavior );

// Instance properties
NSFormattingContext DateComponentsFormatterFormattingContext( DateComponentsFormatterRef formatter );
void DateComponentsFormatterSetFormattingContext( DateComponentsFormatterRef formatter, NSFormattingContext ctx );
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300 && __MAC_OS_X_VERSION_MIN_REQUIRED >= 101300
CFDateRef DateComponentsFormatterReferenceDate( DateComponentsFormatterRef formatter );
void DateComponentsFormatterSetReferenceDate( DateComponentsFormatterRef formatter, CFDateRef dt );
#endif

// Instance methods
Boolean DateComponentsFormatterGetObjectValue( DateComponentsFormatterRef formatter, CFTypeRef *obj, CFStringRef string, CFStringRef *errorDescription );

#endif

