/*
 DateInterval.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
// - create -
DateIntervalRef DateIntervalInit( void );
DateIntervalRef DateIntervalWithStartDateDuration( CFDateRef dt, CFTimeInterval ti );
DateIntervalRef DateIntervalWithStartDateEndDate( CFDateRef startDate, CFDateRef endDate );
// DateIntervalRef DateIntervalWithCoder( CoderRef coder );

// - start/end date and duration
CFDateRef DateIntervalStartDate( DateIntervalRef di );
CFDateRef DateIntervalEndDate( DateIntervalRef di );
CFTimeInterval DateIntervalDuration( DateIntervalRef di );

// - compare date intervals -
NSComparisonResult DateIntervalCompare( DateIntervalRef di1, DateIntervalRef di2 );
Boolean DateIntervalIsEqualTo( DateIntervalRef di1, DateIntervalRef di2 );

// - determine intersections -
Boolean DateIntervalIntersectsDateInterval( DateIntervalRef di1, DateIntervalRef di2 );
DateIntervalRef DateIntervalIntersectionWithDateInterval( DateIntervalRef di1, DateIntervalRef di2 );

// - determine if date occurs in date interval -
Boolean DateIntervalContainsDate( DateIntervalRef di, CFDateRef dt );
#endif
