/*
 DateInterval.m

 Bernie Wylde
 */

#import "DateInterval.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
// - create -
DateIntervalRef DateIntervalInit( void )
{ return [[[NSDateInterval alloc] init] autorelease]; }

DateIntervalRef DateIntervalWithStartDateDuration( CFDateRef dt, CFTimeInterval ti )
{ return [[[NSDateInterval alloc] initWithStartDate:(NSDate *)dt duration:ti] autorelease]; }

DateIntervalRef DateIntervalWithStartDateEndDate( CFDateRef startDate, CFDateRef endDate )
{ return [[[NSDateInterval alloc] initWithStartDate:(NSDate *)startDate endDate:(NSDate *)endDate] autorelease]; }

// DateIntervalRef DateIntervalWithCoder( CoderRef coder )
//{ return [[[NSDateInterval alloc] initWithCoder:coder] autorelease]; }

// - start/end date and duration
CFDateRef DateIntervalStartDate( DateIntervalRef di )
{ return (CFDateRef)[di startDate]; }

CFDateRef DateIntervalEndDate( DateIntervalRef di )
{ return (CFDateRef)[di endDate]; }

CFTimeInterval DateIntervalDuration( DateIntervalRef di )
{ return [di duration]; }

// - compare date intervals -
NSComparisonResult DateIntervalCompare( DateIntervalRef di1, DateIntervalRef di2 )
{ return [di1 compare:di2]; }

Boolean DateIntervalIsEqualTo( DateIntervalRef di1, DateIntervalRef di2 )
{ return [di1 isEqualTo:di2]; }

// - determine intersections -
Boolean DateIntervalIntersectsDateInterval( DateIntervalRef di1, DateIntervalRef di2 )
{ return [di1 intersectsDateInterval:di2]; }

DateIntervalRef DateIntervalIntersectionWithDateInterval( DateIntervalRef di1, DateIntervalRef di2 )
{ return [di1 intersectionWithDateInterval:di2]; }

// - determine if date occurs in date interval -
Boolean DateIntervalContainsDate( DateIntervalRef di, CFDateRef dt )
{ return [di containsDate:(NSDate *)dt]; }
#endif

