/*
 DateIntervalFormatter.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
// - init -
DateIntervalFormatterRef DateIntervalFormatterInit( void );

// - formatting -
CFStringRef DateIntervalFormatterStringFromDate( DateIntervalFormatterRef dif, CFDateRef fromDate, CFDateRef toDate );

// - configure -
NSDateIntervalFormatterStyle DateIntervalFormatterDateStyle( DateIntervalFormatterRef dif );
void DateIntervalFormatterSetDateStyle( DateIntervalFormatterRef dif, NSDateIntervalFormatterStyle style );
NSDateIntervalFormatterStyle DateIntervalFormatterTimeStyle( DateIntervalFormatterRef dif );
void DateIntervalFormatterSetTimeStyle( DateIntervalFormatterRef dif, NSDateIntervalFormatterStyle style );
CFStringRef DateIntervalFormatterDateTemplate( DateIntervalFormatterRef dif );
void DateIntervalFormatterSetDateTemplate( DateIntervalFormatterRef dif, CFStringRef template );
CFCalendarRef DateIntervalFormatterCalendar( DateIntervalFormatterRef dif );
void DateIntervalFormatterSetCalendar( DateIntervalFormatterRef dif, CFCalendarRef cal );
CFLocaleRef DateIntervalFormatterLocale( DateIntervalFormatterRef dif );
void DateIntervalFormatterSetLocale( DateIntervalFormatterRef dif, CFLocaleRef locale );
CFTimeZoneRef DateIntervalFormatterTimeZone( DateIntervalFormatterRef dif );
void DateIntervalFormatterSetTimeZone( DateIntervalFormatterRef dif, CFTimeZoneRef tz );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
// - instance -
CFStringRef DateIntervalFormatterStringFromDateInterval( DateIntervalFormatterRef dif, DateIntervalRef di );
#endif// >= 101200

#endif// >= 101000

