/*
 DateIntervalFormatter.m

 Bernie Wylde
 */

#import "DateIntervalFormatter.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000

// - init -
DateIntervalFormatterRef DateIntervalFormatterInit( void )
{ return [[[NSDateIntervalFormatter alloc] init] autorelease]; }

// - formatting -
CFStringRef DateIntervalFormatterStringFromDate( DateIntervalFormatterRef dif, CFDateRef fromDate, CFDateRef toDate )
{ return (CFStringRef)[dif stringFromDate:(NSDate *)fromDate toDate:(NSDate *)toDate]; }

// - configure -
NSDateIntervalFormatterStyle DateIntervalFormatterDateStyle( DateIntervalFormatterRef dif )
{ return [dif dateStyle]; }

void DateIntervalFormatterSetDateStyle( DateIntervalFormatterRef dif, NSDateIntervalFormatterStyle style )
{ [dif setDateStyle:style]; }

NSDateIntervalFormatterStyle DateIntervalFormatterTimeStyle( DateIntervalFormatterRef dif )
{ return [dif timeStyle]; }

void DateIntervalFormatterSetTimeStyle( DateIntervalFormatterRef dif, NSDateIntervalFormatterStyle style )
{ [dif setTimeStyle:style]; }

CFStringRef DateIntervalFormatterDateTemplate( DateIntervalFormatterRef dif )
{ return (CFStringRef)[dif dateTemplate]; }

void DateIntervalFormatterSetDateTemplate( DateIntervalFormatterRef dif, CFStringRef template )
{ [dif setDateTemplate:(NSString *)template]; }

CFCalendarRef DateIntervalFormatterCalendar( DateIntervalFormatterRef dif )
{ return (CFCalendarRef)[dif calendar]; }

void DateIntervalFormatterSetCalendar( DateIntervalFormatterRef dif, CFCalendarRef cal )
{ [dif setCalendar:(NSCalendar *)cal]; }

CFLocaleRef DateIntervalFormatterLocale( DateIntervalFormatterRef dif )
{ return (CFLocaleRef)[dif locale]; }

void DateIntervalFormatterSetLocale( DateIntervalFormatterRef dif, CFLocaleRef locale )
{ [dif setLocale:(NSLocale *)locale]; }

CFTimeZoneRef DateIntervalFormatterTimeZone( DateIntervalFormatterRef dif )
{ return (CFTimeZoneRef)[dif timeZone]; }

void DateIntervalFormatterSetTimeZone( DateIntervalFormatterRef dif, CFTimeZoneRef tz )
{ [dif setTimeZone:(NSTimeZone *)tz]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
// - instance -
CFStringRef DateIntervalFormatterStringFromDateInterval( DateIntervalFormatterRef dif, DateIntervalRef di )
{ return (CFStringRef)[dif stringFromDateInterval:di]; }
#endif// >= 101200

#endif// >= 101000

