/*
 DatePicker.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

@interface CocoaDatePickerTarget : NSObject
@end

#pragma mark - subclass
@interface DatePickerSC : NSDatePicker
@end

NSDatePicker *DatePickerWithTag( NSInteger tag );
BOOL DatePickerExists( NSInteger tag );

// - configure -
Boolean DatePickerIsBezeled( NSInteger tag );
void DatePickerSetBezeled( NSInteger tag, Boolean flag );
Boolean DatePickerIsBordered( NSInteger tag );
void DatePickerSetBordered( NSInteger tag, Boolean flag );
ColorRef DatePickerBackgroundColor( NSInteger tag );
void DatePickerSetBackgroundColor( NSInteger tag, ColorRef col );
Boolean DatePickerDrawsBackground( NSInteger tag );
void DatePickerSetDrawsBackground( NSInteger tag, Boolean flag );
ColorRef DatePickerTextColor( NSInteger tag );
void DatePickerSetTextColor( NSInteger tag, ColorRef col );
NSDatePickerStyle DatePickerStyle( NSInteger tag );
void DatePickerSetStyle( NSInteger tag, NSDatePickerStyle style );
// delegate
NSDatePickerElementFlags DatePickerElements( NSInteger tag );
void DatePickerSetElements( NSInteger tag, NSDatePickerElementFlags elements );

// - range and mode -
CFCalendarRef DatePickerCalendar( NSInteger tag );
void DatePickerSetCalendar( NSInteger tag, CFCalendarRef cal );
CFLocaleRef DatePickerLocale( NSInteger tag );
void DatePickerSetLocale( NSInteger tag, CFLocaleRef locale );
NSDatePickerMode DatePickerMode( NSInteger tag );
void DatePickerSetMode( NSInteger tag, NSInteger mode );
CFTimeZoneRef DatePickerTimeZone( NSInteger tag );
void DatePickerSetTimeZone( NSInteger tag, CFTimeZoneRef zone );

// - values -
CFDateRef DatePickerDateValue( NSInteger tag );
void DatePickerSetDateValue( NSInteger tag, CFDateRef dt );
CFTimeInterval DatePickerTimeInterval( NSInteger tag );
void DatePickerSetTimeInterval( NSInteger tag, CFTimeInterval ti );

// - constraining -
CFDateRef DatePickerMinDate( NSInteger tag );
void DatePickerSetMinDate( NSInteger tag, CFDateRef dt );
CFDateRef DatePickerMaxDate( NSInteger tag );
void DatePickerSetMaxDate( NSInteger tag, CFDateRef dt );

// Init
DatePickerRef DatePickerInit( NSInteger inTag, CGRect inRect );

// Statement
void CocoaDatePicker( NSInteger inTag, NSInteger inEnabled, CFDateRef inDate, CGRect inRect, NSInteger inStyle, NSInteger inElements, NSInteger inWndTag );

