/*
 DialogEvent.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

@interface CocoaDialogEvent : NSObject {
    BOOL boolVal;
    long longVal;
    double doubleVal;
    NSError *errorObj;
    float floatVal;
    NSPoint pointVal;
    NSSize sizeVal;
    NSRect rectVal;
    NSInteger viewTag;
    NSArray *arrayObj;
    NSURL *urlObj;
    NSURL *otherUrlObj;
    id dragInfo;
    NSArray *pbTypes;
    NSString *stringObj;
    NSFont *fontObj;
    NSColor *colorObj;
    NSView *viewObj;
    id object;
    NSMenu *menuObj;
}

@property (assign) BOOL boolVal;
@property (assign) long longVal;
@property (assign) float floatVal;
@property (assign) double doubleVal;
@property (assign) NSError *errorObj;
@property (assign) NSPoint pointVal;
@property (assign) NSSize sizeVal;
@property (assign) NSRect rectVal;
@property (assign) NSInteger viewTag;
@property (assign) NSArray *arrayObj;
@property (assign) NSURL *urlObj;
@property (assign) NSURL *otherUrlObj;
@property (assign) DraggingInfoRef dragInfo;
@property (assign) NSArray *pbTypes;
@property (assign) NSString *stringObj;
@property (assign) NSFont *fontObj;
@property (assign) NSColor *colorObj;
@property (assign) NSView *viewObj;
@property (assign) id object;
@property (assign) NSMenu *menuObj;
@end

CocoaDialogEvent *CocoaDialogEventObj( void );

BOOL DialogEventBool( void );
void DialogEventSetBool( BOOL value );
long DialogEventLong( void );
void DialogEventSetLong( long value );
float DialogEventFloat( void );
void DialogEventSetFloat( float value );
double DialogEventDouble( void );
void DialogEventSetDouble( double value );

void DialogEventSetNSError( NSError *error );
ErrorRef DialogEventError( void );

NSPoint DialogEventNSPoint( void );
void DialogEventSetNSPoint( NSPoint value );

NSSize DialogEventNSSize( void );
void DialogEventSetNSSize( NSSize value );

NSRect DialogEventNSRect( void );
void DialogEventSetNSRect( NSRect value );

NSArray *DialogEventNSArray( void );
void DialogEventSetNSArray( NSArray *array );

void DialogEventSetNSURL( NSURL *url );

void DialogEventSetOtherNSURL( NSURL *url );

NSString *DialogEventNSString( void );
void DialogEventSetNSString( NSString *string );

id DialogEventNSObject( void );
void DialogEventSetNSObject( id obj );

NSMenu *DialogEventNSMenu( void );
void DialogEventSetNSMenu( NSMenu *menu );

void DialogEventSetFont( NSFont *font );
void DialogEventSetColor( NSColor *col );

void DialogEventSetNSURL( NSURL *url );
void DialogEventSetOtherNSURL( NSURL *url );

CGSize DialogEventSize( void );
void DialogEventSetSize( CGSize value );

CGPoint DialogEventPoint( void );
void DialogEventSetPoint( CGPoint value );

CGRect DialogEventRect( void );
void DialogEventSetRect( CGRect value );

NSInteger DialogEventViewTag( void );
void DialogEventSetViewTag( NSInteger value );
CFArrayRef DialogEventArray( void );
CFURLRef DialogEventURL( void );
CFURLRef DialogEventOtherURL( void );
DraggingInfoRef DialogEventDraggingInfo( void );
void DialogEventSetDraggingInfo( DraggingInfoRef info );
CFStringRef DialogEventString( void );
void DialogEventSetString( CFStringRef string );
FontRef DialogEventFont( void );
ColorRef DialogEventColor( void );

ViewRef DialogEventView( void );
void DialogEventSetView( ViewRef vw );

CFTypeRef DialogEventObject( void );
void DialogEventSetObject( CFTypeRef obj );

void DialogEventSetMenu( CocoaMenuRef menu );

