/*
 DialogEvent.m

 Bernie Wylde
 */

#import "DialogEvent.h"

@implementation CocoaDialogEvent

@synthesize boolVal;
@synthesize longVal;
@synthesize floatVal;
@synthesize doubleVal;
@synthesize errorObj;
@synthesize pointVal;
@synthesize sizeVal;
@synthesize rectVal;
@synthesize viewTag;
@synthesize arrayObj;
@synthesize urlObj;
@synthesize otherUrlObj;
@synthesize dragInfo;
@synthesize pbTypes;
@synthesize stringObj;
@synthesize fontObj;
@synthesize colorObj;
@synthesize viewObj;
@synthesize object;
@synthesize menuObj;
@end

CocoaDialogEvent *CocoaDialogEventObj( void )
{
    static CocoaDialogEvent *sCocoaDialogEvent = nil;
    if ( !sCocoaDialogEvent ) sCocoaDialogEvent = [[CocoaDialogEvent alloc] init];
    return sCocoaDialogEvent;
}

// NS
void DialogEventSetNSError( NSError *error )
{ [CocoaDialogEventObj() setErrorObj:error]; }

NSPoint DialogEventNSPoint( void )
{ return [CocoaDialogEventObj() pointVal]; }

void DialogEventSetNSPoint( NSPoint value )
{ [CocoaDialogEventObj() setPointVal:value]; }

NSSize DialogEventNSSize( void )
{ return [CocoaDialogEventObj() sizeVal]; }

void DialogEventSetNSSize( NSSize value )
{ [CocoaDialogEventObj() setSizeVal:value]; }

NSRect DialogEventNSRect( void )
{ return [CocoaDialogEventObj() rectVal]; }

void DialogEventSetNSRect( NSRect value )
{ [CocoaDialogEventObj() setRectVal:value]; }

NSArray *DialogEventNSArray( void )
{ return [CocoaDialogEventObj() arrayObj]; }

void DialogEventSetNSArray( NSArray *array )
{ [CocoaDialogEventObj() setArrayObj:array]; }

void DialogEventSetNSURL( NSURL *url )
{ [CocoaDialogEventObj() setUrlObj:url]; }

void DialogEventSetOtherNSURL( NSURL *url )
{ [CocoaDialogEventObj() setOtherUrlObj:url]; }

NSString *DialogEventNSString( void )
{ return [CocoaDialogEventObj() stringObj];}

void DialogEventSetNSString( NSString *string )
{ [CocoaDialogEventObj() setStringObj:string]; }

void DialogEventSetFont( NSFont *font )
{ [CocoaDialogEventObj() setFontObj:font]; }

void DialogEventSetColor( NSColor *col )
{ [CocoaDialogEventObj() setColorObj:col]; }

id DialogEventNSObject( void )
{ return [CocoaDialogEventObj() object]; }

void DialogEventSetNSObject( id obj )
{ [CocoaDialogEventObj() setObject:obj]; }

NSMenu *DialogEventNSMenu( void )
{ return [CocoaDialogEventObj() menuObj]; }

void DialogEventSetNSMenu( NSMenu *menu )
{ [CocoaDialogEventObj() setMenuObj:menu]; }


// non-NS
BOOL DialogEventBool( void )
{ return [CocoaDialogEventObj() boolVal]; }

void DialogEventSetBool( BOOL value )
{ [CocoaDialogEventObj() setBoolVal:value]; }

long DialogEventLong( void )
{ return [CocoaDialogEventObj() longVal]; }

void DialogEventSetLong( long value )
{ [CocoaDialogEventObj() setLongVal:value]; }

float DialogEventFloat( void )
{ return [CocoaDialogEventObj() floatVal]; }

void DialogEventSetFloat( float value )
{ [CocoaDialogEventObj() setFloatVal:value]; }

double DialogEventDouble( void )
{ return [CocoaDialogEventObj() doubleVal]; }

void DialogEventSetDouble( double value )
{ [CocoaDialogEventObj() setDoubleVal:value]; }

CGPoint DialogEventPoint( void )
{ return NSPointToCGPoint([CocoaDialogEventObj() pointVal]); }

void DialogEventSetPoint( CGPoint value )
{ [CocoaDialogEventObj() setPointVal:NSPointFromCGPoint(value)]; }

CGSize DialogEventSize( void )
{ return NSSizeToCGSize([CocoaDialogEventObj() sizeVal]); }

void DialogEventSetSize( CGSize value )
{ [CocoaDialogEventObj() setSizeVal:NSSizeFromCGSize(value)]; }

CGRect DialogEventRect( void )
{ return NSRectToCGRect([CocoaDialogEventObj() rectVal]); }

void DialogEventSetRect( CGRect value )
{ [CocoaDialogEventObj() setRectVal:NSRectFromCGRect(value)]; }

NSInteger DialogEventViewTag( void )
{ return [CocoaDialogEventObj() viewTag]; }

void DialogEventSetViewTag( NSInteger value )
{ [CocoaDialogEventObj() setViewTag:value];}

DraggingInfoRef DialogEventDraggingInfo( void )
{ return [CocoaDialogEventObj() dragInfo]; }

void DialogEventSetDraggingInfo( DraggingInfoRef info )
{ [CocoaDialogEventObj() setDragInfo:info]; }

CFArrayRef DialogEventArray( void )
{ return (CFArrayRef)[CocoaDialogEventObj() arrayObj]; }

ErrorRef DialogEventError( void )
{ return (ErrorRef)[CocoaDialogEventObj() errorObj]; }

CFURLRef DialogEventURL( void )
{ return (CFURLRef)[CocoaDialogEventObj() urlObj]; }

CFURLRef DialogEventOtherURL( void )
{ return (CFURLRef)[CocoaDialogEventObj() otherUrlObj]; }

CFStringRef DialogEventString( void )
{ return (CFStringRef)[CocoaDialogEventObj() stringObj]; }

void DialogEventSetString( CFStringRef string )
{ DialogEventSetNSString( (NSString *)string ); }

FontRef DialogEventFont( void )
{ return [CocoaDialogEventObj() fontObj]; }

ColorRef DialogEventColor( void )
{ return [CocoaDialogEventObj() colorObj]; }

ViewRef DialogEventView( void )
{ return [CocoaDialogEventObj() viewObj]; }

void DialogEventSetView( ViewRef vw )
{ [CocoaDialogEventObj() setViewObj:vw]; }

CFTypeRef DialogEventObject( void )
{ return (CFTypeRef)[CocoaDialogEventObj() object]; }

void DialogEventSetObject( CFTypeRef obj )
{ [CocoaDialogEventObj() setObject:(id)obj]; }

void DialogEventSetMenu( CocoaMenuRef menu )
{ DialogEventSetNSMenu( menu ); }
