/*
 DistributedNotificationCenter.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

typedef void (*CocoaDistributedNotificationCenterCallbackType)(NSNotification *);

@interface CocoaDistributedNotificationCenter : NSObject {
    CocoaDistributedNotificationCenterCallbackType callback;
    NSString *name;
}
@property (assign) CocoaDistributedNotificationCenterCallbackType callback;
@property (assign) NSString *name;

- (id)initWithCallback:(CocoaDistributedNotificationCenterCallbackType)cb name:(NSString *)nm;
@end

NSMutableArray *CocoaDistributedNotificationCenters( void );


// - default center -
DistributedNotificationCenterRef DistributedNotificationCenterDefaultCenter( void );
DistributedNotificationCenterRef DistributedNotificationCenterForType( CFStringRef type );

// - observers -
void DistributedNotificationCenterAddObserver( void *callback, CFStringRef name, CFTypeRef object, NSNotificationSuspensionBehavior behavior );
void DistributedNotificationCenterRemoveObserver( void *callback, CFStringRef name );

// - notifications -
void DistributedNotificationCenterPostNotificationName( CFStringRef name, CFTypeRef object, CFDictionaryRef userInfo, NSUInteger options );

// - suspend -
Boolean DistributedNotificationCenterSuspended( DistributedNotificationCenterRef ref );
void DistributedNotificationCenterSetSuspended( DistributedNotificationCenterRef ref, Boolean flag );

