/*
 DraggingInfo.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

typedef BOOL (*CocoaDraggingInfoEnumerateItemsCallbackType)(NSDraggingItem*,NSInteger,void*);

// Dragging session info
CocoaPasteboardRef DraggingInfoPasteboard( DraggingInfoRef info );
NSInteger DraggingInfoSequenceNumber( DraggingInfoRef info );
CFTypeRef DraggingInfoSource( DraggingInfoRef info );
NSDragOperation DraggingInfoSourceOperationMask( DraggingInfoRef info );
CGPoint DraggingInfoLocation( DraggingInfoRef info );
NSInteger DraggingInfoDestinationWindow( DraggingInfoRef info );
NSInteger DraggingInfoNumberOfValidItemsForDrop( DraggingInfoRef info );

// Image info
CGPoint DraggingInfoImageLocation( DraggingInfoRef info );

// Sliding the image
void DraggingInfoSlideImageTo( DraggingInfoRef info, CGPoint screenPt );
Boolean DraggingInfoAnimatesToDestination( DraggingInfoRef info );
void DraggingInfoSetAnimatesToDestination( DraggingInfoRef info, Boolean flag );
NSDraggingFormation DraggingInfoFormation( DraggingInfoRef info );

// Enumerate
void DraggingInfoEnumerateItems( DraggingInfoRef info, NSDraggingItemEnumerationOptions options, NSInteger forViewTag, CFArrayRef classes, CFDictionaryRef searchOptions, CocoaDraggingInfoEnumerateItemsCallbackType callback, void *userData );

// Spring-loading support
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
NSSpringLoadingHighlight DraggingInfoSpringLoadingHighlight( DraggingInfoRef info );
void DraggingInfoResetSpringLoading( DraggingInfoRef info );
#endif
