/*
 DraggingItem.m

 Bernie Wylde
 */

#import "DraggingItem.h"

// Init
DraggingItemRef DraggingItemWithPasteboardWriter( PasteboardWritingRef pbWriter )
{ return [[[NSDraggingItem alloc] initWithPasteboardWriter:pbWriter] autorelease]; }

// Frame
void DraggingItemSetFrame( DraggingItemRef ref, CGRect r, CFTypeRef contents )
{ [ref setDraggingFrame:NSRectFromCGRect(r) contents:(id)contents]; }

CGRect DraggingItemFrame( DraggingItemRef ref )
{ return NSRectToCGRect([ref draggingFrame]); }

// Image components
CFArrayRef DraggingItemImageComponents( DraggingItemRef ref )
{ return (CFArrayRef)[ref imageComponents]; }

//CFArrayRef DraggingItemImageComponentsProvider( DraggingItemRef ref, CocoaDraggingItemImageComponentsProviderCallbackType callback, void *userData );

CFTypeRef DraggingItemItem( DraggingItemRef ref )
{ return (CFTypeRef)[ref item]; }
