/*
 DraggingSession.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

typedef BOOL (*CocoaDraggingSessionEnumerateItemsCallbackType)(NSDraggingSession*,NSDraggingItem*,NSInteger,void *);

// Pasteboard
CocoaPasteboardRef DraggingSessionPasteboard( DraggingSessionRef ref );

// Visual representation
Boolean DraggingSessionAnimatesToStartingPositionOnCancelOrFail( DraggingSessionRef ref );
void DraggingSessionSetAnimatesToStartingPositionOnCancelOrFail( DraggingSessionRef ref, Boolean flag );
NSDraggingFormation DraggingSessionFormation( DraggingSessionRef ref );
void DraggingSessionSetFormation( DraggingSessionRef ref, NSDraggingFormation formation );

// Identify
NSInteger DraggingSessionSequenceNumber( DraggingSessionRef ref );

// Enumerate items
void DraggingSessionEnumerateItems( DraggingSessionRef ref, NSDraggingItemEnumerationOptions options, NSInteger forViewTag, CFArrayRef classes, CFDictionaryRef searchOptions, CocoaDraggingSessionEnumerateItemsCallbackType callback, void *userData );

// Location
CGPoint DraggingSessionLocation( DraggingSessionRef ref );

// Item location
NSInteger DraggingSessionLeaderIndex( DraggingSessionRef ref );
void DraggingSessionSetLeaderIndex( DraggingSessionRef ref, NSInteger index );
