/*
 DraggingSession.m

 Bernie Wylde
 */

#import "DraggingSession.h"

// Pasteboard
CocoaPasteboardRef DraggingSessionPasteboard( DraggingSessionRef ref )
{ return [ref draggingPasteboard]; }

// Visual representation
Boolean DraggingSessionAnimatesToStartingPositionOnCancelOrFail( DraggingSessionRef ref )
{ return [ref animatesToStartingPositionsOnCancelOrFail]; }

void DraggingSessionSetAnimatesToStartingPositionOnCancelOrFail( DraggingSessionRef ref, Boolean flag )
{ [ref setAnimatesToStartingPositionsOnCancelOrFail:flag]; }

NSDraggingFormation DraggingSessionFormation( DraggingSessionRef ref )
{ return [ref draggingFormation]; }

void DraggingSessionSetFormation( DraggingSessionRef ref, NSDraggingFormation formation )
{ [ref setDraggingFormation:formation]; }

// Identify
NSInteger DraggingSessionSequenceNumber( DraggingSessionRef ref )
{ return [ref draggingSequenceNumber]; }

// Enumerate items
void DraggingSessionEnumerateItems( DraggingSessionRef ref, NSDraggingItemEnumerationOptions options, NSInteger forViewTag, CFArrayRef classes, CFDictionaryRef searchOptions, CocoaDraggingSessionEnumerateItemsCallbackType callback, void *userData )
{
    NSView *view = CocoaViewWithTag( forViewTag );
    if ( view ) {
        [ref enumerateDraggingItemsWithOptions:options forView:view classes:(NSArray *)classes searchOptions:(NSDictionary *)searchOptions usingBlock:^(NSDraggingItem *draggingItem, NSInteger idx, BOOL *stop) {
            BOOL flag = NO;
            if ( callback ) flag = (*callback)(ref,draggingItem,idx,userData);
            if ( flag ) *stop = YES;

        }];
    }
}

// Location
CGPoint DraggingSessionLocation( DraggingSessionRef ref )
{ return NSPointToCGPoint([ref draggingLocation]); }

// Item location
NSInteger DraggingSessionLeaderIndex( DraggingSessionRef ref )
{ return [ref draggingLeaderIndex]; }

void DraggingSessionSetLeaderIndex( DraggingSessionRef ref, NSInteger index )
{ [ref setDraggingLeaderIndex:index]; }

