/*
 FontDescriptor.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// Create
FontDescriptorRef FontDescriptorWithAttributes( CFDictionaryRef attributes );
FontDescriptorRef FontDescriptorWithNameAndMatrix( CFStringRef name, AffineTransformRef matrix );
FontDescriptorRef FontDescriptorWithNameAndSize( CFStringRef name, CGFloat size );
FontDescriptorRef FontDescriptorByAddingAttributes( FontDescriptorRef fd, CFDictionaryRef attrs );
FontDescriptorRef FontDescriptorWithFace( FontDescriptorRef fd, CFStringRef face );
FontDescriptorRef FontDescriptorWithFamily( FontDescriptorRef fd, CFStringRef family );
FontDescriptorRef FontDescriptorWithMatrix( FontDescriptorRef fd, AffineTransformRef matrix );
FontDescriptorRef FontDescriptorWithSize( FontDescriptorRef fd, CGFloat size );
FontDescriptorRef FontDescriptorWithSymbolicTraits( FontDescriptorRef fd, UInt32 traits );

// Finding fonts
CFArrayRef FontDescriptorMatchingDescriptorsWithMandatoryKeys( FontDescriptorRef fd, CFSetRef keys );
FontDescriptorRef FontDescriptorMatchingDescriptorWithMandatoryKeys( FontDescriptorRef fd, CFSetRef keys );

// Attributes
CFDictionaryRef FontDescriptorAttributes( FontDescriptorRef fd );
CFTypeRef FontDescriptorObjectForKey( FontDescriptorRef fd, CFStringRef attribute );
AffineTransformRef FontDescriptorMatrix( FontDescriptorRef fd );
CGFloat FontDescriptorPointSize( FontDescriptorRef fd );
CFStringRef FontDescriptorPostscriptName( FontDescriptorRef fd );

// Traits
UInt32 FontDescriptorSymbolicTraits( FontDescriptorRef fd );

// Assets
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300 && __MAC_OS_X_VERSION_MIN_REQUIRED >= 101300
Boolean FontDescriptorRequiresFontAssetRequest( FontDescriptorRef fd );
#endif
