/*
 FontDescriptor.m

 Bernie Wylde
 */

#import "FontDescriptor.h"

// Create
FontDescriptorRef FontDescriptorWithAttributes( CFDictionaryRef attributes )
{ return [NSFontDescriptor fontDescriptorWithFontAttributes:(NSDictionary *)attributes]; }

FontDescriptorRef FontDescriptorWithNameAndMatrix( CFStringRef name, AffineTransformRef matrix )
{ return [NSFontDescriptor fontDescriptorWithName:(NSString *)name matrix:matrix]; }

FontDescriptorRef FontDescriptorWithNameAndSize( CFStringRef name, CGFloat size )
{ return [NSFontDescriptor fontDescriptorWithName:(NSString *)name size:size]; }

FontDescriptorRef FontDescriptorByAddingAttributes( FontDescriptorRef fd, CFDictionaryRef attrs )
{ return [fd fontDescriptorByAddingAttributes:(NSDictionary *)attrs]; }

FontDescriptorRef FontDescriptorWithFace( FontDescriptorRef fd, CFStringRef face )
{ return [fd fontDescriptorWithFace:(NSString *)face]; }

FontDescriptorRef FontDescriptorWithFamily( FontDescriptorRef fd, CFStringRef family )
{ return [fd fontDescriptorWithFamily:(NSString *)family]; }

FontDescriptorRef FontDescriptorWithMatrix( FontDescriptorRef fd, AffineTransformRef matrix )
{ return [fd fontDescriptorWithMatrix:matrix]; }

FontDescriptorRef FontDescriptorWithSize( FontDescriptorRef fd, CGFloat size )
{ return [fd fontDescriptorWithSize:size]; }

FontDescriptorRef FontDescriptorWithSymbolicTraits( FontDescriptorRef fd, UInt32 traits )
{ return [fd fontDescriptorWithSymbolicTraits:traits]; }

// Finding fonts
CFArrayRef FontDescriptorMatchingDescriptorsWithMandatoryKeys( FontDescriptorRef fd, CFSetRef keys )
{ return (CFArrayRef)[fd matchingFontDescriptorsWithMandatoryKeys:(NSSet *)keys]; }

FontDescriptorRef FontDescriptorMatchingDescriptorWithMandatoryKeys( FontDescriptorRef fd, CFSetRef keys )
{ return [fd matchingFontDescriptorWithMandatoryKeys:(NSSet *)keys]; }

// Attributes
CFDictionaryRef FontDescriptorAttributes( FontDescriptorRef fd )
{ return (CFDictionaryRef)[fd fontAttributes]; }

CFTypeRef FontDescriptorObjectForKey( FontDescriptorRef fd, CFStringRef attribute )
{ return (CFTypeRef)[fd objectForKey:(NSString *)attribute]; }

AffineTransformRef FontDescriptorMatrix( FontDescriptorRef fd )
{ return [fd matrix]; }

CGFloat FontDescriptorPointSize( FontDescriptorRef fd )
{ return [fd pointSize]; }

CFStringRef FontDescriptorPostscriptName( FontDescriptorRef fd )
{ return (CFStringRef)[fd postscriptName]; }

// Traits
UInt32 FontDescriptorSymbolicTraits( FontDescriptorRef fd )
{ return [fd symbolicTraits]; }

// Assets
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300 && __MAC_OS_X_VERSION_MIN_REQUIRED >= 101300
Boolean FontDescriptorRequiresFontAssetRequest( FontDescriptorRef fd )
{ return [fd requiresFontAssetRequest]; }
#endif
