/*
 GlyphGenerator.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// Obtaining
GlyphGeneratorRef GlyphGeneratorShared( void );

// Generating glyphs
void GlyphGeneratorGenerateGlyphsForGlyphStorage( GlyphGeneratorRef ref, GlyphStorageRef storage, NSUInteger desiredNumberOfCharacters, NSUInteger *glyphIndex, NSUInteger *characterIndex );






/*
 GlyphStorage.incl
 */

// TextStorage
CFAttributedStringRef GlyphStorageAttributedString( GlyphStorageRef ref );

// Display options
UInt32 GlyphStorageLayoutOptions( GlyphStorageRef ref );

// Cache
void GlyphStorageInsertGlyphs( GlyphStorageRef ref, NSGlyph *glyphs, NSUInteger length, NSUInteger glyphIndex, NSUInteger charIndex );
void GlyphStorageSetIntAttribute( GlyphStorageRef ref, NSInteger attributeTag, NSInteger value, NSUInteger glyphIndex );


