/*
 GlyphGenerator.m

 Bernie Wylde
 */

#import "GlyphGenerator.h"

// Obtaining
GlyphGeneratorRef GlyphGeneratorShared( void )
{ return [NSGlyphGenerator sharedGlyphGenerator]; }

// Generating glyphs
void GlyphGeneratorGenerateGlyphsForGlyphStorage( GlyphGeneratorRef ref, GlyphStorageRef storage, NSUInteger desiredNumberOfCharacters, NSUInteger *glyphIndex, NSUInteger *characterIndex )
{ [ref generateGlyphsForGlyphStorage:storage desiredNumberOfCharacters:desiredNumberOfCharacters glyphIndex:glyphIndex characterIndex:characterIndex]; }



/*
 GlyphStorage.incl
 */
// TextStorage
CFAttributedStringRef GlyphStorageAttributedString( GlyphStorageRef ref )
{ return (CFAttributedStringRef)[ref attributedString]; }

// Display options
UInt32 GlyphStorageLayoutOptions( GlyphStorageRef ref )
{ return [ref layoutOptions]; }

// Cache
void GlyphStorageInsertGlyphs( GlyphStorageRef ref, NSGlyph *glyphs, NSUInteger length, NSUInteger glyphIndex, NSUInteger charIndex )
{ [ref insertGlyphs:glyphs length:length forStartingGlyphAtIndex:glyphIndex characterIndex:charIndex]; }

void GlyphStorageSetIntAttribute( GlyphStorageRef ref, NSInteger attributeTag, NSInteger value, NSUInteger glyphIndex )
{ [ref setIntAttribute:attributeTag value:value forGlyphAtIndex:glyphIndex]; }

