/*
 Graphics.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

typedef void (*CocoaAnimationEffectCallbackType)(void *);

@interface CocoaAnimationEffectDelegate : NSObject {
    CocoaAnimationEffectCallbackType callback;
}
@property (assign) CocoaAnimationEffectCallbackType callback;
@end

// Rectangles
void nsRectFill( CGRect r );
void nsRectFillList( CGRect *rects, NSInteger count );
void nsRectFillListWithGrays( CGRect *rects, CGFloat *grays, NSInteger count );
void nsRectFillListWithColors( CGRect *rects, ColorRef *cols, NSInteger count );
void nsRectFillListUsingOperation( CGRect *rects, NSInteger count, NSCompositingOperation op );
void nsRectFillListWithColorsUsingOperation( CGRect *rects, ColorRef *cols, NSInteger count, NSCompositingOperation op );
void nsRectFillUsingOperation( CGRect r, NSCompositingOperation operation );
void nsFrameRect( CGRect r );
void nsFrameRectWithWidth( CGRect r, CGFloat frameWidth );
void nsFrameRectWithWidthUsingOperation( CGRect r, CGFloat frameWidth, NSCompositingOperation operation );
void nsEraseRect( CGRect r );

// Window depth
NSWindowDepth nsBestDepth( CFStringRef colorSpaceName, NSInteger bps, NSInteger bpp, Boolean planar, Boolean *exactMatch );
CFStringRef nsColorSpaceFromDepth( NSWindowDepth depth );
NSInteger nsNumberOfColorComponents( CFStringRef colorSpaceName );

// System animations
void nsShowAnimationEffect( NSAnimationEffect animationEffect, CGPoint centerLocation, CGSize size, void *didEndCallback, void *contextInfo );

