/*
 Graphics.m

 Bernie Wylde
 */

#import "Graphics.h"

@implementation CocoaAnimationEffectDelegate

@synthesize callback;

- (void)animationEffectDidEnd:(void *)contextInfo {
    if ( callback ) (*callback)(contextInfo);
}
@end

// Rectangles
void nsRectFill( CGRect r )
{ NSRectFill( NSRectFromCGRect(r)); }

void nsRectFillList( CGRect *rects, NSInteger count )
{ NSRectFillList( (NSRect *)rects, count ); }

void nsRectFillListWithGrays( CGRect *rects, CGFloat *grays, NSInteger count )
{ NSRectFillListWithGrays( (NSRect *)rects, grays, count ); }

void nsRectFillListWithColors( CGRect *rects, ColorRef *cols, NSInteger count )
{ NSRectFillListWithColors( (NSRect *)rects, cols, count ); }

void nsRectFillListUsingOperation( CGRect *rects, NSInteger count, NSCompositingOperation op )
{ NSRectFillListUsingOperation( (NSRect *)rects, count, op ); }

void nsRectFillListWithColorsUsingOperation( CGRect *rects, ColorRef *cols, NSInteger count, NSCompositingOperation op )
{ NSRectFillListWithColorsUsingOperation( (NSRect *)rects, cols, count, op ); }

void nsRectFillUsingOperation( CGRect r, NSCompositingOperation operation )
{ NSRectFillUsingOperation( NSRectFromCGRect(r), operation ); }

void nsFrameRect( CGRect r )
{ NSFrameRect( NSRectFromCGRect(r)); }

void nsFrameRectWithWidth( CGRect r, CGFloat frameWidth )
{ NSFrameRectWithWidth( NSRectFromCGRect(r), frameWidth ); }

void nsFrameRectWithWidthUsingOperation( CGRect r, CGFloat frameWidth, NSCompositingOperation operation )
{ NSFrameRectWithWidthUsingOperation( NSRectFromCGRect(r), frameWidth, operation ); }

void nsEraseRect( CGRect r )
{ NSEraseRect( NSRectFromCGRect(r)); }

// Window depth
NSWindowDepth nsBestDepth( CFStringRef colorSpaceName, NSInteger bps, NSInteger bpp, Boolean planar, Boolean *exactMatch )
{ return NSBestDepth( (NSString *)colorSpaceName, bps, bpp, planar, (BOOL *)exactMatch); }

CFStringRef nsColorSpaceFromDepth( NSWindowDepth depth )
{ return (CFStringRef)NSColorSpaceFromDepth( depth ); }

NSInteger nsNumberOfColorComponents( CFStringRef colorSpaceName )
{ return NSNumberOfColorComponents( (NSString *)colorSpaceName ); }

void nsShowAnimationEffect( NSAnimationEffect animationEffect, CGPoint centerLocation, CGSize size, void *didEndCallback, void *contextInfo )
{
    CocoaAnimationEffectDelegate *delegate = nil;
    if ( didEndCallback )  {
        delegate = [[CocoaAnimationEffectDelegate alloc] init];
        [delegate setCallback:didEndCallback];
    }
    NSShowAnimationEffect( animationEffect, NSPointFromCGPoint(centerLocation), NSSizeFromCGSize(size), delegate, @selector(animationEffectDidEnd:), contextInfo );
}

