/*
 HelpManager.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// - get -
HelpManagerRef HelpManagerShared( void );

// - display -
void HelpManagerFindString( CFStringRef string, CFStringRef book );
void HelpManagerOpenHelpAnchor( CFStringRef anchor, CFStringRef book );

// - add help books -
Boolean HelpManagerRegisterBooksInBundle( BundleRef bundle );

// - configure -
void HelpManagerSetContextHelp( CFAttributedStringRef attrString, ObjectRef object );
void HelpManagerRemoveContextHelp( ObjectRef object );

// - display -
CFAttributedStringRef HelpManagerContextHelp( ObjectRef object );
Boolean HelpManagerShowContextHelp( ObjectRef object, CGPoint locationHint );

// - properties -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300
Boolean HelpManagerIsContextHelpModeActive( void );
#endif

