/*
 HelpManager.m

 Bernie Wylde
 */

#import "HelpManager.h"

// - get -
HelpManagerRef HelpManagerShared( void )
{ return [NSHelpManager sharedHelpManager]; }

// - display -
void HelpManagerFindString( CFStringRef string, CFStringRef book )
{ [[NSHelpManager sharedHelpManager] findString:(NSString *)string inBook:(NSString *)book]; }

void HelpManagerOpenHelpAnchor( CFStringRef anchor, CFStringRef book )
{ [[NSHelpManager sharedHelpManager] openHelpAnchor:(NSString *)anchor inBook:(NSString *)book]; }

// - add help books -
Boolean HelpManagerRegisterBooksInBundle( BundleRef bundle )
{ return [[NSHelpManager sharedHelpManager] registerBooksInBundle:bundle]; }

// - configure -
void HelpManagerSetContextHelp( CFAttributedStringRef attrString, ObjectRef object )
{ [[NSHelpManager sharedHelpManager] setContextHelp:(NSAttributedString *)attrString forObject:(id)object]; }

void HelpManagerRemoveContextHelp( ObjectRef object )
{ [[NSHelpManager sharedHelpManager] removeContextHelpForObject:(id)object]; }

// - display -
CFAttributedStringRef HelpManagerContextHelp( ObjectRef object )
{ return (CFAttributedStringRef)[[NSHelpManager sharedHelpManager] contextHelpForObject:(id)object]; }

Boolean HelpManagerShowContextHelp( ObjectRef object, CGPoint locationHint )
{ return [[NSHelpManager sharedHelpManager] showContextHelpForObject:(id)object locationHint:NSPointFromCGPoint(locationHint)]; }

// - properties -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300
Boolean HelpManagerIsContextHelpModeActive( void )
{ return [NSHelpManager isContextHelpModeActive]; }
#endif

