/*
 ImageRep.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// - create -
CFArrayRef ImageRepImageRepsWithContentsOfURL( CFURLRef url );
ImageRepRef ImageRepWithContentsOfURL( CFURLRef url );

// - image types -
Boolean ImageRepCanInitWithData( CFDataRef dta );
CFArrayRef ImageRepImageTypes( void );
CFArrayRef ImageRepImageUnfilteredTypes( void );

// - image size -
CGSize ImageRepSize( ImageRepRef rep );

// - representation info -
NSInteger ImageRepBitsPerSample( ImageRepRef rep );
CFStringRef ImageRepColorSpaceName( ImageRepRef rep );
Boolean ImageRepHasAlpha( ImageRepRef rep );
Boolean ImageRepIsOpaque( ImageRepRef rep );
NSInteger ImageRepPixelsHigh( ImageRepRef rep );
NSInteger ImageRepPixelsWide( ImageRepRef rep );

// - CGImage -
CGImageRef ImageRepCGImageForProposedRect( ImageRepRef rep, CGRect *r, GraphicsContextRef context, CFDictionaryRef hints );

// - drawing -
Boolean ImageRepDrawAtPoint( ImageRepRef rep, CGPoint pt );
Boolean ImageRepDrawInRect( ImageRepRef rep, CGRect r );

// - subclasses -

