/*
 ImageRep.m

 Bernie Wylde
 */

#import "ImageRep.h"

// - create -
CFArrayRef ImageRepImageRepsWithContentsOfURL( CFURLRef url )
{ return (CFArrayRef)[NSImageRep imageRepsWithContentsOfURL:(NSURL *)url]; }

ImageRepRef ImageRepWithContentsOfURL( CFURLRef url )
{ return [NSImageRep imageRepWithContentsOfURL:(NSURL *)url]; }

// - image types -
Boolean ImageRepCanInitWithData( CFDataRef dta )
{ return [NSImageRep canInitWithData:(NSData *)dta]; }

CFArrayRef ImageRepImageTypes( void )
{ return (CFArrayRef)[NSImageRep imageTypes]; }

CFArrayRef ImageRepImageUnfilteredTypes( void )
{ return (CFArrayRef)[NSImageRep imageUnfilteredTypes]; }

// - image size -
CGSize ImageRepSize( ImageRepRef rep )
{ return NSSizeToCGSize([rep size]); }

// - representation info -
NSInteger ImageRepBitsPerSample( ImageRepRef rep )
{ return [rep bitsPerSample]; }

CFStringRef ImageRepColorSpaceName( ImageRepRef rep )
{ return (CFStringRef)[rep colorSpaceName]; }

Boolean ImageRepHasAlpha( ImageRepRef rep )
{ return [rep hasAlpha]; }

Boolean ImageRepIsOpaque( ImageRepRef rep )
{ return [rep isOpaque]; }

NSInteger ImageRepPixelsHigh( ImageRepRef rep )
{ return [rep pixelsHigh]; }

NSInteger ImageRepPixelsWide( ImageRepRef rep )
{ return [rep pixelsWide]; }

// - CGImage -
CGImageRef ImageRepCGImageForProposedRect( ImageRepRef rep, CGRect *r, GraphicsContextRef context, CFDictionaryRef hints )
{ return [rep CGImageForProposedRect:(NSRect *)r context:context hints:(NSDictionary *)hints]; }

// - drawing -
Boolean ImageRepDrawAtPoint( ImageRepRef rep, CGPoint pt )
{ return [rep drawAtPoint:NSPointFromCGPoint(pt)]; }

Boolean ImageRepDrawInRect( ImageRepRef rep, CGRect r )
{ return [rep drawInRect:NSRectFromCGRect(r)]; }

// - subclasses -

