/*
 ImageView.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

@interface ImageViewSC : NSImageView
@end

NSImageView *ImageViewWithTag( NSInteger tag );
BOOL ImageViewExists( NSInteger tag );

// - image -
ImageRef ImageViewImage( NSInteger tag );
void ImageViewSetImage( NSInteger tag, void *inImage );
void ImageViewSetImageNamed( NSInteger tag, CFStringRef imageName );

// - visual characteristics -
NSImageFrameStyle ImageViewFrameStyle( NSInteger tag );
void ImageViewSetFrameStyle( NSInteger tag, NSImageFrameStyle style );
NSImageAlignment ImageViewAlignment( NSInteger tag );
void ImageViewSetAlignment( NSInteger tag, NSImageAlignment alignment );
NSImageScaling ImageViewScaling( NSInteger tag );
void ImageViewSetScaling( NSInteger tag, NSImageScaling scaling );
Boolean ImageViewAnimates( NSInteger tag );
void ImageViewSetAnimates( NSInteger tag, Boolean flag );

// - user events -
void ImageViewSetEditable( NSInteger tag, Boolean flag );
void ImageViewSetAllowsCutCopyPaste( NSInteger tag, Boolean flag );


// Init
ImageViewRef ImageViewInit( NSInteger tag, CGRect r );

// Statement
void CocoaImageView( NSInteger inTag, NSInteger inEnabled, void *inImage, CGRect inRect, NSInteger inScaling, NSInteger inAlignment, NSInteger inFrameStyle, NSInteger inWndTag );

