/*
 IndexPath.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// - create -
IndexPathRef IndexPathWithIndex( NSUInteger value );
IndexPathRef IndexPathWithIndexes( NSUInteger *indexes, NSUInteger length );

// - special node names -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
IndexPathRef IndexPathForItemInSection( NSInteger item, NSInteger section );
NSInteger IndexPathSection( IndexPathRef path );
NSInteger IndexPathItem( IndexPathRef path );
#endif

// - counting nodes -
NSUInteger IndexPathLength( IndexPathRef path );

// - adding and removing nodes -
IndexPathRef IndexPathByAddingIndex( IndexPathRef path, NSUInteger index );
IndexPathRef IndexPathByRemovingLastIndex( IndexPathRef path );

// - compare -
NSComparisonResult IndexPathCompare( IndexPathRef path1, IndexPathRef path2 );

// - working with indexes -
NSUInteger IndexPathIndexAtPosition( IndexPathRef path, NSUInteger position );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
void IndexPathGetIndexes( IndexPathRef path, NSUInteger *indexes, CFRange range );
#endif

