/*
 IndexPath.m

 Bernie Wylde
 */

#import "IndexPath.h"

// - create -
IndexPathRef IndexPathWithIndex( NSUInteger value )
{ return [NSIndexPath indexPathWithIndex:value]; }

IndexPathRef IndexPathWithIndexes( NSUInteger *indexes, NSUInteger length )
{ return [NSIndexPath indexPathWithIndexes:indexes length:length]; }

// - special node names -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
IndexPathRef IndexPathForItemInSection( NSInteger item, NSInteger section )
{ return [NSIndexPath indexPathForItem:item inSection:section]; }

NSInteger IndexPathSection( IndexPathRef path )
{ return [path section]; }

NSInteger IndexPathItem( IndexPathRef path )
{ return [path item]; }
#endif

// - counting nodes -
NSUInteger IndexPathLength( IndexPathRef path )
{ return [path length]; }

// - adding and removing nodes -
IndexPathRef IndexPathByAddingIndex( IndexPathRef path, NSUInteger index )
{ return [path indexPathByAddingIndex:index]; }

IndexPathRef IndexPathByRemovingLastIndex( IndexPathRef path )
{ return [path indexPathByRemovingLastIndex]; }

// - compare -
NSComparisonResult IndexPathCompare( IndexPathRef path1, IndexPathRef path2 )
{ return [path1 compare:path2]; }

// - working with indexes -
NSUInteger IndexPathIndexAtPosition( IndexPathRef path, NSUInteger position )
{ return [path indexAtPosition:position]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
void IndexPathGetIndexes( IndexPathRef path, NSUInteger *indexes, CFRange range )
{ [path getIndexes:indexes range:NSMakeRange(range.location,range.length)]; }
#endif

