/*
 JSONSerialization.m

 Bernie Wylde
 */

#import "JSONSerialization.h"

// Create object
CFTypeRef JSONSerializationJSONObjectWithData( CFDataRef dta, NSJSONReadingOptions options, ErrorRef *err )
{ return (CFTypeRef)[NSJSONSerialization JSONObjectWithData:(NSData *)dta options:options error:err]; }

CFTypeRef JSONSerializationJSONObjectWithStream( CFReadStreamRef stream, NSJSONReadingOptions options, ErrorRef *err )
{ return (CFTypeRef)[NSJSONSerialization JSONObjectWithStream:(NSInputStream *)stream options:options error:err]; }

// Create data
CFDataRef JSONSerializationDataWithJSONObject( CFTypeRef obj, NSJSONWritingOptions options, ErrorRef *err )
{ return (CFDataRef)[NSJSONSerialization dataWithJSONObject:(id)obj options:options error:err]; }

NSInteger JSONSerializationWriteJSONObjectToStream( CFTypeRef obj, CFWriteStreamRef stream, NSJSONWritingOptions options, ErrorRef *err )
{ return [NSJSONSerialization writeJSONObject:(id)obj toStream:(NSOutputStream *)stream options:options error:err]; }

Boolean JSONSerializationIsValidJSONObject( CFTypeRef obj )
{ return [NSJSONSerialization isValidJSONObject:(id)obj]; }

