/*
 LayoutAnchor.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100

// Build constraints
LayoutConstraintRef LayoutAnchorConstraintEqualToAnchor( LayoutAnchorRef ref, LayoutAnchorRef anchor );
LayoutConstraintRef LayoutAnchorConstraintEqualToAnchorConstant( LayoutAnchorRef ref, LayoutAnchorRef anchor, CGFloat constant );
LayoutConstraintRef LayoutAnchorConstraintGreaterThanOrEqualToAnchor( LayoutAnchorRef ref, LayoutAnchorRef anchor );
LayoutConstraintRef LayoutAnchorConstraintGreaterThanOrEqualToAnchorConstant( LayoutAnchorRef ref, LayoutAnchorRef anchor, CGFloat constant );
LayoutConstraintRef LayoutAnchorConstraintLessThanOrEqualToAnchor( LayoutAnchorRef ref, LayoutAnchorRef anchor );
LayoutConstraintRef LayoutAnchorConstraintLessThanOrEqualToAnchorConstant( LayoutAnchorRef ref, LayoutAnchorRef anchor, CGFloat constant );

// Debugging
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300
CFArrayRef LayoutAnchorConstraintsAffectingLayout( LayoutAnchorRef ref );
Boolean LayoutAnchorHasAmbiguousLayout( LayoutAnchorRef ref );
CFStringRef LayoutAnchorName( LayoutAnchorRef ref );
CFTypeRef LayoutAnchorItem( LayoutAnchorRef ref );
#endif  // __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300



/*
 LayoutYAxisAnchor
 */
// Create layout dimension
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300
LayoutDimensionRef LayoutYAxisAnchorWithOffsetToAnchor( LayoutYAxisAnchorRef ref, LayoutYAxisAnchorRef otherAnchor );
#endif



/*
 LayoutXAxisAnchor
 */
// Create layout dimension
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300
LayoutDimensionRef LayoutXAxisAnchorWithOffsetToAnchor( LayoutXAxisAnchorRef ref, LayoutXAxisAnchorRef otherAnchor );
#endif


/*
 LayoutDimension
 */
// Build constraints
LayoutConstraintRef LayoutDimensionConstraintEqualToAnchor( LayoutDimensionRef ref, LayoutDimensionRef anchor, CGFloat multiplier );
LayoutConstraintRef LayoutDimensionConstraintEqualToAnchorConstant( LayoutDimensionRef ref, LayoutDimensionRef anchor, CGFloat multiplier, CGFloat constant );
LayoutConstraintRef LayoutDimensionConstraintEqualToConstant( LayoutDimensionRef ref, CGFloat constant );
LayoutConstraintRef LayoutDimensionConstraintGreaterThanOrEqualToAnchor( LayoutDimensionRef ref, LayoutDimensionRef anchor, CGFloat multiplier );
LayoutConstraintRef LayoutDimensionConstraintGreaterThanOrEqualToAnchorConstant( LayoutDimensionRef ref, LayoutDimensionRef anchor, CGFloat multiplier, CGFloat constant );
LayoutConstraintRef LayoutDimensionConstraintGreaterThanOrEqualToConstant( LayoutDimensionRef ref, CGFloat constant );
LayoutConstraintRef LayoutDimensionConstraintLessThanOrEqualToAnchor( LayoutDimensionRef ref, LayoutDimensionRef anchor, CGFloat multiplier );
LayoutConstraintRef LayoutDimensionConstraintLessThanOrEqualToAnchorConstant( LayoutDimensionRef ref, LayoutDimensionRef anchor, CGFloat multiplier, CGFloat constant );
LayoutConstraintRef LayoutDimensionConstraintLessThanOrEqualToConstant( LayoutDimensionRef ref, CGFloat constant );


#endif  // __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100

