/*
 LayoutAnchor.m

 Bernie Wylde
 */

#import "LayoutAnchor.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100

// Build constraints
LayoutConstraintRef LayoutAnchorConstraintEqualToAnchor( LayoutAnchorRef ref, LayoutAnchorRef anchor )
{ return [ref constraintEqualToAnchor:anchor]; }

LayoutConstraintRef LayoutAnchorConstraintEqualToAnchorConstant( LayoutAnchorRef ref, LayoutAnchorRef anchor, CGFloat constant )
{ return [ref constraintEqualToAnchor:anchor constant:constant]; }

LayoutConstraintRef LayoutAnchorConstraintGreaterThanOrEqualToAnchor( LayoutAnchorRef ref, LayoutAnchorRef anchor )
{ return [ref constraintGreaterThanOrEqualToAnchor:anchor]; }

LayoutConstraintRef LayoutAnchorConstraintGreaterThanOrEqualToAnchorConstant( LayoutAnchorRef ref, LayoutAnchorRef anchor, CGFloat constant )
{ return [ref constraintGreaterThanOrEqualToAnchor:anchor constant:constant]; }

LayoutConstraintRef LayoutAnchorConstraintLessThanOrEqualToAnchor( LayoutAnchorRef ref, LayoutAnchorRef anchor )
{ return [ref constraintLessThanOrEqualToAnchor:anchor]; }

LayoutConstraintRef LayoutAnchorConstraintLessThanOrEqualToAnchorConstant( LayoutAnchorRef ref, LayoutAnchorRef anchor, CGFloat constant )
{ return [ref constraintLessThanOrEqualToAnchor:anchor constant:constant]; }

// Debugging
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300
CFArrayRef LayoutAnchorConstraintsAffectingLayout( LayoutAnchorRef ref )
{ return (CFArrayRef)[ref constraintsAffectingLayout]; }

Boolean LayoutAnchorHasAmbiguousLayout( LayoutAnchorRef ref )
{ return [ref hasAmbiguousLayout]; }

CFStringRef LayoutAnchorName( LayoutAnchorRef ref )
{ return (CFStringRef)[ref name]; }

CFTypeRef LayoutAnchorItem( LayoutAnchorRef ref )
{ return (CFTypeRef)[ref item]; }
#endif  // __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300



/*
 LayoutYAxisAnchor
 */
// Create layout dimension
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300
LayoutDimensionRef LayoutYAxisAnchorWithOffsetToAnchor( LayoutYAxisAnchorRef ref, LayoutYAxisAnchorRef otherAnchor )
{ return [ref anchorWithOffsetToAnchor:otherAnchor]; }
#endif


/*
 LayoutXAxisAnchor
 */
// Create layout dimension
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300
LayoutDimensionRef LayoutXAxisAnchorWithOffsetToAnchor( LayoutXAxisAnchorRef ref, LayoutXAxisAnchorRef otherAnchor )
{ return [ref anchorWithOffsetToAnchor:otherAnchor]; }
#endif



/*
 LayoutDimension
 */
// Build constraints
LayoutConstraintRef LayoutDimensionConstraintEqualToAnchor( LayoutDimensionRef ref, LayoutDimensionRef anchor, CGFloat multiplier )
{ return [ref constraintEqualToAnchor:anchor multiplier:multiplier]; }

LayoutConstraintRef LayoutDimensionConstraintEqualToAnchorConstant( LayoutDimensionRef ref, LayoutDimensionRef anchor, CGFloat multiplier, CGFloat constant )
{ return [ref constraintEqualToAnchor:anchor multiplier:multiplier constant:constant]; }

LayoutConstraintRef LayoutDimensionConstraintEqualToConstant( LayoutDimensionRef ref, CGFloat constant )
{ return [ref constraintEqualToConstant:constant]; }

LayoutConstraintRef LayoutDimensionConstraintGreaterThanOrEqualToAnchor( LayoutDimensionRef ref, LayoutDimensionRef anchor, CGFloat multiplier )
{ return [ref constraintGreaterThanOrEqualToAnchor:anchor multiplier:multiplier]; }

LayoutConstraintRef LayoutDimensionConstraintGreaterThanOrEqualToAnchorConstant( LayoutDimensionRef ref, LayoutDimensionRef anchor, CGFloat multiplier, CGFloat constant )
{ return [ref constraintGreaterThanOrEqualToAnchor:anchor multiplier:multiplier constant:constant]; }

LayoutConstraintRef LayoutDimensionConstraintGreaterThanOrEqualToConstant( LayoutDimensionRef ref, CGFloat constant )
{ return [ref constraintGreaterThanOrEqualToConstant:constant]; }

LayoutConstraintRef LayoutDimensionConstraintLessThanOrEqualToAnchor( LayoutDimensionRef ref, LayoutDimensionRef anchor, CGFloat multiplier )
{ return [ref constraintLessThanOrEqualToAnchor:anchor multiplier:multiplier]; }

LayoutConstraintRef LayoutDimensionConstraintLessThanOrEqualToAnchorConstant( LayoutDimensionRef ref, LayoutDimensionRef anchor, CGFloat multiplier, CGFloat constant )
{ return [ref constraintLessThanOrEqualToAnchor:anchor multiplier:multiplier constant:constant]; }

LayoutConstraintRef LayoutDimensionConstraintLessThanOrEqualToConstant( LayoutDimensionRef ref, CGFloat constant )
{ return [ref constraintLessThanOrEqualToConstant:constant]; }


#endif  // __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100

