/*
 LayoutConstraint.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// Create
CFArrayRef LayoutConstraintConstraintsWithVisualFormat( CFStringRef format, NSLayoutFormatOptions options, CFDictionaryRef metrics, CFDictionaryRef views );
LayoutConstraintRef LayoutConstraintWithItem( CFTypeRef view1, NSLayoutAttribute attr1, NSLayoutRelation relation, CFTypeRef view2, NSLayoutAttribute attr2, CGFloat multiplier, CGFloat constant );

// Activate/deactivate
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
Boolean LayoutConstraintIsActive( LayoutConstraintRef ref );
void LayoutConstraintSetActive( LayoutConstraintRef ref, Boolean flag );
void LayoutConstraintActivateConstraints( CFArrayRef constraints );
void LayoutConstraintDeactivateConstraints( CFArrayRef constraints );
#endif

// Data
CFTypeRef LayoutConstraintFirstItem( LayoutConstraintRef ref );
NSLayoutAttribute LayoutConstraintFirstAttribute( LayoutConstraintRef ref );
NSLayoutRelation LayoutConstraintRelation( LayoutConstraintRef ref );
CFTypeRef LayoutConstraintSecondItem( LayoutConstraintRef ref );
NSLayoutAttribute LayoutConstraintSecondAttribute( LayoutConstraintRef ref );
CGFloat LayoutConstraintMultiplier( LayoutConstraintRef ref );
CGFloat LayoutConstraintConstant( LayoutConstraintRef ref );
void LayoutConstraintSetConstant( LayoutConstraintRef ref, CGFloat value );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
LayoutAnchorRef LayoutConstraintFirstAnchor( LayoutConstraintRef ref );
LayoutAnchorRef LayoutConstraintSecondAnchor( LayoutConstraintRef ref );
#endif

// Priority
NSLayoutPriority LayoutConstraintPriority( LayoutConstraintRef ref );
void LayoutConstraintSetPriority( LayoutConstraintRef ref, NSLayoutPriority priority );

// Identify
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
CFStringRef LayoutConstraintIdentifier( LayoutConstraintRef ref );
void LayoutConstraintSetIdentifier( LayoutConstraintRef ref, CFStringRef identifier );
#endif

// Archiving
Boolean LayoutConstraintShouldBeArchived( LayoutConstraintRef ref );
void LayoutConstraintSetShouldBeArchived( LayoutConstraintRef ref, Boolean flag );

