/*
 LevelIndicator.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

@interface LevelIndicatorSC : NSLevelIndicator
@end

//@interface CocoaLevelIndicatorTarget : NSObject
//@end
//
//CocoaLevelIndicatorTarget *CocoaLevelIndicatorTargetGet( void );

NSLevelIndicator *LevelIndicatorWithTag( NSInteger tag );
BOOL LevelIndicatorExists( NSInteger tag );

// - range -
double LevelIndicatorMinValue( NSInteger tag );
void LevelIndicatorSetMinValue( NSInteger tag, double value );
double LevelIndicatorMaxValue( NSInteger tag );
void LevelIndicatorSetMaxValue( NSInteger tag, double value );
double LevelIndicatorWarningValue( NSInteger tag );
void LevelIndicatorSetWarningValue( NSInteger tag, double value );
double LevelIndicatorCriticalValue( NSInteger tag );
void LevelIndicatorSetCriticalValue( NSInteger tag, double value );

// - tick marks and style -
NSTickMarkPosition LevelIndicatorTickMarkPosition( NSInteger tag );
void LevelIndicatorSetTickMarkPosition( NSInteger tag, NSTickMarkPosition position );
NSInteger LevelIndicatorNumberOfTickMarks( NSInteger tag );
void LevelIndicatorSetNumberOfTickMarks( NSInteger tag, NSInteger tickMarks );
NSInteger LevelIndicatorNumberOfMajorTickMarks( NSInteger tag );
void LevelIndicatorSetNumberOfMajorTickMarks( NSInteger tag, NSInteger tickMarks );
CGRect LevelIndicatorRectOfTickMarkAtIndex( NSInteger tag, NSInteger index );
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
NSLevelIndicatorStyle LevelIndicatorStyle( NSInteger tag );
void LevelIndicatorSetStyle( NSInteger tag, NSLevelIndicatorStyle style );
#endif

// - instance properties -
Boolean LevelIndicatorIsEditable( NSInteger tag );
void LevelIndicatorSetEditable( NSInteger tag, Boolean flag );
ImageRef LevelIndicatorImage( NSInteger tag );
void LevelIndicatorSetImage( NSInteger tag, void *inImage );
void LevelIndicatorSetImageNamed( NSInteger tag, CFStringRef imageName );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300 && __MAC_OS_X_VERSION_MIN_REQUIRED >= 101300
ColorRef LevelIndicatorCriticalFillColor( NSInteger tag );
void LevelIndicatorSetCriticalFillColor( NSInteger tag, ColorRef col );
Boolean LevelIndicatorDrawsTieredCapacityLevels( NSInteger tag );
void LevelIndicatorSetDrawsTieredCapacityLevels( NSInteger tag, Boolean flag );
ColorRef LevelIndicatorFillColor( NSInteger tag );
void LevelIndicatorSetFillColor( NSInteger tag, ColorRef col );
NSLevelIndicatorPlaceholderVisibility LevelIndicatorPlaceholderVisibility( NSInteger tag );
void LevelIndicatorSetPlaceholderVisibility( NSInteger tag, NSLevelIndicatorPlaceholderVisibility visibility );
ImageRef LevelIndicatorRatingImage( NSInteger tag );
void LevelIndicatorSetRatingImage( NSInteger tag, void *inImage );
ImageRef LevelIndicatorRatingPlaceholderImage( NSInteger tag );
void LevelIndicatorSetRatingPlaceholderImage( NSInteger tag, void *inImage );
void LevelIndicatorSetRatingPlaceholderImageNamed( NSInteger tag, CFStringRef imageName );
ColorRef LevelIndicatorWarningFillColor( NSInteger tag );
void LevelIndicatorSetWarningFillColor( NSInteger tag, ColorRef col );
#endif


// Init
LevelIndicatorRef LevelIndicatorInit( NSInteger inTag, CGRect inRect );

// Statement
void CocoaLevelIndicator( NSInteger inTag, NSInteger inEnabled, double inValue, CGRect inRect, double inMinValue, double inMaxValue, double inWarningValue, double inCriticalValue, NSInteger inTickMarks, NSInteger inMajorTickMarks, NSInteger inWndTag );

