/*
 MagnificationGestureRecognizer.m

 Bernie Wylde
 */

#import "MagnificationGestureRecognizer.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000

/*
 Subclass
 */
@implementation CocoaMagnificationGestureRecognizer
@end

// - init -
MagnificationGestureRecognizerRef MagnificationGestureRecognizerInit( void *callback, void *userData )
{
    GestureRecognizerTarget *target = [[[GestureRecognizerTarget alloc] initWithCallback:callback userData:userData] autorelease];
    return [[[NSMagnificationGestureRecognizer alloc] initWithTarget:target action:@selector(action:)] autorelease];
}

// - magnification factor -
CGFloat MagnificationGestureRecognizerMagnification( MagnificationGestureRecognizerRef ref )
{ return [ref magnification]; }

void MagnificationGestureRecognizerSetMagnification( MagnificationGestureRecognizerRef ref, CGFloat magnification )
{ [ref setMagnification:magnification]; }

#endif
