/*
 Nib.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

#pragma mark - cocoa nibs
@interface CocoaNibObject : NSObject {
    NSString *nibName;
    NSArray *topLevelObjects;
}
- (id)initWithName:(NSString *)name objects:(NSArray *)objects;

@property (nonatomic,assign) NSString *nibName;
@property (nonatomic,assign) NSArray *topLevelObjects;
@end

CocoaNibObject *CocoaNibObjectWithName( NSString *name );
void CocoaNibObjectAdd( NSString *name, NSArray *objects );
void CocoaNibViewSetup( NSInteger wndTag, NSView *superview );
void CocoaNibWindowToolbarItemSetup( NSInteger wndTag, NSToolbar *toolbar );
void CocoaNibWindowToolbarSetup( NSInteger wndTag );
id CocoaWindowFromNibObjects( NSInteger tag, NSString *nibName, NSString *wndIdentifier );
void CocoaViewFromNibObjects( NSInteger tag, NSString *nibName, NSString *viewIdentifier, NSPoint origin, NSView *superview );

#pragma mark - nibpopover
void CocoaPopoverFromNibObjects( NSInteger tag, NSString *nibName );
void CocoaNibPopover( NSInteger inTag, CFStringRef inNibName );

#pragma mark - nibtoolbar
void CocoaToolbarFromNibObjects( NSInteger tag, NSString *nibName );
void CocoaNibToolbar( NSInteger inTag, CFStringRef inNibName );

#pragma mark - nibview
void CocoaNibView( NSInteger inTag, CFStringRef inNibName, CFStringRef inViewIdentifier, CGPoint inOrigin, NSInteger inSuperviewTag );

#pragma mark - nib <everything>
void CocoaNib( CFStringRef inNibName );
