/*
 Notification.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// - create -
NotificationRef NotificationWithName( CFStringRef name, CFTypeRef object, CFDictionaryRef userInfo );

// - info -
CFStringRef NotificationName( NotificationRef ref );
CFTypeRef NotificationObject( NotificationRef ref );
CFDictionaryRef NotificationUserInfo( NotificationRef ref );



/*
 NotificationCenter.h
 */
typedef void (*CocoaNotificationCenterCallbackType)(NSNotification *);

@interface CocoaNotificationCenter : NSObject {
    CocoaNotificationCenterCallbackType callback;
    NSString *name;
}
@property (assign) CocoaNotificationCenterCallbackType callback;
@property (assign) NSString *name;

- (id)initWithCallback:(CocoaNotificationCenterCallbackType)cb name:(NSString *)nm;

@end

NSMutableArray *CocoaNotificationCenters( void );

// - default center -
NotificationCenterRef NotificationCenterDefault( void );

// - add and remove observers -
void NotificationCenterAddObserver( void *callback, CFStringRef name, CFTypeRef object );
void NotificationCenterRemoveObserver( void *callback, CFStringRef name );

// - post notification -
void NotificationCenterPostNotification( NotificationRef note );
void NotificationCenterPostNotificationName( CFStringRef name, CFTypeRef object, CFDictionaryRef userInfo );

