/*
 NotificationQueue.m

 Bernie Wylde
 */

#import "NotificationQueue.h"

// - create -
NotificationQueueRef NotificationQueueWithNotificationCenter( NotificationCenterRef ref )
{ return [[[NSNotificationQueue alloc] initWithNotificationCenter:ref] autorelease]; }

// - default queue -
NotificationQueueRef NotificationQueueDefault( void )
{ return [NSNotificationQueue defaultQueue]; }

// - managing notifications -
void NotificationQueueEnqueueNotificationWithCoalescing( NotificationQueueRef queue, NotificationRef note, NSPostingStyle style, NSNotificationCoalescing coalesceMask, CFArrayRef modes )
{ [queue enqueueNotification:note postingStyle:style coalesceMask:coalesceMask forModes:(NSArray *)modes]; }

void NotificationQueueEnqueueNotification( NotificationQueueRef queue, NotificationRef note, NSPostingStyle style )
{ [queue enqueueNotification:note postingStyle:style]; }

void NotificationQueueDequeueNotification( NotificationQueueRef queue, NotificationRef note, NSNotificationCoalescing coalesceMask )
{ [queue dequeueNotificationsMatching:note coalesceMask:coalesceMask]; }

