/*
 Number.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

CFNumberRef NumberWithBool( Boolean value );
CFNumberRef NumberWithChar( char value );
CFNumberRef NumberWithShort( short value );
CFNumberRef NumberWithLong( long value );
CFNumberRef NumberWithLongLong( SInt64 value );
CFNumberRef NumberWithUnsignedChar( unsigned char value );
CFNumberRef NumberWithUnsignedShort( unsigned short value );
CFNumberRef NumberWithUnsignedLong( unsigned long value );
CFNumberRef NumberWithUnsignedLongLong( unsigned long long value );
CFNumberRef NumberWithFloat( float value );
CFNumberRef NumberWithDouble( double value );

Boolean NumberBoolValue( CFNumberRef number );
char NumberCharValue( CFNumberRef number );
NSDecimal NumberDecimalValue( CFNumberRef number );
short NumberShortValue( CFNumberRef number );
long NumberLongValue( CFNumberRef number );
SInt64 NumberLongLongValue( CFNumberRef number );
unsigned char NumberUnsignedCharValue( CFNumberRef number );
unsigned short NumberUnsignedShortValue( CFNumberRef number );
unsigned long NumberUnsignedLongValue( CFNumberRef number );
UInt64 NumberUnsignedLongLongValue( CFNumberRef number );
float NumberFloatValue( CFNumberRef number );
double NumberDoubleValue( CFNumberRef number );

// - string representation -
CFStringRef NumberDescriptionWithLocale( CFNumberRef number, CFLocaleRef locale );
CFStringRef NumberStringValue( CFNumberRef number );

NSComparisonResult NumberCompare( CFNumberRef number1, CFNumberRef number2 );
Boolean NumberIsEqualToNumber( CFNumberRef number1, CFNumberRef number2 );

// Type information
CFStringRef NumberObjCType( CFNumberRef number );

