/*
 Number.m

 Bernie Wylde
 */

#import "Number.h"

CFNumberRef NumberWithBool( Boolean value )
{ return (CFNumberRef)[NSNumber numberWithBool:value]; }

CFNumberRef NumberWithChar( char value )
{ return (CFNumberRef)[NSNumber numberWithChar:value]; }

CFNumberRef NumberWithShort( short value )
{ return (CFNumberRef)[NSNumber numberWithShort:value]; }

CFNumberRef NumberWithLong( long value )
{ return (CFNumberRef)[NSNumber numberWithInt:value]; }

CFNumberRef NumberWithLongLong( SInt64 value )
{ return (CFNumberRef)[NSNumber numberWithLongLong:value]; }

CFNumberRef NumberWithUnsignedChar( unsigned char value )
{ return (CFNumberRef)[NSNumber numberWithUnsignedChar:value]; }

CFNumberRef NumberWithUnsignedShort( unsigned short value )
{ return (CFNumberRef)[NSNumber numberWithUnsignedShort:value]; }

CFNumberRef NumberWithUnsignedLong( unsigned long value )
{ return (CFNumberRef)[NSNumber numberWithUnsignedInt:value]; }

CFNumberRef NumberWithUnsignedLongLong( unsigned long long value )
{ return (CFNumberRef)[NSNumber numberWithUnsignedLongLong:value]; }

CFNumberRef NumberWithFloat( float value )
{ return (CFNumberRef)[NSNumber numberWithFloat:value]; }

CFNumberRef NumberWithDouble( double value )
{ return (CFNumberRef)[NSNumber numberWithDouble:value]; }

Boolean NumberBoolValue( CFNumberRef number )
{ return [(NSNumber *)number boolValue]; }

char NumberCharValue( CFNumberRef number )
{ return [(NSNumber *)number charValue]; }

NSDecimal NumberDecimalValue( CFNumberRef number )
{ return [(NSNumber *)number decimalValue]; }

short NumberShortValue( CFNumberRef number )
{ return [(NSNumber *)number shortValue]; }

long NumberLongValue( CFNumberRef number )
{ return [(NSNumber *)number intValue]; }

SInt64 NumberLongLongValue( CFNumberRef number )
{ return [(NSNumber *)number longLongValue]; }

unsigned char NumberUnsignedCharValue( CFNumberRef number )
{ return [(NSNumber *)number unsignedCharValue]; }

unsigned short NumberUnsignedShortValue( CFNumberRef number )
{ return [(NSNumber *)number unsignedShortValue]; }

unsigned long NumberUnsignedLongValue( CFNumberRef number )
{ return [(NSNumber *)number unsignedLongValue]; }

UInt64 NumberUnsignedLongLongValue( CFNumberRef number )
{ return [(NSNumber *)number unsignedLongLongValue]; }

float NumberFloatValue( CFNumberRef number )
{ return [(NSNumber *)number floatValue]; }

double NumberDoubleValue( CFNumberRef number )
{ return [(NSNumber *)number doubleValue]; }

// - string representation -
CFStringRef NumberDescriptionWithLocale( CFNumberRef number, CFLocaleRef locale )
{ return (CFStringRef)[(NSNumber *)number descriptionWithLocale:(NSLocale *)locale]; }

CFStringRef NumberStringValue( CFNumberRef number )
{ return (CFStringRef)[(NSNumber *)number stringValue]; }

NSComparisonResult NumberCompare( CFNumberRef number1, CFNumberRef number2 )
{ return [(NSNumber *)number1 compare:(NSNumber *)number2]; }

Boolean NumberIsEqualToNumber( CFNumberRef number1, CFNumberRef number2 )
{ return [(NSNumber *)number1 isEqualToNumber:(NSNumber *)number2]; }

// Type information
CFStringRef NumberObjCType( CFNumberRef number )
{ return (CFStringRef)[NSString stringWithCString:[(NSNumber *)number objCType] encoding:NSUTF8StringEncoding]; }



