/*
 Object.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

typedef void (*CocoaObjectPerformFunctionCallbackType)(id);

@interface CocoaObjectTarget : NSObject {
    CocoaObjectPerformFunctionCallbackType callback;
}
@property (assign) CocoaObjectPerformFunctionCallbackType callback;

- (void)objectSelector:(id)object;
@end


@interface NSObject (Additions)
//@property (nonatomic,retain) NSNumber *IDNumber;
@property (nonatomic,retain) NSNumber *wndTagNumber;
@property (nonatomic,retain) NSMutableDictionary *objProperties;

//- (NSInteger)ID;
//- (void)setID:(NSInteger)objID;

- (NSInteger)wndTag;
- (void)setWndTag:(NSInteger)tag;

- (NSMutableDictionary *)objectProperties;
- (void)setObjectProperties:(NSMutableDictionary *)properties;
@end


// - create, copy, dealloc -
CFTypeRef ObjectCopy( CFTypeRef obj );
CFTypeRef ObjectMutableCopy( CFTypeRef obj );


ClassRef ObjectClass( CFTypeRef obj );
ClassRef ObjectSuperclass( CFTypeRef obj );
Boolean ObjectIsSubclassOfClass( CFTypeRef obj, ClassRef class );

// Sending messages
void ObjectPerformSelector( CFTypeRef obj, CFStringRef selector, CFTypeRef withObj, CFTimeInterval afterDelay );
void ObjectPerformSelectorOnMainThread( CFTypeRef obj, CFStringRef selector, CFTypeRef withObj, Boolean waitUntilDone );
void ObjectPerformSelectorInBackground( CFTypeRef obj, CFStringRef selector, CFTypeRef withObj );

// - instance methods -
Boolean ObjectIsEqual( CFTypeRef obj1, CFTypeRef obj2 );
void ObjectSetValueForKey( CFTypeRef obj, CFTypeRef value, CFStringRef key );
CFTypeRef ObjectValueForKey( CFTypeRef obj, CFStringRef key );


// -- NSObject protocol methods --
Boolean ObjectIsKindOfClass( CFTypeRef obj, ClassRef class );


// -- custom --
void ObjectCallFunction( void *fnAddress, CFTypeRef withObj, CFTimeInterval afterDelay );
void ObjectCallFunctionOnMainThread( void *fnAddress, CFTypeRef withObj, Boolean waitUntilDone );
void ObjectCallFunctionInBackground( void *fnAddress, CFTypeRef withObj );

CFTypeRef ObjectProperty( CFTypeRef obj, CFStringRef key );
void ObjectSetProperty( CFTypeRef obj, CFStringRef key, CFTypeRef value );
void ObjectRemoveProperty( CFTypeRef obj, CFStringRef key );
void ObjectRemoveAllProperties( CFTypeRef obj );

