/*
 Operation.m

 Bernie Wylde
 */

#import "Operation.h"

// Init
OperationRef OperationInit( void )
{ return [[[NSOperation alloc] init] autorelease]; }

// Executing
void OperationStart( OperationRef op )
{ [op start]; }

void OperationMain( OperationRef op )
{ [op main]; }

void OperationSetCompletionFunction( OperationRef op, CocoaOperationFunctionCallbackType fnAddress )
{
    [op setCompletionBlock:^(void) {
        (*fnAddress)();
    }];
}

// Cancelling
void OperationCancel( OperationRef op )
{ [op cancel]; }

// Status
Boolean OperationIsCancelled( OperationRef op )
{ return [op isCancelled]; }

Boolean OperationIsExecuting( OperationRef op )
{ return [op isExecuting]; }

Boolean OperationIsFinished( OperationRef op )
{ return [op isFinished]; }

Boolean OperationIsConcurrent( OperationRef op )
{ return [op isConcurrent]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
Boolean OperationIsAsynchronous( OperationRef op )
{ return [op isAsynchronous]; }
#endif

Boolean OperationIsReady( OperationRef op )
{ return [op isReady]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
CFStringRef OperationName( OperationRef op )
{ return (CFStringRef)[op name]; }

void OperationSetName( OperationRef op, CFStringRef name )
{ [op setName:(NSString *)name]; }
#endif

// Dependencies
void OperationAddDependency( OperationRef op1, OperationRef op2 )
{ [op1 addDependency:op2]; }

void OperationRemoveDependency( OperationRef op1, OperationRef op2 )
{ [op1 removeDependency:op2]; }

CFArrayRef OperationDependencies( OperationRef op )
{ return (CFArrayRef)[op dependencies]; }

// Execution priority
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
NSQualityOfService OperationQualityOfService( OperationRef op )
{ return [op qualityOfService]; }

void OperationSetQualityOfService( OperationRef op, NSQualityOfService qos )
{ [op setQualityOfService:qos]; }
#endif

NSOperationQueuePriority OperationQueuePriority( OperationRef op )
{ return [op queuePriority]; }

void OperationSetQueuePriority( OperationRef op, NSOperationQueuePriority priority )
{ [op setQueuePriority:priority]; }

// Waiting
void OperationWaitUntilFinished( OperationRef op )
{ [op waitUntilFinished]; }


