/*
 Orthography.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// - create -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300// && __MAC_OS_X_VERSION_MIN_REQUIRED >= 101300
OrthographyRef OrthographyDefaultForLanguage( CFStringRef language );
#endif
OrthographyRef OrthographyWithDominantScript( CFStringRef script, CFDictionaryRef map );

// - correspondences between languages and scripts -
CFDictionaryRef OrthographyLanguageMap( OrthographyRef ref );
CFStringRef OrthographyDominantLanguage( OrthographyRef ref );
CFStringRef OrthographyDominantScript( OrthographyRef ref );
CFStringRef OrthographyDominantLanguageForScript( OrthographyRef ref, CFStringRef script );
CFArrayRef OrthographyLanguagesForScript( OrthographyRef ref, CFStringRef script );
CFArrayRef OrthographyAllScripts( OrthographyRef ref );
CFArrayRef OrthographyAllLanguages( OrthographyRef ref );

