/*
 Orthography.m

 Bernie Wylde
 */

#import "Orthography.h"

// - create -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300 && __MAC_OS_X_VERSION_MIN_REQUIRED >= 101300
OrthographyRef OrthographyDefaultForLanguage( CFStringRef language )
{ return [NSOrthography defaultOrthographyForLanguage:(NSString *)language]; }
#endif
OrthographyRef OrthographyWithDominantScript( CFStringRef script, CFDictionaryRef map )
{ return [NSOrthography orthographyWithDominantScript:(NSString *)script languageMap:(NSDictionary *)map]; }

// - correspondences between languages and scripts -
CFDictionaryRef OrthographyLanguageMap( OrthographyRef ref )
{ return (CFDictionaryRef)[ref languageMap]; }

CFStringRef OrthographyDominantLanguage( OrthographyRef ref )
{ return (CFStringRef)[ref dominantLanguage]; }

CFStringRef OrthographyDominantScript( OrthographyRef ref )
{ return (CFStringRef)[ref dominantScript]; }

CFStringRef OrthographyDominantLanguageForScript( OrthographyRef ref, CFStringRef script )
{ return (CFStringRef)[ref dominantLanguageForScript:(NSString *)script]; }

CFArrayRef OrthographyLanguagesForScript( OrthographyRef ref, CFStringRef script )
{ return (CFArrayRef)[ref languagesForScript:(NSString *)script]; }

CFArrayRef OrthographyAllScripts( OrthographyRef ref )
{ return (CFArrayRef)[ref allScripts]; }

CFArrayRef OrthographyAllLanguages( OrthographyRef ref )
{ return (CFArrayRef)[ref allLanguages]; }

