/*
 PDFInfo.m

 Bernie Wylde
 */

#import "PDFInfo.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
// - init -
PDFInfoRef PDFInfoInit( void )
{ return [[[NSPDFInfo alloc] init] autorelease]; }

// - methods -
CFURLRef PDFInfoURL( PDFInfoRef ref )
{ return (CFURLRef)[ref URL]; }

void PDFInfoSetURL( PDFInfoRef ref, CFURLRef url )
{ [ref setURL:(NSURL *)url]; }

Boolean PDFInfoIsFileExtensionHidden( PDFInfoRef ref )
{ return [ref isFileExtensionHidden]; }

void PDFInfoSetFileExtensionHidden( PDFInfoRef ref, Boolean flag )
{ [ref setFileExtensionHidden:flag]; }

CFArrayRef PDFInfoTagNames( PDFInfoRef ref )
{ return (CFArrayRef)[ref tagNames]; }

void PDFInfoSetTagNames( PDFInfoRef ref, CFArrayRef names )
{ [ref setTagNames:(NSArray *)names]; }

NSPaperOrientation PDFInfoOrientation( PDFInfoRef ref )
{ return [ref orientation]; }

void PDFInfoSetOrientation( PDFInfoRef ref, NSPaperOrientation orientation )
{ [ref setOrientation:orientation]; }

CGSize PDFInfoPaperSize( PDFInfoRef ref )
{ return NSSizeToCGSize([ref paperSize]); }

void PDFInfoSetPaperSize( PDFInfoRef ref, CGSize size )
{ [ref setPaperSize:NSSizeFromCGSize(size)]; }

CFMutableDictionaryRef PDFInfoAttributes( PDFInfoRef ref )
{ return (CFMutableDictionaryRef)[ref attributes]; }
#endif
