/*
 PDFPanel.m

 Bernie Wylde
 */

#import "PDFPanel.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
// - create -
PDFPanelRef PDFPanelInit( void )
{ return [NSPDFPanel panel]; }

// - contents -
// accessoryController
NSPDFPanelOptions PDFPanelOptions( PDFPanelRef ref )
{ return [ref options]; }

void PDFPanelSetOptions( PDFPanelRef ref, NSPDFPanelOptions options )
{ [ref setOptions:options]; }

CFStringRef PDFPanelDefaultFileName( PDFPanelRef ref )
{ return (CFStringRef)[ref defaultFileName]; }

void PDFPanelSetDefaultFileName( PDFPanelRef ref, CFStringRef fileName )
{ [ref setDefaultFileName:(NSString *)fileName]; }

// - display -
void PDFPanelBeginSheet( PDFPanelRef ref, PDFInfoRef info, NSInteger wndTag, CocoaPDFPanelCallbackType callback, void *userData )
{
    NSWindow *window = WindowWithTag( wndTag );
    if ( window ) {
        [ref beginSheetWithPDFInfo:info modalForWindow:window completionHandler:^(NSInteger returnCode) {
            if ( callback ) (*callback)(info,returnCode,userData);
        }];
    }
}
#endif

