/*
 PageLayout.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

typedef void (*CocoaPageLayoutCallbackType)(PageLayoutRef,NSInteger,void *);

@interface CocoaPageLayoutDelegate : NSObject {
    CocoaPageLayoutCallbackType callback;
}
@property (assign) CocoaPageLayoutCallbackType callback;
@end

CocoaPageLayoutDelegate *CocoaPageLayoutDelegateGet( void );

// - init -
PageLayoutRef PageLayoutInit( void );

// - dialog -
void PageLayoutBeginSheet( PageLayoutRef pageLayout, PrintInfoRef info, NSInteger wndTag, void *callback, void *userData );
NSInteger PageLayoutRunModal( PageLayoutRef pageLayout );
NSInteger PageLayoutRunModalWithPrintInfo( PageLayoutRef pageLayout, PrintInfoRef info );

// - customize -
void PageLayoutAddAccessoryController( PageLayoutRef pageLayout, ViewControllerRef vc );
void PageLayoutRemoveAccessoryController( PageLayoutRef pageLayout, ViewControllerRef vc );
CFArrayRef PageLayoutAccessoryControllers( PageLayoutRef pageLayout );

// - printinfo -
PrintInfoRef PageLayoutPrintInfo( PageLayoutRef pageLayout );

