/*
 PageLayout.m

 Bernie Wylde
 */

#import "PageLayout.h"

CocoaPageLayoutDelegate *sCocoaPageLayoutDelegate;

@implementation CocoaPageLayoutDelegate

@synthesize callback;

- (void)pageLayoutDidEnd:(NSPageLayout *)pageLayout returnCode:(NSInteger)returnCode  contextInfo:(void *)userData {
    if ( callback ) (*callback)(pageLayout,returnCode,userData);
}

@end

CocoaPageLayoutDelegate *CocoaPageLayoutDelegateGet( void )
{
    if ( !sCocoaPageLayoutDelegate ) sCocoaPageLayoutDelegate = [[CocoaPageLayoutDelegate alloc] init];
    return sCocoaPageLayoutDelegate;
}


// - init -
PageLayoutRef PageLayoutInit( void )
{ return [NSPageLayout pageLayout]; }

// - dialog -
void PageLayoutBeginSheet( PageLayoutRef pageLayout, PrintInfoRef info, NSInteger wndTag, void *callback, void *userData )
{
    NSWindow *w = CocoaWindowWithTag( wndTag );
    if ( w ) {
        CocoaPageLayoutDelegate *delegate = CocoaPageLayoutDelegateGet();
        delegate.callback = callback;
        [pageLayout beginSheetWithPrintInfo:info modalForWindow:w delegate:delegate didEndSelector:@selector(pageLayoutDidEnd:returnCode:contextInfo:) contextInfo:userData];
    }
}

NSInteger PageLayoutRunModal( PageLayoutRef pageLayout )
{ return [pageLayout runModal]; }

NSInteger PageLayoutRunModalWithPrintInfo( PageLayoutRef pageLayout, PrintInfoRef info )
{ return [pageLayout runModalWithPrintInfo:info]; }

// - customize -
void PageLayoutAddAccessoryController( PageLayoutRef pageLayout, ViewControllerRef vc )
{ [pageLayout addAccessoryController:vc]; }

void PageLayoutRemoveAccessoryController( PageLayoutRef pageLayout, ViewControllerRef vc )
{ [pageLayout removeAccessoryController:vc]; }

CFArrayRef PageLayoutAccessoryControllers( PageLayoutRef pageLayout )
{ return (CFArrayRef)[pageLayout accessoryControllers]; }

// - printinfo -
PrintInfoRef PageLayoutPrintInfo( PageLayoutRef pageLayout )
{ return [pageLayout printInfo]; }

