/*
 PanGestureRecognizer.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000

/*
 Subclass
 */
@interface CocoaPanGestureRecognizer : NSPanGestureRecognizer
@end

// - init -
PanGestureRecognizerRef PanGestureRecognizerInit( void *callback, void *userData );

// - configure -
NSUInteger PanGestureRecognizerButtonMask( PanGestureRecognizerRef ref );
void PanGestureRecognizerSetButtonMask( PanGestureRecognizerRef ref, NSUInteger mask );

// - tracking location and velocity -
CGPoint PanGestureRecognizerTranslationInView( PanGestureRecognizerRef ref, NSInteger tag );
void PanGestureRecognizerSetTranslationInView( PanGestureRecognizerRef ref, CGPoint translation, NSInteger tag );
CGPoint PanGestureRecognizerVelocityInView( PanGestureRecognizerRef ref, NSInteger tag );

// - instance properties -
NSInteger PanGestureRecognizerNumberOfTouchesRequired( PanGestureRecognizerRef ref );
void PanGestureRecognizerSetNumberOfTouchesRequired( PanGestureRecognizerRef ref, NSInteger touches );

#endif

