/*
 PanGestureRecognizer.m

 Bernie Wylde
 */

#import "PanGestureRecognizer.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000

/*
 Subclass
 */
@implementation CocoaPanGestureRecognizer 
@end

// - init -
PanGestureRecognizerRef PanGestureRecognizerInit( void *callback, void *userData )
{
    GestureRecognizerTarget *target = [[[GestureRecognizerTarget alloc] initWithCallback:callback userData:userData] autorelease];
    return [[[NSPanGestureRecognizer alloc] initWithTarget:target action:@selector(action:)] autorelease];
}

// - configure -
NSUInteger PanGestureRecognizerButtonMask( PanGestureRecognizerRef ref )
{ return [ref buttonMask]; }

void PanGestureRecognizerSetButtonMask( PanGestureRecognizerRef ref, NSUInteger mask )
{ [ref setButtonMask:mask]; }

// - tracking location and velocity -
CGPoint PanGestureRecognizerTranslationInView( PanGestureRecognizerRef ref, NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return NSPointToCGPoint([ref translationInView:view]);
    return CGPointZero;
}

void PanGestureRecognizerSetTranslationInView( PanGestureRecognizerRef ref, CGPoint translation, NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [ref setTranslation:NSPointFromCGPoint(translation) inView:view];
}

CGPoint PanGestureRecognizerVelocityInView( PanGestureRecognizerRef ref, NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return NSPointToCGPoint([ref velocityInView:view]);
    return CGPointZero;
}

// - instance properties -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101202
NSInteger PanGestureRecognizerNumberOfTouchesRequired( PanGestureRecognizerRef ref )
{ return [ref numberOfTouchesRequired]; }

void PanGestureRecognizerSetNumberOfTouchesRequired( PanGestureRecognizerRef ref, NSInteger touches )
{ [ref setNumberOfTouchesRequired:touches]; }
#endif

#endif
