/*
 Pasteboard.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// create
CocoaPasteboardRef PasteboardGeneral( void );
CocoaPasteboardRef PasteboardWithName( CFStringRef name );
CocoaPasteboardRef PasteboardWithUniqueName( void );
void PasteboardReleaseGlobally( CocoaPasteboardRef pb );

// writing data
NSInteger PasteboardRefClearContents( CocoaPasteboardRef pb );
Boolean PasteboardRefWriteObjects( CocoaPasteboardRef pb, CFArrayRef objects );
Boolean PasteboardRefSetStringForType( CocoaPasteboardRef pb, CFStringRef string, CFStringRef type );

// reading data
CFArrayRef PasteboardRefItems( CocoaPasteboardRef pb );
CFTypeRef PasteboardRefPropertyListForType( CocoaPasteboardRef pb, CFStringRef type );
CFStringRef PasteboardRefStringForType( CocoaPasteboardRef pb, CFStringRef type );

// validating contents
CFArrayRef PasteboardRefTypes( CocoaPasteboardRef pb );

// pasteboard info
CFStringRef PasteboardRefName( CocoaPasteboardRef pb );
NSInteger PasteboardRefChangeCount( CocoaPasteboardRef pb );


// - convenience - these functions work on the general pasteboard
// writing data
NSInteger PasteboardClearContents( void );
Boolean PasteboardWriteObjects( CFArrayRef objects );
Boolean PasteboardSetStringForType( CFStringRef string, CFStringRef type );

// reading data
CFArrayRef PasteboardItems( void );
CFTypeRef PasteboardPropertyListForType( CFStringRef type );
CFStringRef PasteboardStringForType( CFStringRef type );

// validating contents
CFArrayRef PasteboardTypes( void );

// pasteboard info
CFStringRef PasteboardName( void );
NSInteger PasteboardChangeCount( void );

