/*
 Pasteboard.m

 Bernie Wylde
 */

#import "Pasteboard.h"

// create
CocoaPasteboardRef PasteboardGeneral( void )
{ return [NSPasteboard generalPasteboard]; }

CocoaPasteboardRef PasteboardWithName( CFStringRef name )
{ return [NSPasteboard pasteboardWithName:(NSString *)name]; }

CocoaPasteboardRef PasteboardWithUniqueName( void )
{ return [NSPasteboard pasteboardWithUniqueName]; }

void PasteboardReleaseGlobally( CocoaPasteboardRef pb )
{ return [pb releaseGlobally]; }

// writing data
NSInteger PasteboardRefClearContents( CocoaPasteboardRef pb )
{ return [pb clearContents]; }

Boolean PasteboardRefWriteObjects( CocoaPasteboardRef pb, CFArrayRef objects )
{ return [pb writeObjects:(NSArray *)objects]; }

Boolean PasteboardRefSetStringForType( CocoaPasteboardRef pb, CFStringRef string, CFStringRef type )
{ return [pb setString:(NSString *)string forType:(NSString *)type]; }

// reading data
CFArrayRef PasteboardRefItems( CocoaPasteboardRef pb )
{ return (CFArrayRef)[pb pasteboardItems]; }

CFTypeRef PasteboardRefPropertyListForType( CocoaPasteboardRef pb, CFStringRef type )
{ return (CFTypeRef)[pb propertyListForType:(NSString *)type]; }

CFStringRef PasteboardRefStringForType( CocoaPasteboardRef pb, CFStringRef type )
{ return (CFStringRef)[pb stringForType:(NSString *)type]; }

// validating contents
CFArrayRef PasteboardRefTypes( CocoaPasteboardRef pb )
{ return (CFArrayRef)[pb types]; }

// pasteboard info
CFStringRef PasteboardRefName( CocoaPasteboardRef pb )
{ return (CFStringRef)[pb name]; }

NSInteger PasteboardRefChangeCount( CocoaPasteboardRef pb )
{ return [pb changeCount]; }


// - convenience - these functions work on the general pasteboard
// writing data
NSInteger PasteboardClearContents( void )
{ return [[NSPasteboard generalPasteboard] clearContents]; }

Boolean PasteboardWriteObjects( CFArrayRef objects )
{ return [[NSPasteboard generalPasteboard] writeObjects:(NSArray *)objects]; }

Boolean PasteboardSetStringForType( CFStringRef string, CFStringRef type )
{ return [[NSPasteboard generalPasteboard] setString:(NSString *)string forType:(NSString *)type]; }

// reading data
CFArrayRef PasteboardItems( void )
{ return (CFArrayRef)[[NSPasteboard generalPasteboard] pasteboardItems]; }

CFTypeRef PasteboardPropertyListForType( CFStringRef type )
{ return (CFTypeRef)[[NSPasteboard generalPasteboard] propertyListForType:(NSString *)type]; }

CFStringRef PasteboardStringForType( CFStringRef type )
{ return (CFStringRef)[[NSPasteboard generalPasteboard] stringForType:(NSString *)type]; }

// validating contents
CFArrayRef PasteboardTypes( void )
{ return (CFArrayRef)[[NSPasteboard generalPasteboard] types]; }

// pasteboard info
CFStringRef PasteboardName( void )
{ return (CFStringRef)[[NSPasteboard generalPasteboard] name]; }

NSInteger PasteboardChangeCount( void )
{ return [[NSPasteboard generalPasteboard] changeCount]; }

