/*
 PointerArray.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// - create -
PointerArrayRef PointerArrayWithOptions( NSPointerFunctionsOptions options );
PointerArrayRef PointerArrayWithPointerFunctions( PointerFunctionsRef pf );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1080
PointerArrayRef PointerArrayStrongObjects( void );
PointerArrayRef PointerArrayWeakObjects( void );
#endif

// - manage -
NSUInteger PointerArrayCount( PointerArrayRef pa );
CFArrayRef PointerArrayAllObjects( PointerArrayRef pa );
void *PointerArrayPointerAtIndex( PointerArrayRef pa, NSUInteger index );
void PointerArrayAddPointer( PointerArrayRef pa, void *p );
void PointerArrayRemovePointerAtIndex( PointerArrayRef pa, NSUInteger index );
void PointerArrayInsertPointerAtIndex( PointerArrayRef pa, void *p, NSUInteger index );
void PointerArrayReplacePointerAtIndex( PointerArrayRef pa, void *p, NSUInteger index );
void PointerArrayCompact( PointerArrayRef pa );

// - pointer functions -
PointerFunctionsRef PointerArrayPointerFunctions( PointerArrayRef pa );

