/*
 PointerArray.m

 Bernie Wylde
 */

#import "PointerArray.h"

// - create -
PointerArrayRef PointerArrayWithOptions( NSPointerFunctionsOptions options )
{ return [NSPointerArray pointerArrayWithOptions:options]; }

PointerArrayRef PointerArrayWithPointerFunctions( PointerFunctionsRef pf )
{ return [NSPointerArray pointerArrayWithPointerFunctions:pf]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1080
PointerArrayRef PointerArrayStrongObjects( void )
{ return [NSPointerArray strongObjectsPointerArray]; }

PointerArrayRef PointerArrayWeakObjects( void )
{ return [NSPointerArray weakObjectsPointerArray]; }
#endif

// - manage -
NSUInteger PointerArrayCount( PointerArrayRef pa )
{ return [pa count]; }

CFArrayRef PointerArrayAllObjects( PointerArrayRef pa )
{ return (CFArrayRef)[pa allObjects]; }

void *PointerArrayPointerAtIndex( PointerArrayRef pa, NSUInteger index )
{ return [pa pointerAtIndex:index]; }

void PointerArrayAddPointer( PointerArrayRef pa, void *p )
{ [pa addPointer:p]; }

void PointerArrayRemovePointerAtIndex( PointerArrayRef pa, NSUInteger index )
{ [pa removePointerAtIndex:index]; }

void PointerArrayInsertPointerAtIndex( PointerArrayRef pa, void *p, NSUInteger index )
{ [pa insertPointer:p atIndex:index]; }

void PointerArrayReplacePointerAtIndex( PointerArrayRef pa, void *p, NSUInteger index )
{ [pa replacePointerAtIndex:index withPointer:p]; }

void PointerArrayCompact( PointerArrayRef pa )
{ [pa compact]; }

// - pointer functions -
PointerFunctionsRef PointerArrayPointerFunctions( PointerArrayRef pa )
{ return [pa pointerFunctions]; }
