/*
 PointerFunctions.m

 Bernie Wylde
 */

#import "PointerFunctions.h"

// - create -
PointerFunctionsRef PointerFunctionsWithOptions( NSPointerFunctionsOptions options )
{ return [NSPointerFunctions pointerFunctionsWithOptions:options]; }

// - personality functions -
void *PointerFunctionsHashFunction( PointerFunctionsRef pf )
{ return [pf hashFunction]; }

void PointerFunctionsSetHashFunction( PointerFunctionsRef pf, void *fnAddress )
{ [pf setHashFunction:fnAddress]; }

void *PointerFunctionsIsEqualFunction( PointerFunctionsRef pf )
{ return [pf isEqualFunction]; }

void PointerFunctionsSetIsEqualFunction( PointerFunctionsRef pf, void *fnAddress )
{ [pf setIsEqualFunction:fnAddress]; }

void *PointerFunctionsSizeFunction( PointerFunctionsRef pf )
{ return [pf sizeFunction]; }

void PointerFunctionsSetSizeFunction( PointerFunctionsRef pf, void *fnAddress )
{ [pf setSizeFunction:fnAddress]; }

void *PointerFunctionsDescriptionFunction( PointerFunctionsRef pf )
{ return [pf descriptionFunction]; }

void PointerFunctionsSetDescriptionFunction( PointerFunctionsRef pf, void *fnAddress )
{ [pf setDescriptionFunction:fnAddress]; }

// - memory configuration -
void *PointerFunctionsAcquireFunction( PointerFunctionsRef pf )
{ return [pf acquireFunction]; }

void PointerFunctionsSetAcquireFunction( PointerFunctionsRef pf, void *fnAddress )
{ [pf setAcquireFunction:fnAddress]; }

void *PointerFunctionsRelinquishFunction( PointerFunctionsRef pf )
{ return [pf relinquishFunction]; }

void PointerFunctionsSetRelinquishFunction( PointerFunctionsRef pf, void *fnAddress )
{ [pf setRelinquishFunction:fnAddress]; }

