/*
 PopUpButton.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

@interface PopUpButtonSC : NSPopUpButton
@end

//@interface CocoaPopUpButtonTarget : NSObject
//@end

NSPopUpButton *PopUpButtonWithTag( NSInteger tag );
BOOL PopUpButtonExists( NSInteger tag );

// Type of menu
Boolean PopUpButtonPullsDown( NSInteger tag );
void PopUpButtonSetPullsDown( NSInteger tag, Boolean flag );
Boolean PopUpButtonAutoenablesItems( NSInteger tag );
void PopUpButtonSetAutoenablesItems( NSInteger tag, Boolean flag );


void PopUpButtonAddItemWithTitle( NSInteger tag, CFStringRef title );
void PopUpButtonAddItemsWithTitles( NSInteger tag, CFArrayRef titles );
void PopUpButtonInsertItemWithTitle( NSInteger tag, CFStringRef title, NSInteger index );
void PopUpButtonRemoveAllItems( NSInteger tag );
void PopUpButtonRemoveItemWithTitle( NSInteger tag, CFStringRef title );
void PopUpButtonRemoveItemAtIndex( NSInteger tag, NSInteger index );
CFStringRef PopUpButtonTitleOfSelectedItem( NSInteger tag );
NSInteger PopUpButtonIndexOfSelectedItem( NSInteger tag );
void PopUpButtonSelectItemAtIndex( NSInteger tag, NSInteger index );
void PopUpButtonSelectItemWithTag( NSInteger popUpTag, NSInteger itemTag );
void PopUpButtonSelectItemWithTitle( NSInteger tag, CFStringRef title );
NSInteger PopUpButtonNumberOfItems( NSInteger tag );
CFArrayRef PopUpButtonItemArray( NSInteger tag );
CFStringRef PopUpButtonItemTitleAtIndex( NSInteger tag, NSInteger index );
CFArrayRef PopUpButtonItemTitles( NSInteger tag );

NSInteger PopUpButtonIndexOfItemWithTag( NSInteger popUpTag, NSInteger itemTag );
NSInteger PopUpButtonIndexOfItemWithTitle( NSInteger tag, CFStringRef title );

CocoaMenuRef PopUpButtonMenu( NSInteger tag );
void PopUpButtonSetMenu( NSInteger tag, CocoaMenuRef menu );
NSInteger PopUpButtonMenuIndex( NSInteger tag );
void PopUpButtonSetMenuIndex( NSInteger tag, NSInteger menuIndex );

void PopUpButtonSetTitle( NSInteger tag, CFStringRef title );
void PopUpButtonItemSetEnabled( NSInteger tag, NSInteger index, Boolean flag );

// Edge
CGRectEdge PopUpButtonPreferredEdge( NSInteger tag );
void PopUpButtonSetPreferredEdge( NSInteger tag, CGRectEdge edge );

// State
void PopUpButtonSynchronizeTitleAndSelectedItem( NSInteger tag );

// -- PopUpButtonCell methods --
Boolean PopUpButtonUsesItemFromMenu( NSInteger tag );
void PopUpButtonSetUsesItemFromMenu( NSInteger tag, Boolean flag );
Boolean PopUpButtonAltersStateOfSelectedItem( NSInteger tag );
void PopUpButtonSetAltersStateOfSelectedItem( NSInteger tag, Boolean flag );
NSPopUpArrowPosition PopUpButtonArrowPosition( NSInteger tag );
void PopUpButtonSetArrowPosition( NSInteger tag, NSPopUpArrowPosition position );


// Init
PopUpButtonRef PopUpButtonInit( NSInteger tag, CGRect r );

// Statement
void CocoaPopUpButton( NSInteger inTag, NSInteger inEnabled, NSInteger inIndex, CFTypeRef inItems, CGRect inRect, NSInteger inPullsDown, NSInteger inWndTag );
