/*
 PopUpButton.m

 Bernie Wylde
 */

#import "PopUpButton.h"

#pragma mark - subclass
@implementation PopUpButtonSC
- (void)drawRect:(NSRect)dirtyRect {
    CocoaSubclassDrawRect( self, dirtyRect );
    if ( !DialogEventBool() ) [super drawRect:dirtyRect];
}

- (BOOL)acceptsFirstResponder {
    DialogEventSetBool(NO);
    CocoaSubclassAcceptsFirstResponder( self );
    return DialogEventBool();
}

- (void)mouseDown:(NSEvent *)event {
    CocoaSubclassMouseDown( self, event );
    if ( !DialogEventBool() ) [super mouseDown:event];
}

- (void)mouseUp:(NSEvent *)event {
    CocoaSubclassMouseUp( self, event );
}

- (void)mouseEntered:(NSEvent *)event {
    CocoaSubclassMouseEntered( self, event );
}

- (void)mouseExited:(NSEvent *)event {
    CocoaSubclassMouseExited( self, event );
}

- (void)mouseDragged:(NSEvent *)event {
    CocoaSubclassMouseDragged( self, event );
}

- (void)mouseMoved:(NSEvent *)event {
    CocoaSubclassMouseMoved( self, event );
}

- (void)rightMouseDown:(NSEvent *)event {
    CocoaSubclassRightMouseDown( self, event );
    if ( !DialogEventBool() ) [super rightMouseDown:event];
}

- (void)rightMouseUp:(NSEvent *)event {
    CocoaSubclassRightMouseUp( self, event );
}

- (void)rightMouseDragged:(NSEvent *)event {
    CocoaSubclassRightMouseDragged( self, event );
}

- (void)keyDown:(NSEvent *)event {
    CocoaSubclassKeyDown( self, event );
    if ( !DialogEventBool() ) [super keyDown:event];
}

- (void)keyUp:(NSEvent *)event {
    CocoaSubclassKeyUp( self, event );
}

- (void)flagsChanged:(NSEvent *)event {
    CocoaSubclassFlagsChanged( self, event );
}
@end

//NSPopUpButton *PopUpButtonWithTag( NSInteger tag )
//{ return (NSPopUpButton *)CocoaValidateViewKindOfClass( tag, [NSPopUpButton class] ); }

NSPopUpButton *PopUpButtonWithTag( NSInteger tag )
{ return (NSPopUpButton *)CocoaFindViewWithTag( tag, [NSPopUpButton class] ); }

BOOL PopUpButtonExists( NSInteger tag )
{ return CocoaViewWithKindOfClassExists( tag, [NSPopUpButton class] ); }


// Type of menu
Boolean PopUpButtonPullsDown( NSInteger tag )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) return [btn pullsDown];
    return NO;
}

void PopUpButtonSetPullsDown( NSInteger tag, Boolean flag )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) [btn setPullsDown:tag];
}

Boolean PopUpButtonAutoenablesItems( NSInteger tag )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) return [btn autoenablesItems];
    return NO;
}

// State
void PopUpButtonSynchronizeTitleAndSelectedItem( NSInteger tag )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) [btn synchronizeTitleAndSelectedItem];
}



void PopUpButtonAddItemWithTitle( NSInteger tag, CFStringRef title )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) [btn addItemWithTitle:(NSString *)title];
}

void PopUpButtonAddItemsWithTitles( NSInteger tag, CFArrayRef titles )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) [btn addItemsWithTitles:(NSArray *)titles];
}

void PopUpButtonInsertItemWithTitle( NSInteger tag, CFStringRef title, NSInteger index )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) [btn insertItemWithTitle:(NSString *)title atIndex:index];
}

void PopUpButtonRemoveAllItems( NSInteger tag )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) [btn removeAllItems];
}

void PopUpButtonRemoveItemWithTitle( NSInteger tag, CFStringRef title )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) [btn removeItemWithTitle:(NSString *)title];
}

void PopUpButtonRemoveItemAtIndex( NSInteger tag, NSInteger index )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) [btn removeItemAtIndex:index];
}

CFStringRef PopUpButtonTitleOfSelectedItem( NSInteger tag )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) return (CFStringRef)[btn titleOfSelectedItem];
    return NULL;
}

NSInteger PopUpButtonIndexOfSelectedItem( NSInteger tag )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) return [btn indexOfSelectedItem];
    return 0;
}

void PopUpButtonSelectItemAtIndex( NSInteger tag, NSInteger index )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) [btn selectItemAtIndex:index];
}

void PopUpButtonSelectItemWithTag( NSInteger popUpTag, NSInteger itemTag )
{
    NSPopUpButton *btn = PopUpButtonWithTag( popUpTag );
    if ( btn ) [btn selectItemWithTag:itemTag];
}

void PopUpButtonSelectItemWithTitle( NSInteger tag, CFStringRef title )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) [btn selectItemWithTitle:(NSString *)title];
}

NSInteger PopUpButtonNumberOfItems( NSInteger tag )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) return [btn numberOfItems];
    return 0;
}

CFArrayRef PopUpButtonItemArray( NSInteger tag )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) return (CFArrayRef)[btn itemArray];
    return NULL;
}

CFStringRef PopUpButtonItemTitleAtIndex( NSInteger tag, NSInteger index )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) return (CFStringRef)[btn itemTitleAtIndex:index];
    return NULL;
}

CFArrayRef PopUpButtonItemTitles( NSInteger tag )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) return (CFArrayRef)[btn itemTitles];
    return NULL;
}

NSInteger PopUpButtonIndexOfItemWithTag( NSInteger popUpTag, NSInteger itemTag )
{
    NSPopUpButton *btn = PopUpButtonWithTag( popUpTag );
    if ( btn ) return [btn indexOfItemWithTag:itemTag];
    return 0;
}

NSInteger PopUpButtonIndexOfItemWithTitle( NSInteger tag, CFStringRef title )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) return [btn indexOfItemWithTitle:(NSString *)title];
    return 0;
}

CocoaMenuRef PopUpButtonMenu( NSInteger tag )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) return [btn menu];
    return nil;
}

void PopUpButtonSetMenu( NSInteger tag, CocoaMenuRef menu )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) [btn setMenu:menu];
}

NSInteger PopUpButtonMenuIndex( NSInteger tag )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) {
        NSMenu *menu = [btn menu];
        if ( menu ) {
            return CocoaMenuIndex( menu );
        }
    }
    return 0;
}

void PopUpButtonSetMenuIndex( NSInteger tag, NSInteger menuIndex )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) {
        NSMenu *menu = MenuAtIndex( menuIndex );
        if ( menu ) [btn setMenu:menu];
    }
}

void PopUpButtonSetTitle( NSInteger tag, CFStringRef title )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) [btn setTitle:(NSString *)title];
}

void PopUpButtonSetPreferredEdge( NSInteger tag, CGRectEdge edge )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) [btn setPreferredEdge:(NSRectEdge)edge];
}

void PopUpButtonSetAutoenablesItems( NSInteger tag, Boolean flag )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) [btn setAutoenablesItems:flag];
}

void PopUpButtonItemSetEnabled( NSInteger tag, NSInteger index, Boolean flag )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) {
        NSMenuItem *item = [btn itemAtIndex:index];
        if ( item ) [item setEnabled:flag];
    }
}

// Edge
CGRectEdge PopUpButtonPreferredEdge( NSInteger tag )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) return (CGRectEdge)[btn preferredEdge];
    return CGRectMaxXEdge;
}


// -- PopUpButtonCell methods --
Boolean PopUpButtonUsesItemFromMenu( NSInteger tag )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) return [[btn cell] usesItemFromMenu];
    return NO;
}

void PopUpButtonSetUsesItemFromMenu( NSInteger tag, Boolean flag )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) [[btn cell] setUsesItemFromMenu:flag];
}

Boolean PopUpButtonAltersStateOfSelectedItem( NSInteger tag )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) return [[btn cell] altersStateOfSelectedItem];
    return NO;
}

void PopUpButtonSetAltersStateOfSelectedItem( NSInteger tag, Boolean flag )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) [[btn cell] setAltersStateOfSelectedItem:flag];
}

NSPopUpArrowPosition PopUpButtonArrowPosition( NSInteger tag )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) return [[btn cell] arrowPosition];
    return 0;
}

void PopUpButtonSetArrowPosition( NSInteger tag, NSPopUpArrowPosition position )
{
    NSPopUpButton *btn = PopUpButtonWithTag( tag );
    if ( btn ) [[btn cell] setArrowPosition:position];
}

// Init
PopUpButtonRef PopUpButtonInit( NSInteger inTag, CGRect inRect )
{
    // rect
    NSRect rect = NSRectFromCGRect( inRect );
    if ( NSIsEmptyRect( rect ) ) {
        rect = NSMakeRect( 18, 17, 76, 26 );
    }

    // subclass
    BOOL subclass = IsSubclassFlag();

    // init
    NSPopUpButton *btn;
    if ( subclass ) {
        btn = [[[PopUpButtonSC alloc] initWithFrame:rect pullsDown:NO] autorelease];
    } else {
        btn = [[[NSPopUpButton alloc] initWithFrame:rect pullsDown:NO] autorelease];
    }

    // tag
    [btn setTag: inTag];

    // fix font
    CocoaControlFixFont( btn );

    // target/action
    [btn setTarget:CocoaControlTargetObj()];
    [btn setAction:@selector(controlAction:)];

    return btn;
}

// Statement
void CocoaPopUpButton( NSInteger inTag, NSInteger inEnabled, NSInteger inIndex, CFTypeRef inItems, CGRect inRect, NSInteger inPullsDown, NSInteger inWndTag )
{
    BOOL show = ( inTag > 0 );
    inTag = ABS(inTag);
    
    NSRect rect = NSRectFromCGRect( inRect );
    
    // target window
    id w = CocoaTargetWindow( &inWndTag );
    
    if ( w ) {
        NSView *contentView = CocoaTargetContentView( w );
        NSPopUpButton *btn = CocoaViewSubviewWithTag( contentView, inTag );
        
        if ( !btn ) {
            btn = TitlebarAccessoryViewWithTag( inTag );
        }
        
        if ( btn ) {
            
            // make sure it's correct class
//            if ( !CocoaValidateViewClass( inWndTag, inTag, [btn class], [NSPopUpButton class] ) ) {
//                return;
//            }
            
            if ( !CocoaValidateViewClass( inWndTag, inTag, btn, [NSPopUpButton class] ) ) {
                return;
            }

            // enabled
            if ( inEnabled != kFBParamMissing ) [btn setEnabled:inEnabled];
            
            // index
            if ( inIndex != kFBParamMissing ) {
                if ( inIndex < [btn numberOfItems] ) [btn selectItemAtIndex:inIndex];
            }
            
            // items
            if ( inItems ) {
                NSArray *items = nil;
                if ( CFGetTypeID(inItems) == CFStringGetTypeID() ) {
                    items = [(NSString *)inItems componentsSeparatedByString:@";"];
                } else if ( CFGetTypeID(inItems) == CFArrayGetTypeID() ) {
                    items = (NSArray *)inItems;
                }
                
                if ( items ) {
                    [btn removeAllItems];
                    NSMenu *menu = [btn menu];
                    for ( NSString *item in items ) {
                        if ( [item isEqualToString:@"-"] ) {
                            [menu addItem:[NSMenuItem separatorItem]];
                        } else {
                            [menu addItemWithTitle:item action:nil keyEquivalent:@""];
                        }
                    }
                }
            }
            
            // rect
            if ( !NSIsEmptyRect( rect ) ) [btn setFrame:rect];
            
            // pullsDown
            if ( inPullsDown != kFBParamMissing ) [btn setPullsDown:inPullsDown];
            
        } else {
            
            // rect
//            if ( NSIsEmptyRect( rect ) ) {
//                rect = NSMakeRect( 18, 17, 76, 26 );
//            }
            
//            if ( subclass ) {
//                btn = [[PopUpButtonSC alloc] initWithFrame:rect pullsDown:inPullsDown];
//            } else {
//                btn = [[NSPopUpButton alloc] initWithFrame:rect pullsDown:inPullsDown];
//            }
            
            btn = PopUpButtonInit( inTag, inRect );
            
            // pulls down
            if ( inPullsDown != kFBParamMissing ) [btn setPullsDown:YES];

            // default autoresizing
            [btn setAutoresizingMask:NSViewMinYMargin];
            
            // tag
//            [btn setTag: inTag];
            
            // enabled
            if ( inEnabled != kFBParamMissing ) [btn setEnabled:inEnabled];
            
            // items
            if ( inItems ) {
                NSArray *items = nil;
                if ( CFGetTypeID(inItems) == CFStringGetTypeID() ) {
                    items = [(NSString *)inItems componentsSeparatedByString:@";"];
                } else if ( CFGetTypeID(inItems) == CFArrayGetTypeID() ) {
                    items = (NSArray *)inItems;
                }
                if ( items ) {
                    NSMenu *menu = [btn menu];
                    for ( NSString *item in items ) {
                        if ( [item isEqualToString:@"-"] ) {
                            [menu addItem:[NSMenuItem separatorItem]];
                        } else {
                            [menu addItemWithTitle:item action:nil keyEquivalent:@""];
                        }
                    }
                }
            }
            
            // index
            if ( inIndex != kFBParamMissing ) {
                if ( inIndex < [btn numberOfItems] ) [btn selectItemAtIndex:inIndex];
            }
            
            // wndTag
            [btn setWndTag:inWndTag];
            
            // fix font
//            CocoaControlFixFont( btn );
            
            // target/action
//            [btn setTarget:CocoaControlTargetObj()];
//            [btn setAction:@selector(controlAction:)];
            
            // add to window
            [contentView addSubview:btn];
 //           [btn release];
        }
        
        [btn setHidden:!show];
    } else {
        CocoaShowWindowDoesNotExistAlert( inWndTag );
    }
}

