/*
 Port.m

 Bernie Wylde
 */

#import "Port.h"

// Create
PortRef PortInit( void )
{ return [NSPort port]; }

// Validate
void PortInvalidate( PortRef ref )
{ [ref invalidate]; }

Boolean PortIsValid( PortRef ref )
{ return [ref isValid]; }

// Info
Boolean PortSendBeforeDate( PortRef ref, CFDateRef dt, CFMutableArrayRef components, PortRef fromPort, NSUInteger reserved )
{ return [ref sendBeforeDate:(NSDate *)dt components:(NSMutableArray *)components from:fromPort reserved:reserved]; }

Boolean PortSendBeforeDateMsgID( PortRef ref, CFDateRef dt, NSUInteger msgID, CFMutableArrayRef components, PortRef fromPort, NSUInteger reserved )
{ return [ref sendBeforeDate:(NSDate *)dt msgid:msgID components:(NSMutableArray *)components from:fromPort reserved:reserved]; }

NSUInteger PortReservedSpaceLength( PortRef ref )
{ return [ref reservedSpaceLength]; }

// Monitoring
void PortRemoveFromRunLoop( PortRef ref, RunLoopRef runLoop, CFStringRef mode )
{ [ref removeFromRunLoop:runLoop forMode:(NSString *)mode]; }

void PortScheduleInRunLoop( PortRef ref, RunLoopRef runLoop, CFStringRef mode )
{ [ref scheduleInRunLoop:runLoop forMode:(NSString *)mode]; }

