/*
 Predicate.h
 
 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// Create
PredicateRef PredicateWithFormat( CFStringRef format, ... );
PredicateRef PredicateWithFormatAndArgumentArray( CFStringRef format, CFArrayRef arguments );
PredicateRef PredicateWithSubstitionVariables( PredicateRef pred, CFDictionaryRef variables );
PredicateRef PredicateWithValue( Boolean value );
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
PredicateRef PredicateFromMetadataQueryString( CFStringRef string );
#endif

// Evaluate
Boolean PredicateEvaluateWithObject( PredicateRef pred, CFTypeRef obj );
Boolean PredicateEvaluateWithObjectAndSubstitutionVariables( PredicateRef pred, CFTypeRef obj, CFDictionaryRef variables );
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
void PredicateAllowEvaluation( PredicateRef pred );
#endif

// String representation
CFStringRef PredicateFormat( PredicateRef pred );

