/*
 PressGestureRecognizer.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000

/*
 Subclass
 */
@interface CocoaPressGestureRecognizer : NSPressGestureRecognizer
@end

// - init -
PressGestureRecognizerRef PressGestureRecognizerInit( void *callback, void *userData );

// - configure -
NSUInteger PressGestureRecognizerButtonMask( PressGestureRecognizerRef ref );
void PressGestureRecognizerSetButtonMask( PressGestureRecognizerRef ref, NSUInteger mask );
CFTimeInterval PressGestureRecognizerMinimumPressDuration( PressGestureRecognizerRef ref );
void PressGestureRecognizerSetMinimumPressDuration( PressGestureRecognizerRef ref, CFTimeInterval duration );
CGFloat PressGestureRecognizerAllowableMovement( PressGestureRecognizerRef ref );
void PressGestureRecognizerSetAllowableMovement( PressGestureRecognizerRef ref, CGFloat movement );

// - instance properties -
NSInteger PressGestureRecognizerNumberOfTouchesRequired( PressGestureRecognizerRef ref );
void PressGestureRecognizerSetNumberOfTouchesRequired( PressGestureRecognizerRef ref, NSInteger touches );

#endif
