/*
 PressGestureRecognizer.m

 Bernie Wylde
 */

#import "PressGestureRecognizer.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000

/*
 Subclass
 */
@implementation CocoaPressGestureRecognizer
@end

// - init -
PressGestureRecognizerRef PressGestureRecognizerInit( void *callback, void *userData )
{
    GestureRecognizerTarget *target = [[[GestureRecognizerTarget alloc] initWithCallback:callback userData:userData] autorelease];
    return [[[NSPressGestureRecognizer alloc] initWithTarget:target action:@selector(action:)] autorelease];
}

// - configure -
NSUInteger PressGestureRecognizerButtonMask( PressGestureRecognizerRef ref )
{ return [ref buttonMask]; }

void PressGestureRecognizerSetButtonMask( PressGestureRecognizerRef ref, NSUInteger mask )
{ [ref setButtonMask:mask]; }

CFTimeInterval PressGestureRecognizerMinimumPressDuration( PressGestureRecognizerRef ref )
{ return [ref minimumPressDuration]; }

void PressGestureRecognizerSetMinimumPressDuration( PressGestureRecognizerRef ref, CFTimeInterval duration )
{ [ref setMinimumPressDuration:duration]; }

CGFloat PressGestureRecognizerAllowableMovement( PressGestureRecognizerRef ref )
{ return [ref allowableMovement]; }

void PressGestureRecognizerSetAllowableMovement( PressGestureRecognizerRef ref, CGFloat movement )
{ [ref setAllowableMovement:movement]; }

// - instance properties -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101202
NSInteger PressGestureRecognizerNumberOfTouchesRequired( PressGestureRecognizerRef ref )
{ return [ref numberOfTouchesRequired]; }

void PressGestureRecognizerSetNumberOfTouchesRequired( PressGestureRecognizerRef ref, NSInteger touches )
{ [ref setNumberOfTouchesRequired:touches]; }
#endif

#endif
