/*
 PrintInfo.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

PrintInfoRef PrintInfoWithDictionary( CFDictionaryRef dict );
PrintInfoRef PrintInfoShared( void );
CGFloat PrintInfoLeftMargin( void );
void PrintInfoSetLeftMargin( CGFloat value );
CGFloat PrintInfoTopMargin( void );
void PrintInfoSetTopMargin( CGFloat value );
CGFloat PrintInfoRightMargin( void );
void PrintInfoSetRightMargin( CGFloat value );
CGFloat PrintInfoBottomMargin( void );
void PrintInfoSetBottomMargin( CGFloat value );
CGRect PrintInfoImageablePageBounds( void );
NSInteger PrintInfoOrientation( void );
void PrintInfoSetOrientation( NSInteger orientation );
CFStringRef PrintInfoPaperName( void );
void PrintInfoSetPaperName( CFStringRef string );
CFStringRef PrintInfoLocalizedPaperName( void );
CGSize PrintInfoPaperSize( void );
void PrintInfoSetPaperSize( CGSize size );
NSPrintingPaginationMode PrintInfoHorizontalPagination( void );
void PrintInfoSetHorizontalPagination( NSPrintingPaginationMode value );
NSPrintingPaginationMode PrintInfoVerticalPagination( void );
void PrintInfoSetVerticalPagination( NSPrintingPaginationMode value );
Boolean PrintInfoIsHorizontallyCentered( void );
void PrintInfoSetHorizontallyCentered( Boolean flag );
Boolean PrintInfoIsVerticallyCentered( void );
void PrintInfoSetVerticallyCentered( Boolean flag );
PrinterRef PrintInfoPrinter( void );
void PrintInfoSetPrinter( PrinterRef printer );
CFStringRef PrintInfoJobDisposition( void );
void PrintInfoSetJobDisposition( CFStringRef value );
void PrintInfoSetUpPrintOperationDefaultValues( void );
CFMutableDictionaryRef PrintInfoDictionary( void );
Boolean PrintInfoIsSelectionOnly( void );
void PrintInfoSetSelectionOnly( Boolean flag );
CGFloat PrintInfoScalingFactor( void );
void PrintInfoSetScalingFactor( CGFloat value );
CFMutableDictionaryRef PrintInfoPrintSettings( void );

// - instance methods -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
void PrintInfoTakeSettingsFromPDFInfo( PDFInfoRef info );
#endif

