/*
 PrintInfo.m

 Bernie Wylde
 */

#import "PrintInfo.h"

PrintInfoRef PrintInfoWithDictionary( CFDictionaryRef dict )
{ return [[[NSPrintInfo alloc] initWithDictionary:(NSDictionary *)dict] autorelease]; }

PrintInfoRef PrintInfoShared( void )
{ return [NSPrintInfo sharedPrintInfo]; }

CGFloat PrintInfoLeftMargin( void )
{ return [[NSPrintInfo sharedPrintInfo] leftMargin]; }

void PrintInfoSetLeftMargin( CGFloat value )
{ [[NSPrintInfo sharedPrintInfo] setLeftMargin:value]; }

CGFloat PrintInfoTopMargin( void )
{ return [[NSPrintInfo sharedPrintInfo] topMargin]; }

void PrintInfoSetTopMargin( CGFloat value )
{ [[NSPrintInfo sharedPrintInfo] setTopMargin:value]; }

CGFloat PrintInfoRightMargin( void )
{ return [[NSPrintInfo sharedPrintInfo] rightMargin]; }

void PrintInfoSetRightMargin( CGFloat value )
{ [[NSPrintInfo sharedPrintInfo] setRightMargin:value]; }

CGFloat PrintInfoBottomMargin( void )
{ return [[NSPrintInfo sharedPrintInfo] bottomMargin]; }

void PrintInfoSetBottomMargin( CGFloat value )
{ [[NSPrintInfo sharedPrintInfo] setBottomMargin:value]; }

CGRect PrintInfoImageablePageBounds( void )
{ return NSRectToCGRect([[NSPrintInfo sharedPrintInfo] imageablePageBounds]); }

NSInteger PrintInfoOrientation( void )
{ return [[NSPrintInfo sharedPrintInfo] orientation]; }

void PrintInfoSetOrientation( NSInteger orientation )
{ [[NSPrintInfo sharedPrintInfo] setOrientation:orientation]; }

CFStringRef PrintInfoPaperName( void )
{ return (CFStringRef)[[NSPrintInfo sharedPrintInfo] paperName]; }

void PrintInfoSetPaperName( CFStringRef string )
{ [[NSPrintInfo sharedPrintInfo] setPaperName:(NSString *)string]; }

CFStringRef PrintInfoLocalizedPaperName( void )
{ return (CFStringRef)[[NSPrintInfo sharedPrintInfo] localizedPaperName]; }

CGSize PrintInfoPaperSize( void )
{ return NSSizeToCGSize([[NSPrintInfo sharedPrintInfo] paperSize]); }

void PrintInfoSetPaperSize( CGSize size )
{ [[NSPrintInfo sharedPrintInfo] setPaperSize:NSSizeFromCGSize(size)]; }

NSPrintingPaginationMode PrintInfoHorizontalPagination( void )
{ return [[NSPrintInfo sharedPrintInfo] horizontalPagination]; }

void PrintInfoSetHorizontalPagination( NSPrintingPaginationMode value )
{ [[NSPrintInfo sharedPrintInfo] setHorizontalPagination:value]; }

NSPrintingPaginationMode PrintInfoVerticalPagination( void )
{ return [[NSPrintInfo sharedPrintInfo] verticalPagination]; }

void PrintInfoSetVerticalPagination( NSPrintingPaginationMode value )
{ [[NSPrintInfo sharedPrintInfo] setVerticalPagination:value]; }

Boolean PrintInfoIsHorizontallyCentered( void )
{ return [[NSPrintInfo sharedPrintInfo] isHorizontallyCentered]; }

void PrintInfoSetHorizontallyCentered( Boolean flag )
{ [[NSPrintInfo sharedPrintInfo] setHorizontallyCentered:flag]; }

Boolean PrintInfoIsVerticallyCentered( void )
{ return [[NSPrintInfo sharedPrintInfo] isVerticallyCentered]; }

void PrintInfoSetVerticallyCentered( Boolean flag )
{ [[NSPrintInfo sharedPrintInfo] setVerticallyCentered:flag]; }

PrinterRef PrintInfoPrinter( void )
{ return [[NSPrintInfo sharedPrintInfo] printer]; }

void PrintInfoSetPrinter( PrinterRef printer )
{ [[NSPrintInfo sharedPrintInfo] setPrinter:printer]; }

CFStringRef PrintInfoJobDisposition( void )
{ return (CFStringRef)[[NSPrintInfo sharedPrintInfo] jobDisposition]; }

void PrintInfoSetJobDisposition( CFStringRef value )
{ [[NSPrintInfo sharedPrintInfo] setJobDisposition:(NSString *)value]; }

void PrintInfoSetUpPrintOperationDefaultValues( void )
{ [[NSPrintInfo sharedPrintInfo] setUpPrintOperationDefaultValues]; }

CFMutableDictionaryRef PrintInfoDictionary( void )
{ return (CFMutableDictionaryRef)[[NSPrintInfo sharedPrintInfo] dictionary]; }

Boolean PrintInfoIsSelectionOnly( void )
{ return [[NSPrintInfo sharedPrintInfo] isSelectionOnly]; }

void PrintInfoSetSelectionOnly( Boolean flag )
{ [[NSPrintInfo sharedPrintInfo] setSelectionOnly:flag]; }

CGFloat PrintInfoScalingFactor( void )
{ return [[NSPrintInfo sharedPrintInfo] scalingFactor]; }

void PrintInfoSetScalingFactor( CGFloat value )
{ [[NSPrintInfo sharedPrintInfo] setScalingFactor:value]; }

CFMutableDictionaryRef PrintInfoPrintSettings( void )
{ return (CFMutableDictionaryRef)[[NSPrintInfo sharedPrintInfo] printSettings]; }

// - instance methods -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
void PrintInfoTakeSettingsFromPDFInfo( PDFInfoRef info )
{ [[NSPrintInfo sharedPrintInfo] takeSettingsFromPDFInfo:info]; }
#endif

