/*
 PrintOperation.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

typedef void (*CocoaPrintOperationDelegateCallbackType)(PrintOperationRef,BOOL,void*);// printOperation,success,userData

@interface CocoaPrintOperationDelegate : NSObject {
    CocoaPrintOperationDelegateCallbackType callback;
}
@property (assign) CocoaPrintOperationDelegateCallbackType callback;
@end

PrintOperationRef PrintOperationEPSWithViewToData( NSInteger viewTag, CGRect rect, CFMutableDataRef data );
PrintOperationRef PrintOperationEPSWithViewToDataPrintInfo( NSInteger viewTag, CGRect rect, CFMutableDataRef data, PrintInfoRef printInfo );
PrintOperationRef PrintOperationEPSWithViewToPath( NSInteger viewTag, CGRect rect, CFStringRef path, PrintInfoRef printInfo );
PrintOperationRef PrintOperationPDFWithViewToData( NSInteger viewTag, CGRect rect, CFMutableDataRef data );
PrintOperationRef PrintOperationPDFWithViewToDataPrintInfo( NSInteger viewTag, CGRect rect, CFMutableDataRef data, PrintInfoRef printInfo );
PrintOperationRef PrintOperationPDFWithViewToPath( NSInteger viewTag, CGRect rect, CFStringRef path, PrintInfoRef printInfo );
PrintOperationRef PrintOperationWithView( NSInteger viewTag );
PrintOperationRef PrintOperationWithViewPrintInfo( NSInteger viewTag, PrintInfoRef printInfo );
PrintOperationRef PrintOperationCurrent( void );
Boolean PrintOperationIsCopying( PrintOperationRef printOperation );
PrintInfoRef PrintOperationPrintInfo( PrintOperationRef printOperation );
void PrintOperationSetPrintInfo( PrintOperationRef printOperation, PrintInfoRef printInfo );
NSInteger PrintOperationView( PrintOperationRef printOperation );
NSPrintRenderingQuality PrintOperationPreferredRenderingQuality( PrintOperationRef printOperation );
Boolean PrintOperationRun( PrintOperationRef printOperation );

void PrintOperationRunModal( PrintOperationRef printOperation, NSInteger wndTag, void *callback, void *userData );

Boolean PrintOperationDeliverResult( PrintOperationRef printOperation );
Boolean PrintOperationShowsPrintPanel( PrintOperationRef printOperation );
void PrintOperationSetShowsPrintPanel( PrintOperationRef printOperation, Boolean flag );
Boolean PrintOperationShowsProgressPanel( PrintOperationRef printOperation );
void PrintOperationSetShowsProgressPanel( PrintOperationRef printOperation, Boolean flag );
CFStringRef PrintOperationJobTitle( PrintOperationRef printOperation );
void PrintOperationSetJobTitle( PrintOperationRef printOperation, CFStringRef title );
PrintPanelRef PrintOperationPrintPanel( PrintOperationRef printOperation );
void PrintOperationSetPrintPanel( PrintOperationRef printOperation, PrintPanelRef printPanel );
GraphicsContextRef PrintOperationContext( PrintOperationRef printOperation );
GraphicsContextRef PrintOperationCreateContext( PrintOperationRef printOperation );
NSInteger PrintOperationCurrentPage( PrintOperationRef printOperation );
CFRange PrintOperationPageRange( PrintOperationRef printOperation );
NSPrintingPageOrder PrintOperationPageOrder( PrintOperationRef printOperation );
void PrintOperationSetPageOrder( PrintOperationRef printOperation, NSPrintingPageOrder pageOrder );
Boolean PrintOperationCanSpawnSeparateThread( PrintOperationRef printOperation );
void PrintOperationSetCanSpawnSeparateThread( PrintOperationRef printOperation, Boolean flag );

