/*
 PrintPanel.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

typedef void (*CocoaPrintPanelDelegateCallbackType)(NSPrintPanel *,NSInteger,void*);// printPanel,returnCode,userData

@interface CocoaPrintPanelDelegate : NSObject {
    CocoaPrintPanelDelegateCallbackType callback;
}
@property (assign) CocoaPrintPanelDelegateCallbackType callback;
@end

PrintPanelRef PrintPanelInit( void );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300
CFStringRef PrintPanelJobStyleHint( PrintPanelRef pp );
void PrintPanelSetJobStyleHint( PrintPanelRef pp, CFStringRef hint );
#endif

NSPrintPanelOptions PrintPanelOptions( PrintPanelRef pp );
void PrintPanelSetOptions( PrintPanelRef pp, NSPrintPanelOptions options );
CFStringRef PrintPanelDefaultButtonTitle( PrintPanelRef pp );
void PrintPanelSetDefaultButtonTitle( PrintPanelRef pp, CFStringRef string );
CFStringRef PrintPanelHelpAnchor( PrintPanelRef pp );
void PrintPanelSetHelpAnchor( PrintPanelRef pp, CFStringRef string );

void PrintPanelBeginSheet( PrintPanelRef pp, PrintInfoRef printInfo, NSInteger wndTag, void *callback, void *userData );
NSInteger PrintPanelRunModal( PrintPanelRef pp );
NSInteger PrintPanelRunModalWithPrintInfo( PrintPanelRef pp, PrintInfoRef po );

PrintInfoRef PrintPanelPrintInfo( PrintPanelRef pp );

