/*
 PrintPanel.m

 Bernie Wylde
 */

#import "PrintPanel.h"

CocoaPrintPanelDelegate *sCocoaPrintPanelDelegate;

@implementation CocoaPrintPanelDelegate

@synthesize callback;

- (void)printPanelDidEnd:(NSPrintPanel *)printPanel returnCode:(NSInteger)returnCode contextInfo:(void *)contextInfo {
    if ( callback ) (*callback)(printPanel,returnCode,contextInfo);
}
@end

PrintPanelRef PrintPanelInit( void )
{ return [NSPrintPanel printPanel]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300
CFStringRef PrintPanelJobStyleHint( PrintPanelRef pp )
{ return (CFStringRef)[pp jobStyleHint]; }

void PrintPanelSetJobStyleHint( PrintPanelRef pp, CFStringRef hint )
{ [pp setJobStyleHint:(NSString *)hint]; }
#endif

NSPrintPanelOptions PrintPanelOptions( PrintPanelRef pp )
{ return [pp options]; }

void PrintPanelSetOptions( PrintPanelRef pp, NSPrintPanelOptions options )
{ [pp setOptions:options]; }

CFStringRef PrintPanelDefaultButtonTitle( PrintPanelRef pp )
{ return (CFStringRef)[pp defaultButtonTitle]; }

void PrintPanelSetDefaultButtonTitle( PrintPanelRef pp, CFStringRef string )
{ [pp setDefaultButtonTitle:(NSString *)string]; }

CFStringRef PrintPanelHelpAnchor( PrintPanelRef pp )
{ return (CFStringRef)[pp helpAnchor]; }

void PrintPanelSetHelpAnchor( PrintPanelRef pp, CFStringRef string )
{ [pp setHelpAnchor:(NSString *)string]; }

void PrintPanelBeginSheet( PrintPanelRef pp, PrintInfoRef printInfo, NSInteger wndTag, void *callback, void *userData )
{
    NSWindow *window = WindowWithTag( wndTag );
    if ( window ) {
        if ( !sCocoaPrintPanelDelegate ) sCocoaPrintPanelDelegate = [[CocoaPrintPanelDelegate alloc] init];
        sCocoaPrintPanelDelegate.callback = callback;
        
        [pp beginSheetWithPrintInfo:printInfo modalForWindow:window delegate:sCocoaPrintPanelDelegate didEndSelector:@selector(printPanelDidEnd:returnCode:contextInfo:) contextInfo:userData];
    }
}

NSInteger PrintPanelRunModal( PrintPanelRef pp )
{ return [pp runModal]; }

NSInteger PrintPanelRunModalWithPrintInfo( PrintPanelRef pp, PrintInfoRef po )
{ return [pp runModalWithPrintInfo:po]; }

PrintInfoRef PrintPanelPrintInfo( PrintPanelRef pp )
{ return [pp printInfo]; }

