/*
 Printer.m

 Bernie Wylde
 */

#import "Printer.h"

// - create -
PrinterRef PrinterWithName( CFStringRef name )
{ return [NSPrinter printerWithName:(NSString *)name]; }

PrinterRef PrinterWithType( CFStringRef type )
{ return [NSPrinter printerWithType:(NSString *)type]; }

// - printer info -
CFArrayRef PrinterNames( void )
{ return (CFArrayRef)[NSPrinter printerNames]; }

CFArrayRef PrinterTypes( void )
{ return (CFArrayRef)[NSPrinter printerTypes]; }

// - attributes -
CFStringRef PrinterName( PrinterRef printer )
{ return (CFStringRef)[printer name]; }

CFStringRef PrinterType( PrinterRef printer )
{ return (CFStringRef)[printer type]; }

// - specific info -
CGSize PrinterPageSizeForPaper( PrinterRef printer, CFStringRef paperName )
{ return NSSizeToCGSize([printer pageSizeForPaper:(NSString *)paperName]); }

NSInteger PrinterLanguageLevel( PrinterRef printer )
{ return [printer languageLevel]; }

// - query tables -
CFDictionaryRef PrinterDeviceDescription( PrinterRef printer )
{ return (CFDictionaryRef)[printer deviceDescription]; }

