/*
 ProcessInfo.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// - get process info agent
ProcessInfoRef ProcessInfoInit( void );

// - accessing process info -
CFArrayRef ProcessInfoArguments( void );
CFDictionaryRef ProcessInfoEnvironment( void );
CFStringRef ProcessInfoGloballyUniqueString( void );
int ProcessInfoProcessIdentifier( void );
CFStringRef ProcessInfoProcessName( void );

// - user info -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
CFStringRef ProcessInfoUserName( void );
CFStringRef ProcessInfoFullUserName( void );
#endif

// - sudden app termination -
void ProcessInfoDisableSuddenTermination( void );
void ProcessInfoEnableSuddenTermination( void );

// - control auto termination
void ProcessInfoDisableAutomaticTermination( CFStringRef reason );
void ProcessInfoEnableAutomaticTermination( CFStringRef reason );
Boolean ProcessInfoAutomaticTerminationSupportEnabled( void );

// - host info -
CFStringRef ProcessInfoHostName( void );
CFStringRef ProcessInfoOperatingSystemVersionString( void );
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
NSOperatingSystemVersion ProcessInfoOperatingSystemVersion( void );
Boolean ProcessInfoIsOperatingSystemAtLeastVersion( NSOperatingSystemVersion version);
#endif

// - computer info -
NSUInteger ProcessInfoProcessorCount( void );
NSUInteger ProcessInfoActiveProcessorCount( void );
unsigned long long ProcessInfoPhysicalMemory( void );
CFTimeInterval ProcessInfoSystemUptime( void );

// - activities -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
void *ProcessInfoBeginActivity( NSActivityOptions options, CFStringRef reason );
void ProcessInfoEndActivity( void *obj );
#endif

// - thermal state -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101003
NSProcessInfoThermalState ProcessInfoThermalState( void );
#endif

