/*
 ProgressIndicator.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

@interface ProgressIndicatorSC : NSProgressIndicator
@end

@interface NSProgressIndicator (Additions)
@property (nonatomic,retain) NSNumber *tagNumber;

- (NSInteger)tag;
- (void)setTag:(NSInteger)tag;
@end

NSProgressIndicator *ProgressIndicatorWithTag( NSInteger tag );
BOOL ProgressIndicatorExists( NSInteger tag );

// - animating -
void ProgressIndicatorStartAnimation( NSInteger tag );
void ProgressIndicatorStopAnimation( NSInteger tag );
Boolean ProgressIndicatorUsesThreadedAnimation( NSInteger tag );
void ProgressIndicatorSetUsesThreadedAnimation( NSInteger tag, Boolean flag );

// - advancing -
void ProgressIndicatorIncrementBy( NSInteger tag, double delta );
double ProgressIndicatorDoubleValue( NSInteger tag );
void ProgressIndicatorSetDoubleValue( NSInteger tag, double value );
double ProgressIndicatorMinValue( NSInteger tag );
void ProgressIndicatorSetMinValue( NSInteger tag, double value );
double ProgressIndicatorMaxValue( NSInteger tag );
void ProgressIndicatorSetMaxValue( NSInteger tag, double value );

// - appearance -
NSControlSize ProgressIndicatorControlSize( NSInteger tag );
void ProgressIndicatorSetControlSize( NSInteger tag, NSControlSize size );
NSControlTint ProgressIndicatorControlTint( NSInteger tag );
void ProgressIndicatorSetControlTint( NSInteger tag, NSControlTint tint );
Boolean ProgressIndicatorIsBezeled( NSInteger tag );
void ProgressIndicatorSetBezeled( NSInteger tag, Boolean flag );
Boolean ProgressIndicatorIsIndeterminate( NSInteger tag );
void ProgressIndicatorSetIndeterminate( NSInteger tag, Boolean flag );
NSUInteger ProgressIndicatorStyle( NSInteger tag );
void ProgressIndicatorSetStyle( NSInteger tag, NSUInteger style );
void ProgressIndicatorSizeToFit( NSInteger tag );
Boolean ProgressIndicatorIsDisplayWhenStopped( NSInteger tag );
void ProgressIndicatorSetDisplayWhenStopped( NSInteger tag, Boolean flag );


// Init
ProgressIndicatorRef ProgressIndicatorInit( NSInteger inTag, CGRect inRect );

// Statement
void CocoaProgressIndicator( NSInteger inTag, double inValue, CGRect inRect, double inMinValue, double inMaxValue, NSInteger inWndTag );

