/*
 PropertyList.m

 Bernie Wylde
 */

#import "PropertyList.h"


// - serializing -
CFDataRef PropertyListSerializationDataWithPropertyList( CFTypeRef plistObj, NSPropertyListFormat format, ErrorRef *err )
{ return (CFDataRef)[NSPropertyListSerialization dataWithPropertyList:(id)plistObj format:format options:0 error:err]; }

//NSInteger PropertyListSerializationWritePropertyList( CFTypeRef plistObj, OutputStreamRef stream, NSPropertyListFormat format, ErrorRef *err )
//{ return [NSPropertyListSerialization writePropertyList:(id)plistObj toStream:stream format:format options:0 error:err]; }

// - deserializing -
CFTypeRef PropertyListSerializationPropertyListWithData( CFDataRef dta, NSPropertyListReadOptions options, NSPropertyListFormat *format, ErrorRef *err )
{ return (CFTypeRef)[NSPropertyListSerialization propertyListWithData:(NSData *)dta options:options format:format error:err]; }

//CFTypeRef PropertyListSerializationPropertyListWithStream( InputStreamRef stream, NSPropertyListMutabilityOptions options, NSPropertyListFormat format, ErrorRef *err )
//{ return (CFTypeRef)[NSPropertyListSerialization propertyListWithStream:stream options:options format:format error:err]; }

// - validating -
Boolean PropertyListSerializationPropertyListIsValidForFormat( CFTypeRef plistObj, NSPropertyListFormat format )
{ return [NSPropertyListSerialization propertyList:(id)plistObj isValidForFormat:format]; }

