/*
 Range.m

 Bernie Wylde
 */

#import "Range.h"

CFRange RangeMake( NSUInteger location, NSUInteger length )
{ return NSRangeToCFRange(NSMakeRange(location,length)); }

NSUInteger RangeMax( CFRange range )
{ return NSMaxRange(NSRangeFromCFRange(range)); }

Boolean RangeLocation( CFRange range, NSUInteger location )
{ return NSLocationInRange(location,NSRangeFromCFRange(range)); }

Boolean RangeEqual( CFRange range1, CFRange range2 )
{ return NSEqualRanges(NSRangeFromCFRange(range1),NSRangeFromCFRange(range2)); }

CFRange RangeUnion( CFRange range1, CFRange range2 )
{ return NSRangeToCFRange(NSUnionRange(NSRangeFromCFRange(range1),NSRangeFromCFRange(range2))); }

CFRange RangeIntersection( CFRange range1, CFRange range2 )
{ return NSRangeToCFRange(NSIntersectionRange(NSRangeFromCFRange(range1),NSRangeFromCFRange(range2))); }

CFRange RangeFromString( CFStringRef string )
{ return NSRangeToCFRange(NSRangeFromString((NSString *)string)); }

CFStringRef RangeToString( CFRange range )
{ return (CFStringRef)NSStringFromRange(NSRangeFromCFRange(range)); }
