/*
 RotationGestureRecognizer.m

 Bernie Wylde
 */

#import "RotationGestureRecognizer.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000

/*
 Subclass
 */
@implementation CocoaRotationGestureRecognizer
@end

// - init -
RotationGestureRecognizerRef RotationGestureRecognizerInit( void *callback, void *userData )
{
    GestureRecognizerTarget *target = [[[GestureRecognizerTarget alloc] initWithCallback:callback userData:userData] autorelease];
    return [[[NSRotationGestureRecognizer alloc] initWithTarget:target action:@selector(action:)] autorelease];
}

// - interpreting -
CGFloat RotationGestureRecognizerRotation( RotationGestureRecognizerRef ref )
{ return [ref rotation]; }

void RotationGestureRecognizerSetRotation( RotationGestureRecognizerRef ref, CGFloat rotation )
{ [ref setRotation:rotation]; }

CGFloat RotationGestureRecognizerRotationInDegrees( RotationGestureRecognizerRef ref )
{ return [ref rotationInDegrees]; }

void RotationGestureRecognizerSetRotationDegrees( RotationGestureRecognizerRef ref, CGFloat rotation )
{ [ref setRotationInDegrees:rotation]; }

#endif
