/*
 RulerMarker.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// Create
RulerMarkerRef RulerMarkerWithRulerView( RulerViewRef ruler, CGFloat location, ImageRef image, CGPoint imageOrigin );

// Ruler view
RulerViewRef RulerMarkerRuler( RulerMarkerRef ref );

// Image
ImageRef RulerMarkerImage( RulerMarkerRef ref );
void RulerMarkerSetImage( RulerMarkerRef ref, ImageRef image );
CGPoint RulerMarkerImageOrigin( RulerMarkerRef ref );
void RulerMarkerSetImageOrigin( RulerMarkerRef ref, CGPoint origin );
CGRect RulerMarkerImageRectInRuler( RulerMarkerRef ref );
CGFloat RulerMarkerThicknessRequiredInRuler( RulerMarkerRef ref );

// Movability
Boolean RulerMarkerIsMovable( RulerMarkerRef ref );
void RulerMarkerSetMovable( RulerMarkerRef ref, Boolean flag );
Boolean RulerMarkerIsRemovable( RulerMarkerRef ref );
void RulerMarkerSetRemovable( RulerMarkerRef ref, Boolean flag );

// Location
CGFloat RulerMarkerLocation( RulerMarkerRef ref );
void RulerMarkerSetLocation( RulerMarkerRef ref, CGFloat location );

// Represented object
CFTypeRef RulerMarkerRepresentedObject( RulerMarkerRef ref );
void RulerMarkerSetRepresentedObject( RulerMarkerRef ref, CFTypeRef obj );

// Drawing and event handling
void RulerMarkerDrawRect( RulerMarkerRef ref, CGRect r );
Boolean RulerMarkerisDragging( RulerMarkerRef ref );

