/*
 RulerMarker.m

 Bernie Wylde
 */

#import "RulerMarker.h"

// Create
RulerMarkerRef RulerMarkerWithRulerView( RulerViewRef ruler, CGFloat location, ImageRef image, CGPoint imageOrigin )
{ return [[[NSRulerMarker alloc] initWithRulerView:ruler markerLocation:location image:image imageOrigin:NSPointFromCGPoint(imageOrigin)] autorelease]; }

// Ruler view
RulerViewRef RulerMarkerRuler( RulerMarkerRef ref )
{ return [ref ruler]; }

// Image
ImageRef RulerMarkerImage( RulerMarkerRef ref )
{ return [ref image]; }

void RulerMarkerSetImage( RulerMarkerRef ref, ImageRef image )
{ [ref setImage:image]; }

CGPoint RulerMarkerImageOrigin( RulerMarkerRef ref )
{ return NSPointToCGPoint([ref imageOrigin]); }

void RulerMarkerSetImageOrigin( RulerMarkerRef ref, CGPoint origin )
{ [ref setImageOrigin:NSPointFromCGPoint(origin)]; }

CGRect RulerMarkerImageRectInRuler( RulerMarkerRef ref )
{ return NSRectToCGRect([ref imageRectInRuler]); }

CGFloat RulerMarkerThicknessRequiredInRuler( RulerMarkerRef ref )
{ return [ref thicknessRequiredInRuler]; }

// Movability
Boolean RulerMarkerIsMovable( RulerMarkerRef ref )
{ return [ref isMovable]; }

void RulerMarkerSetMovable( RulerMarkerRef ref, Boolean flag )
{ [ref setMovable:flag]; }

Boolean RulerMarkerIsRemovable( RulerMarkerRef ref )
{ return [ref isRemovable]; }

void RulerMarkerSetRemovable( RulerMarkerRef ref, Boolean flag )
{ [ref setRemovable:flag]; }

// Location
CGFloat RulerMarkerLocation( RulerMarkerRef ref )
{ return [ref markerLocation]; }

void RulerMarkerSetLocation( RulerMarkerRef ref, CGFloat location )
{ [ref setMarkerLocation:location]; }

// Represented object
CFTypeRef RulerMarkerRepresentedObject( RulerMarkerRef ref )
{ return (CFTypeRef)[ref representedObject]; }

void RulerMarkerSetRepresentedObject( RulerMarkerRef ref, CFTypeRef obj )
{ [ref setRepresentedObject:(id)obj]; }

// Drawing and event handling
void RulerMarkerDrawRect( RulerMarkerRef ref, CGRect r )
{ [ref drawRect:NSRectFromCGRect(r)]; }

Boolean RulerMarkerisDragging( RulerMarkerRef ref )
{ return [ref isDragging]; }

