/*
 RulerView.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// Create
RulerViewRef RulerViewWithScrollView( NSInteger scrollTag, NSRulerOrientation orientation );

// Measurement units
void RulerViewRegisterUnit( CFStringRef name, CFStringRef abbreviation, CGFloat unitToPointsFactor, CFArrayRef stepUpCycle, CFArrayRef stepDownCycle );
CFStringRef RulerViewMeasurementUnits( RulerViewRef ref );
void RulerViewSetMeasurementUnits( RulerViewRef ref, CFStringRef unitName );

// Client view
ViewRef RulerViewClientView( RulerViewRef ref );
void RulerViewSetClientView( RulerViewRef ref, ViewRef clientView );

// Accessory view
ViewRef RulerViewAccessoryView( RulerViewRef ref );
void RulerViewSetAccessoryView( RulerViewRef ref, ViewRef accessoryView );

// Zero mark position
CGFloat RulerViewOriginOffset( RulerViewRef ref );
void RulerViewSetOriginOffset( RulerViewRef ref, CGFloat offset );

// Markers
CFArrayRef RulerViewMarkers( RulerViewRef ref );
void RulerViewSetMarkers( RulerViewRef ref, CFArrayRef markers );
void RulerViewAddMarker( RulerViewRef ref, RulerMarkerRef marker );
void RulerViewRemoveMarker( RulerViewRef ref, RulerMarkerRef marker );

// Temporary ruler lines
void RulerViewMoveRulerline( RulerViewRef ref, CGFloat fromLocation, CGFloat toLocation );

// Drawing
void RulerViewDrawHashMarksAndLabelsInRect( RulerViewRef ref, CGRect r );
void RulerViewDrawMarkersInRect( RulerViewRef ref, CGRect r );
void RulerViewInvalidateHashMarks( RulerViewRef ref );

// Layout
NSInteger RulerViewScrollView( RulerViewRef ref );
void RulerViewSetScrollView( RulerViewRef ref, NSInteger scrollTag );
NSRulerOrientation RulerViewOrientation( RulerViewRef ref );
void RulerViewSetOrientation( RulerViewRef ref, NSRulerOrientation orientation );
CGFloat RulerViewReservedThicknessForAccessoryView( RulerViewRef ref );
void RulerViewSetReservedThicknessForAccessoryView( RulerViewRef ref, CGFloat thickness );
CGFloat RulerViewReservedThicknessForMarkers( RulerViewRef ref );
void RulerViewSetReservedThicknessForMarkers( RulerViewRef ref, CGFloat thickness );
CGFloat RulerViewRuleThickness( RulerViewRef ref );
void RulerViewSetRuleThickness( RulerViewRef ref, CGFloat thickness );
CGFloat RulerViewRequiredThickness( RulerViewRef ref );
CGFloat RulerViewBaselineLocation( RulerViewRef ref );
Boolean RulerViewIsFlipped( RulerViewRef ref );

