/*
 RunLoop.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// Run loops and modes
RunLoopRef RunLoopCurrent( void );
CFStringRef RunLoopCurrentMode( RunLoopRef ref );
CFDateRef RunLoopLimitDateForMode( RunLoopRef ref, CFStringRef mode );
RunLoopRef RunLoopMain( void );
CFRunLoopRef RunLoopCFRunLoop( RunLoopRef ref );

// Timers
void RunLoopAddTimer( RunLoopRef ref, CFRunLoopTimerRef timer, CFStringRef mode );

// Ports
void RunLoopAddPort( RunLoopRef ref, PortRef port, CFStringRef mode );
void RunLoopRemovePort( RunLoopRef ref, PortRef port, CFStringRef mode );

// Running a loop
void RunLoopRun( RunLoopRef ref );
Boolean RunLoopRunModeBeforeDate( RunLoopRef ref, CFStringRef mode, CFDateRef dt );
void RunLoopRunUntilDate( RunLoopRef ref, CFDateRef dt );
void RunLoopAcceptInputForModeBeforeDate( RunLoopRef ref, CFStringRef mode, CFDateRef dt );
