/*
 RunLoop.m

 Bernie Wylde
 */

#import "RunLoop.h"

// Run loops and modes
RunLoopRef RunLoopCurrent( void )
{ return [NSRunLoop currentRunLoop]; }

CFStringRef RunLoopCurrentMode( RunLoopRef ref )
{ return (CFStringRef)[ref currentMode]; }

CFDateRef RunLoopLimitDateForMode( RunLoopRef ref, CFStringRef mode )
{ return (CFDateRef)[ref limitDateForMode:(NSString *)mode]; }

RunLoopRef RunLoopMain( void )
{ return [NSRunLoop mainRunLoop]; }

CFRunLoopRef RunLoopCFRunLoop( RunLoopRef ref )
{ return [ref getCFRunLoop]; }

// Timers
void RunLoopAddTimer( RunLoopRef ref, CFRunLoopTimerRef timer, CFStringRef mode )
{ [ref addTimer:(NSTimer *)timer forMode:(NSString *)mode]; }

// Ports
void RunLoopAddPort( RunLoopRef ref, PortRef port, CFStringRef mode )
{ [ref addPort:port forMode:(NSString *)mode]; }

void RunLoopRemovePort( RunLoopRef ref, PortRef port, CFStringRef mode )
{ [ref removePort:port forMode:(NSString *)mode]; }

// Running a loop
void RunLoopRun( RunLoopRef ref )
{ [ref run]; }

Boolean RunLoopRunModeBeforeDate( RunLoopRef ref, CFStringRef mode, CFDateRef dt )
{ return [ref runMode:(NSString *)mode beforeDate:(NSDate *)dt]; }

void RunLoopRunUntilDate( RunLoopRef ref, CFDateRef dt )
{ [ref runUntilDate:(NSDate *)dt]; }

void RunLoopAcceptInputForModeBeforeDate( RunLoopRef ref, CFStringRef mode, CFDateRef dt )
{ [ref acceptInputForMode:(NSString *)mode beforeDate:(NSDate *)dt]; }

