/*
 RunningApplication.m

 Bernie Wylde
 */

#import "RunningApplication.h"

RunningApplicationRef RunningApplicationWithProcessIdentifier( pid_t pid )
{ return [NSRunningApplication runningApplicationWithProcessIdentifier:pid]; }

CFArrayRef RunningApplicationsWithBundleIdentifier( CFStringRef identifier )
{ return (CFArrayRef)[NSRunningApplication runningApplicationsWithBundleIdentifier:(NSString *)identifier]; }

RunningApplicationRef RunningApplicationCurrentApplication( void )
{ return [NSRunningApplication currentApplication]; }

Boolean RunningApplicationIsActive( RunningApplicationRef ra )
{ return [ra isActive]; }

Boolean RunningApplicationActivate( RunningApplicationRef ra, NSApplicationActivationOptions options )
{ return [ra activateWithOptions:options]; }

NSApplicationActivationPolicy RunningApplicationActivationPolicy( RunningApplicationRef ra )
{ return [ra activationPolicy]; }

Boolean RunningApplicationHide( RunningApplicationRef ra )
{ return [ra hide]; }

Boolean RunningApplicationUnhide( RunningApplicationRef ra )
{ return [ra unhide]; }

Boolean RunningApplicationIsHidden( RunningApplicationRef ra )
{ return [ra isHidden]; }

CFStringRef RunningApplicationLocalizedName( RunningApplicationRef ra )
{ return (CFStringRef)[ra localizedName]; }

ImageRef RunningApplicationIcon( RunningApplicationRef ra )
{ return [ra icon]; }

CFStringRef RunningApplicationBundleIdentifier( RunningApplicationRef ra )
{ return (CFStringRef)[ra bundleIdentifier]; }

CFURLRef RunningApplicationBundleURL( RunningApplicationRef ra )
{ return (CFURLRef)[ra bundleURL]; }

NSInteger RunningApplicationExecutableArchitecture( RunningApplicationRef ra )
{ return [ra executableArchitecture]; }

CFURLRef RunningApplicationExecutableURL( RunningApplicationRef ra )
{ return (CFURLRef)[ra executableURL]; }

CFDateRef RunningApplicationLaunchDate( RunningApplicationRef ra )
{ return (CFDateRef)[ra launchDate]; }

Boolean RunningApplicationIsFinishedLaunching( RunningApplicationRef ra )
{ return [ra isFinishedLaunching]; }

pid_t RunningApplicationProcessIdentifier( RunningApplicationRef ra )
{ return [ra processIdentifier]; }

Boolean RunningApplicationOwnsMenuBar( RunningApplicationRef ra )
{ return [ra ownsMenuBar]; }

Boolean RunningApplicationForceTerminate( RunningApplicationRef ra )
{ return [ra forceTerminate]; }

Boolean RunningApplicationTerminate( RunningApplicationRef ra )
{ return [ra terminate]; }

Boolean RunningApplicationIsTerminated( RunningApplicationRef ra )
{ return [ra isTerminated]; }

void RunningApplicationTerminateAutomaticallyTerminableApplications( void )
{ [NSRunningApplication terminateAutomaticallyTerminableApplications]; }

