/*
 Scanner.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// - create -
ScannerRef ScannerWithString( CFStringRef string );
ScannerRef ScannerLocalizedWithString( CFStringRef string );

// - get a scanner's string -
CFStringRef ScannerString( ScannerRef ref );

// - configure -
NSUInteger ScannerLocation( ScannerRef ref );
void ScannerSetLocation( ScannerRef ref, NSUInteger location );
Boolean ScannerCaseSensitive( ScannerRef ref );
void ScannerSetCaseSensitive( ScannerRef ref, Boolean flag );
CFCharacterSetRef ScannerCharactersToBeSkipped( ScannerRef ref );
void ScannerSetCharactersToBeSkipped( ScannerRef ref, CFCharacterSetRef set );
CFLocaleRef ScannerLocale( ScannerRef ref );
void ScannerSetLocale( ScannerRef ref, CFLocaleRef locale );

// - scanning a string -
Boolean ScannerScanCharactersFromSet( ScannerRef ref, CFCharacterSetRef set, CFStringRef *result );
Boolean ScannerScanUpToCharactersFromSet( ScannerRef ref, CFCharacterSetRef set, CFStringRef *result );
Boolean ScannerScanDecimal( ScannerRef ref, NSDecimal *result );
Boolean ScannerScanDouble( ScannerRef ref, double *result );
Boolean ScannerScanFloat( ScannerRef ref, float *result );
Boolean ScannerScanHexDouble( ScannerRef ref, double *result );
Boolean ScannerScanHexFloat( ScannerRef ref, float *result );
Boolean ScannerScanHexInt( ScannerRef ref, unsigned int *result );
Boolean ScannerScanHexLongLong( ScannerRef ref, UInt64 *result );
Boolean ScannerScanInteger( ScannerRef ref, NSInteger *result );
//Boolean ScannerScanInt( ScannerRef ref, long *result );
Boolean ScannerScanLongLong( ScannerRef ref, long long *result );
Boolean ScannerScanString( ScannerRef ref, CFStringRef string, CFStringRef *result );
//Boolean ScannerScanUnsignedLongLong( ScannerRef ref, UInt64 *result );
Boolean ScannerScanUpToString( ScannerRef ref, CFStringRef string, CFStringRef *result );
Boolean ScannerIsAtEnd( ScannerRef ref );

