/*
 Scanner.m

 Bernie Wylde
 */

#import "Scanner.h"

// - create -
ScannerRef ScannerWithString( CFStringRef string )
{ return [NSScanner scannerWithString:(NSString *)string]; }

ScannerRef ScannerLocalizedWithString( CFStringRef string )
{ return [NSScanner localizedScannerWithString:(NSString *)string]; }

// - get a scanner's string -
CFStringRef ScannerString( ScannerRef ref )
{ return (CFStringRef)[ref string]; }

// - configure -
NSUInteger ScannerLocation( ScannerRef ref )
{ return [ref scanLocation]; }

void ScannerSetLocation( ScannerRef ref, NSUInteger location )
{ [ref setScanLocation:location]; }

Boolean ScannerCaseSensitive( ScannerRef ref )
{ return [ref caseSensitive]; }

void ScannerSetCaseSensitive( ScannerRef ref, Boolean flag )
{ [ref setCaseSensitive:flag]; }

CFCharacterSetRef ScannerCharactersToBeSkipped( ScannerRef ref )
{ return (CFCharacterSetRef)[ref charactersToBeSkipped]; }

void ScannerSetCharactersToBeSkipped( ScannerRef ref, CFCharacterSetRef set )
{ [ref setCharactersToBeSkipped:(NSCharacterSet *)set]; }

CFLocaleRef ScannerLocale( ScannerRef ref )
{ return (CFLocaleRef)[ref locale]; }

void ScannerSetLocale( ScannerRef ref, CFLocaleRef locale )
{ [ref setLocale:(NSLocale *)locale]; }

// - scanning a string -
Boolean ScannerScanCharactersFromSet( ScannerRef ref, CFCharacterSetRef set, CFStringRef *result )
{ return [ref scanCharactersFromSet:(NSCharacterSet *)set intoString:(NSString **)result]; }

Boolean ScannerScanUpToCharactersFromSet( ScannerRef ref, CFCharacterSetRef set, CFStringRef *result )
{ return [ref scanUpToCharactersFromSet:(NSCharacterSet *)set intoString:(NSString **)result]; }

Boolean ScannerScanDecimal( ScannerRef ref, NSDecimal *result )
{ return [ref scanDecimal:result]; }

Boolean ScannerScanDouble( ScannerRef ref, double *result )
{ return [ref scanDouble:result]; }

Boolean ScannerScanFloat( ScannerRef ref, float *result )
{ return [ref scanFloat:result]; }

Boolean ScannerScanHexDouble( ScannerRef ref, double *result )
{ return [ref scanHexDouble:result]; }

Boolean ScannerScanHexFloat( ScannerRef ref, float *result )
{ return [ref scanHexFloat:result]; }

Boolean ScannerScanHexInt( ScannerRef ref, unsigned int *result )
{ return [ref scanHexInt:result]; }

Boolean ScannerScanHexLongLong( ScannerRef ref, UInt64 *result )
{ return [ref scanHexLongLong:result]; }

Boolean ScannerScanInteger( ScannerRef ref, NSInteger *result )
{ return [ref scanInteger:result]; }

//Boolean ScannerScanInt( ScannerRef ref, long *result )
//{ return [ref scanInt:result]; }

Boolean ScannerScanLongLong( ScannerRef ref, long long *result )
{ return [ref scanLongLong:result]; }

Boolean ScannerScanString( ScannerRef ref, CFStringRef string, CFStringRef *result )
{ return [ref scanString:(NSString *)string intoString:(NSString **)result]; }

//Boolean ScannerScanUnsignedLongLong( ScannerRef ref, UInt64 *result )
//{ return [ref scanUnsignedLongLong:result]; }

Boolean ScannerScanUpToString( ScannerRef ref, CFStringRef string, CFStringRef *result )
{ return [ref scanUpToString:(NSString *)string intoString:(NSString **)result]; }

Boolean ScannerIsAtEnd( ScannerRef ref )
{ return [ref isAtEnd]; }

