/*
 Screen.m

 Bernie Wylde
 */

#import "Screen.h"

ScreenRef ScreenMainScreen( void )
{ return [NSScreen mainScreen]; }

ScreenRef ScreenDeepestScreen( void )
{ return [NSScreen deepestScreen]; }

CFArrayRef ScreenScreens( void )
{ return (CFArrayRef)[NSScreen screens]; }

NSWindowDepth ScreenDepth( ScreenRef scrn )
{ return [scrn depth]; }

CGRect ScreenFrame( ScreenRef scrn )
{ return NSRectToCGRect([scrn frame]); }

// supportedWindowDepths

CFDictionaryRef ScreenDeviceDescription( ScreenRef scrn )
{ return (CFDictionaryRef)[scrn deviceDescription]; }

CGRect ScreenVisibleFrame( ScreenRef scrn )
{ return NSRectToCGRect([scrn visibleFrame]); }

//CGRect ScreenColorSpace( ScreenRef scrn );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
Boolean ScreenCanRepresentDisplayGamut( ScreenRef scrn, NSInteger gamut )
{ return [scrn canRepresentDisplayGamut:gamut]; }
#endif

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
Boolean ScreenScreensHaveSeparateSpaces( void )
{ return [NSScreen screensHaveSeparateSpaces]; }
#endif

CGRect ScreenBackingAlignedRect( ScreenRef scrn, CGRect rect, NSAlignmentOptions options )
{ return NSRectToCGRect([scrn backingAlignedRect:NSRectFromCGRect(rect) options:options]); }

CGFloat ScreenBackingScaleFactor( ScreenRef scrn )
{ return [scrn backingScaleFactor]; }

CGRect ScreenConvertRectFromBacking( ScreenRef scrn, CGRect rect )
{ return NSRectToCGRect([scrn convertRectFromBacking:NSRectFromCGRect(rect)]); }

CGRect ScreenConvertRectToBacking( ScreenRef scrn, CGRect rect )
{ return NSRectToCGRect([scrn convertRectToBacking:NSRectFromCGRect(rect)]); }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
CGFloat ScreenMaximumExtendedDynamicRangeColorComponentValue( ScreenRef scrn )
{ return [scrn maximumExtendedDynamicRangeColorComponentValue]; }
#endif

// -- convenience --
CGRect ScreenMainFrame( void )
{ return NSRectToCGRect([[NSScreen mainScreen] frame]); }

