/*
 Scroller.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// Scroller size
CGFloat ScrollerWidth( NSControlSize size, NSScrollerStyle style );
NSControlSize ScrollerControlSize( ScrollerRef ref );

// Knob position
CGFloat ScrollerKnobProportion( ScrollerRef ref );
void ScrollerSetKnobProportion( ScrollerRef ref, CGFloat proportion );

// Calculate layout -
CGRect ScrollerRectForPart( ScrollerRef ref, NSScrollerPart part );
NSScrollerPart ScrollerTestPart( ScrollerRef ref, CGPoint pt );
NSUsableScrollerParts ScrollerUsableParts( ScrollerRef ref );

// Draw scroller parts
void ScrollerDrawKnobSlotInRect( ScrollerRef ref, CGRect r, Boolean highlight );

// Event handling
NSScrollerPart ScrollerHitPart( ScrollerRef ref );

// Presentation style
NSScrollerStyle ScrollerPreferredScrollerStyle( void );
NSScrollerStyle ScrollerScrollerStyle( ScrollerRef ref );
NSScrollerKnobStyle ScrollerKnobStyle( ScrollerRef ref );

// Type properties
Boolean ScrollerIsCompatibleWithOverlayScrollers( void );

