/*
 Scroller.m

 Bernie Wylde
 */

#import "Scroller.h"

// Scroller size
CGFloat ScrollerWidth( NSControlSize size, NSScrollerStyle style )
{ return [NSScroller scrollerWidthForControlSize:size scrollerStyle:style]; }

NSControlSize ScrollerControlSize( ScrollerRef ref )
{ return [ref controlSize]; }

// Knob position
CGFloat ScrollerKnobProportion( ScrollerRef ref )
{ return [ref knobProportion]; }

void ScrollerSetKnobProportion( ScrollerRef ref, CGFloat proportion )
{ [ref setKnobProportion:proportion]; }

// Calculate layout -
CGRect ScrollerRectForPart( ScrollerRef ref, NSScrollerPart part )
{ return NSRectToCGRect([ref rectForPart:part]); }

NSScrollerPart ScrollerTestPart( ScrollerRef ref, CGPoint pt )
{ return [ref testPart:NSPointFromCGPoint(pt)]; }

NSUsableScrollerParts ScrollerUsableParts( ScrollerRef ref )
{ return [ref usableParts]; }

// Draw scroller parts
void ScrollerDrawKnobSlotInRect( ScrollerRef ref, CGRect r, Boolean highlight )
{ [ref drawKnobSlotInRect:NSRectFromCGRect(r) highlight:highlight]; }

// Event handling
NSScrollerPart ScrollerHitPart( ScrollerRef ref )
{ return [ref hitPart]; }

// Presentation style
NSScrollerStyle ScrollerPreferredScrollerStyle( void )
{ return [NSScroller preferredScrollerStyle]; }

NSScrollerStyle ScrollerScrollerStyle( ScrollerRef ref )
{ return [ref scrollerStyle]; }

NSScrollerKnobStyle ScrollerKnobStyle( ScrollerRef ref )
{ return [ref knobStyle]; }

// Type properties
Boolean ScrollerIsCompatibleWithOverlayScrollers( void )
{ return [NSScroller isCompatibleWithOverlayScrollers]; }


