/*
 SearchField.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

@interface SearchFieldSC : NSSearchField
@end


// dialog events
enum {
    searchFieldDidStartSearching = 1400,
    searchFieldDidEndSearching
};


#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
@interface CocoaSearchFieldDelegate : NSObject <NSSearchFieldDelegate>
@end
#else
@interface CocoaSearchFieldDelegate : NSObject <NSTextFieldDelegate>
@end
#endif

//@interface CocoaSearchFieldDelegate : NSObject <NSTextFieldDelegate>
//@end

CocoaSearchFieldDelegate *CocoaSearchFieldDelegateGet( void );


NSSearchField *SearchFieldWithTag( NSInteger tag );
BOOL SearchFieldExists( NSInteger tag );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
Boolean SearchFieldSendsSearchStringImmediately( NSInteger tag );
void SearchFieldSetSendsSearchStringImmediately( NSInteger tag, Boolean flag );
Boolean SearchFieldSendsWholeSearchString( NSInteger tag );
void SearchFieldSetSendsWholeSearchString( NSInteger tag, Boolean flag );
#endif

CFArrayRef SearchFieldRecentSearches( NSInteger tag );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
Boolean SearchFieldCentersPlaceholder( NSInteger tag );
void SearchFieldSetCentersPlaceholder( NSInteger tag, Boolean flag );
#endif

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
NSInteger SearchFieldMaximumRecents( NSInteger tag );
void SearchFieldSetMaximumRecents( NSInteger tag, NSInteger value );
#endif

CFStringRef SearchFieldRecentsAutosaveName( NSInteger tag );
void SearchFieldSetRecentsAutosaveName( NSInteger tag, CFStringRef name );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
NSInteger SearchFieldSearchMenuTemplate( NSInteger tag );
void SearchFieldSetSearchMenuTemplate( NSInteger tag, NSInteger menuIndex );
#endif


// Init
SearchFieldRef SearchFieldInit( NSInteger inTag, CGRect inRect );

// Statement
void CocoaSearchField( NSInteger inTag, NSInteger inEnabled, CFStringRef inText, CGRect inRect, NSInteger inWndTag );
