/*
 Set.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

CFSetRef SetWithArray( CFArrayRef array );
CFSetRef SetWithObject( CFTypeRef obj );
CFSetRef SetWithObjects( CFTypeRef obj, ... );
CFSetRef SetByAddingObject( CFSetRef set, CFTypeRef obj );
CFSetRef SetByAddingObjectsFromSet( CFSetRef set1, CFSetRef set2 );
CFSetRef SetByAddingObjectsFromArray( CFSetRef set, CFArrayRef array );
NSUInteger SetCount( CFSetRef set );
CFArrayRef SetAllObjects( CFSetRef set );
CFTypeRef SetAnyObject( CFSetRef set );
Boolean SetContainsObject( CFSetRef set, CFTypeRef obj );
CFTypeRef SetMember( CFSetRef set, CFTypeRef obj );
EnumeratorRef SetObjectEnumerator( CFSetRef set );
Boolean SetIsSubsetOfSet( CFSetRef set1, CFSetRef set2 );
Boolean SetIntersectsSet( CFSetRef set1, CFSetRef set2 );
Boolean SetIsEqualToSet( CFSetRef set1, CFSetRef set2 );
CFTypeRef SetValueForKey( CFSetRef set, CFStringRef key );
void SetSetValueForKey( CFSetRef set, CFTypeRef value, CFStringRef key );
CFArrayRef SetSortedArrayUsingDescriptors( CFSetRef set, CFArrayRef sortDescriptors );
CFStringRef SetDescription( CFSetRef set );
CFMutableSetRef SetWithCapacity( NSUInteger length );
void SetAddObject( CFMutableSetRef set, CFTypeRef obj );
void SetRemoveObject( CFMutableSetRef set, CFTypeRef obj );
void SetRemoveAllObjects( CFMutableSetRef set );
void SetAddObjectsFromArray( CFMutableSetRef set, CFArrayRef array );
void SetUnionSet( CFMutableSetRef set1, CFSetRef set2 );
void SetMinusSet( CFMutableSetRef set1, CFSetRef set2 );
void SetIntersectSet( CFMutableSetRef set1, CFSetRef set2 );
void SetSet( CFMutableSetRef set1, CFSetRef set2 );

