/*
 Set.m

 Bernie Wylde
 */

#import "Set.h"

CFSetRef SetWithArray( CFArrayRef array )
{ return (CFSetRef)[NSSet setWithArray:(NSArray *)array]; }

CFSetRef SetWithObject( CFTypeRef obj )
{ return (CFSetRef)[NSSet setWithObject:(id)obj]; }

CFSetRef SetWithObjects( CFTypeRef obj, ... )
{
    va_list ap;
    va_start( ap, obj );
    NSMutableSet *set = [NSMutableSet setWithCapacity:0];
    while ( obj ) {
        [set addObject:obj];
        obj = va_arg( ap, id );
    }
    va_end( ap );
    return (CFSetRef)set;
}

CFSetRef SetByAddingObject( CFSetRef set, CFTypeRef obj )
{ return (CFSetRef)[(NSSet *)set setByAddingObject:(id)obj]; }

CFSetRef SetByAddingObjectsFromSet( CFSetRef set1, CFSetRef set2 )
{ return (CFSetRef)[(NSSet *)set1 setByAddingObjectsFromSet:(NSSet *)set2]; }

CFSetRef SetByAddingObjectsFromArray( CFSetRef set, CFArrayRef array )
{ return (CFSetRef)[(NSSet *)set setByAddingObjectsFromArray:(NSArray *)array]; }

NSUInteger SetCount( CFSetRef set )
{ return [(NSSet *)set count]; }

CFArrayRef SetAllObjects( CFSetRef set )
{ return (CFArrayRef)[(NSSet *)set allObjects]; }

CFTypeRef SetAnyObject( CFSetRef set )
{ return (CFTypeRef)[(NSSet *)set anyObject]; }

Boolean SetContainsObject( CFSetRef set, CFTypeRef obj )
{ return [(NSSet *)set containsObject:(id)obj]; }

CFTypeRef SetMember( CFSetRef set, CFTypeRef obj )
{ return (CFTypeRef)[(NSSet *)set member:(id)obj]; }

EnumeratorRef SetObjectEnumerator( CFSetRef set )
{ return [(NSSet *)set objectEnumerator]; }

Boolean SetIsSubsetOfSet( CFSetRef set1, CFSetRef set2 )
{ return [(NSSet *)set1 isSubsetOfSet:(NSSet *)set2]; }

Boolean SetIntersectsSet( CFSetRef set1, CFSetRef set2 )
{ return [(NSSet *)set1 intersectsSet:(NSSet *)set2]; }

Boolean SetIsEqualToSet( CFSetRef set1, CFSetRef set2 )
{ return [(NSSet *)set1 isEqualToSet:(NSSet *)set2]; }

CFTypeRef SetValueForKey( CFSetRef set, CFStringRef key )
{ return (CFTypeRef)[(NSSet *)set valueForKey:(NSString *)key]; }

void SetSetValueForKey( CFSetRef set, CFTypeRef value, CFStringRef key )
{ [(NSSet *)set setValue:(id)value forKey:(NSString *)key]; }

CFArrayRef SetSortedArrayUsingDescriptors( CFSetRef set, CFArrayRef sortDescriptors )
{ return (CFArrayRef)[(NSSet *)set sortedArrayUsingDescriptors:(NSArray *)sortDescriptors]; }

CFStringRef SetDescription( CFSetRef set )
{ return (CFStringRef)[(NSSet *)set description]; }


CFMutableSetRef SetWithCapacity( NSUInteger length )
{ return (CFMutableSetRef)[NSMutableSet setWithCapacity:length]; }

void SetAddObject( CFMutableSetRef set, CFTypeRef obj )
{ [(NSMutableSet *)set addObject:(id)obj]; }

void SetRemoveObject( CFMutableSetRef set, CFTypeRef obj )
{ [(NSMutableSet *)set removeObject:(id)obj]; }

void SetRemoveAllObjects( CFMutableSetRef set )
{ [(NSMutableSet *)set removeAllObjects]; }

void SetAddObjectsFromArray( CFMutableSetRef set, CFArrayRef array )
{ [(NSMutableSet *)set addObjectsFromArray:(NSArray *)array]; }

void SetUnionSet( CFMutableSetRef set1, CFSetRef set2 )
{ [(NSMutableSet *)set1 unionSet:(NSSet *)set2]; }

void SetMinusSet( CFMutableSetRef set1, CFSetRef set2 )
{ [(NSMutableSet *)set1 minusSet:(NSSet *)set2]; }

void SetIntersectSet( CFMutableSetRef set1, CFSetRef set2 )
{ [(NSMutableSet *)set1 intersectSet:(NSSet *)set2]; }

void SetSet( CFMutableSetRef set1, CFSetRef set2 )
{ [(NSMutableSet *)set1 setSet:(NSSet *)set2]; }

