/*
 Shadow.m

 Bernie Wylde
 */

#import "Shadow.h"

ShadowRef ShadowInit( void )
{ return [[[NSShadow alloc] init] autorelease]; }

CGSize ShadowOffset( ShadowRef shadow )
{ return NSSizeToCGSize([shadow shadowOffset]); }

void ShadowSetOffset( ShadowRef shadow, CGSize offset )
{ [shadow setShadowOffset:NSSizeFromCGSize(offset)]; }

CGFloat ShadowBlurRadius( ShadowRef shadow )
{ return [shadow shadowBlurRadius]; }

void ShadowSetBlurRadius( ShadowRef shadow, CGFloat radius )
{ [shadow setShadowBlurRadius:radius]; }

ColorRef ShadowColor( ShadowRef shadow )
{ return [shadow shadowColor]; }

void ShadowSetColor( ShadowRef shadow, ColorRef col )
{ [shadow setShadowColor:col]; }

void ShadowSet( ShadowRef shadow )
{ [shadow set]; }

// convenience
ShadowRef ShadowWithAttributes( CGSize offset, CGFloat blurRadius, ColorRef col )
{
    NSShadow *shadow = [[[NSShadow alloc] init] autorelease];
    [shadow setShadowOffset:NSSizeFromCGSize(offset)];
    [shadow setShadowBlurRadius:blurRadius];
    if ( col ) [shadow setShadowColor:col];
    return shadow;
}

void ShadowSetWithAttributes( CGSize offset, CGFloat blurRadius, ColorRef col )
{
    NSShadow *shadow = [[[NSShadow alloc] init] autorelease];
    [shadow setShadowOffset:NSSizeFromCGSize(offset)];
    [shadow setShadowBlurRadius:blurRadius];
    if ( col ) [shadow setShadowColor:col];
    [shadow set];
}
