/*
 SortDescriptor.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// - init -
SortDescriptorRef SortDescriptorWithKey( CFStringRef key, Boolean ascending );
SortDescriptorRef SortDescriptorWithKeyAndSelector( CFStringRef key, Boolean ascending, CFStringRef selector );

// - info -
Boolean SortDescriptorAscending( SortDescriptorRef sd );
CFStringRef SortDescriptorKey( SortDescriptorRef sd );

// - using -
NSComparisonResult SortDescriptorCompare( SortDescriptorRef sd, CFTypeRef obj1, CFTypeRef obj2 );
SortDescriptorRef SortDescriptorReversedSortDescriptor( SortDescriptorRef sd );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
void SortDescriptorAllowEvaluation( SortDescriptorRef sd );
#endif

