/*
 SortDescriptor.m

 Bernie Wylde
 */

#import "SortDescriptor.h"

// - init -
SortDescriptorRef SortDescriptorWithKey( CFStringRef key, Boolean ascending )
{ return [NSSortDescriptor sortDescriptorWithKey:(NSString *)key ascending:ascending]; }

SortDescriptorRef SortDescriptorWithKeyAndSelector( CFStringRef key, Boolean ascending, CFStringRef selector )
{ return [NSSortDescriptor sortDescriptorWithKey:(NSString *)key ascending:ascending selector:NSSelectorFromString((NSString *)selector)]; }

// - info -
Boolean SortDescriptorAscending( SortDescriptorRef sd )
{ return [sd ascending]; }

CFStringRef SortDescriptorKey( SortDescriptorRef sd )
{ return (CFStringRef)[sd key]; }

// - using -
NSComparisonResult SortDescriptorCompare( SortDescriptorRef sd, CFTypeRef obj1, CFTypeRef obj2 )
{ return [sd compareObject:(id)obj1 toObject:(id)obj2]; }

SortDescriptorRef SortDescriptorReversedSortDescriptor( SortDescriptorRef sd )
{ return [sd reversedSortDescriptor]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
void SortDescriptorAllowEvaluation( SortDescriptorRef sd )
{ [sd allowEvaluation]; }
#endif

