/*
 Sound.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// dialog events
enum {
    soundDidFinishPlaying = 3700
};

@interface CocoaSoundDelegate : NSObject <NSSoundDelegate>
@end

CocoaSoundDelegate *CocoaSoundDelegateObj( void );

// -- create --
Boolean SoundCanInitWithPasteboard( CocoaPasteboardRef pb );
SoundRef SoundWithContentsOfURL( CFURLRef url, Boolean byReference );
SoundRef SoundWithData( CFDataRef data );
SoundRef SoundWithPasteboard( CocoaPasteboardRef pb );

// -- configure --
CFStringRef SoundName( SoundRef snd );
Boolean SoundSetName( SoundRef snd, CFStringRef name );
float SoundVolume( SoundRef snd );
void SoundSetVolume( SoundRef snd, float value );
CFTimeInterval SoundCurrentTime( SoundRef snd );
void SoundSetCurrentTime( SoundRef snd, CFTimeInterval ti );
Boolean SoundLoops( SoundRef snd );
void SoundSetLoops( SoundRef snd, Boolean flag );
void SoundSetPlaybackDeviceIdentifier( SoundRef snd, CFStringRef identifier );

// -- info --
CFArrayRef SoundUnfilteredTypes( void );
SoundRef SoundNamed( CFStringRef name );
CFTimeInterval SoundDuration( SoundRef snd );

// -- play --
Boolean SoundIsPlaying( SoundRef snd );
Boolean SoundPause( SoundRef snd );
Boolean SoundPlay( SoundRef snd );
Boolean SoundResume( SoundRef snd );
Boolean SoundStop( SoundRef snd );

// -- write --
void SoundWriteToPasteboard( SoundRef snd, CocoaPasteboardRef pb );

