/*
 StatusItem.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// - status bar -
StatusBarRef StatusItemStatusBar( StatusItemRef item );

// - behavior -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
StatusBarButtonRef StatusItemButton( StatusItemRef item );
#endif
CocoaMenuRef StatusItemMenu( StatusItemRef item );
void StatusItemSetMenu( StatusItemRef item, CocoaMenuRef menu );
void StatusItemSetMenuIndex( StatusItemRef item, NSInteger menuIndex );

// - appearance -
CGFloat StatusItemLength( StatusItemRef item );
void StatusItemSetLength( StatusItemRef item, CGFloat length );

// - instance properties -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
CFStringRef StatusItemAutosaveName( StatusItemRef item );
void StatusItemSetAutosaveName( StatusItemRef item, CFStringRef name );
NSStatusItemBehavior StatusItemBehavior( StatusItemRef item );
void StatusItemSetBehavior( StatusItemRef item, NSStatusItemBehavior behavior );
Boolean StatusItemIsVisible( StatusItemRef item );
void StatusItemSetVisible( StatusItemRef item, Boolean flag );
#endif

// - convenience -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
void StatusItemButtonSetImage( StatusItemRef item, ImageRef image );
Boolean StatusItemButtonAppearsDisabled( StatusItemRef item );
void StatusItemButtonSetAppearsDisabled( StatusItemRef item, Boolean flag );
void StatusItemButtonSetActionCallback( StatusItemRef item, void *callback, void *userData );
#endif

