/*
 StatusItem.m

 Bernie Wylde
 */

#import "StatusItem.h"

// - status bar -
StatusBarRef StatusItemStatusBar( StatusItemRef item )
{ return [item statusBar]; }

// - behavior -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
StatusBarButtonRef StatusItemButton( StatusItemRef item )
{ return [item button]; }
#endif

CocoaMenuRef StatusItemMenu( StatusItemRef item )
{ return [item menu]; }

void StatusItemSetMenu( StatusItemRef item, CocoaMenuRef menu )
{ [item setMenu:menu]; }

void StatusItemSetMenuIndex( StatusItemRef item, NSInteger menuIndex )
{
    NSMenu *menu = MenuAtIndex( menuIndex );
    if ( menu ) [item setMenu:menu];
}

// - appearance -
CGFloat StatusItemLength( StatusItemRef item )
{ return [item length]; }

void StatusItemSetLength( StatusItemRef item, CGFloat length )
{ [item setLength:length]; }

// - instance properties -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
CFStringRef StatusItemAutosaveName( StatusItemRef item )
{ return (CFStringRef)[item autosaveName]; }

void StatusItemSetAutosaveName( StatusItemRef item, CFStringRef name )
{ [item setAutosaveName:(NSString *)name]; }

NSStatusItemBehavior StatusItemBehavior( StatusItemRef item )
{ return [item behavior]; }

void StatusItemSetBehavior( StatusItemRef item, NSStatusItemBehavior behavior )
{ [item setBehavior:behavior]; }

Boolean StatusItemIsVisible( StatusItemRef item )
{ return [item isVisible]; }

void StatusItemSetVisible( StatusItemRef item, Boolean flag )
{ [item setVisible:flag]; }
#endif

// - convenience -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
void StatusItemButtonSetImage( StatusItemRef item, ImageRef image )
{ [[item button] setImage:image]; }

Boolean StatusItemButtonAppearsDisabled( StatusItemRef item )
{ return [[item button] appearsDisabled]; }

void StatusItemButtonSetAppearsDisabled( StatusItemRef item, Boolean flag )
{ [[item button] setAppearsDisabled:flag]; }

void StatusItemButtonSetActionCallback( StatusItemRef item, void *callback, void *userData )
{
    CocoaStatusBarButtonTarget *target = [[[CocoaStatusBarButtonTarget alloc] init] autorelease];
    target.callback = callback;
    target.userData = userData;
    [[item button] setTarget:target];
    [[item button] setAction:@selector(action:)];
}
#endif

