/*
 TabView.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

@interface TabViewSC : NSTabView
@end

@interface NSTabView (Additions)
@property (nonatomic,retain) NSNumber *tagNumber;
- (NSInteger)tag;
- (void)setTag:(NSInteger)tag;
@end

// dialog events
enum {
    tabViewDidChangeNumberOfTabViewItems = 1700,
    tabViewShouldSelectTabViewItem,
    tabViewWillSelectTabViewItem,
    tabViewDidSelectTabViewItem
};

@interface CocoaTabViewDelegate : NSObject <NSTabViewDelegate> {
    BOOL boolVal;
    NSInteger indexVal;
}
@property (assign) BOOL boolVal;
@property (assign) NSInteger indexVal;
@end

CocoaTabViewDelegate *CocoaTabViewDelegateGet( void );

NSTabView *TabViewWithTag( NSInteger tag );
BOOL TabViewExists( NSInteger tag );

void TabViewSetType( NSInteger tag, NSTabViewType type );
NSInteger TabViewIndex( NSInteger tag );
void TabViewSelectFirstItem( NSInteger tag );
void TabViewSelectLastItem( NSInteger tag );
void TabViewSelectNextItem( NSInteger tag );
void TabViewSelectPreviousItem( NSInteger tag );
void TabViewSetFont( NSInteger tag, CTNSFontRef inFont );
void TabViewSetControlTint( NSInteger tag, NSControlTint tint );
void TabViewSetDrawsBackground( NSInteger tag, Boolean flag );
CGRect TabViewContentRect( NSInteger tag );

// custom
void TabViewAddSubview( NSInteger tabTag, NSInteger index, NSInteger subviewTag );



// Init
TabViewRef TabViewInit( NSInteger inTag, CGRect inRect );

// Statement
void CocoaTabView( NSInteger inTag, NSInteger inIndex, CFTypeRef inItems, CGRect inRect, NSInteger inWndTag );

