/*
 TableCellView.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// Represented object
CFTypeRef TableCellViewObjectValue( TableCellViewRef ref );
void TableCellViewSetObjectValue( TableCellViewRef ref, CFTypeRef obj );

// Displayed items
ImageViewRef TableCellViewImageView( TableCellViewRef ref );
void TableCellViewSetImageView( TableCellViewRef ref, ImageViewRef imgViewRef );
TextFieldRef TableCellViewTextField( TableCellViewRef ref );
void TableCellViewSetTextField( TableCellViewRef ref, TextFieldRef txtFldRef );

// Background style
NSBackgroundStyle TableCellViewBackgroundStyle( TableCellViewRef ref );
void TableCellViewSetBackgroundStyle( TableCellViewRef ref, NSBackgroundStyle style );

// Row size style
NSTableViewRowSizeStyle TableCellViewRowSizeStyle( TableCellViewRef ref );
void TableCellViewSetRowSizeStyle( TableCellViewRef ref, NSTableViewRowSizeStyle style );

// Dragging images
CFArrayRef TableCellViewDraggingImageComponents( TableCellViewRef ref );

// Convenience
void TableCellViewTextFieldSetString( TableCellViewRef ref, CFStringRef string );
void TableCellViewImageViewSetImage( TableCellViewRef ref, ImageRef image );
