/*
 TableCellView.m

 Bernie Wylde
 */

#import "TableCellView.h"

// Represented object
CFTypeRef TableCellViewObjectValue( TableCellViewRef ref )
{ return (CFTypeRef)[ref objectValue]; }

void TableCellViewSetObjectValue( TableCellViewRef ref, CFTypeRef obj )
{ [ref setObjectValue:(id)obj]; }

// Displayed items
ImageViewRef TableCellViewImageView( TableCellViewRef ref )
{ return [ref imageView]; }

void TableCellViewSetImageView( TableCellViewRef ref, ImageViewRef imgViewRef )
{ [ref setImageView:imgViewRef]; }

TextFieldRef TableCellViewTextField( TableCellViewRef ref )
{ return [ref textField]; }

void TableCellViewSetTextField( TableCellViewRef ref, TextFieldRef txtFldRef )
{ [ref setTextField:txtFldRef]; }

// Background style
NSBackgroundStyle TableCellViewBackgroundStyle( TableCellViewRef ref )
{ return [ref backgroundStyle]; }

void TableCellViewSetBackgroundStyle( TableCellViewRef ref, NSBackgroundStyle style )
{ [ref setBackgroundStyle:style]; }

// Row size style
NSTableViewRowSizeStyle TableCellViewRowSizeStyle( TableCellViewRef ref )
{ return [ref rowSizeStyle]; }

void TableCellViewSetRowSizeStyle( TableCellViewRef ref, NSTableViewRowSizeStyle style )
{ [ref setRowSizeStyle:style]; }

// Dragging images
CFArrayRef TableCellViewDraggingImageComponents( TableCellViewRef ref )
{ return (CFArrayRef)[ref draggingImageComponents]; }

// Convenience
void TableCellViewTextFieldSetString( TableCellViewRef ref, CFStringRef string )
{ [[ref textField] setStringValue:(NSString *)string]; }

void TableCellViewImageViewSetImage( TableCellViewRef ref, ImageRef image )
{ [[ref imageView] setImage:image]; }
