/*
 TableColumn.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// Create
TableColumnRef TableColumnWithIdentifier( CFStringRef identifier );

// TableView
TableViewRef TableColumnTableView( TableColumnRef ref );
void TableColumnSetTableView( TableColumnRef ref, TableViewRef tv );

// Size
CGFloat TableColumnWidth( TableColumnRef ref );
void TableColumnSetWidth( TableColumnRef ref, CGFloat width );
CGFloat TableColumnMinWidth( TableColumnRef ref );
void TableColumnSetMinWidth( TableColumnRef ref, CGFloat width );
CGFloat TableColumnMaxWidth( TableColumnRef ref );
void TableColumnSetMaxWidth( TableColumnRef ref, CGFloat width );
NSUInteger TableColumnResizingMask( TableColumnRef ref );
void TableColumnSetResizingMask( TableColumnRef ref, NSUInteger mask );
void TableColumnSizeToFit(  TableColumnRef ref );

// Header
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
CFStringRef TableColumnTitle( TableColumnRef ref );
void TableColumnSetTitle( TableColumnRef ref, CFStringRef title );
#endif// 101000
TableHeaderCellRef TableColumnHeaderCell( TableColumnRef ref );
void TableColumnSetHeaderCell( TableColumnRef ref, TableHeaderCellRef cell );

// Identifier
CFStringRef TableColumnIdentifier( TableColumnRef ref );
void TableColumnSetIdentifier( TableColumnRef ref, CFStringRef identifier );

// Sorting
SortDescriptorRef TableColumnSortDescriptorPrototype( TableColumnRef ref );
void TableColumnSetSortDescriptorPrototype( TableColumnRef ref, SortDescriptorRef sortDescriptor );

// Visibility
Boolean TableColumnIsHidden( TableColumnRef ref );
void TableColumnSetHidden( TableColumnRef ref, Boolean flag );

// Tooltip
CFStringRef TableColumnHeaderToolTip( TableColumnRef ref );
void TableColumnSetHeaderToolTip( TableColumnRef ref, CFStringRef tooltip );
