/*
 TableColumn.m

 Bernie Wylde
 */

#import "TableColumn.h"

// Create
TableColumnRef TableColumnWithIdentifier( CFStringRef identifier )
{ return [[[NSTableColumn alloc] initWithIdentifier:(NSString *)identifier] autorelease]; }

// TableView
TableViewRef TableColumnTableView( TableColumnRef ref )
{ return [ref tableView]; }

void TableColumnSetTableView( TableColumnRef ref, TableViewRef tv )
{ [ref setTableView:tv]; }

// Size
CGFloat TableColumnWidth( TableColumnRef ref )
{ return [ref width]; }

void TableColumnSetWidth( TableColumnRef ref, CGFloat width )
{ [ref setWidth:width]; }

CGFloat TableColumnMinWidth( TableColumnRef ref )
{ return [ref minWidth]; }

void TableColumnSetMinWidth( TableColumnRef ref, CGFloat width )
{ [ref setMinWidth:width]; }

CGFloat TableColumnMaxWidth( TableColumnRef ref )
{ return [ref maxWidth]; }

void TableColumnSetMaxWidth( TableColumnRef ref, CGFloat width )
{ [ref setMaxWidth:width]; }

NSUInteger TableColumnResizingMask( TableColumnRef ref )
{ return [ref resizingMask]; }

void TableColumnSetResizingMask( TableColumnRef ref, NSUInteger mask )
{ [ref setResizingMask:mask]; }

void TableColumnSizeToFit(  TableColumnRef ref )
{ [ref sizeToFit]; }

// Header
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
CFStringRef TableColumnTitle( TableColumnRef ref )
{ return (CFStringRef)[ref title]; }

void TableColumnSetTitle( TableColumnRef ref, CFStringRef title )
{ [ref setTitle:(NSString *)title]; }
#endif// 101000

TableHeaderCellRef TableColumnHeaderCell( TableColumnRef ref )
{ return [ref headerCell]; }

void TableColumnSetHeaderCell( TableColumnRef ref, TableHeaderCellRef cell )
{ [ref setHeaderCell:cell]; }

// Identifier
CFStringRef TableColumnIdentifier( TableColumnRef ref )
{ return (CFStringRef)[ref identifier]; }

void TableColumnSetIdentifier( TableColumnRef ref, CFStringRef identifier )
{ [ref setIdentifier:(NSString *)identifier]; }

// Sorting
SortDescriptorRef TableColumnSortDescriptorPrototype( TableColumnRef ref )
{ return [ref sortDescriptorPrototype]; }

void TableColumnSetSortDescriptorPrototype( TableColumnRef ref, SortDescriptorRef sortDescriptor )
{ [ref setSortDescriptorPrototype:sortDescriptor]; }

// Visibility
Boolean TableColumnIsHidden( TableColumnRef ref )
{ return [ref isHidden]; }

void TableColumnSetHidden( TableColumnRef ref, Boolean flag )
{ [ref setHidden:flag]; }

// Tooltip
CFStringRef TableColumnHeaderToolTip( TableColumnRef ref )
{ return (CFStringRef)[ref headerToolTip]; }

void TableColumnSetHeaderToolTip( TableColumnRef ref, CFStringRef tooltip )
{ [ref setHeaderToolTip:(NSString *)tooltip]; }

