/*
 TableRowView.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// dialog events
enum {
    tableRowViewBackgroundColor = 3000,
    tableRowViewDrawBackgroundInRect,
    tableRowViewDrawDraggingDestinationFeedbackInRect,
    tableRowViewDrawSelectionInRect,
    tableRowViewDrawSeparatorInRect
};

@interface TableRowViewSC : NSTableRowView {
    NSColor *selectionColorProp;
}
@property (assign) NSColor *selectionColorProp;
@end


@interface NSTableRowView (Additions)
@property (nonatomic,retain) NSNumber *tagNumber;
- (NSInteger)tag;
- (void)setTag:(NSInteger)tag;
@end


// Init
TableRowViewRef TableRowViewInit( void );

// Display style
Boolean TableRowViewIsEmphasized( TableRowViewRef ref );
void TableRowViewSetEmphasized( TableRowViewRef ref, Boolean flag );
NSBackgroundStyle TableRowViewInteriorBackgroundStyle( TableRowViewRef ref );
Boolean TableRowViewIsFloating( TableRowViewRef ref );
void TableRowViewSetFloating( TableRowViewRef ref, Boolean flag );

// Row selection
Boolean TableRowViewIsSelected( TableRowViewRef ref );
void TableRowViewSetSelected( TableRowViewRef ref, Boolean flag );
NSTableViewSelectionHighlightStyle TableRowViewSelectionHighlightStyle( TableRowViewRef ref );
void TableRowViewSetSelectionHighlightStyle( TableRowViewRef ref, NSTableViewSelectionHighlightStyle style );

// Drag and drop

// Row grouping
Boolean TableRowViewIsGroupRowStyle( TableRowViewRef ref );
void TableRowViewSetGroupRowStyle( TableRowViewRef ref, Boolean flag );
NSInteger TableRowViewNumberOfColumns( TableRowViewRef ref );

// Overriding display characteristics
ColorRef TableRowViewBackgroundColor( TableRowViewRef ref );
void TableRowViewSetBackgroundColor( TableRowViewRef ref, ColorRef col );

// Row column view
CFTypeRef TableRowViewViewAtColumn( TableRowViewRef ref, NSInteger column );

// Instance properties
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
Boolean TableRowViewIsNextRowSelected( TableRowViewRef ref );
void TableRowViewSetNextRowSelected( TableRowViewRef ref, Boolean flag );
Boolean TableRowViewIsPreviousRowSelected( TableRowViewRef ref );
void TableRowViewSetPreviousRowSelected( TableRowViewRef ref, Boolean flag );
#endif

