/*
 TableRowView.m

 Bernie Wylde
 */

#import "TableRowView.h"

@implementation TableRowViewSC

@synthesize selectionColorProp;

- (void)forwardEvent:(NSInteger)event {
    CallUserDefinedOnDialogFunction( event, 0, 0, self );
}

//- (ColorRef)backgroundColor {
//    DialogEventSetColor( [self backgroundColor] );
//    [self forwardEvent:tableRowViewBackgroundColor];
//    return DialogEventColor();
//}

//- (void)drawBackgroundInRect:(NSRect)dirtyRect {
//    DialogEventSetNSRect(dirtyRect);
//    [self forwardEvent:tableRowViewDrawBackgroundInRect];
//}

- (void)drawSelectionInRect:(NSRect)dirtyRect {
    DialogEventSetNSRect(dirtyRect);
    [self forwardEvent:tableRowViewDrawSelectionInRect];
    
}

- (void)drawSeparatorInRect:(NSRect)dirtyRect {
    DialogEventSetNSRect(dirtyRect);
    [self forwardEvent:tableRowViewDrawSeparatorInRect];
}
@end






@implementation NSTableRowView (Additions)
@dynamic tagNumber;
- (NSInteger)tag {
    return [objc_getAssociatedObject(self, @selector(tagNumber)) integerValue];
}
- (void)setTag:(NSInteger)tag {
    objc_setAssociatedObject(self, @selector(tagNumber), [NSNumber numberWithInteger:tag], OBJC_ASSOCIATION_RETAIN_NONATOMIC);
}
@end


// Init
TableRowViewRef TableRowViewInit( void )
{ return [[[TableRowViewSC alloc] init] autorelease]; }

// Display style
Boolean TableRowViewIsEmphasized( TableRowViewRef ref )
{ return [ref isEmphasized]; }

void TableRowViewSetEmphasized( TableRowViewRef ref, Boolean flag )
{ [ref setEmphasized:flag]; }

NSBackgroundStyle TableRowViewInteriorBackgroundStyle( TableRowViewRef ref )
{ return [ref interiorBackgroundStyle]; }

Boolean TableRowViewIsFloating( TableRowViewRef ref )
{ return [ref isFloating]; }

void TableRowViewSetFloating( TableRowViewRef ref, Boolean flag )
{ [ref setFloating:flag]; }

// Row selection
Boolean TableRowViewIsSelected( TableRowViewRef ref )
{ return [ref isSelected]; }

void TableRowViewSetSelected( TableRowViewRef ref, Boolean flag )
{ [ref setSelected:flag]; }

NSTableViewSelectionHighlightStyle TableRowViewSelectionHighlightStyle( TableRowViewRef ref )
{ return [ref selectionHighlightStyle]; }

void TableRowViewSetSelectionHighlightStyle( TableRowViewRef ref, NSTableViewSelectionHighlightStyle style )
{ [ref setSelectionHighlightStyle:style]; }

// Drag and drop

// Row grouping
Boolean TableRowViewIsGroupRowStyle( TableRowViewRef ref )
{ return [ref isGroupRowStyle]; }

void TableRowViewSetGroupRowStyle( TableRowViewRef ref, Boolean flag )
{ [ref setGroupRowStyle:flag]; }

NSInteger TableRowViewNumberOfColumns( TableRowViewRef ref )
{ return [ref numberOfColumns]; }

// Overriding display characteristics
ColorRef TableRowViewBackgroundColor( TableRowViewRef ref )
{ return [ref backgroundColor]; }

void TableRowViewSetBackgroundColor( TableRowViewRef ref, ColorRef col )
{ [ref setBackgroundColor:col]; }

// Row column view
CFTypeRef TableRowViewViewAtColumn( TableRowViewRef ref, NSInteger column )
{ return (CFTypeRef)[ref viewAtColumn:column]; }

// Instance properties
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
Boolean TableRowViewIsNextRowSelected( TableRowViewRef ref )
{ return [ref isNextRowSelected]; }

void TableRowViewSetNextRowSelected( TableRowViewRef ref, Boolean flag )
{ [ref setNextRowSelected:flag]; }

Boolean TableRowViewIsPreviousRowSelected( TableRowViewRef ref )
{ return [ref isPreviousRowSelected]; }

void TableRowViewSetPreviousRowSelected( TableRowViewRef ref, Boolean flag )
{ [ref setPreviousRowSelected:flag]; }
#endif


