/*
 Text.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// dialog events
enum {
    textDidBeginEditing = 2100,
    textDidChange,
    textDidEndEditing
};

CFStringRef TextString( NSInteger tag );
void TextSetString( NSInteger tag, CFStringRef string );
CFRange TextSelectedRange( NSInteger tag );
void TextSetSelectedRange( NSInteger tag, CFRange range );
//CTNSFontRef TextFont( NSInteger tag );
void TextSetFont( NSInteger tag, CTNSFontRef inFont );
void TextSetFontInRange( NSInteger tag, CTNSFontRef inFont, CFRange range );

void TextSetFontWithName( NSInteger tag, CFStringRef inName, CGFloat size );
void TextSetFontWithNameInRange( NSInteger tag, CFStringRef inName, CGFloat size, CFRange range );

BOOL TextReadRTFDFromURL( NSInteger tag, CFURLRef url );
BOOL TextWriteRTFDToURL( NSInteger tag, CFURLRef url, Boolean atomically );

void TextShowGuessPanel( NSInteger tag );

// Constraining size
CGSize TextMaxSize( NSInteger tag );
void TextSetMaxSize( NSInteger tag, CGSize size );
CGSize TextMinSize( NSInteger tag );
void TextSetMinSize( NSInteger tag, CGSize size );
Boolean TextIsVerticallyResizable( NSInteger tag );
void TextSetVerticallyResizable( NSInteger tag, Boolean flag );
Boolean TextIsHorizontallyResizable( NSInteger tag );
void TextSetHorizontallyResizable( NSInteger tag, Boolean flag );
void TextSizeToFit( NSInteger tag );

void TextSelectAll( NSInteger tag );
void TextCopy( NSInteger tag );
void TextCut( NSInteger tag );
void TextPaste( NSInteger tag );
void TextCopyFont( NSInteger tag );
void TextPasteFont( NSInteger tag );
void TextDelete( NSInteger tag );
NSTextAlignment TextAlignment( NSInteger tag );
void TextSetAlignment( NSInteger tag, NSTextAlignment alignment );
void TextAlignCenter( NSInteger tag );
void TextAlignLeft( NSInteger tag );
void TextAlignRight( NSInteger tag );
ColorRef TextColor( NSInteger tag );
void TextSetColor( NSInteger tag, ColorRef col );
void TextSetColorInRange( NSInteger tag, ColorRef col, CFRange range );
void TextSuperscript( NSInteger tag );
void TextSubscript( NSInteger tag );
void TextUnscript( NSInteger tag );
void TextUnderline( NSInteger tag );

// - replacing text -
void TextReplaceCharactersInRangeWithString( NSInteger tag, CFRange range, CFStringRef string );

// - scrolling -
void TextScrollRangeToVisible( NSInteger tag, CFRange range );

