/*
 TextAttachment.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// Init
TextAttachmentRef TextAttachmentInit( void );

// Contents

#if __LP64__
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
CGRect TextAttachmentBounds( TextAttachmentRef ref );
void TextAttachmentSetBounds( TextAttachmentRef ref, CGRect r );
CFDataRef TextAttachmentContents( TextAttachmentRef ref );
void TextAttachmentSetContents( TextAttachmentRef ref, CFDataRef dta );
CFStringRef TextAttachmentFileType( TextAttachmentRef ref );
void TextAttachmentSetFileType( TextAttachmentRef ref, CFStringRef type );
ImageRef TextAttachmentImage( TextAttachmentRef ref );
void TextAttachmentSetImage( TextAttachmentRef ref, ImageRef image );
#endif
#endif

FileWrapperRef TextAttachmentFileWrapper( TextAttachmentRef ref );
void TextAttachmentSetFileWrapper( TextAttachmentRef ref, FileWrapperRef wrapper );

// Cell
TextAttachmentCellRef TextAttachmentCell( TextAttachmentRef ref );
void TextAttachmentSetCell( TextAttachmentRef ref, TextAttachmentCellRef cell );



/*
 TextAttachmentCell
 */

// Init
TextAttachmentCellRef TextAttachmentCellWithImage( ImageRef image );

// Draw
void TextAttachmentCellDraw( TextAttachmentCellRef ref, CGRect frame, NSInteger controlViewTag );
void TextAttachmentCellDrawCharacterIndex( TextAttachmentCellRef ref, CGRect frame, NSInteger controlViewTag, NSUInteger charIndex );
void TextAttachmentCellDrawCharacterIndexLayoutManager( TextAttachmentCellRef ref, CGRect frame, NSInteger controlViewTag, NSUInteger charIndex, LayoutManagerRef layoutManager );
void TextAttachmentCellHighlight( TextAttachmentCellRef ref, Boolean highlight, CGRect frame, NSInteger controlViewTag );

// Cell size and position
CGSize TextAttachmentCellSize( TextAttachmentCellRef ref );
CGPoint TextAttachmentCellBaselineOffset( TextAttachmentCellRef ref );
CGRect TextAttachmentCellFrameForTextContainer( TextAttachmentCellRef ref, TextContainerRef tc, CGRect proposedLineFragment, CGPoint glyphPosition, NSUInteger charIndex );

// Set attachment
void TextAttachmentCellSetAttachment( TextAttachmentCellRef ref, TextAttachmentRef attachment );

