/*
 TextCheckingResult.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// Range and type
CFRange TextCheckingResultRange( TextCheckingResultRef ref );
NSTextCheckingType TextCheckingResultType( TextCheckingResultRef ref );
NSUInteger TextCheckingResultNumberOfRanges( TextCheckingResultRef ref );
CFRange TextCheckingResultRangeAtIndex( TextCheckingResultRef ref, NSUInteger index );

// Text replacement
//TextCheckingResultRef TextCheckingResultReplacementCheckingResultWithRange( CFRange range, CFStringRef replacementString );
TextCheckingResultRef TextCheckingResultReplacementCheckingResult( CFRange range, CFStringRef replacementString );
CFStringRef TextCheckingResultReplacementString( TextCheckingResultRef ref );

// Regular expressions
//TextCheckingResultRef TextCheckingResultRegularExpressionCheckingResultWithRanges( CFRange *ranges, NSUInteger count, RegularExpressionRef regex );
TextCheckingResultRef TextCheckingResultRegularExpressionCheckingResult( CFRange *ranges, NSUInteger count, RegularExpressionRef regex );
RegularExpressionRef TextCheckingResultRegularExpression( TextCheckingResultRef ref );

// Components
CFDictionaryRef TextCheckingResultComponents( TextCheckingResultRef ref );

// URLs
//TextCheckingResultRef TextCheckingResultLinkCheckingResultWithRange( CFRange range, CFURLRef url );
TextCheckingResultRef TextCheckingResultLinkCheckingResult( CFRange range, CFURLRef url );
CFURLRef TextCheckingResultURL( TextCheckingResultRef ref );

// Addresses
//TextCheckingResultRef TextCheckingResultAddressCheckingResultWithRange( CFRange range, CFDictionaryRef components );
TextCheckingResultRef TextCheckingResultAddressCheckingResult( CFRange range, CFDictionaryRef components );
CFDictionaryRef TextCheckingResultAddressComponents( TextCheckingResultRef ref );

// Transit info
//TextCheckingResultRef TextCheckingResultTransitInformationCheckingResultWithRange( CFRange range, CFDictionaryRef components );
TextCheckingResultRef TextCheckingResultTransitInformationCheckingResult( CFRange range, CFDictionaryRef components );

// Phone numbers
//TextCheckingResultRef TextCheckingResultPhoneNumberCheckingResultWithRange( CFRange range, CFStringRef phoneNumber );
TextCheckingResultRef TextCheckingResultPhoneNumberCheckingResult( CFRange range, CFStringRef phoneNumber );
CFStringRef TextCheckingResultPhoneNumber( TextCheckingResultRef ref );

// Dates and times
//TextCheckingResultRef TextCheckingResultDateCheckingResultWithRange( CFRange range, CFDateRef dt );
TextCheckingResultRef TextCheckingResultDateCheckingResult( CFRange range, CFDateRef dt );
//TextCheckingResultRef TextCheckingResultDateCheckingResultWithRangeAndTimeZone( CFRange range, CFDateRef dt, CFTimeZoneRef zone, CFTimeInterval duration );
TextCheckingResultRef TextCheckingResultDateCheckingResultWithTimeZone( CFRange range, CFDateRef dt, CFTimeZoneRef zone, CFTimeInterval duration );
CFDateRef TextCheckingResultDate( TextCheckingResultRef ref );
CFTimeInterval TextCheckingResultDuration( TextCheckingResultRef ref );
CFTimeZoneRef TextCheckingResultTimeZone( TextCheckingResultRef ref );

// Typography
//TextCheckingResultRef TextCheckingResultDashCheckingResultWithRange( CFRange range, CFStringRef replacementString );
TextCheckingResultRef TextCheckingResultDashCheckingResult( CFRange range, CFStringRef replacementString );
//TextCheckingResultRef TextCheckingResultQuoteCheckingResultWithRange( CFRange range, CFStringRef replacementString );
TextCheckingResultRef TextCheckingResultQuoteCheckingResult( CFRange range, CFStringRef replacementString );

// Spelling
//TextCheckingResultRef TextCheckingResultSpellCheckingResultWithRange( CFRange range );
TextCheckingResultRef TextCheckingResultSpellCheckingResult( CFRange range );
//TextCheckingResultRef TextCheckingResultCorrectionCheckingResultWithRange( CFRange range, CFStringRef replacementString );
TextCheckingResultRef TextCheckingResultCorrectionCheckingResult( CFRange range, CFStringRef replacementString );

// Orthography
//TextCheckingResultRef TextCheckingResultOrthographyCheckingResultWithRange( CFRange range, OrthographyRef orthography );
TextCheckingResultRef TextCheckingResultOrthographyCheckingResult( CFRange range, OrthographyRef orthography );
OrthographyRef TextCheckingResultOrthography( TextCheckingResultRef ref );

// Grammar
//TextCheckingResultRef TextCheckingResultGrammarCheckingResultWithRange( CFRange range, CFArrayRef details );
TextCheckingResultRef TextCheckingResultGrammarCheckingResult( CFRange range, CFArrayRef details );
CFArrayRef TextCheckingResultGrammarDetails( TextCheckingResultRef ref );

// Adjust ranges
TextCheckingResultRef TextCheckingResultByAdjustingRangesWithOffset( TextCheckingResultRef ref, NSInteger offset );

// Instance properties
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
CFArrayRef TextCheckingResultAlternativeStrings( TextCheckingResultRef ref );
#endif

// Instance methods
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300
CFRange TextCheckingResultRangeWithName( TextCheckingResultRef ref, CFStringRef name );
#endif

// Type methods
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
//TextCheckingResultRef TextCheckingResultCorrectionCheckingResultWithRange( CFRange range, CFStringRef replacementString, CFArrayRef alternativeStrings );
TextCheckingResultRef TextCheckingResultCorrectionCheckingResultWithAlternativeStrings( CFRange range, CFStringRef replacementString, CFArrayRef alternativeStrings );
#endif


