/*
 TextCheckingResult.m

 Bernie Wylde
 */

#import "TextCheckingResult.h"

// Range and type
CFRange TextCheckingResultRange( TextCheckingResultRef ref )
{ return NSRangeToCFRange([ref range]); }

NSTextCheckingType TextCheckingResultType( TextCheckingResultRef ref )
{ return [ref resultType]; }

NSUInteger TextCheckingResultNumberOfRanges( TextCheckingResultRef ref )
{ return [ref numberOfRanges]; }

CFRange TextCheckingResultRangeAtIndex( TextCheckingResultRef ref, NSUInteger index )
{ return NSRangeToCFRange([ref rangeAtIndex:index]); }

// Text replacement
//TextCheckingResultRef TextCheckingResultReplacementCheckingResultWithRange( CFRange range, CFStringRef replacementString )
//{ return [NSTextCheckingResult replacementCheckingResultWithRange:NSRangeFromCFRange(range) replacementString:(NSString *)replacementString]; }

TextCheckingResultRef TextCheckingResultReplacementCheckingResult( CFRange range, CFStringRef replacementString )
{ return [NSTextCheckingResult replacementCheckingResultWithRange:NSRangeFromCFRange(range) replacementString:(NSString *)replacementString]; }

CFStringRef TextCheckingResultReplacementString( TextCheckingResultRef ref )
{ return (CFStringRef)[ref replacementString]; }

// Regular expressions
//TextCheckingResultRef TextCheckingResultRegularExpressionCheckingResultWithRanges( CFRange *ranges, NSUInteger count, RegularExpressionRef regex )
//{ return [NSTextCheckingResult regularExpressionCheckingResultWithRanges:(NSRange *)ranges count:count regularExpression:regex]; }

TextCheckingResultRef TextCheckingResultRegularExpressionCheckingResult( CFRange *ranges, NSUInteger count, RegularExpressionRef regex )
{ return [NSTextCheckingResult regularExpressionCheckingResultWithRanges:(NSRange *)ranges count:count regularExpression:regex]; }

RegularExpressionRef TextCheckingResultRegularExpression( TextCheckingResultRef ref )
{ return [ref regularExpression]; }

// Components
CFDictionaryRef TextCheckingResultComponents( TextCheckingResultRef ref )
{ return (CFDictionaryRef)[ref components]; }

// URLs
//TextCheckingResultRef TextCheckingResultLinkCheckingResultWithRange( CFRange range, CFURLRef url )
//{ return [NSTextCheckingResult linkCheckingResultWithRange:NSRangeFromCFRange(range) URL:(NSURL *)url]; }

TextCheckingResultRef TextCheckingResultLinkCheckingResult( CFRange range, CFURLRef url )
{ return [NSTextCheckingResult linkCheckingResultWithRange:NSRangeFromCFRange(range) URL:(NSURL *)url]; }

CFURLRef TextCheckingResultURL( TextCheckingResultRef ref )
{ return (CFURLRef)[ref URL]; }

// Addresses
//TextCheckingResultRef TextCheckingResultAddressCheckingResultWithRange( CFRange range, CFDictionaryRef components )
//{ return [NSTextCheckingResult addressCheckingResultWithRange:NSRangeFromCFRange(range) components:(NSDictionary *)components]; }

TextCheckingResultRef TextCheckingResultAddressCheckingResult( CFRange range, CFDictionaryRef components )
{ return [NSTextCheckingResult addressCheckingResultWithRange:NSRangeFromCFRange(range) components:(NSDictionary *)components]; }

CFDictionaryRef TextCheckingResultAddressComponents( TextCheckingResultRef ref )
{ return (CFDictionaryRef)[ref addressComponents]; }

// Transit info
//TextCheckingResultRef TextCheckingResultTransitInformationCheckingResultWithRange( CFRange range, CFDictionaryRef components )
//{ return [NSTextCheckingResult transitInformationCheckingResultWithRange:NSRangeFromCFRange(range) components:(NSDictionary *)components]; }

TextCheckingResultRef TextCheckingResultTransitInformationCheckingResult( CFRange range, CFDictionaryRef components )
{ return [NSTextCheckingResult transitInformationCheckingResultWithRange:NSRangeFromCFRange(range) components:(NSDictionary *)components]; }

// Phone numbers
//TextCheckingResultRef TextCheckingResultPhoneNumberCheckingResultWithRange( CFRange range, CFStringRef phoneNumber )
//{ return [NSTextCheckingResult phoneNumberCheckingResultWithRange:NSRangeFromCFRange(range) phoneNumber:(NSString *)phoneNumber]; }

TextCheckingResultRef TextCheckingResultPhoneNumberCheckingResult( CFRange range, CFStringRef phoneNumber )
{ return [NSTextCheckingResult phoneNumberCheckingResultWithRange:NSRangeFromCFRange(range) phoneNumber:(NSString *)phoneNumber]; }

CFStringRef TextCheckingResultPhoneNumber( TextCheckingResultRef ref )
{ return (CFStringRef)[ref phoneNumber]; }

// Dates and times
//TextCheckingResultRef TextCheckingResultDateCheckingResultWithRange( CFRange range, CFDateRef dt )
//{ return [NSTextCheckingResult dateCheckingResultWithRange:NSRangeFromCFRange(range) date:(NSDate *)dt]; }

TextCheckingResultRef TextCheckingResultDateCheckingResult( CFRange range, CFDateRef dt )
{ return [NSTextCheckingResult dateCheckingResultWithRange:NSRangeFromCFRange(range) date:(NSDate *)dt]; }

//TextCheckingResultRef TextCheckingResultDateCheckingResultWithRangeAndTimeZone( CFRange range, CFDateRef dt, CFTimeZoneRef zone, CFTimeInterval duration )
//{ return [NSTextCheckingResult dateCheckingResultWithRange:NSRangeFromCFRange(range) date:(NSDate *)dt timeZone:(NSTimeZone *)zone duration:duration]; }

TextCheckingResultRef TextCheckingResultDateCheckingResultWithTimeZone( CFRange range, CFDateRef dt, CFTimeZoneRef zone, CFTimeInterval duration )
{ return [NSTextCheckingResult dateCheckingResultWithRange:NSRangeFromCFRange(range) date:(NSDate *)dt timeZone:(NSTimeZone *)zone duration:duration]; }

CFDateRef TextCheckingResultDate( TextCheckingResultRef ref )
{ return (CFDateRef)[ref date]; }

CFTimeInterval TextCheckingResultDuration( TextCheckingResultRef ref )
{ return [ref duration]; }

CFTimeZoneRef TextCheckingResultTimeZone( TextCheckingResultRef ref )
{ return (CFTimeZoneRef)[ref timeZone]; }

// Typography
//TextCheckingResultRef TextCheckingResultDashCheckingResultWithRange( CFRange range, CFStringRef replacementString )
//{ return [NSTextCheckingResult dashCheckingResultWithRange:NSRangeFromCFRange(range) replacementString:(NSString *)replacementString]; }

TextCheckingResultRef TextCheckingResultDashCheckingResult( CFRange range, CFStringRef replacementString )
{ return [NSTextCheckingResult dashCheckingResultWithRange:NSRangeFromCFRange(range) replacementString:(NSString *)replacementString]; }

//TextCheckingResultRef TextCheckingResultQuoteCheckingResultWithRange( CFRange range, CFStringRef replacementString )
//{ return [NSTextCheckingResult quoteCheckingResultWithRange:NSRangeFromCFRange(range) replacementString:(NSString *)replacementString]; }

TextCheckingResultRef TextCheckingResultQuoteCheckingResult( CFRange range, CFStringRef replacementString )
{ return [NSTextCheckingResult quoteCheckingResultWithRange:NSRangeFromCFRange(range) replacementString:(NSString *)replacementString]; }

// Spelling
//TextCheckingResultRef TextCheckingResultSpellCheckingResultWithRange( CFRange range )
//{ return [NSTextCheckingResult spellCheckingResultWithRange:NSRangeFromCFRange(range)]; }

TextCheckingResultRef TextCheckingResultSpellCheckingResult( CFRange range )
{ return [NSTextCheckingResult spellCheckingResultWithRange:NSRangeFromCFRange(range)]; }

//TextCheckingResultRef TextCheckingResultCorrectionCheckingResultWithRange( CFRange range, CFStringRef replacementString )
//{ return [NSTextCheckingResult correctionCheckingResultWithRange:NSRangeFromCFRange(range) replacementString:(NSString *)replacementString]; }

TextCheckingResultRef TextCheckingResultCorrectionCheckingResult( CFRange range, CFStringRef replacementString )
{ return [NSTextCheckingResult correctionCheckingResultWithRange:NSRangeFromCFRange(range) replacementString:(NSString *)replacementString]; }

// Orthography
//TextCheckingResultRef TextCheckingResultOrthographyCheckingResultWithRange( CFRange range, OrthographyRef orthography )
//{ return [NSTextCheckingResult orthographyCheckingResultWithRange:NSRangeFromCFRange(range) orthography:orthography]; }

TextCheckingResultRef TextCheckingResultOrthographyCheckingResult( CFRange range, OrthographyRef orthography )
{ return [NSTextCheckingResult orthographyCheckingResultWithRange:NSRangeFromCFRange(range) orthography:orthography]; }

OrthographyRef TextCheckingResultOrthography( TextCheckingResultRef ref )
{ return [ref orthography]; }

// Grammar
//TextCheckingResultRef TextCheckingResultGrammarCheckingResultWithRange( CFRange range, CFArrayRef details )
//{ return [NSTextCheckingResult grammarCheckingResultWithRange:NSRangeFromCFRange(range) details:(NSArray *)details]; }

TextCheckingResultRef TextCheckingResultGrammarCheckingResult( CFRange range, CFArrayRef details )
{ return [NSTextCheckingResult grammarCheckingResultWithRange:NSRangeFromCFRange(range) details:(NSArray *)details]; }

CFArrayRef TextCheckingResultGrammarDetails( TextCheckingResultRef ref )
{ return (CFArrayRef)[ref grammarDetails]; }

// Adjust ranges
TextCheckingResultRef TextCheckingResultByAdjustingRangesWithOffset( TextCheckingResultRef ref, NSInteger offset )
{ return [ref resultByAdjustingRangesWithOffset:offset]; }

// Instance properties
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
CFArrayRef TextCheckingResultAlternativeStrings( TextCheckingResultRef ref )
{ return (CFArrayRef)[ref alternativeStrings]; }
#endif

// Instance methods
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300 && __MAC_OS_X_VERSION_MIN_REQUIRED >= 101300
CFRange TextCheckingResultRangeWithName( TextCheckingResultRef ref, CFStringRef name )
{ return NSRangeToCFRange([ref rangeWithName:(NSString *)name]); }
#endif

// Type methods
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
//TextCheckingResultRef TextCheckingResultCorrectionCheckingResultWithRange( CFRange range, CFStringRef replacementString, CFArrayRef alternativeStrings )
//{ return [NSTextCheckingResult correctionCheckingResultWithRange:NSRangeFromCFRange(range) replacementString:(NSString *)replacementString alternativeStrings:(NSArray *)alternativeStrings]; }

TextCheckingResultRef TextCheckingResultCorrectionCheckingResultWithAlternativeStrings( CFRange range, CFStringRef replacementString, CFArrayRef alternativeStrings )
{ return [NSTextCheckingResult correctionCheckingResultWithRange:NSRangeFromCFRange(range) replacementString:(NSString *)replacementString alternativeStrings:(NSArray *)alternativeStrings]; }
#endif

