/*
 TextContainer.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

// - create -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
TextContainerRef TextContainerWithSize( CGSize size );
// - initWithCoder:
#endif

// - components -
LayoutManagerRef TextContainerLayoutManager( TextContainerRef ref );
void TextContainerSetLayoutManager( TextContainerRef ref, LayoutManagerRef lm );
void TextContainerReplaceLayoutManager( TextContainerRef ref, LayoutManagerRef lm );
NSInteger TextContainerTextView( TextContainerRef tc );

// - shape -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
CGSize TextContainerSize( TextContainerRef tc );
void TextContainerSetSize( TextContainerRef tc, CGSize size );
CFArrayRef TextContainerExclusionPaths( TextContainerRef tc );
void TextContainerSetExclusionPaths( TextContainerRef tc, CFArrayRef paths );
NSLineBreakMode TextContainerLineBreakMode( TextContainerRef tc );
void TextContainerSetLineBreakMode( TextContainerRef tc, NSLineBreakMode lineBreakMode );
#endif
Boolean TextContainerWidthTracksTextView( TextContainerRef tc );
void TextContainerSetWidthTracksTextView( TextContainerRef tc, Boolean flag );
Boolean TextContainerHeightTracksTextView( TextContainerRef tc );
void TextContainerSetHeightTracksTextView( TextContainerRef tc, Boolean flag );

// - constrain -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
NSUInteger TextContainerMaximumNumberOfLines( TextContainerRef tc );
void TextContainerSetMaximumNumberOfLines( TextContainerRef tc, NSUInteger lines );
#endif
CGFloat TextContainerLineFragmentPadding( TextContainerRef tc );
void TextContainerSetLineFragmentPadding( TextContainerRef tc, CGFloat padding );
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
CGRect TextContainerLineFragmentRectForProposedRect( TextContainerRef tc, CGRect proposedRect, NSUInteger index, NSWritingDirection direction, CGRect *remainingRect );
#endif
Boolean TextContainerIsSimpleRectangularTextContainer( TextContainerRef tc );

