/*
 TextTab.m

 Bernie Wylde
 */

#import "TextTab.h"

// - create -
TextTabRef TextTabInit( NSTextAlignment alignment, CGFloat location, CFDictionaryRef options )
{ return [[[NSTextTab alloc] initWithTextAlignment:alignment location:location options:(NSDictionary *)options] autorelease]; }

// - tab stop info -
CGFloat TextTabLocation( TextTabRef ref )
{ return [ref location]; }

// - text tab info -
NSTextAlignment TextTabAlignment( TextTabRef ref )
{ return [ref alignment]; }

CFDictionaryRef TextTabOptions( TextTabRef ref )
{ return (CFDictionaryRef)[ref options]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
CFCharacterSetRef TextTabColumnTerminatorsForLocale( CFLocaleRef locale )
{ return (CFCharacterSetRef)[NSTextTab columnTerminatorsForLocale:(NSLocale *)locale]; }
#endif

