/*
 Timer.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

typedef void (*CocoaTimerCallbackType)(CFRunLoopTimerRef,CFTypeRef);

@interface CocoaTimerTarget : NSObject {
    CocoaTimerCallbackType callback;
}
- (id)initWithCallback:(CocoaTimerCallbackType)cb;
@property (assign) CocoaTimerCallbackType callback;
@end

// - create -
CFRunLoopTimerRef TimerScheduledWithInterval( CFTimeInterval ti, CocoaTimerCallbackType callback, CFTypeRef userInfo, Boolean repeats );
CFRunLoopTimerRef TimerWithInterval( CFTimeInterval ti, CocoaTimerCallbackType callback, CFTypeRef userInfo, Boolean repeats );
CFRunLoopTimerRef TimerWithFireDate( CFDateRef dt, CFTimeInterval ti, CocoaTimerCallbackType callback, CFTypeRef userInfo, Boolean repeats );

// - fire -
void TimerFire( CFRunLoopTimerRef t );

// - stop -
void TimerInvalidate( CFRunLoopTimerRef t );

// - info -
Boolean TimerIsValid( CFRunLoopTimerRef t );
CFDateRef TimerFireDate( CFRunLoopTimerRef t );
CFTimeInterval TimerTimeInterval( CFRunLoopTimerRef t );
CFTypeRef TimerUserInfo( CFRunLoopTimerRef t );

// - tolerance -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
CFTimeInterval TimerTolerance( CFRunLoopTimerRef t );
#endif

