/*
 TokenField.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

#pragma mark - subclass
@interface TokenFieldSC : NSTokenField
@end

// dialog events
enum {
    tokenFieldDisplayStringForRepresentedObject = 1800,
    tokenFieldStyleForRepresentedObject,
    tokenFieldCompletionsForSubstring,
    tokenFieldEditingStringForRepresentedObject,
    tokenFieldRepresentedObjectForEditingString,
    tokenFieldShouldAddObjects,
    tokenFieldReadFromPasteboard,
    tokenFieldWriteRepresentedObjectToPasteboard,
    tokenFieldHasMenuForRepresentedObject,
    tokenFieldMenuForRepresentedObject
};

@interface CocoaTokenFieldDelegate : NSObject <NSTokenFieldDelegate> {
    BOOL boolVal;
}
@property (assign) BOOL boolVal;
@end

CocoaTokenFieldDelegate *CocoaTokenFieldDelegateGet( void );

NSTokenField *TokenFieldWithTag( NSInteger tag );
BOOL TokenFieldExists( NSInteger tag );

// Style
NSUInteger TokenFieldStyle( NSInteger tag );
void TokenFieldSetStyle( NSInteger tag, NSUInteger style );

// Character set
CFCharacterSetRef TokenFieldTokenizingCharacterSet( NSInteger tag );
void TokenFieldSetTokenizingCharacterSet( NSInteger tag, CFCharacterSetRef set );
CFCharacterSetRef TokenFieldDefaultTokenizingCharacterSet( void );

// CompletionDelay
CFTimeInterval TokenFieldCompletionDelay( NSInteger tag );
void TokenFieldSetCompletionDelay( NSInteger tag, CFTimeInterval ti );
CFTimeInterval TokenFieldDefaultCompletionDelay( void );

// Custom
CFArrayRef TokenFieldRangesOfSelections( NSInteger tag );



// Init
TokenFieldRef TokenFieldInit( NSInteger inTag, CGRect inRect );

// Statement
void CocoaTokenField( NSInteger inTag, NSInteger inEnabled, CFStringRef inText, CGRect inRect, NSInteger inStyle, NSInteger inWndTag );
