/*
 Toolbar.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

#pragma mark - subclass
@interface ToolbarSC : NSToolbar
@end

// toolbarItem dialog events
enum {
    toolbarItemClick = 1900,
    toolbarItemValidate
};

@interface CocoaToolbarItemTarget : NSObject
@end

CocoaToolbarItemTarget *CocoaToolbarItemTargetGet( void );

@interface CocoaToolbarDelegate : NSObject <NSToolbarDelegate>
@end

CocoaToolbarDelegate *CocoaToolbarDelegateGet( void );

@interface CocoaToolbarObj : NSObject {
    NSToolbar *toolbar;
    NSMutableDictionary *items;
    NSMutableArray *allowedIdentifiers;
    NSMutableArray *defaultIdentifiers;
}

@property (assign) NSToolbar *toolbar;
@property (assign) NSMutableDictionary *items;
@property (assign) NSMutableArray *allowedIdentifiers;
@property (assign) NSMutableArray *defaultIdentifiers;

- (id)initWithToolbar:(NSToolbar *)tb;

@end

CocoaToolbarObj *CocoaToolbarObjWithTag( NSInteger tag );
void CocoaToolbarObjAdd( NSToolbar *tb );
void CocoaToolbarObjAddItem( CocoaToolbarObj *obj, NSString *identifier, NSInteger tag, NSString *label, NSImage *image, Boolean allowed, Boolean dflt );
NSInteger CocoaToolbarTag( NSToolbar *tb );
NSInteger CocoaToolbarLastTag( void );
NSToolbar *CocoaToolbarWithTag( NSInteger tag );

NSToolbar *ToolbarWithTag( NSInteger tag );
BOOL ToolbarExists( NSInteger tag );

// Attributes
NSToolbarDisplayMode ToolbarDisplayMode( NSInteger tag );
void ToolbarSetDisplayMode( NSInteger tag, NSToolbarDisplayMode mode );
Boolean ToolbarShowsBaselineSeparator( NSInteger tag );
void ToolbarSetShowsBaselineSeparator( NSInteger tag, Boolean flag );
Boolean ToolbarAllowsUserCustomization( NSInteger tag );
void ToolbarSetAllowsUserCustomization( NSInteger tag, Boolean flag );
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
Boolean ToolbarAllowsExtensionItems( NSInteger tag );
void ToolbarSetAllowsExtensionItems( NSInteger tag, Boolean flag );
#endif
NSToolbarSizeMode ToolbarSizeMode( NSInteger tag );
void ToolbarSetSizeMode( NSInteger tag, NSToolbarSizeMode size );

// Display
Boolean ToolbarIsVisible( NSInteger tag );
void ToolbarSetVisible( NSInteger tag, Boolean flag );

// Customization
void ToolbarRunCustomizationPalette( NSInteger tag );
Boolean ToolbarCustomizationPaletteIsRunning( NSInteger tag );

// Autosaving
Boolean ToolbarAutosavesConfiguration( NSInteger tag );
void ToolbarSetAutosavesConfiguration( NSInteger tag, Boolean flag );
CFDictionaryRef ToolbarConfigurationDictionary( NSInteger tag );
void ToolbarSetConfigurationFromDictionary( NSInteger tag, CFDictionaryRef dict );

//void ToolbarInsertItem( NSInteger toolbarTag, NSInteger itemTag, CFStringRef inIdentifier, CFStringRef inLabel, CFStringRef inImageName, Boolean allowed, Boolean dflt );


// Init
ToolbarRef ToolbarInit( NSInteger inTag, CFStringRef identifier );

// Statement
void CocoaToolbar( NSInteger inTag );
