/*
 ToolbarItem.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

#pragma mark - subclass
@interface ToolbarItemSC : NSToolbarItem
@end

NSToolbarItem *ToolbarItemWithTag( NSInteger toolbarTag, NSInteger itemTag );

// Attributes
CFStringRef ToolbarItemIdentifier( NSInteger toolbarTag, NSInteger itemTag );
CFStringRef ToolbarItemLabel( NSInteger toolbarTag, NSInteger itemTag );
CFStringRef ToolbarItemPaletteLabel( NSInteger toolbarTag, NSInteger itemTag );
void ToolbarItemSetPaletteLabel( NSInteger toolbarTag, NSInteger itemTag, CFStringRef label );
CFStringRef ToolbarItemToolTip( NSInteger toolbarTag, NSInteger itemTag );
void ToolbarItemSetToolTip( NSInteger toolbarTag, NSInteger itemTag, CFStringRef toolTip );
MenuItemRef ToolbarItemMenuFormRepresentation( NSInteger toolbarTag, NSInteger itemTag );
void ToolbarItemSetMenuFormRepresentation( NSInteger toolbarTag, NSInteger itemTag, MenuItemRef menuItem );
Boolean ToolbarItemIsEnabled( NSInteger toolbarTag, NSInteger itemTag );
void ToolbarItemSetEnabled( NSInteger toolbarTag, NSInteger itemTag, Boolean flag );
ImageRef ToolbarItemImage( NSInteger toolbarTag, NSInteger itemTag );
ViewRef ToolbarItemView( NSInteger toolbarTag, NSInteger itemTag );
void ToolbarItemSetView( NSInteger toolbarTag, NSInteger itemTag, NSInteger vwTag );

CGSize ToolbarItemMinSize( NSInteger toolbarTag, NSInteger itemTag );
void ToolbarItemSetMinSize( NSInteger toolbarTag, NSInteger itemTag, CGSize size );
CGSize ToolbarItemMaxSize( NSInteger toolbarTag, NSInteger itemTag );
void ToolbarItemSetMaxSize( NSInteger toolbarTag, NSInteger itemTag, CGSize size );

// VisibilityPriority
NSInteger ToolbarItemVisibilityPriority( NSInteger toolbarTag, NSInteger itemTag );
void ToolbarItemSetVisibilityPriority( NSInteger toolbarTag, NSInteger itemTag, NSInteger priority );

// Validation
void ToolbarItemValidate( NSInteger toolbarTag, NSInteger itemTag );
Boolean ToolbarItemAutovalidates( NSInteger toolbarTag, NSInteger itemTag );
void ToolbarItemSetAutovalidates( NSInteger toolbarTag, NSInteger itemTag, Boolean flag );

// Duplicates
Boolean ToolbarItemAllowsDuplicatesInToolbar( NSInteger toolbarTag, NSInteger itemTag );



// Init
//ToolbarItemRef ToolbarItemInit( NSInteger inTag, CFStringRef inIdentifier );

// Statement
void CocoaToolbarItem( NSInteger inTag, NSString *inIdentifier, CFStringRef inLabel, void *inImage, NSInteger inAllowed, NSInteger inDefault, NSInteger inToolbarTag );

