/*
 Touch.m

 Bernie Wylde
 */

#import "Touch.h"

// Type
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101202
NSTouchType TouchType( TouchRef ref )
{ return [ref type]; }
#endif

// Properties of this touch
CFTypeRef TouchIdentity( TouchRef ref )
{ return (CFTypeRef)[ref identity]; }

NSTouchPhase TouchPhase( TouchRef ref )
{ return [ref phase]; }

CGPoint TouchNormalizedPosition( TouchRef ref )
{ return NSPointToCGPoint([ref normalizedPosition]); }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
Boolean TouchIsResting( TouchRef ref )
{ return [ref isResting]; }
#endif

// Properties of touch device
CFTypeRef TouchDevice( TouchRef ref )
{ return (CFTypeRef)[ref device]; }

CGSize TouchDeviceSize( TouchRef ref )
{ return NSSizeToCGSize([ref deviceSize]); }

// Touch location
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101202
CGPoint TouchLocationInView( TouchRef ref, NSInteger tag )
{
    NSView *view = ViewWithTag( tag );
    if ( view ) return NSPointToCGPoint([ref locationInView:view]);
    return CGPointZero;
}

CGPoint TouchPreviousLocationInView( TouchRef ref, NSInteger tag )
{
    NSView *view = ViewWithTag( tag );
    if ( view ) return NSPointToCGPoint([ref previousLocationInView:view]);
    return CGPointZero;
}
#endif
