/*
 URL.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

CFURLRef URLWithString( CFStringRef string );
CFURLRef URLWithStringRelativeToURL( CFStringRef string, CFURLRef baseURL );
CFURLRef URLFileURLWithPath( CFStringRef path );
CFURLRef URLFileURLWithPathComponents( CFArrayRef components );

CFURLRef URLByResolvingBookmarkData( CFDataRef bookmarkData, NSURLBookmarkResolutionOptions options, CFURLRef relativeURL, BOOL *isStale, ErrorRef *err );

Boolean URLIsEqual( CFURLRef url1, CFURLRef url2 );

CFStringRef URLPath( CFURLRef url );

CFArrayRef URLPathComponents( CFURLRef url );

CFStringRef URLLastPathComponent( CFURLRef url );
CFStringRef URLPathExtension( CFURLRef url );
CFURLRef URLByAppendingPathComponent( CFURLRef url, CFStringRef pathComponent );
CFURLRef URLByAppendingPathExtension( CFURLRef url, CFStringRef extension );
CFURLRef URLByDeletingLastPathComponent( CFURLRef url );
CFURLRef URLByDeletingPathExtension( CFURLRef url );
CFDictionaryRef URLResourceValuesForKeys( CFURLRef url, CFArrayRef keys );

CFDataRef URLBookmarkDataWithContentsOfURL( CFURLRef url, ErrorRef *err );
CFDataRef URLBookmarkDataWithOptions( CFURLRef url, NSURLBookmarkCreationOptions options, CFArrayRef resourceKeys, CFURLRef relativeURL, ErrorRef *err );
CFDictionaryRef URLResourceValuesForKeysFromBookmarkData( CFArrayRef resourceKeys, CFDataRef bookmarkData );

Boolean URLGetResourceValueForKey( CFURLRef url, CFStringRef key, CFTypeRef *value, ErrorRef *err );
Boolean URLSetResourceValueForKey( CFURLRef url, CFStringRef key, CFTypeRef value, ErrorRef *err );
Boolean URLSetResourceValues( CFURLRef url, CFDictionaryRef keyedValues, ErrorRef *err );

Boolean URLWriteBookmarkData( CFDataRef bookmarkData, CFURLRef toURL, NSURLBookmarkFileCreationOptions options, ErrorRef *err );

// Pasteboards
CFURLRef URLFromPasteboard( CocoaPasteboardRef pb );
void URLWriteToPasteboard( CFURLRef url, CocoaPasteboardRef pb );
