/*
 URL.m

 Bernie Wylde
 */

#import "URL.h"

CFURLRef URLWithString( CFStringRef string )
{ return (CFURLRef)[NSURL URLWithString:(NSString *)string]; }

CFURLRef URLWithStringRelativeToURL( CFStringRef string, CFURLRef baseURL )
{ return (CFURLRef)[NSURL URLWithString:(NSString *)string relativeToURL:(NSURL *)baseURL]; }

CFURLRef URLFileURLWithPath( CFStringRef path )
{ return (CFURLRef)[NSURL fileURLWithPath:(NSString *)path]; }

CFURLRef URLFileURLWithPathComponents( CFArrayRef components )
{ return (CFURLRef)[NSURL fileURLWithPathComponents:(NSArray *)components]; }

CFURLRef URLByResolvingBookmarkData( CFDataRef bookmarkData, NSURLBookmarkResolutionOptions options, CFURLRef relativeURL, BOOL *isStale, ErrorRef *err )
{ return (CFURLRef)[NSURL URLByResolvingBookmarkData:(NSData *)bookmarkData options:options relativeToURL:(NSURL *)relativeURL bookmarkDataIsStale:isStale error:err]; }

Boolean URLIsEqual( CFURLRef url1, CFURLRef url2 )
{ return [(NSURL *)url1 isEqual:(NSURL *)url2]; }

CFStringRef URLPath( CFURLRef url )
{ return (CFStringRef)[(NSURL *)url path]; }

CFArrayRef URLPathComponents( CFURLRef url )
{ return (CFArrayRef)[(NSURL *)url pathComponents]; }

CFStringRef URLLastPathComponent( CFURLRef url )
{ return (CFStringRef)[(NSURL *)url lastPathComponent]; }

CFStringRef URLPathExtension( CFURLRef url )
{ return (CFStringRef)[(NSURL *)url pathExtension]; }

CFURLRef URLByAppendingPathComponent( CFURLRef url, CFStringRef pathComponent )
{ return (CFURLRef)[(NSURL *)url URLByAppendingPathComponent:(NSString *)pathComponent]; }

CFURLRef URLByAppendingPathExtension( CFURLRef url, CFStringRef extension )
{ return (CFURLRef)[(NSURL *)url URLByAppendingPathExtension:(NSString *)extension]; }

CFURLRef URLByDeletingLastPathComponent( CFURLRef url )
{ return (CFURLRef)[(NSURL *)url URLByDeletingLastPathComponent]; }

CFURLRef URLByDeletingPathExtension( CFURLRef url )
{ return (CFURLRef)[(NSURL *)url URLByDeletingPathExtension]; }

CFDictionaryRef URLResourceValuesForKeys( CFURLRef url, CFArrayRef keys )
{ return (CFDictionaryRef)[(NSURL *)url resourceValuesForKeys:(NSArray *)keys error:nil]; }

Boolean URLGetResourceValueForKey( CFURLRef url, CFStringRef key, CFTypeRef *value, ErrorRef *err )
{ return [(NSURL *)url getResourceValue:(id *)value forKey:(NSString *)key error:err]; }

Boolean URLSetResourceValueForKey( CFURLRef url, CFStringRef key, CFTypeRef value, ErrorRef *err )
{ return [(NSURL *)url setResourceValue:(id)value forKey:(NSString *)key error:err]; }

Boolean URLSetResourceValues( CFURLRef url, CFDictionaryRef keyedValues, ErrorRef *err )
{ return [(NSURL *)url setResourceValues:(NSDictionary *)keyedValues error:err]; }

CFDataRef URLBookmarkDataWithContentsOfURL( CFURLRef url, ErrorRef *err )
{ return (CFDataRef)[NSURL bookmarkDataWithContentsOfURL:(NSURL *)url error:err]; }

CFDataRef URLBookmarkDataWithOptions( CFURLRef url, NSURLBookmarkCreationOptions options, CFArrayRef resourceKeys, CFURLRef relativeURL, ErrorRef *err )
{ return (CFDataRef)[(NSURL *)url bookmarkDataWithOptions:options includingResourceValuesForKeys:(NSArray *)resourceKeys relativeToURL:(NSURL *)relativeURL error:err]; }

CFDictionaryRef URLResourceValuesForKeysFromBookmarkData( CFArrayRef resourceKeys, CFDataRef bookmarkData )
{ return (CFDictionaryRef)[NSURL resourceValuesForKeys:(NSArray *)resourceKeys fromBookmarkData:(NSData *)bookmarkData]; }

Boolean URLWriteBookmarkData( CFDataRef bookmarkData, CFURLRef toURL, NSURLBookmarkFileCreationOptions options, ErrorRef *err )
{ return [NSURL writeBookmarkData:(NSData *)bookmarkData toURL:(NSURL *)toURL options:options error:err]; }

// Pasteboards
CFURLRef URLFromPasteboard( CocoaPasteboardRef pb )
{ return (CFURLRef)[NSURL URLFromPasteboard:pb]; }

void URLWriteToPasteboard( CFURLRef url, CocoaPasteboardRef pb )
{ [(NSURL *)url writeToPasteboard:pb]; }
