/*
 UserNotification.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1080

// - init -
UserNotificationRef UserNotificationInit( void );

// - dislay info -
CFStringRef UserNotificationTitle( UserNotificationRef ref );
void UserNotificationSetTitle( UserNotificationRef ref, CFStringRef title );
CFStringRef UserNotificationSubtitle( UserNotificationRef ref );
void UserNotificationSetSubtitle( UserNotificationRef ref, CFStringRef subtitle );
CFStringRef UserNotificationInformativeText( UserNotificationRef ref );
void UserNotificationSetInformativeText( UserNotificationRef ref, CFStringRef infoText );
ImageRef UserNotificationContentImage( UserNotificationRef ref );
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
void UserNotificationSetContentImage( UserNotificationRef ref, ImageRef image );
CFStringRef UserNotificationIdentifier( UserNotificationRef ref );
void UserNotificationSetIdentifier( UserNotificationRef ref, CFStringRef identifier );
CFAttributedStringRef UserNotificationResponse( UserNotificationRef ref );
CFStringRef UserNotificationResponsePlaceholder( UserNotificationRef ref );
#endif

// - displayed buttons -
Boolean UserNotificationHasActionButton( UserNotificationRef ref );
void UserNotificationSetHasActionButton( UserNotificationRef ref, Boolean flag );
CFStringRef UserNotificationActionButtonTitle( UserNotificationRef ref );
void UserNotificationSetActionButtonTitle( UserNotificationRef ref, CFStringRef title );
CFStringRef UserNotificationOtherButtonTitle( UserNotificationRef ref );
void UserNotificationSetOtherButtonTitle( UserNotificationRef ref, CFStringRef title );
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
Boolean UserNotificationHasReplyButton( UserNotificationRef ref );
void UserNotificationSetHasReplyButton( UserNotificationRef ref, Boolean flag );
#endif

// - delivery timing -
CFDateRef UserNotificationDeliveryDate( UserNotificationRef ref );
void UserNotificationSetDeliveryDate( UserNotificationRef ref, CFDateRef dt );
CFDateRef UserNotificationActualDeliveryDate( UserNotificationRef ref );
DateComponentsRef UserNotificationDeliveryRepeatInterval( UserNotificationRef ref );
void UserNotificationSetDeliveryRepeatInterval( UserNotificationRef ref, DateComponentsRef components );
CFTimeZoneRef UserNotificationDeliveryTimeZone( UserNotificationRef ref );
void UserNotificationSetDeliveryTimeZone( UserNotificationRef ref, CFTimeZoneRef zone );

// - delivery info -
Boolean UserNotificationIsPresented( UserNotificationRef ref );
Boolean UserNotificationIsRemote( UserNotificationRef ref );
CFStringRef UserNotificationSoundName( UserNotificationRef ref );
void UserNotificationSetSoundName( UserNotificationRef ref, CFStringRef name );

// - activation method -
NSUserNotificationActivationType UserNotificationActivationType( UserNotificationRef ref );
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
UserNotificationActionRef UserNotificationAdditionalActivationAction( UserNotificationRef ref );
CFArrayRef UserNotificationAdditionalActions( UserNotificationRef ref );
void UserNotificationSetAdditionalActions( UserNotificationRef ref, CFArrayRef actions );
#endif

// - user info -
CFDictionaryRef UserNotificationUserInfo( UserNotificationRef ref );
void UserNotificationSetUserInfo( UserNotificationRef ref, CFDictionaryRef userInfo );

// - convenience -
UserNotificationRef UserNotificationWithTitle( CFStringRef title, CFStringRef subtitle,  CFStringRef infoText, CFStringRef sndName );
#endif

