/*
 UserNotificationCenter.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1080

// - default user notification center -
UserNotificationCenterRef UserNotificationCenterDefault( void );

// - queue -
void UserNotificationCenterScheduleNotification( UserNotificationRef ref );
CFArrayRef UserNotificationCenterScheduledNotifications( void );
void UserNotificationCenterRemoveScheduledNotification( UserNotificationRef ref );

// - deliver -
void UserNotificationCenterDeliverNotification( UserNotificationRef ref );
CFArrayRef UserNotificationCenterDeliveredNotifications( void );
void UserNotificationCenterRemoveDeliveredNotification( UserNotificationRef ref );
void UserNotificationCenterRemoveAllDeliveredNotifications( void );

// - delegate -

// - convenience -
void UserNotificationCenterScheduleNotificationWithTitle( CFStringRef title, CFStringRef subtitle,  CFStringRef infoText, CFStringRef sndName );
void UserNotificationCenterDeliverNotificationWithTitle( CFStringRef title, CFStringRef subtitle,  CFStringRef infoText, CFStringRef sndName );

#endif

