/*
 UserNotificationCenter.m

 Bernie Wylde
 */

#import "UserNotificationCenter.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1080

// - default user notification center -
UserNotificationCenterRef UserNotificationCenterDefault( void )
{ return [NSUserNotificationCenter defaultUserNotificationCenter]; }

// - queue -
void UserNotificationCenterScheduleNotification( UserNotificationRef ref )
{ [[NSUserNotificationCenter defaultUserNotificationCenter] scheduleNotification:ref]; }

CFArrayRef UserNotificationCenterScheduledNotifications( void )
{ return (CFArrayRef)[[NSUserNotificationCenter defaultUserNotificationCenter] scheduledNotifications]; }

void UserNotificationCenterRemoveScheduledNotification( UserNotificationRef ref )
{ [[NSUserNotificationCenter defaultUserNotificationCenter] removeScheduledNotification:ref]; }

// - deliver -
void UserNotificationCenterDeliverNotification( UserNotificationRef ref )
{ [[NSUserNotificationCenter defaultUserNotificationCenter] deliverNotification:ref]; }

CFArrayRef UserNotificationCenterDeliveredNotifications( void )
{ return (CFArrayRef)[[NSUserNotificationCenter defaultUserNotificationCenter] deliveredNotifications]; }

void UserNotificationCenterRemoveDeliveredNotification( UserNotificationRef ref )
{ [[NSUserNotificationCenter defaultUserNotificationCenter] removeDeliveredNotification:ref]; }

void UserNotificationCenterRemoveAllDeliveredNotifications( void )
{ [[NSUserNotificationCenter defaultUserNotificationCenter] removeAllDeliveredNotifications]; }

// - delegate -

// - convenience -
void UserNotificationCenterScheduleNotificationWithTitle( CFStringRef title, CFStringRef subtitle,  CFStringRef infoText, CFStringRef sndName )
{
    NSUserNotification *note = [[[NSUserNotification alloc] init] autorelease];
    if ( title ) [note setTitle:(NSString *)title];
    if ( subtitle ) [note setSubtitle:(NSString *)subtitle];
    if ( infoText ) [note setInformativeText:(NSString *)infoText];
    if ( sndName ) [note setSoundName:(NSString *)sndName];
    [[NSUserNotificationCenter defaultUserNotificationCenter] scheduleNotification:note];
}

void UserNotificationCenterDeliverNotificationWithTitle( CFStringRef title, CFStringRef subtitle,  CFStringRef infoText, CFStringRef sndName )
{
    NSUserNotification *note = [[[NSUserNotification alloc] init] autorelease];
    if ( title ) [note setTitle:(NSString *)title];
    if ( subtitle ) [note setSubtitle:(NSString *)subtitle];
    if ( infoText ) [note setInformativeText:(NSString *)infoText];
    if ( sndName ) [note setSoundName:(NSString *)sndName];
    [[NSUserNotificationCenter defaultUserNotificationCenter] deliverNotification:note];
}

#endif

