/*
 Value.m

 Bernie Wylde
 */

#import "Value.h"

ValueRef ValueWithPointer( void *p )
{ return [NSValue valueWithPointer:p]; }

void *ValuePointer( ValueRef v )
{ return [v pointerValue]; }

ValueRef ValueWithRange( CFRange range )
{ return [NSValue valueWithRange:NSMakeRange(range.location,range.length)]; }

CFRange ValueRange( ValueRef v )
{
    NSRange range = [v rangeValue];
    return CFRangeMake(range.location,range.length);
}

ValueRef ValueWithPoint( CGPoint pt )
{ return [NSValue valueWithPoint:NSPointFromCGPoint(pt)]; }

CGPoint ValuePoint( ValueRef v )
{ return NSPointToCGPoint([v pointValue]); }

ValueRef ValueWithSize( CGSize size )
{ return [NSValue valueWithSize:NSSizeFromCGSize(size)]; }

CGSize ValueSize( ValueRef v )
{ return NSSizeToCGSize([v sizeValue]); }

ValueRef ValueWithRect( CGRect r )
{ return [NSValue valueWithRect:NSRectFromCGRect(r)]; }

CGRect ValueRect( ValueRef v )
{ return NSRectToCGRect([v rectValue]); }

// - CATransform3DAdditions -
ValueRef ValueWithCATransform3D( CATransform3D t )
{ return [NSValue valueWithCATransform3D:t]; }

