/*
 View.m
 
 Bernie Wylde
 */

#import "View.h"

@implementation ViewSC

//- (void)drawLayer:(CALayer *)theLayer inContext:(CGContextRef)theContext {
//    CallUserDefinedOnDialogFunction( CALayerDraw, 0, 0, NULL );
//}

//- (void)setTrackingAreaRect:(NSRect)rect options:(NSTrackingAreaOptions)options {
//    NSTrackingArea *trackingArea = [[NSTrackingArea alloc] initWithRect:rect options:options owner:self userInfo:nil];
//    [self addTrackingArea:trackingArea];
//    [trackingArea release];
//}

- (void)viewWillMoveToWindow:(NSWindow *)newWindow {
    NSTrackingAreaOptions options = NSTrackingMouseEnteredAndExited | NSTrackingMouseMoved | NSTrackingActiveAlways;
    NSTrackingArea *trackingArea = [[NSTrackingArea alloc] initWithRect:[self bounds] options:options owner:self userInfo:nil];
    [self addTrackingArea:trackingArea];
    //[trackingArea release];// ????
}

- (void)updateTrackingAreas {
    NSArray *areas = [self trackingAreas];
    if ( [areas count] > 0 ) {
        NSTrackingArea *trackingArea = [areas objectAtIndex:0];
        [self removeTrackingArea:trackingArea];
        
        [trackingArea release];// ????
        
        NSTrackingAreaOptions options = NSTrackingMouseEnteredAndExited | NSTrackingMouseMoved | NSTrackingActiveAlways;
        trackingArea = [[NSTrackingArea alloc] initWithRect:[self bounds] options:options owner:self userInfo:nil];
        [self addTrackingArea:trackingArea];
        
        //[trackingArea release];// ????
        
    }
    [super updateTrackingAreas];
}

- (void)drawRect:(NSRect)dirtyRect {
    if ( ![self suspendDrawRect] ) {
        CocoaSubclassDrawRect( self, dirtyRect );
        if ( !DialogEventBool() ) [super drawRect:dirtyRect];
    }
}

// this is required for key events
//- (BOOL)acceptsFirstResponder {
//    return self.responderFlag;
//}

- (BOOL)acceptsFirstResponder {
    DialogEventSetBool(NO);
    CocoaSubclassAcceptsFirstResponder( self );
    return DialogEventBool();
}

- (void)mouseDown:(NSEvent *)event {
    CocoaSubclassMouseDown( self, event );
    if ( !DialogEventBool() ) [super mouseDown:event];
}

- (void)mouseUp:(NSEvent *)event {
    CocoaSubclassMouseUp( self, event );
}

- (void)mouseEntered:(NSEvent *)event {
    CocoaSubclassMouseEntered( self, event );
}

- (void)mouseExited:(NSEvent *)event {
    CocoaSubclassMouseExited( self, event );
}

- (void)mouseDragged:(NSEvent *)event {
    CocoaSubclassMouseDragged( self, event );
}

- (void)mouseMoved:(NSEvent *)event {
    CocoaSubclassMouseMoved( self, event );
}

- (void)rightMouseDown:(NSEvent *)event {
    CocoaSubclassRightMouseDown( self, event );
    if ( !DialogEventBool() ) [super rightMouseDown:event];
}

- (void)rightMouseUp:(NSEvent *)event {
    CocoaSubclassRightMouseUp( self, event );
}

- (void)rightMouseDragged:(NSEvent *)event {
    CocoaSubclassRightMouseDragged( self, event );
}

- (void)keyDown:(NSEvent *)event {
    CocoaSubclassKeyDown( self, event );
    if ( !DialogEventBool() ) [super keyDown:event];
}

- (void)keyUp:(NSEvent *)event {
    CocoaSubclassKeyUp( self, event );
    //    if ( !DialogEventBool() ) [super keyUp:event];
}

- (void)flagsChanged:(NSEvent *)event {
    CocoaSubclassFlagsChanged( self, event );
    //    if ( !DialogEventBool() ) [super flagsChanged:event];
}

//- (void)updateTrackingAreas {
//    CocoaSubclassUpdateTrackingAreas( self );
//}

- (void)resetCursorRects {
    //[super resetCursorRects];
    CocoaSubclassResetCursorRects( self );
}

#pragma mark - dragging
- (NSDragOperation)draggingEntered:(id <NSDraggingInfo>)sender {
    return CocoaSubclassDraggingEntered( self, sender );
}

//- (BOOL)wantsPeriodicDraggingUpdates {
//    return NO;
//}

//- (NSDragOperation)draggingUpdated:(id<NSDraggingInfo>)sender {
//
//    return NSDragOperationNone;
//}

- (void)draggingEnded:(id<NSDraggingInfo>)sender {
    
}

- (void)draggingExited:(id <NSDraggingInfo>)sender {
    CocoaSubclassDraggingExited( self, sender );
}

//- (BOOL)prepareForDragOperation:(id<NSDraggingInfo>)sender {
//    return NO;
//}

- (BOOL)performDragOperation:(id <NSDraggingInfo>)sender {
    return CocoaSubclassPerformDragOperation( self, sender );
}

- (void)concludeDragOperation:(id<NSDraggingInfo>)sender {
    
}

- (void)updateDraggingItemsForDrag:(id<NSDraggingInfo>)sender {
    
}

- (void)viewDidChangeEffectiveAppearance {
    CocoaSubclassViewDidChangeEffectiveAppearance( self );
}

#pragma mark - flipped
- (BOOL)isFlipped {
    //return flip;
    return self.flipFlag;
}
@end

static CocoaSortSubviewsFunctionType sCocoaSortSubviewsFunctionAddress;

NSComparisonResult CocoaSortSubviewsFunction( NSView *view1, NSView *view2, void *context )
{
    NSInteger tag1 = [view1 tag];
    NSInteger tag2 = [view2 tag];
    if ( sCocoaSortSubviewsFunctionAddress ) return (*sCocoaSortSubviewsFunctionAddress)(tag1,tag2,context);
    return NSOrderedSame;
}


@implementation NSView (Additions)

// suspendDrawRect
@dynamic suspendDrawRectNumber;
- (BOOL)suspendDrawRect {
    return [objc_getAssociatedObject(self, @selector(suspendDrawRectNumber)) boolValue];
}
- (void)setSuspendDrawRect:(BOOL)flag {
    objc_setAssociatedObject(self, @selector(suspendDrawRectNumber), [NSNumber numberWithBool:flag], OBJC_ASSOCIATION_RETAIN_NONATOMIC);
}

// flipFlag
@dynamic flipFlagNumber;
- (BOOL)flipFlag {
    return [objc_getAssociatedObject(self, @selector(flipFlagNumber)) boolValue];
}
- (void)setFlipFlag:(BOOL)flag {
    objc_setAssociatedObject(self, @selector(flipFlagNumber), [NSNumber numberWithBool:flag], OBJC_ASSOCIATION_RETAIN_NONATOMIC);
}

// responderFlag
@dynamic responderFlagNumber;
- (BOOL)responderFlag {
    return [objc_getAssociatedObject(self, @selector(responderFlagNumber)) boolValue];
}
- (void)setResponderFlag:(BOOL)flag {
    objc_setAssociatedObject(self, @selector(responderFlagNumber), [NSNumber numberWithBool:flag], OBJC_ASSOCIATION_RETAIN_NONATOMIC);
}

// dragFileTypes
@dynamic dragFileTypesArray;
- (NSArray *)dragFileTypes {
    return objc_getAssociatedObject(self, @selector(dragFileTypesArray));
}
- (void)setDragFileTypes:(NSArray *)types {
    objc_setAssociatedObject(self, @selector(dragFileTypesArray), types, OBJC_ASSOCIATION_RETAIN_NONATOMIC);
}

// dragFileExtensions
@dynamic dragFileExtensionsArray;
- (NSArray *)dragFileExtensions {
    return objc_getAssociatedObject(self, @selector(dragFileExtensionsArray));
}
- (void)setDragFileExtensions:(NSArray *)extensions {
    objc_setAssociatedObject(self, @selector(dragFileExtensionsArray), extensions, OBJC_ASSOCIATION_RETAIN_NONATOMIC);
}

// dragInsideFlag
@dynamic dragInsideFlagNumber;
- (BOOL)dragInsideFlag {
    return [objc_getAssociatedObject(self, @selector(dragInsideFlagNumber)) boolValue];
}
- (void)setDragInsideFlag:(BOOL)flag {
    objc_setAssociatedObject(self, @selector(dragInsideFlagNumber), [NSNumber numberWithBool:flag], OBJC_ASSOCIATION_RETAIN_NONATOMIC);
}

@end


id ViewSubviewWithIdentifier( id superview, CFStringRef identifier )
{
    NSArray *subviews = [superview subviews];
    for (id obj in subviews ) {
        if ( class_respondsToSelector( [obj class], NSSelectorFromString( @"identifier" ) ) ) {
            if ( [obj identifier] != nil ) {
                if ( [(NSString *)[obj identifier] compare:(NSString *)identifier] == NSOrderedSame ) {
                    return obj;
                }
            }
            obj = ViewSubviewWithIdentifier( obj, identifier );
            if ( obj != nil ) return obj;
        }
    }
    return nil;
}

NSInteger CocoaViewTag( id view )
{
    NSInteger tag = 0;
    if ( [view class] == [NSView class] || [view class] == [ViewSC class] || [view class] == [ContentViewSC class] ) {
        tag = [[view identifier] integerValue];
    } else {
        tag = [view tag];
    }
    return tag;
}

id CocoaViewSubviewWithTag( NSView *superview, NSInteger tag )
{
    id obj = nil;
    
    if ( [superview isKindOfClass:[NSTabView class]] ) {
        NSArray *items = [(NSTabView *)superview tabViewItems];
        for ( NSTabViewItem *item in items ) {
            NSView *itemView = [item view];
            obj = CocoaViewSubviewWithTag( itemView, tag );
            if ( obj ) return obj;
        }
    } else if ( [superview class] == [NSSegmentedControl class] ) { // don't descend into segmented control because segment views are given tag values by macOS < 10.13
        return nil;
    } else {
        NSArray *subviews = [superview subviews];
        for ( obj in subviews ) {
            
            NSInteger viewTag = 0;
            if ( [obj class] == [NSView class] || [obj class] == [ViewSC class] ) {
                viewTag = [[obj identifier] integerValue];
            } else {

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
                if ( [obj class] == [NSVisualEffectView class] ) {
                    viewTag = [[obj identifier] integerValue];
                } else {
                    viewTag = [obj tag];
                }
#else
                viewTag = [obj tag];
#endif
            }
            
            if ( viewTag == tag ) return obj;
            obj = CocoaViewSubviewWithTag( obj, tag );
            if ( obj ) return obj;
            
        }
    }
    return nil;
}


NSView *CocoaViewWithTag( NSInteger tag )
{
    NSView *view = nil;
    
    if ( tag ) {
        if ( tag > 1000000 ) return (NSView *)tag;
        
        NSView *contentView = CocoaOutputWindowContentView();
        if ( !contentView ) {
            NSWindow *w = CocoaFrontWindow();
            contentView = [w contentView];
        }
        if ( contentView ) {
            NSWindow *w = [contentView window];
            
            if ( tag == windowContentViewTag ) return contentView;
            
            view = CocoaViewSubviewWithTag( contentView, tag );
            
            // check window titlebar accessoryview
            if ( !view ) {
                view = TitlebarAccessoryViewWithTag( tag );
            }
            
            // it may be in the toolbar
            if ( !view ) {
                NSToolbar *toolbar = [w toolbar];
                if ( toolbar ) {
                    NSInteger toolbarTag = CocoaToolbarTag( toolbar );
                    if ( toolbarTag ) {
                        NSToolbarItem *item = ToolbarItemWithTag( toolbarTag, tag );
                        if ( item ) {
                            view = item.view;
                        }
                    }
                }
            }
            
        } else {
            
            // warn of 0 view tag
            
        }
    }
    return view;
}

NSInteger ViewSuperview( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        NSView *superview = [view superview];
        if ( superview ) return [superview tag];
    }
    return 0;
}

CFArrayRef ViewSubviews( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return (CFArrayRef)[view subviews];
    return nil;
}

NSInteger ViewWindow( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        NSWindow *w = [view window];
        if ( w ) return [w tag];
    }
    return 0;
}

void ViewSetFrameOrigin( NSInteger tag, CGPoint origin )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        [view setFrameOrigin:NSPointFromCGPoint( origin )];
    }
}

void ViewSetFrameSize( NSInteger tag, CGSize size )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        [view setFrameSize:NSSizeFromCGSize( size )];
    }
}

void ViewSetFrameRotation( NSInteger tag, CGFloat rotation )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        [view setFrameRotation:rotation];
    }
}

CGRect ViewBounds( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        return NSRectToCGRect( [view bounds] );
    }
    return CGRectZero;
}

void ViewSetBounds( NSInteger tag, CGRect bounds )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        [view setBounds:NSRectFromCGRect( bounds )];
    }
}

void ViewSetBoundsOrigin( NSInteger tag, CGPoint origin )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        [view setBoundsOrigin:NSPointFromCGPoint( origin )];
    }
}

void ViewSetBoundsSize( NSInteger tag, CGSize size )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        [view setBoundsSize:NSSizeFromCGSize( size )];
    }
}

void ViewSetBoundsRotation( NSInteger tag, CGFloat rotation )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        [view setBoundsRotation:rotation];
    }
}

CGFloat ViewFrameRotation( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view frameRotation];
    return 0.0;
}

CGFloat ViewBoundsRotation( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view boundsRotation];
    return 0.0;
}


// Layer
void ViewSetWantsLayer( NSInteger tag, Boolean flag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view setWantsLayer:flag];
}

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1080
Boolean ViewWantsUpdateLayer( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view wantsUpdateLayer];
    return NO;
}
#endif

CALayerRef ViewLayer( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view layer];
    return nil;
}

void ViewSetLayer( NSInteger tag, CALayerRef layer )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view setLayer:layer];
}

CALayerRef ViewMakeBackingLayer( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view makeBackingLayer];
    return nil;
}

NSViewLayerContentsPlacement ViewLayerContentsPlacement( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view layerContentsPlacement];
    return 0;
}

void ViewSetLayerContentsPlacement( NSInteger tag, NSViewLayerContentsPlacement placement )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view setLayerContentsPlacement:placement];
}

NSViewLayerContentsRedrawPolicy ViewLayerContentsRedrawPolicy( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view layerContentsRedrawPolicy];
    return 0;
}

void ViewSetLayerContentsRedrawPolicy( NSInteger tag, NSViewLayerContentsRedrawPolicy policy )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view setLayerContentsRedrawPolicy:policy];
}

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
Boolean ViewCanDrawSubviewsIntoLayer( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view canDrawSubviewsIntoLayer];
    return 0;
}

void ViewSetCanDrawSubviewsIntoLayer( NSInteger tag, Boolean flag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view setCanDrawSubviewsIntoLayer:flag];
}

Boolean ViewLayerUsesCoreImageFilters( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view layerUsesCoreImageFilters];
    return 0;
}

void ViewSetLayerUsesCoreImageFilters( NSInteger tag, Boolean flag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view setLayerUsesCoreImageFilters:flag];
}
#endif// 1090

CGFloat ViewAlphaValue( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        return [view alphaValue];
    }
    return 0;
}

void ViewSetAlphaValue( NSInteger tag, CGFloat value )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        [view setAlphaValue:value];
    }
}

CGFloat ViewFrameCenterRotation( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        return [view frameCenterRotation];
    }
    return 0;
}

void ViewSetFrameCenterRotation( NSInteger tag, CGFloat rotation )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        [view setFrameCenterRotation:rotation];
    }
}

CFArrayRef ViewBackgroundFilters( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return (CFArrayRef)[view backgroundFilters];
    return nil;
}

void ViewSetBackgroundFilters( NSInteger tag, CFArrayRef filters )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view setBackgroundFilters:(NSArray *)filters];
}

CIFilterRef ViewCompositingFilter( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view compositingFilter];
    return nil;
}

void ViewSetCompositingFilter( NSInteger tag, CIFilterRef filter )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view setCompositingFilter:filter];
}

CFArrayRef ViewContentFilters( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return (CFArrayRef)[view contentFilters];
    return nil;
}

void ViewSetContentFilters( NSInteger tag, CFArrayRef filters )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view setContentFilters:(NSArray *)filters];
}

ShadowRef ViewShadow( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view shadow];
    return nil;
}

void ViewSetShadow( NSInteger tag, ShadowRef shadow )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        [view setWantsLayer:YES];
        [view setShadow:shadow];
    }
}


// Drawing
Boolean ViewCanDrawConcurrently( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view canDrawConcurrently];
    return NO;
}

void ViewSetCanDrawConcurrently( NSInteger tag, Boolean flag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view setCanDrawConcurrently:flag];
}

CGRect ViewVisibleRect( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return NSRectToCGRect([view visibleRect]);
    return CGRectZero;
}

Boolean ViewNeedsToDrawRect( NSInteger tag, CGRect r )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view needsToDrawRect:NSRectFromCGRect(r)];
    return NO;
}

Boolean ViewWantsDefaultClipping( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view wantsDefaultClipping];
    return NO;
}

BitmapImageRepRef ViewBitmapImageRepForCachingDisplayInRect( NSInteger tag, CGRect r )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view bitmapImageRepForCachingDisplayInRect:NSRectFromCGRect(r)];
    return nil;
}

void ViewCacheDisplayInRectToBitmapImageRep( NSInteger tag, CGRect r, BitmapImageRepRef repRef )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view cacheDisplayInRect:NSRectFromCGRect(r) toBitmapImageRep:repRef];
}

void ViewPrint( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        [view print:nil];
    }
}

void ViewSetNeedsDisplay( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        [view setNeedsDisplay:YES];
    }
}

Boolean ViewIsOpaque( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view isOpaque];
    return NO;
}

// Converting coordinate values
CGPoint ViewConvertPointFromView( NSInteger tag1, CGPoint pt, NSInteger tag2 )
{
    NSView *view1 = CocoaViewWithTag( tag1 );
    if ( view1 ) {
        NSView *view2 = nil;
        if ( tag2 ) view2 = CocoaViewWithTag( tag2 );
        return NSPointToCGPoint([view1 convertPoint:NSPointFromCGPoint(pt) fromView:view2]);
    }
    return CGPointZero;
}

void ViewRotateByAngle( NSInteger tag, CGFloat angle )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        [view rotateByAngle:angle];
    }
}

void ViewAddSubview( NSInteger viewTag, NSInteger subviewTag )
{
    NSView *view = CocoaViewWithTag( viewTag );
    if ( view ) {
        NSView *subview = CocoaViewWithTag( subviewTag );
        if ( subview ) {
            [view addSubview:subview];
            [subview setWndTag:[[view window] tag]];// 20190603 bw
        }
    }
}

void ViewAddSubviewPositioned( NSInteger superviewTag, NSInteger subviewTag, NSWindowOrderingMode position, NSInteger otherViewTag )
{
    NSView *superview = CocoaViewWithTag( superviewTag );
    if ( superview ) {
        NSView *subview = CocoaViewWithTag( subviewTag );
        if ( subview ) {
            NSView *otherView = nil;
            if ( otherViewTag ) otherView = CocoaViewWithTag( otherViewTag );
            [superview addSubview:subview positioned:position relativeTo:otherView];
        }
    }
}

void ViewRemoveFromSuperview( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view removeFromSuperview];
}

//void ViewReplaceSubview( NSInteger tag, NSInteger subview1, NSInteger subview2 )
//{
//    NSView *view = CocoaViewWithTag( tag );
//    if ( view ) {
//        // ...
//    }
//}

Boolean ViewIsDescendantOf( NSInteger tag, NSInteger superTag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        NSView *superview = CocoaViewWithTag( superTag );
        if ( superview ) {
            return [view isDescendantOf:superview];
        }
    }
    return NO;
}

NSInteger ViewOpaqueAncestor( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        NSView *ancestor = [view opaqueAncestor];
        if ( ancestor ) {
            return [ancestor tag];
        }
    }
    return 0;
}

NSInteger ViewAncestorSharedWithView( NSInteger tag, NSInteger otherTag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        NSView *otherView = CocoaViewWithTag( otherTag );
        if ( otherView ) {
            NSView *ancestor = [view ancestorSharedWithView:otherView];
            if ( ancestor ) {
                return [ancestor tag];
            }
        }
    }
    return 0;
}

void ViewSortSubviewsUsingFunction( NSInteger tag, void *fnAddress, void *context )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        sCocoaSortSubviewsFunctionAddress = fnAddress;
        [view sortSubviewsUsingFunction:CocoaSortSubviewsFunction context:context];
    }
}

Boolean ViewAutoresizesSubviews( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [(NSView *)view autoresizesSubviews];
    return NO;
}

void ViewSetAutoresizesSubviews( NSInteger tag, Boolean flag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [(NSView *)view setAutoresizesSubviews:flag];
}

NSUInteger ViewAutoresizingMask( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view autoresizingMask];
    return 0;
}

void ViewSetAutoresizingMask( NSInteger tag, NSUInteger mask )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [(NSView *)view setAutoresizingMask:mask];
}


// Layout anchors
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
LayoutYAxisAnchorRef ViewBottomAnchor( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view bottomAnchor];
    return nil;
}

LayoutXAxisAnchorRef ViewCenterXAnchor( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view centerXAnchor];
    return nil;
}

LayoutYAxisAnchorRef ViewCenterYAnchor( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view centerYAnchor];
    return nil;
}

LayoutYAxisAnchorRef ViewFirstBaselineAnchor( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view firstBaselineAnchor];
    return nil;
}

LayoutDimensionRef ViewHeightAnchor( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view heightAnchor];
    return nil;
}

LayoutYAxisAnchorRef ViewLastBaselineAnchor( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view lastBaselineAnchor];
    return nil;
}

LayoutXAxisAnchorRef ViewLeadingAnchor( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view leadingAnchor];
    return nil;
}

LayoutXAxisAnchorRef ViewLeftAnchor( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view leftAnchor];
    return nil;
}

LayoutXAxisAnchorRef ViewRightAnchor( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view rightAnchor];
    return nil;
}

LayoutYAxisAnchorRef ViewTopAnchor( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view topAnchor];
    return nil;
}

LayoutXAxisAnchorRef ViewTrailingAnchor( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view trailingAnchor];
    return nil;
}

LayoutDimensionRef ViewWidthAnchor( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view widthAnchor];
    return nil;
}
#endif// 101100

// Constraints
CFArrayRef ViewConstraints( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return (CFArrayRef)[view constraints];
    return nil;
}

void ViewAddConstraint( NSInteger tag, LayoutConstraintRef constraint )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view addConstraint:constraint];
}

void ViewAddConstraints( NSInteger tag, CFArrayRef constraints )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view addConstraints:(NSArray *)constraints];
}

void ViewRemoveConstraint( NSInteger tag, LayoutConstraintRef constraint )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view removeConstraint:constraint];
}

void ViewRemoveConstraints( NSInteger tag, CFArrayRef constraints )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view removeConstraints:(NSArray *)constraints];
}

// Layout guides
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
void ViewAddLayoutGuide( NSInteger tag, LayoutGuideRef guide )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view addLayoutGuide:guide];
}

CFArrayRef ViewLayoutGuides( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return (CFArrayRef)[view layoutGuides];
    return nil;
}

void ViewRemoveLayoutGuide( NSInteger tag, LayoutGuideRef guide )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view removeLayoutGuide:guide];
}
#endif// 101100

// Measuring in auto layout
CGSize ViewFittingSize( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return NSSizeToCGSize([view fittingSize]);
    return CGSizeZero;
}

CGSize ViewIntrinsicContentSize( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return NSSizeToCGSize([view intrinsicContentSize]);
    return CGSizeZero;
}

void ViewInvalidateIntrinsicContentSize( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view invalidateIntrinsicContentSize];
}

void ViewLockFocus( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view lockFocus];
}

void ViewUnlockFocus( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view unlockFocus];
}

NSInteger ViewFocusView( void )
{
    NSView *focusView = [NSView focusView];
    if ( [focusView respondsToSelector:@selector(tag)] ) {
        return [focusView tag];
    }
    return 0;
}

// Vibrancy
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
Boolean ViewAllowsVibrancy( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view allowsVibrancy];
    return NO;
}
#endif

CGRect ViewFrame( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return NSRectToCGRect([view frame]);
    return NSRectToCGRect( NSZeroRect );
}

void ViewSetFrame( NSInteger tag, CGRect r )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view setFrame:NSRectFromCGRect(r)];
}

NSInteger ViewTag( ViewRef view )
{ return CocoaViewTag( view ); }

void ViewSetToolTip( NSInteger tag, CFStringRef string )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [(NSView *)view setToolTip:(NSString *)string];
}

// Tracking rect
NSTrackingRectTag ViewAddTrackingRect( NSInteger tag, CGRect r, id owner, void *userData, Boolean assumeInside )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        return [view addTrackingRect:NSRectFromCGRect(r) owner:owner userData:userData assumeInside:assumeInside];
    }
    return 0;
}

void ViewRemoveTrackingRect( NSInteger tag, NSTrackingRectTag rectTag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        [view removeTrackingRect:rectTag];
    }
}

// Tracking area
void ViewAddTrackingArea( NSInteger tag, TrackingAreaRef ta )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view addTrackingArea:ta];
}

void ViewRemoveTrackingArea( NSInteger tag, TrackingAreaRef ta )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view removeTrackingArea:ta];
}

CFArrayRef ViewTrackingAreas( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return (CFArrayRef)[view trackingAreas];
    return nil;
}

//void ViewUpdateTrackingAreas( NSInteger tag )
//{
//    NSView *view = CocoaViewWithTag( tag );
//    if ( view ) [view updateTrackingAreas]
//}

// Cursor tracking
void ViewAddCursorRect( NSInteger tag, CGRect r, CursorRef curs )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view addCursorRect:NSRectFromCGRect(r) cursor:curs];
}

void ViewRemoveCursorRect( NSInteger tag, CGRect r, CursorRef curs )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view removeCursorRect:NSRectFromCGRect(r) cursor:curs];
}

void ViewDiscardCursorRects( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view discardCursorRects];
}


// Definition windows
void ViewShowDefinition( NSInteger tag, CFAttributedStringRef aString, CGPoint pt )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [(NSView *)view showDefinitionForAttributedString:(NSAttributedString *)aString atPoint:NSPointFromCGPoint(pt)];
}

void ViewShowDefinitionBaselineOriginProvider( NSInteger tag, CFAttributedStringRef aString, CFRange targetRange, CFDictionaryRef options, CocoaViewShowDefinitionBaselineOriginProviderType originProvider, void *userData )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        [(NSView *)view showDefinitionForAttributedString:(NSAttributedString *)aString range:NSRangeFromCFRange(targetRange) options:(NSDictionary *)options baselineOriginProvider:^(NSRange adjustedRange) {
            CGPoint pt = CGPointZero;
            if ( originProvider ) pt = (*originProvider)(NSRangeToCFRange(adjustedRange),userData);
            return NSPointFromCGPoint(pt);
        }];
    }
}

Boolean ViewIsHidden( NSInteger tag )
{
    NSView *view = (NSView *)CocoaViewWithTag( tag );
    if ( view ) return [view isHidden];
    return NO;
}

void ViewSetHidden( NSInteger tag, Boolean flag )
{
    NSView *view = (NSView *)CocoaViewWithTag( tag );
    if ( view ) [view setHidden:flag];
}

Boolean ViewIsHiddenOrHasHiddenAncestor( NSInteger tag )
{
    NSView *view = (NSView *)CocoaViewWithTag( tag );
    if ( view ) return [view isHiddenOrHasHiddenAncestor];
    return NO;
}

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
// Gesture recognizer
CFArrayRef ViewGestureRecognizers( NSInteger tag )
{
    NSView *view = (NSView *)CocoaViewWithTag( tag );
    if ( view ) return (CFArrayRef)[view gestureRecognizers];
    return nil;
}

void ViewAddGestureRecognizer( NSInteger tag, GestureRecognizerRef ref )
{
    NSView *view = (NSView *)CocoaViewWithTag( tag );
    if ( view ) [view addGestureRecognizer:ref];
}

void ViewRemoveGestureRecognizer( NSInteger tag, GestureRecognizerRef ref )
{
    NSView *view = (NSView *)CocoaViewWithTag( tag );
    if ( view ) [view removeGestureRecognizer:ref];
}
#endif

// Event handling
NSInteger ViewHitTest( NSInteger tag, CGPoint pt )
{
    NSView *view = (NSView *)CocoaViewWithTag( tag );
    if ( view ) {
        NSView *otherview = [view hitTest:NSPointFromCGPoint(pt)];
        if ( otherview ) {
            return CocoaViewTag( otherview );
        }
    }
    return 0;
}


NSInteger ViewNextKeyView( NSInteger tag )
{
    NSView *view = (NSView *)CocoaViewWithTag( tag );
    if ( view ) {
        NSView *nextView = [view nextKeyView];
        if ( nextView ) {
            return CocoaViewTag( nextView );
        }
    }
    return 0;
}

void ViewSetNextKeyView( NSInteger tag, NSInteger nextViewTag )
{
    NSView *view = (NSView *)CocoaViewWithTag( tag );
    if ( view ) {
        NSView *nextView = (NSView *)CocoaViewWithTag( nextViewTag );
        if ( nextView ) [view setNextKeyView:nextView];
    }
}

NSInteger ViewNextValidKeyView( NSInteger tag )
{
    NSView *view = (NSView *)CocoaViewWithTag( tag );
    if ( view ) {
        NSView *nextView = [view nextValidKeyView];
        if ( nextView ) {
            return CocoaViewTag( nextView );
        }
    }
    return 0;
}

NSInteger ViewPreviousKeyView( NSInteger tag )
{
    NSView *view = (NSView *)CocoaViewWithTag( tag );
    if ( view ) {
        NSView *prevView = [view previousKeyView];
        if ( prevView ) {
            return CocoaViewTag( prevView );
        }
    }
    return 0;
}

NSInteger ViewPreviousValidKeyView( NSInteger tag )
{
    NSView *view = (NSView *)CocoaViewWithTag( tag );
    if ( view ) {
        NSView *prevView = [view previousValidKeyView];
        if ( prevView ) {
            return CocoaViewTag( prevView );
        }
    }
    return 0;
}

void ViewScrollRect( NSInteger tag, CGRect r, CGSize size )
{
    NSView *view = (NSView *)CocoaViewWithTag( tag );
    if ( view ) {
        [view scrollRect:NSRectFromCGRect(r) by:NSSizeFromCGSize(size)];
    }
}

NSInteger ViewEnclosingScrollView( NSInteger tag )
{
    NSView *view = (NSView *)CocoaViewWithTag( tag );
    if ( view ) {
        NSScrollView *scrollView = [view enclosingScrollView];
        if ( scrollView ) return [scrollView tag];
    }
    return 0;
}

void ViewRegisterForDraggedTypes( NSInteger tag, CFArrayRef types )
{
    NSView *view = (NSView *)CocoaViewWithTag( tag );
    if ( view ) {
        [view registerForDraggedTypes:(NSArray *)types];

//        if ( [view class] == [ViewSC class] || [view class] == [TextViewSubclass class] || [view class] == [ContentViewSC class] ) {
//            [view registerForDraggedTypes:(NSArray *)types];
//        } else {
//            CocoaShowAlert( NSWarningAlertStyle, @"Error.", @"View must be subclassed in order to receive dragging events." );
//        }
    }
}

void ViewSetNeedsDisplayInRect( NSInteger tag, CGRect r )
{
    NSView *view = (NSView *)CocoaViewWithTag( tag );
    if ( view ) {
        [view setNeedsDisplayInRect:NSRectFromCGRect(r)];
    }
}

// custom
void ViewSetAcceptsFirstResponder( NSInteger tag, Boolean flag )
{
    NSView *view = (NSView *)CocoaViewWithTag( tag );
    if ( view ) {
        if ( [view class] == [ViewSC class] ) {
            //[(ViewSC *)view setResponderFlag:flag];
            [view setResponderFlag:flag];
        } else if ( [view class] == [ContentViewSC class] ) {
            if ( flag ) [(ContentViewSC *)view setSubclassFlag:flag];
            [(ContentViewSC *)view setResponderFlag:flag];
        }
    }
}

void ViewRegisterForDraggedFileTypes( NSInteger tag, CFTypeRef inFileTypes )
{
    NSView *view = (NSView *)CocoaViewWithTag( tag );
    if ( view ) {
        
        NSArray *fileTypes = nil;
        if ( inFileTypes ) {
            if ( CFGetTypeID( inFileTypes ) == CFStringGetTypeID() ) {
                fileTypes = [(NSString *)inFileTypes componentsSeparatedByString:@";"];
            } else if ( CFGetTypeID( inFileTypes ) == CFArrayGetTypeID() ) {
                fileTypes = (NSArray *)inFileTypes;
            }
        }
        
        if ( [view class] == [ViewSC class] ) {
            [(ViewSC *)view setDragFileTypes:[fileTypes retain]];
            //[view registerForDraggedTypes:[NSArray arrayWithObject:NSFilenamesPboardType]];
        } else if ( [view class] == [ContentViewSC class] ) {
            [(ContentViewSC *)view setDragFileTypes:[fileTypes retain]];
            //[view registerForDraggedTypes:[NSArray arrayWithObject:NSFilenamesPboardType]];
        } else if ( [view class] == [TextViewSC class] ) {

        } else {
            //CocoaShowAlert( NSWarningAlertStyle, @"Error.", @"View must be subclassed in order to receive dragging events." );
        }
        
        [view registerForDraggedTypes:[NSArray arrayWithObject:NSFilenamesPboardType]];
    }
}

void ViewRegisterForDraggedFileExtensions( NSInteger tag, CFTypeRef inFileExtensions )
{
    NSView *view = (NSView *)CocoaViewWithTag( tag );
    if ( view ) {
        
        NSArray *fileExtensions = nil;
        if ( inFileExtensions ) {
            if ( CFGetTypeID( inFileExtensions ) == CFStringGetTypeID() ) {
                fileExtensions = [(NSString *)inFileExtensions componentsSeparatedByString:@";"];
            } else if ( CFGetTypeID( inFileExtensions ) == CFArrayGetTypeID() ) {
                fileExtensions = (NSArray *)inFileExtensions;
            }
        }
        
        if ( [view class] == [ViewSC class] ) {
            [(ViewSC *)view setDragFileExtensions:[fileExtensions retain]];
            //[view registerForDraggedTypes:[NSArray arrayWithObject:NSFilenamesPboardType]];
        }  else if ( [view class] == [ContentViewSC class] ) {
            [(ContentViewSC *)view setDragFileExtensions:[fileExtensions retain]];
            //[view registerForDraggedTypes:[NSArray arrayWithObject:NSFilenamesPboardType]];
        } else {
            //CocoaShowAlert( NSWarningAlertStyle, @"Error.", @"View must be subclassed in order to receive dragging events." );
        }
        
        [view registerForDraggedTypes:[NSArray arrayWithObject:NSFilenamesPboardType]];
    }
}

BOOL ViewDragInside( NSInteger tag )
{
    NSView *view = (NSView *)CocoaViewWithTag( tag );
    if ( view ) {
        if ( [view class] == [ViewSC class] ) {
            //return [(ViewSC *)view dragInside];
            return [view dragInsideFlag];
        } else if ( [view class] == [ContentViewSC class] ) {
            return [(ContentViewSC *)view dragInside];
        }
    }
    return NO;
}

void ViewSetDragInside( NSInteger tag, BOOL flag )
{
    NSView *view = (NSView *)CocoaViewWithTag( tag );
    if ( view ) {
        if ( [view class] == [ViewSC class] ) {
            //[(ViewSC *)view setDragInside:flag];
            [view setDragInsideFlag:flag];
        } else if ( [view class] == [ContentViewSC class] ) {
            [(ContentViewSC *)view setDragInside:flag];
        }
    }
}


// Notifications
Boolean ViewPostsFrameChangedNotifications( NSInteger tag )
{
    NSView *view = (NSView *)CocoaViewWithTag( tag );
    if ( view ) return [view postsFrameChangedNotifications];
    return NO;
}

void ViewSetPostsFrameChangedNotifications( NSInteger tag, Boolean flag )
{
    NSView *view = (NSView *)CocoaViewWithTag( tag );
    if ( view ) [view setPostsFrameChangedNotifications:flag];
}

Boolean ViewPostsBoundsChangedNotifications( NSInteger tag )
{
    NSView *view = (NSView *)CocoaViewWithTag( tag );
    if ( view ) return [view postsBoundsChangedNotifications];
    return NO;
}

void ViewSetPostsBoundsChangedNotifications( NSInteger tag, Boolean flag )
{
    NSView *view = (NSView *)CocoaViewWithTag( tag );
    if ( view ) [view setPostsBoundsChangedNotifications:flag];
}


// generic functions
//CFStringRef CocoaViewText( NSInteger tag )
//{
//    NSView *view = CocoaViewWithTag( tag );
//    if ( view ) {
//        if ( [view isKindOfClass:[NSControl class]] ) {
//            return (CFStringRef)[(NSControl *)view stringValue];
//        }
//        
//        if ( [view class] == [NSBox class] ) {
//            return (CFStringRef)[(NSBox *)view title];
//        }
//        
//        if ( [view class] == [NSButton class] ) {
//            return (CFStringRef)[(NSButton *)view title];
//        }
//        
//        if ( [view class] == [NSPopUpButton class] ) {
//            return (CFStringRef)[(NSPopUpButton *)view title];
//        }
//        
//        if ( [view isKindOfClass:[NSText class]] ) {
//            return (CFStringRef)[(NSText *)view string];
//        }
//    }
//    return NULL;
//}

void *ViewAnimator( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view animator];
    return NULL;
}

void ViewAnimatorSetFrame( NSInteger tag, CGRect r )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [[view animator] setFrame:NSRectFromCGRect(r)];
}

void ViewAnimatorSetFrameOrigin( NSInteger tag, CGPoint origin )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [[view animator] setFrameOrigin:NSPointFromCGPoint(origin)];
}

void ViewAnimatorSetFrameSize( NSInteger tag, CGSize size )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [[view animator] setFrameSize:NSSizeFromCGSize(size)];
}

void ViewAnimatorSetFrameRotation( NSInteger tag, CGFloat rot )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [[view animator] setFrameRotation:rot];
}

void ViewAnimatorSetBounds( NSInteger tag, CGRect r )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [[view animator] setBounds:NSRectFromCGRect(r)];
}

void ViewAnimatorSetBoundsOrigin( NSInteger tag, CGPoint origin )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [[view animator] setBoundsOrigin:NSPointFromCGPoint(origin)];
}

void ViewAnimatorSetBoundsSize( NSInteger tag, CGSize size )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [[view animator] setBoundsSize:NSSizeFromCGSize(size)];
}

void ViewAnimatorSetBoundsRotation( NSInteger tag, CGFloat rot )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [[view animator] setBoundsRotation:rot];
}

void ViewAnimatorSetFrameCenterRotation( NSInteger tag, CGFloat rot )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [[view animator] setFrameCenterRotation:rot];
}

void ViewAnimatorSetAlphaValue( NSInteger tag, CGFloat value )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [[view animator] setAlphaValue:value];
}

//void ViewSetTrackingArea( NSInteger tag, CGRect r, NSTrackingAreaOptions options )
//{
//    NSView *view = CocoaViewWithTag( tag );
//    if ( view ) {
//        if ( [view class] == [ViewSC class] ) {
//            [(ViewSC *)view setTrackingAreaRect:NSRectFromCGRect(r) options:options];
//        }
//    }
//}


// custom
id ViewWithTag( NSInteger tag )
{ return (id)CocoaViewWithTag( tag ); }

Boolean ViewIsFlipped( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
//    if ( view ) return [view isFlipped];
    if ( view ) return [view flipFlag];
    return NO;
}

void ViewSetFlipped( NSInteger tag, Boolean flag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        if ( [view class] == [ViewSC class] ) {
//            [(ViewSC *)view setFlip:flag];
            [view setFlipFlag:flag];
        } else if ( [view class] == [ContentViewSC class] ) {
            [(ContentViewSC *)view setFlip:flag];
        }
    }
}

void ViewsEmbedInView( NSInteger tag, ... )
{
    NSInteger inWndTag = 0;
    id w = CocoaTargetWindow( &inWndTag );
    if ( w ) {
        va_list ap;
        va_start(ap,tag);
        
        CGFloat minX = 10000;
        CGFloat minY = 10000;
        CGFloat maxX = 0;
        CGFloat maxY = 0;
        
        NSMutableArray *array = [NSMutableArray arrayWithCapacity:0];
        while ( tag ) {
            id view = CocoaViewWithTag( tag );
            if ( view ) {
                [array addObject:view];
                NSRect r = [view frame];
                CGFloat x1 = r.origin.x;
                CGFloat y1 = r.origin.y;
                CGFloat x2 = x1 + r.size.width;
                CGFloat y2 = y1 + r.size.height;
                
                if ( x1 < minX ) minX = x1;
                if ( y1 < minY ) minY = y1;
                if ( x2 > maxX ) maxX = x2;
                if ( y2 > maxY ) maxY = y2;
            }
            tag = va_arg( ap, NSInteger );
        }
        
        NSView *superview = [[NSView alloc] initWithFrame:NSMakeRect(minX,minY,minX+(maxX-minX),minY+(maxY-minY))];
        for ( id view in array ) {
            NSRect r = [view frame];
            r.origin.x -= minX;
            r.origin.y -= minY;
            [view setFrame:r];
            [superview addSubview:view];
        }
        [[w contentView] addSubview:superview];
        va_end(ap);
    }
}

// gesture recognizer
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000

// - user dialog -
void ViewSetClickGestureRecognizer( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        GestureRecognizerTarget *target = [[GestureRecognizerTarget alloc] init];
        NSClickGestureRecognizer *gr = [[[NSClickGestureRecognizer alloc] initWithTarget:target action:@selector(clickAction:)] autorelease];
        [view addGestureRecognizer:gr];
    }
}

void ViewSetMagnificationGestureRecognizer( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        GestureRecognizerTarget *target = [[GestureRecognizerTarget alloc] init];
        NSMagnificationGestureRecognizer *gr = [[[NSMagnificationGestureRecognizer alloc] initWithTarget:target action:@selector(magnificationAction:)] autorelease];
        [view addGestureRecognizer:gr];
    }
}

void ViewSetPanGestureRecognizer( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        GestureRecognizerTarget *target = [[GestureRecognizerTarget alloc] init];
        NSPanGestureRecognizer *gr = [[[NSPanGestureRecognizer alloc] initWithTarget:target action:@selector(panAction:)] autorelease];
        [view addGestureRecognizer:gr];
    }
}

void ViewSetPressGestureRecognizer( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        GestureRecognizerTarget *target = [[GestureRecognizerTarget alloc] init];
        NSPressGestureRecognizer *gr = [[[NSPressGestureRecognizer alloc] initWithTarget:target action:@selector(pressAction:)] autorelease];
        [view addGestureRecognizer:gr];
    }
}

void ViewSetRotationGestureRecognizer( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        GestureRecognizerTarget *target = [[GestureRecognizerTarget alloc] init];
        NSRotationGestureRecognizer *gr = [[[NSRotationGestureRecognizer alloc] initWithTarget:target action:@selector(rotationAction:)] autorelease];
        [view addGestureRecognizer:gr];
    }
}

// - callback function -
void ViewSetClickGestureRecognizerCallback( NSInteger tag, void *callback, void *userData )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        GestureRecognizerTarget *target = [[GestureRecognizerTarget alloc] initWithCallback:callback userData:userData];
        NSClickGestureRecognizer *gr = [[[NSClickGestureRecognizer alloc] initWithTarget:target action:@selector(clickAction:)] autorelease];
        [view addGestureRecognizer:gr];
    }
}

void ViewSetMagnificationGestureRecognizerCallback( NSInteger tag, void *callback, void *userData )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        GestureRecognizerTarget *target = [[GestureRecognizerTarget alloc] initWithCallback:callback userData:userData];
        NSMagnificationGestureRecognizer *gr = [[[NSMagnificationGestureRecognizer alloc] initWithTarget:target action:@selector(magnificationAction:)] autorelease];
        [view addGestureRecognizer:gr];
    }
}

void ViewSetPanGestureRecognizerCallback( NSInteger tag, void *callback, void *userData )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        GestureRecognizerTarget *target = [[GestureRecognizerTarget alloc] initWithCallback:callback userData:userData];
        NSPanGestureRecognizer *gr = [[[NSPanGestureRecognizer alloc] initWithTarget:target action:@selector(panAction:)] autorelease];
        [view addGestureRecognizer:gr];
    }
}

void ViewSetPressGestureRecognizerCallback( NSInteger tag, void *callback, void *userData )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        GestureRecognizerTarget *target = [[GestureRecognizerTarget alloc] initWithCallback:callback userData:userData];
        NSPressGestureRecognizer *gr = [[[NSPressGestureRecognizer alloc] initWithTarget:target action:@selector(pressAction:)] autorelease];
        [view addGestureRecognizer:gr];
    }
}

void ViewSetRotationGestureRecognizerCallback( NSInteger tag, void *callback, void *userData )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        GestureRecognizerTarget *target = [[GestureRecognizerTarget alloc] initWithCallback:callback userData:userData];
        NSRotationGestureRecognizer *gr = [[[NSRotationGestureRecognizer alloc] initWithTarget:target action:@selector(rotationAction:)] autorelease];
        [view addGestureRecognizer:gr];
    }
}
#endif


// Appearance
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
void ViewSetAppearance( NSInteger tag, AppearanceRef appearance )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view setAppearance:appearance];
}

void ViewSetAppearanceNamed( NSInteger tag, CFStringRef name )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) [view setAppearance:[NSAppearance appearanceNamed:(NSString *)name]];
}
#endif


/*
 NSAppearanceCustomization
 */
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
AppearanceRef ViewAppearance( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) return [view appearance];
    return nil;
}

AppearanceRef ViewEffectiveAppearance( NSInteger tag )
{
    NSView *view;
    if ( tag ) {
        view = CocoaViewWithTag( tag );
    } else {
        view = [[[NSView alloc] init] autorelease];
    }
    if ( view ) return [view effectiveAppearance];
    return nil;
}
#endif


// - custom -
Boolean ViewExists( NSInteger tag )
{ return ( ViewWithTag(tag) != nil ); }


CFTypeRef ViewProperty( NSInteger tag, CFStringRef key )
{
    id property = nil;
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        property = ObjectProperty( view, key );
    }
    return (CFTypeRef)property;
}

void ViewSetProperty( NSInteger tag, CFStringRef key, CFTypeRef value )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        ObjectSetProperty( view, key, value );
    }
}

void ViewRemoveProperty( NSInteger tag, CFStringRef key )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        ObjectRemoveProperty( view, key );
    }
}

void ViewRemoveAllProperties( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        ObjectRemoveAllProperties( view );
    }
}



// Suspend drawRect: method
void ViewSuspendDrawRect( NSInteger tag, Boolean flag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        [view setSuspendDrawRect:flag];
    }
}

Boolean ViewDrawRectIsSuspended( NSInteger tag )
{
    NSView *view = CocoaViewWithTag( tag );
    if ( view ) {
        return [view suspendDrawRect];
    }
    return NO;
}


// Create
ViewRef ViewInit( NSInteger inTag, CGRect inRect )
{
    // rect
    NSRect rect = NSRectFromCGRect( inRect );
    if ( NSIsEmptyRect( rect ) ) rect = NSMakeRect( 20, 20, 163, 96 );

    // subclass
    BOOL subclass = IsSubclassFlag();
    
    // init
    NSView *view;
    if ( subclass ) {
        view = [[[ViewSC alloc] initWithFrame:rect] autorelease];
    } else {
        view = [[[NSView alloc] initWithFrame:rect] autorelease];
    }
    
    // tag
    [view setIdentifier:[NSString stringWithFormat:@"%ld",(long)inTag]];
    
    return view;
}


void CocoaView( NSInteger inTag, CGRect inRect, NSInteger subclass, NSInteger inWndTag )
{
    BOOL show = ( inTag > 0 );
    inTag = ABS(inTag);
    
    NSRect rect = NSRectFromCGRect( inRect );
    
    // target window
    id w = CocoaTargetWindow( &inWndTag );
    
    if ( w ) {
        NSView *contentView = CocoaTargetContentView( w );
        id view = CocoaViewSubviewWithTag( contentView, inTag );
        
        if ( !view ) {
            view = TitlebarAccessoryViewWithTag( inTag );
        }
        
        if ( view ) {    // view already exists
            
            // make sure it's same view type
            if ( [view class] != [NSView class] && [view class] != [ViewSC class] ) return;
            
            // rect
            if ( !NSIsEmptyRect( rect ) ) [view setFrame:rect];
            
        } else {
            
            // rect
//            if ( NSIsEmptyRect( rect ) ) {
//                rect = NSMakeRect( 20, 20, 163, 96 );
//            }
            
            // subclass
            if ( subclass != kFBParamMissing ) SetSubclassFlag( subclass );
            
            // init
//            if ( inSubclass ) {
//                view = [[ViewSC alloc] initWithFrame:rect];
//            } else {
//                view = [[NSView alloc] initWithFrame:rect];
//            }
            
            view = ViewInit( inTag, inRect );
            
            // default autoresizing
            [(NSView *)view setAutoresizingMask:NSViewMinYMargin];
            
            // tag
//            [view setIdentifier:[NSString stringWithFormat:@"%ld",(long)inTag]];
            
            // wndTag
            [view setWndTag:inWndTag];
            
            // add to window
            [contentView addSubview:view];
//            [view release];
        }
        
        [view setHidden:!show];
    } else {
        CocoaShowWindowDoesNotExistAlert( inWndTag );
    }
}



