/*
 VisualEffectView.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000

@interface VisualEffectViewSC : NSVisualEffectView
@end

VisualEffectViewRef VisualEffectViewWithTag( NSInteger tag );
Boolean VisualEffectViewExists( NSInteger tag );

// Functions
NSVisualEffectMaterial VisualEffectViewMaterial( NSInteger tag );
void VisualEffectViewSetMaterial( NSInteger tag, NSVisualEffectMaterial material );
NSBackgroundStyle VisualEffectViewInteriorBackgroundStyle( NSInteger tag );
NSVisualEffectBlendingMode VisualEffectViewBlendingMode( NSInteger tag );
void VisualEffectViewSetBlendingMode( NSInteger tag, NSVisualEffectBlendingMode mode );
NSVisualEffectState VisualEffectViewState( NSInteger tag );
void VisualEffectViewSetState( NSInteger tag, NSVisualEffectState state );
ImageRef VisualEffectViewMaskImage( NSInteger tag );
void VisualEffectViewSetMaskImage( NSInteger tag, ImageRef image );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
Boolean VisualEffectViewIsEmphasized( NSInteger tag );
void VisualEffectViewSetEmphasized( NSInteger tag, Boolean flag );
#endif// >= 10.12


// Init
VisualEffectViewRef VisualEffectViewInit( NSInteger inTag, CGRect inRect );

// Statement
void CocoaVisualEffectView( NSInteger inTag, CGRect inRect, NSInteger inMaterial, NSInteger inMode, NSInteger inState, void *inImage, NSInteger inEmphasized, NSInteger inWndTag );

#endif// >= 10.10

