/*
 Window.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

#pragma mark - titlebar accessory view
///////////////////////////////////////////////////
//          titlebar accessory view              //
///////////////////////////////////////////////////
id TitlebarAccessoryViewWithTag( NSInteger tag );

#pragma mark - window
///////////////////////////////////////////////////
//                  cocoa window                 //
///////////////////////////////////////////////////

@interface WindowSC : NSWindow
@end


// content view tag
enum {
    windowContentViewTag = -1437226411
};

enum {
    WindowContentViewTag = -1437226411
};

id CocoaVisibleTargetWindow( NSInteger *inWndTag );
id CocoaTargetWindow( NSInteger *inWndTag );
NSView *CocoaTargetContentView( id w );

@interface ContentViewSC : NSView {
    BOOL flip;
    BOOL subclassFlag;
    BOOL responderFlag;
    NSArray *dragFileTypes;
    NSArray *dragFileExtensions;
    BOOL dragInside;
}

@property (assign) BOOL flip;
@property (assign) BOOL subclassFlag;
@property (assign) BOOL responderFlag;
@property (assign) NSArray *dragFileTypes;
@property (assign) NSArray *dragFileExtensions;
@property (assign) BOOL dragInside;

@end


// dialog events
enum {
    windowWillBeginSheet = 5000,
    windowDidEndSheet,
    windowWillResize,           // get/set CGSize
    windowDidResize,
    windowWillStartLiveResize,
    windowDidEndLiveResize,
    windowWillMiniaturize,
    windowDidMiniaturize,
    windowDidDeminiaturize,
    windowShouldZoom,          // get CGRect, set Boolean
    windowWillEnterFullScreen,
    windowDidEnterFullScreen,
    windowWillExitFullScreen,
    windowDidExitFullScreen,
    windowDidFailToEnterFullScreen,
    windowDidFailToExitFullScreen,
    windowWillMove,
    windowDidMove,
    windowDidChangeScreen,
    windowShouldClose,         // set Boolean
    windowWillClose,
    windowDidBecomeKey,
    windowDidResignKey,
    windowDidBecomeMain,
    windowDidResignMain,
    windowDidUpdate,
    
    // drag
    windowDraggingEntered,
    windowWantsPeriodicDraggingUpdates,
    windowDraggingUpdated,
    windowDraggingEnded,
    windowDraggingExited,
    windowPrepareForDragOperation,
    windowPerformDragOperation,
    windowConcludeDragOperation,
    windowUpdateDraggingItemsForDrag,
    
    // subclass
    windowMouseDown,
    windowMouseUp,
    windowKeyDown,
    windowKeyUp,
    windowFlagsChanged,
    windowMouseEntered,
    windowMouseExited
};

typedef void (*CocoaWindowCallbackType)(NSInteger,NSInteger,void *);

@interface CocoaWindowDelegate : NSObject <NSWindowDelegate> {
    BOOL boolVal;
    NSSize sizeVal;
    NSRect rectVal;
    CocoaWindowCallbackType allWindowsCallback;
    NSArray *dragFileTypes;
    NSArray *dragFileExtensions;
    BOOL dragInside;
}
@property (assign) BOOL boolVal;
@property (assign) NSSize sizeVal;
@property (assign) NSRect rectVal;
@property (assign) CocoaWindowCallbackType allWindowsCallback;
@property (assign) NSArray *dragFileTypes;
@property (assign) NSArray *dragFileExtensions;
@property (assign) BOOL dragInside;

- (void)window:(NSWindow *)w forwardEvent:(NSInteger)event tag:(NSInteger)tag obj:(id)obj;

@end

CocoaWindowDelegate *CocoaWindowDelegateGet( void );

@interface NSWindow (Additions)
@property (nonatomic,retain) NSNumber *tagNumber;
@property (nonatomic,retain) NSValue *callbackValue;
@property (nonatomic,retain) NSValue *userDataValue;

- (NSInteger)tag;
- (void)setTag:(NSInteger)tag;
- (CocoaWindowCallbackType)cocoaWindowCallback;
- (void *)cocoaWindowUserData;
- (void)setCocoaWindowCallback:(CocoaWindowCallbackType)cb;
- (void)setCocoaWindowUserData:(void *)userData;
@end

// private
#if !__LP64__
BOOL CocoaWindowIsFBWindow( NSInteger tag );
BOOL FBWindowIsCocoaWindow( NSInteger tag );
#endif  //!__LP64__

NSInteger CocoaOutputWindowTag( void );
void CocoaOutputWindowSetTag( NSInteger tag );
id CocoaVisibleOutputWindow( void );
id CocoaOutputWindow( void );
NSView *CocoaOutputWindowContentView( void );
NSInteger CocoaParentTagForView( id view );
id CocoaTargetWithTag( NSInteger tag );
id CocoaVisibleTargetWithTag( NSInteger tag );



BOOL CocoaObjectIsPopover( NSInteger tag );
BOOL CocoaObjectIsWindow( NSInteger tag );

id CocoaVisibleWindowWithTag( NSInteger tag );

id CocoaWindowWithTag( NSInteger tag );

NSWindow *CocoaWindowWithIdentifier( NSString *identifier );

NSWindow *CocoaVisibleFrontWindow( void );
NSWindow *CocoaFrontWindow( void );
BOOL WindowIsCocoa( NSInteger tag );

void CocoaWindowCarbonRuntimeCosmeticFix( NSWindow *w );

void CocoaWindowMakeFirstTextViewResponder( NSWindow *w );

void CocoaWindowSetTitle( NSInteger tag, CFStringRef title );

// public
//void CocoaWindowSetTarget( NSInteger tag );

// Configure
void WindowToggleFullScreen( NSInteger tag );
Boolean WindowWorksWhenModal( NSInteger tag );
CGFloat WindowAlphaValue( NSInteger tag );
void WindowSetAlphaValue( NSInteger tag, CGFloat value );
ColorRef WindowBackgroundColor( NSInteger tag );
void WindowSetBackgroundColor( NSInteger tag, ColorRef col );
ColorSpaceRef WindowColorSpace( NSInteger tag );
void WindowSetColorSpace( NSInteger tag, ColorSpaceRef cs );
ViewRef WindowContentView( NSInteger tag );
Boolean WindowCanHide( NSInteger tag );
void WindowSetCanHide( NSInteger tag, Boolean flag );
Boolean WindowIsOnActiveSpace( NSInteger tag );
Boolean WindowHidesOnDeactivate( NSInteger tag );
void WindowSetHidesOnDeactivate( NSInteger tag, Boolean flag );
NSWindowCollectionBehavior WindowCollectionBehavior( NSInteger tag );
void WindowSetCollectionBehavior( NSInteger tag, NSWindowCollectionBehavior behavior );
Boolean WindowIsOpaque( NSInteger tag );
void WindowSetOpaque( NSInteger tag, Boolean flag );
Boolean WindowHasShadow( NSInteger tag );
void WindowSetHasShadow( NSInteger tag, Boolean flag );

void WindowInvalidateShadow( NSInteger tag );
Boolean WindowAutorecalculatesContentBorderThickness( NSInteger tag, CGRectEdge edge );
void WindowSetAutorecalculatesContentBorderThickness( NSInteger tag, Boolean flag, CGRectEdge edge );

CGFloat WindowContentBorderThickness( NSInteger tag, CGRectEdge edge );
void WindowSetContentBorderThickness( NSInteger tag, CGFloat thickness, CGRectEdge edge );
Boolean WindowPreventsApplicationTerminationWhenModal( NSInteger tag );
void WindowSetPreventsApplicationTerminationWhenModal( NSInteger tag, Boolean flag );

// Info
NSWindowDepth WindowDefaultDepthLimit( void );
NSInteger WindowNumber( NSInteger tag );
CFArrayRef WindowNumbersWithOptions( NSWindowNumberListOptions options );
CFDictionaryRef WindowDeviceDescription( NSInteger tag );
Boolean WindowCanBecomeVisibleWithoutLogin( NSInteger tag );
void WindowSetCanBecomeVisibleWithoutLogin( NSInteger tag, Boolean flag );
NSWindowSharingType WindowSharingType( NSInteger tag );
void WindowSetSharingType( NSInteger tag, NSWindowSharingType type );
NSBackingStoreType WindowBackingType( NSInteger tag );
void WindowSetBackingType( NSInteger tag, NSBackingStoreType type );
NSWindowDepth WindowDepthLimit( NSInteger tag );
void WindowSetDepthLimit( NSInteger tag, NSWindowDepth depth );
Boolean WindowHasDynamicDepthLimit( NSInteger tag );

NSInteger WindowAttachedSheet( NSInteger tag );
Boolean WindowIsSheet( NSInteger tag );
CGSize WindowAspectRatio( NSInteger tag );
void WindowSetAspectRatio( NSInteger tag, CGSize size );
CFStringRef WindowTitle( NSInteger tag );
CFURLRef WindowRepresentedURL( NSInteger tag );
void WindowSetRepresentedURL( NSInteger tag, CFURLRef url );

ScreenRef WindowScreen( NSInteger tag );
ScreenRef WindowDeepestScreen( NSInteger tag );
Boolean WindowDisplaysWhenScreenProfileChanges( NSInteger tag );
void WindowSetDisplaysWhenScreenProfileChanges( NSInteger tag, Boolean flag );

Boolean WindowIsMovableByWindowBackground( NSInteger tag );
void WindowSetMovableByWindowBackground( NSInteger tag, Boolean flag );
Boolean WindowIsMovable( NSInteger tag );
void WindowSetMovable( NSInteger tag, Boolean flag );
void WindowCenter( NSInteger tag );
void WindowPerformClose( NSInteger tag );
void WindowClose( NSInteger tag );

Boolean WindowIsReleasedWhenClosed( NSInteger tag );
void WindowSetReleasedWhenClosed( NSInteger tag, Boolean flag );

Boolean WindowIsMiniaturized( NSInteger tag );
void WindowPerformMiniaturize( NSInteger tag );
void WindowMiniaturize( NSInteger tag );
void WindowDeminiaturize( NSInteger tag );
ImageRef WindowMiniwindowImage( NSInteger tag );
void WindowSetMiniwindowImage( NSInteger tag, void *inImage );
void WindowSetMiniwindowImageNamed( NSInteger tag, CFStringRef imageName );
CFStringRef WindowMiniwindowTitle( NSInteger tag );
void WindowSetMiniwindowTitle( NSInteger tag, CFStringRef title );
DockTileRef WindowDockTile( NSInteger tag );

void WindowPrint( NSInteger tag );
CFDataRef WindowDataWithEPSInsideRect( NSInteger tag, CGRect r );
CFDataRef WindowDataWithPDFInsideRect( NSInteger tag, CGRect r );

// Scripting attributes
Boolean WindowHasCloseBox( NSInteger tag );
Boolean WindowHasTitleBar( NSInteger tag );
void WindowSetIsMiniaturized( NSInteger tag, Boolean flag );
void WindowSetIsVisible( NSInteger tag, Boolean flag );
void WindowSetIsZoomed( NSInteger tag, Boolean flag );

// Ordered indices
NSInteger WindowOrderedIndex( NSInteger tag );
void WindowSetOrderedIndex( NSInteger tag, NSInteger index );


CGRect WindowFrame( NSInteger tag );
CGRect WindowContentRect( NSInteger tag );
void WindowSetFrameTopLeftPoint( NSInteger tag, CGPoint pt );

void WindowConstrainFrameRect( NSInteger tag, CGRect frame, ScreenRef screen );

void WindowSetMinSize( NSInteger tag, CGSize size );
void WindowSetMaxSize( NSInteger tag, CGSize size );
void WindowSetContentAspectRatio( NSInteger tag, CGSize size );
CGSize WindowContentMinSize( NSInteger tag );
void WindowSetContentMinSize( NSInteger tag, CGSize size );
CGSize WindowContentMaxSize( NSInteger tag );
void WindowSetContentMaxSize( NSInteger tag, CGSize size );
void WindowOrderOut( NSInteger tag );
void WindowOrderBack( NSInteger tag );
void WindowOrderFront( NSInteger tag );
void WindowOrderFrontRegardless( NSInteger tag );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
NSWindowOcclusionState WindowOcclusionState( NSInteger tag );
#endif

Boolean WindowIsKey( NSInteger tag );
Boolean WindowCanBecomeKey( NSInteger tag );
void WindowMakeKey( NSInteger tag );
void WindowMakeKeyAndOrderFront( NSInteger tag );
Boolean WindowIsMain( NSInteger tag );
Boolean WindowCanBecomeMain( NSInteger tag );
void WindowMakeMain( NSInteger tag );
void WindowSetFrameUsingName( NSInteger tag, CFStringRef name );
void WindowSetFrameUsingNameForce( NSInteger tag, CFStringRef name, Boolean force );
void WindowSaveFrameUsingName( NSInteger tag, CFStringRef name );
CFStringRef WindowFrameAutosaveName( NSInteger tag );
CFStringRef WindowStringWithSavedFrame( NSInteger tag );
void WindowSetFrameFromString( NSInteger tag, CFStringRef string );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
void WindowBeginSheet( NSInteger tag, NSInteger sheetTag );
void WindowBeginCriticalSheet( NSInteger tag, NSInteger sheetTag );
void WindowEndSheet( NSInteger tag, NSInteger sheetTag );
void WindowEndSheetWithReturnCode( NSInteger tag, NSInteger sheetTag, NSInteger returnCode );
#endif

void WindowFlush( NSInteger tag );

// Default buttons
void WindowEnableKeyEquivalentForDefaultButtonCell( NSInteger tag );
void WindowDisableKeyEquivalentForDefaultButtonCell( NSInteger tag );

NSInteger WindowInitialFirstResponder( NSInteger tag );
void WindowSetInitialFirstResponder( NSInteger wndTag, NSInteger responderTag );
NSInteger WindowFirstResponder( NSInteger tag );
void WindowMakeFirstResponder( NSInteger wndTag, NSInteger viewTag );
void WindowSelectKeyViewPrecedingView( NSInteger wndTag, NSInteger viewTag );
void WindowSelectKeyViewFollowingView( NSInteger wndTag, NSInteger viewTag );
void WindowSelectPreviousKeyView( NSInteger tag );
void WindowSelectNextKeyView( NSInteger tag );
NSSelectionDirection WindowKeyViewSelectionDirection( NSInteger tag );
Boolean WindowAutorecalculatesKeyViewLoop( NSInteger tag );
void WindowSetAutorecalculatesKeyViewLoop( NSInteger tag, Boolean flag );
void WindowRecalculateKeyViewLoop( NSInteger tag );

Boolean WindowAcceptsMouseMovedEvents( NSInteger tag );
void WindowSetAcceptsMouseMovedEvents( NSInteger tag, Boolean flag );
Boolean WindowIgnoresMouseEvents( NSInteger tag );
void WindowSetIgnoresMouseEvents( NSInteger tag, Boolean flag );
CGPoint WindowMouseLocationOutsideOfEventStream( NSInteger tag );
NSInteger WindowNumberAtPoint( CGPoint pt, NSInteger belowWindowNumber );

void WindowSetToolbar( NSInteger wndTag, NSInteger toolbarTag );
NSInteger WindowToolbar( NSInteger tag );
void WindowToggleToolbarShown( NSInteger tag );
void WindowRunToolbarCustomizationPalette( NSInteger tag );

void WindowSetDocumentEdited( NSInteger tag, Boolean flag );
Boolean WindowDocumentEdited( NSInteger tag );

// Converting coordinates
CGFloat WindowBackingScaleFactor( NSInteger tag );
CGRect WindowBackingAlignedRect( NSInteger tag, CGRect r, NSAlignmentOptions options );
CGRect WindowConvertRectFromBacking( NSInteger tag, CGRect r );
CGRect WindowConvertRectToBacking( NSInteger tag, CGRect r );
CGRect WindowConvertRectToScreen( NSInteger tag, CGRect r );
CGRect WindowConvertRectFromScreen( NSInteger tag, CGRect r );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
Boolean WindowTitlebarAppearsTransparent( NSInteger tag );
void WindowSetTitlebarAppearsTransparent( NSInteger tag, Boolean flag );
void WindowAddTitlebarAccessoryView( NSInteger wndTag, NSInteger viewTag, NSLayoutAttribute layout );
void WindowInsertTitlebarAccessoryView( NSInteger wndTag, NSInteger viewTag, NSInteger index, NSLayoutAttribute layout );
void WindowRemoveTitlebarAccessoryView( NSInteger wndTag, NSInteger index );
#endif

// Tabs
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
Boolean WindowAllowsAutomaticWindowTabbing( void );
NSWindowUserTabbingPreference WindowUserTabbingPreference( void );
#endif
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300 && __MAC_OS_X_VERSION_MIN_REQUIRED >= 101300
WindowTabRef WindowTab( NSInteger tag );
#endif
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
CFStringRef WindowTabbingIdentifier( NSInteger tag );
void WindowAddTabbedWindow( NSInteger tag, NSInteger otherTag, NSWindowOrderingMode orderingMode );
NSWindowTabbingMode WindowTabbingMode( NSInteger tag );
CFArrayRef WindowTabbedWindows( NSInteger tag );
void WindowSelectNextTab( NSInteger tag );
void WindowSelectPreviousTab( NSInteger tag );
void WindowMoveTabToNewWindow( NSInteger tag );
void WindowToggleTabBar( NSInteger tag );
#endif
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300 && __MAC_OS_X_VERSION_MIN_REQUIRED >= 101300
void WindowToggleTabOverview( NSInteger tag );
WindowTabGroupRef WindowTabGroup( NSInteger tag );
#endif

void WindowSetAllowsToolTipsWhenApplicationIsInactive( NSInteger tag, Boolean flag);
void WindowSetTitleWithRepresentedFilename( NSInteger tag, CFStringRef filename );
CFArrayRef WindowChildWindows( NSInteger tag );
void WindowAddChildWindow( NSInteger parTag, NSInteger childTag, NSWindowOrderingMode ordered );
void WindowRemoveChildWindow( NSInteger parTag, NSInteger childTag );
NSInteger WindowParentWindow( NSInteger tag );
void WindowSetFrameOrigin( NSInteger tag, CGPoint pt );
void WindowSetFrame( NSInteger tag, CGRect frame, Boolean display, Boolean animate );
CGPoint WindowCascadeTopLeftFromPoint( NSInteger tag, CGPoint pt );
Boolean WindowIsZoomed( NSInteger tag );
void WindowPerformZoom( NSInteger tag );
void WindowZoom( NSInteger tag );
Boolean WindowShowsResizeIndicator( NSInteger tag );
void WindowSetShowsResizeIndicator( NSInteger tag, Boolean flag );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
CGSize WindowMaxFullScreenContentSize( NSInteger tag );
void WindowSetMaxFullScreenContentSize( NSInteger tag, CGSize size );
CGSize WindowMinFullScreenContentSize( NSInteger tag );
void WindowSetMinFullScreenContentSize( NSInteger tag, CGSize size );
#endif

Boolean WindowIsVisible( NSInteger tag );
void WindowRemoveFrameUsingName( CFStringRef name );
Boolean WindowIsExcludedFromWindowsMenu( NSInteger tag );
void WindowSetExcludedFromWindowsMenu( NSInteger tag, Boolean flag );

// Drawing
void WindowDisplay( NSInteger tag );
void WindowDisplayIfNeeded( NSInteger tag );
Boolean WindowViewsNeedDisplay( NSInteger tag );
void WindowSetViewsNeedDisplay( NSInteger tag, Boolean flag );
CGContextRef WindowGraphicsContext( NSInteger tag );
Boolean WindowAllowsConcurrentViewDrawing( NSInteger tag );
void WindowSetAllowsConcurrentViewDrawing( NSInteger tag, Boolean flag );

Boolean WindowAreCursorRectsEnabled( NSInteger tag );
void WindowEnableCursorRects( NSInteger tag );
void WindowDisableCursorRects( NSInteger tag );
void WindowDiscardCursorRects( NSInteger tag );
void WindowInvalidateCursorRectsForView( NSInteger tag, NSInteger vwTag );
void WindowResetCursorRects( NSInteger tag );

// Animation
NSWindowAnimationBehavior WindowAnimationBehavior( NSInteger tag );
void WindowSetAnimationBehavior( NSInteger tag, NSWindowAnimationBehavior behavior );

// Dragging items
void WindowRegisterForDraggedTypes( NSInteger tag, CFArrayRef types );
void WindowUnregisterDraggedTypes( NSInteger tag );

CGRect WindowContentRectForFrameRectAndStyle( CGRect r, NSInteger styleMask );
CGRect WindowFrameRectForContentRectAndStyle( CGRect r, NSInteger styleMask );
CGFloat WindowMinFrameWidthWithTitle( CFStringRef title, NSInteger styleMask );

CGRect WindowContentRectForFrameRect( NSInteger tag, CGRect r );
CGRect WindowFrameRectForContentRect( NSInteger tag, CGRect r );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
NSInteger WindowSheetParent( NSInteger tag );
CFArrayRef WindowSheets( NSInteger tag );
#endif

CGSize WindowResizeIncrements( NSInteger tag );
void WindowSetResizeIncrements( NSInteger tag, CGSize size );

Boolean WindowInLiveResize( NSInteger tag );

void WindowSetContentSize( NSInteger tag, CGSize size );
CGSize WindowContentResizeIncrements( NSInteger tag );
void WindowSetContentResizeIncrements( NSInteger tag, CGSize size );
void WindowOrderRelativeTo( NSInteger wndTag, NSWindowOrderingMode order, NSInteger otherWndTag );
NSInteger WindowLevel( NSInteger tag );
void WindowSetLevel( NSInteger tag, NSInteger level );

void *WindowStandardWindowButtonForStyleMask( NSWindowButton btn, NSUInteger styleMask );
void *WindowStandardWindowButton( NSInteger tag, NSWindowButton btn );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
NSWindowTitleVisibility WindowTitleVisibility( NSInteger tag );
void WindowSetTitleVisibility( NSInteger tag, NSWindowTitleVisibility visibility );
#endif

NSUInteger WindowResizeFlags( NSInteger tag );

// Instance properties
Boolean WindowIsFloatingPanel( NSInteger tag );
Boolean WindowIsMiniaturizable( NSInteger tag );
Boolean WindowIsModalPanel( NSInteger tag );
Boolean WindowIsResizable( NSInteger tag );
NSUInteger WindowStyleMask( NSInteger tag );
Boolean WindowIsZoomable( NSInteger tag );

// Instance methods
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
void WindowMergeAllWindows( NSInteger tag );
#endif
void WindowSetFrameAutosaveName( NSInteger tag, CFStringRef name );

/*
 NSAppearanceCustomization
 */
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
AppearanceRef WindowAppearance( NSInteger tag );
AppearanceRef WindowEffectiveAppearance( NSInteger tag );
#endif

// custom
void WindowSetOutput( NSInteger tag );

void WindowAddSubview( NSInteger tag, ViewRef vwRef );

void WindowSetTitleWithRepresentedURL( NSInteger tag, CFURLRef url );
Boolean WindowExists( NSInteger tag );
id WindowWithTag( NSInteger tag );
id WindowViewWithTag( NSInteger wndTag, NSInteger viewTag );
void WindowSetDelegateCallback( NSInteger tag, void *callback, void *userData );
void WindowSubclassContentView( NSInteger tag );
void WindowRecalculateKeyViewLoopByTagOrder( NSInteger wndTag );

CFTypeRef WindowProperty( NSInteger tag, CFStringRef key );
void WindowSetProperty( NSInteger tag, CFStringRef key, CFTypeRef value );
void WindowRemoveProperty( NSInteger tag, CFStringRef key );
void WindowRemoveAllProperties( NSInteger tag );

// Cascade
void WindowCascadeTopLeftFromWindow( NSInteger tag, NSInteger otherTag );
void WindowCascadeTopLeftFromNextWindow( NSInteger tag );

// SheetAlert
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
void WindowEndSheetAlert( NSInteger tag, NSInteger alertTag );
#endif

void WindowRegisterForDraggedFileTypes( NSInteger tag, CFTypeRef inFileTypes );
void WindowRegisterForDraggedFileExtensions( NSInteger tag, CFTypeRef inFileExtensions );



// Init
CocoaWindowRef WindowInit( NSInteger inTag, CGRect inRect );

// Statement
void CocoaWindow( NSInteger inTag, CFStringRef inTitle, CGRect inRect, NSInteger inStyle );

#pragma mark - nibwindow
void CocoaNibWindow( NSInteger inTag, CFStringRef inNibName, CFStringRef inWndIdentifier );

