/*
 WindowTab.m

 Bernie Wylde
 */

#import "WindowTab.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300 && __MAC_OS_X_VERSION_MIN_REQUIRED >= 101300

NSInteger WindowTabAccessoryView( WindowTabRef ref )
{
    NSView *view = [ref accessoryView];
    if ( view ) return [view tag];
    return 0;
}

void WindowTabSetAccessoryView( WindowTabRef ref, NSInteger tag )
{
    NSView *view = ViewWithTag( tag );
    if ( view ) [ref setAccessoryView:view];
}

CFAttributedStringRef WindowTabAttributedTitle( WindowTabRef ref )
{ return (CFAttributedStringRef)[ref attributedTitle]; }

void WindowTabSetAttributedTitle( WindowTabRef ref, CFAttributedStringRef aString )
{ [ref setAttributedTitle:(NSAttributedString *)aString]; }

CFStringRef WindowTabTitle( WindowTabRef ref )
{ return (CFStringRef)[ref title]; }

void WindowTabSetTitle( WindowTabRef ref, CFStringRef title )
{ [ref setTitle:(NSString *)title]; }

CFStringRef WindowTabToolTip( WindowTabRef ref )
{ return (CFStringRef)[ref toolTip]; }

void WindowTabSetToolTip( WindowTabRef ref, CFStringRef toolTip )
{ [ref setToolTip:(NSString *)toolTip]; }

#endif
