/*
 Contacts.m
 
 Bernie Wylde 20190222
 */

#import "Contacts.h"

#if __LP64__
#ifdef CONTACTS_EXTERN

#pragma mark - CNContact
///////////////////////////////////////////////////
//                     CNContact                 //
///////////////////////////////////////////////////
// Identification
CFStringRef CNContactIdentifier( CNContactRef ref )
{ return (CFStringRef)[ref identifier]; }

CNContactType cnContactType( CNContactRef ref )
{ return [ref contactType]; }

// Date properties
DateComponentsRef CNContactBirthday( CNContactRef ref )
{ return [ref birthday]; }

DateComponentsRef CNContactNonGregorianBirthday( CNContactRef ref )
{ return [ref nonGregorianBirthday]; }

CFArrayRef CNContactDates( CNContactRef ref )
{ return (CFArrayRef)[ref dates]; }

// Name properties
CFStringRef CNContactNamePrefix( CNContactRef ref )
{ return (CFStringRef)[ref namePrefix]; }

CFStringRef CNContactGivenName( CNContactRef ref )
{ return (CFStringRef)[ref givenName]; }

CFStringRef CNContactMiddleName( CNContactRef ref )
{ return (CFStringRef)[ref middleName]; }

CFStringRef CNContactFamilyName( CNContactRef ref )
{ return (CFStringRef)[ref familyName]; }

CFStringRef CNContactPreviousFamilyName( CNContactRef ref )
{ return (CFStringRef)[ref previousFamilyName]; }

CFStringRef CNContactNameSuffix( CNContactRef ref )
{ return (CFStringRef)[ref nameSuffix]; }

CFStringRef CNContactNickname( CNContactRef ref )
{ return (CFStringRef)[ref nickname]; }

CFStringRef CNContactPhoneticGivenName( CNContactRef ref )
{ return (CFStringRef)[ref phoneticGivenName]; }

CFStringRef CNContactPhoneticMiddleName( CNContactRef ref )
{ return (CFStringRef)[ref phoneticMiddleName]; }

CFStringRef CNContactPhoneticFamilyName( CNContactRef ref )
{ return (CFStringRef)[ref phoneticFamilyName]; }

CFStringRef CNContactOrganizationName( CNContactRef ref )
{ return (CFStringRef)[ref organizationName]; }

CFStringRef CNContactDepartmentName( CNContactRef ref )
{ return (CFStringRef)[ref departmentName]; }

CFStringRef CNContactJobTitle( CNContactRef ref )
{ return (CFStringRef)[ref jobTitle]; }

// Localization
CFStringRef CNContactLocalizedStringForKey( CFStringRef key )
{ return (CFStringRef)[CNContact localizedStringForKey:(NSString *)key]; }

// Contact comparator
CNKeyDescriptorRef CNContactDescriptorForAllComparatorKeys( void )
{ return [CNContact descriptorForAllComparatorKeys]; }

// Social properties
CFArrayRef CNContactSocialProfiles( CNContactRef ref )
{ return (CFArrayRef)[ref socialProfiles]; }

// Phone numbers
CFArrayRef CNContactPhoneNumbers( CNContactRef ref )
{ return (CFArrayRef)[ref phoneNumbers]; }

// URL addresses
CFArrayRef CNContactURLAddresses( CNContactRef ref )
{ return (CFArrayRef)[ref urlAddresses]; }

// Postal addresses
CFArrayRef CNContactPostalAddresses( CNContactRef ref )
{ return (CFArrayRef)[ref postalAddresses]; }

// Email addresses
CFArrayRef CNContactEmailAddresses( CNContactRef ref )
{ return (CFArrayRef)[ref emailAddresses]; }

// Note property
CFStringRef CNContactNote( CNContactRef ref )
{ return (CFStringRef)[ref note]; }

// Image properties
CFDataRef CNContactImageData( CNContactRef ref )
{ return (CFDataRef)[ref imageData]; }

CFDataRef CNContactThumbnailImageData( CNContactRef ref )
{ return (CFDataRef)[ref thumbnailImageData]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
Boolean CNContactImageDataAvailable( CNContactRef ref )
{ return [ref imageDataAvailable]; }
#endif

// Labeled value properties
CFArrayRef CNContactRelations( CNContactRef ref )
{ return (CFArrayRef)[ref contactRelations]; }

CFArrayRef CNContactInstantMessageAddresses( CNContactRef ref )
{ return (CFArrayRef)[ref instantMessageAddresses]; }

// Partial contact property
Boolean CNContactIsKeyAvailable( CNContactRef ref, CFStringRef key )
{ return [ref isKeyAvailable:(NSString *)key]; }

Boolean CNContactAreKeysAvailable( CNContactRef ref, CFArrayRef keys )
{ return [ref areKeysAvailable:(NSArray *)keys]; }

// Instance properties
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
CFStringRef CNContactPhoneticOrganizationName( CNContactRef ref )
{ return (CFStringRef)[ref phoneticOrganizationName]; }
#endif



#pragma mark - CNContactFetchRequest
///////////////////////////////////////////////////
//           CNContactFetchRequest               //
///////////////////////////////////////////////////
// Fetching options
Boolean CNContactFetchRequestMutableObjects( CNContactFetchRequestRef ref )
{ return [ref mutableObjects]; }

void CNContactFetchRequestSetMutableObjects( CNContactFetchRequestRef ref, Boolean flag )
{ [ref setMutableObjects:flag]; }

Boolean CNContactFetchRequestUnifyResults( CNContactFetchRequestRef ref )
{ return [ref unifyResults]; }

void CNContactFetchRequestSetUnifyResults( CNContactFetchRequestRef ref, Boolean flag )
{ [ref setUnifyResults:flag]; }

CNContactSortOrder CNContactFetchRequestSortOrder( CNContactFetchRequestRef ref )
{ return [ref sortOrder]; }

void CNContactFetchRequestSetSortOrder( CNContactFetchRequestRef ref, CNContactSortOrder order )
{ [ref setSortOrder:order]; }

// Keys
CNContactFetchRequestRef CNContactFetchRequestWithKeysToFetch( CFArrayRef keys )
{ return [[[CNContactFetchRequest alloc] initWithKeysToFetch:(NSArray *)keys] autorelease]; }

CFArrayRef CNContactFetchRequestKeysToFetch( CNContactFetchRequestRef ref )
{ return (CFArrayRef)[ref keysToFetch]; }

void CNContactFetchRequestSetKeysToFetch( CNContactFetchRequestRef ref, CFArrayRef keys )
{ [ref setKeysToFetch:(NSArray *)keys]; }

PredicateRef CNContactFetchPredicate( CNContactFetchRequestRef ref )
{ return [ref predicate]; }

void CNContactFetchSetPredicate( CNContactFetchRequestRef ref, PredicateRef predicate )
{ [ref setPredicate:predicate]; }


#pragma mark - CNContactFormatter
///////////////////////////////////////////////////
//              CNContactFormatter               //
///////////////////////////////////////////////////
// Init
CNContactFormatterRef CNContactFormatterInit( void )
{ return [[[CNContactFormatter alloc] init] autorelease]; }

// Class
CFAttributedStringRef CNContactFormatterAttributedStringFromContactStyle( CNContactRef contact, CNContactFormatterStyle style, CFDictionaryRef defaultAttributes )
{ return (CFAttributedStringRef)[CNContactFormatter attributedStringFromContact:contact style:style defaultAttributes:(NSDictionary *)defaultAttributes]; }

CNKeyDescriptorRef CNContactFormatterDescriptorForRequiredKeysForStyle( CNContactFormatterStyle style )
{ return [CNContactFormatter descriptorForRequiredKeysForStyle:style]; }

CFStringRef CNContactFormatterStringFromContactStyle( CNContactRef contact, CNContactFormatterStyle style )
{ return (CFStringRef)[CNContactFormatter stringFromContact:contact style:style]; }

// Manual formatting
CFStringRef CNContactFormatterDelimiterForContact( CNContactRef contact )
{ return (CFStringRef)[CNContactFormatter delimiterForContact:contact]; }

CNContactDisplayNameOrder CNContactFormatterNameOrderForContact( CNContactRef contact )
{ return [CNContactFormatter nameOrderForContact:contact]; }

// Style
CNContactFormatterStyle cnContactFormatterStyle( CNContactFormatterRef ref )
{ return [ref style]; }

void CNContactFormatterSetStyle( CNContactFormatterRef ref, CNContactFormatterStyle style )
{ [ref setStyle:style]; }

// Instance
CFAttributedStringRef CNContactFormatterAttributedStringFromContact( CNContactFormatterRef ref, CNContactRef contact, CFDictionaryRef defaultAttributes )
{ return (CFAttributedStringRef)[ref attributedStringFromContact:contact defaultAttributes:(NSDictionary *)defaultAttributes]; }

CFStringRef CNContactFormatterStringFromContact( CNContactFormatterRef ref, CNContactRef contact )
{ return (CFStringRef)[ref stringFromContact:contact]; }


#pragma mark - CNContactProperty
///////////////////////////////////////////////////
//              CNContactProperty                //
///////////////////////////////////////////////////
// Properties
CNContactRef CNContactPropertyContact( CNContactPropertyRef ref )
{ return [ref contact]; }

CFStringRef CNContactPropertyKey( CNContactPropertyRef ref )
{ return (CFStringRef)[ref key]; }

CFTypeRef CNContactPropertyValue( CNContactPropertyRef ref )
{ return (CFTypeRef)[ref value]; }

CFStringRef CNContactPropertyLabel( CNContactPropertyRef ref )
{ return (CFStringRef)[ref label]; }

// Identifier
CFStringRef CNContactPropertyIdentifier( CNContactPropertyRef ref )
{ return (CFStringRef)[ref identifier]; }


#pragma mark - CNContactRelation
///////////////////////////////////////////////////
//              CNContactRelation                //
///////////////////////////////////////////////////
CNContactRelationRef CNContactRelationWithName( CFStringRef name )
{ return [CNContactRelation contactRelationWithName:(NSString *)name]; }

CFStringRef CNContactRelationName( CNContactRelationRef ref )
{ return (CFStringRef)[ref name]; }


#pragma mark - CNContactStore
///////////////////////////////////////////////////
//                CNContactStore                 //
///////////////////////////////////////////////////
// Init
CNContactStoreRef CNContactStoreInit( void )
{ return [[[CNContactStore alloc] init] autorelease]; }

// Privacy access
CNAuthorizationStatus CNContactStoreAuthorizationStatusForEntityType( CNEntityType type )
{ return [CNContactStore authorizationStatusForEntityType:type]; }

void CNContactStoreRequestAccessForEntityType( CNContactStoreRef ref, CNEntityType type, CNContactStoreRequestAccessForEntityTypeCompletionHandlerType fnAddress, void *userData )
{
    [ref requestAccessForEntityType:type completionHandler:^(BOOL granted, NSError *error) {
        (*fnAddress)( ref, granted, error, userData );
    }];
}

// Fetching and saving
Boolean CNContactStoreEnumerateContactsWithFetchRequest( CNContactStoreRef ref, CNContactFetchRequestRef request, ErrorRef *err, CNContactStoreEnumerateContactsWithFetchRequestCompletionHandlerType fnAddress, void *userData )
{
    return [ref enumerateContactsWithFetchRequest:request error:err usingBlock:^(CNContact *contact, BOOL *stop) {
        BOOL flag = (*fnAddress)( contact, userData );
        if ( flag ) *stop = flag;
    }];
}


#pragma mark - CNContactsUserDefaults
///////////////////////////////////////////////////
//             CNContactsUserDefaults             //
///////////////////////////////////////////////////
// Country code
CFStringRef CNContactsUserDefaultsCountryCode( void )
{ return (CFStringRef)[[CNContactsUserDefaults sharedDefaults] countryCode]; }

// Sort order
CNContactSortOrder CNContactsUserDefaultsSortOrder( void )
{ return [[CNContactsUserDefaults sharedDefaults] sortOrder]; }

// Shared defaults
CNContactsUserDefaultsRef CNContactsUserDefaultsSharedDefaults( void )
{ return [CNContactsUserDefaults sharedDefaults]; }


#pragma mark - CNContactVCardSerialization
///////////////////////////////////////////////////
//          CNContactVCardSerialization          //
///////////////////////////////////////////////////
CFDataRef CNContactVCardSerializationDataWithContacts( CFArrayRef contacts, ErrorRef *err )
{ return (CFDataRef)[CNContactVCardSerialization dataWithContacts:(NSArray *)contacts error:err]; }

CFArrayRef CNContactVCardSerializationContactsWithData( CFDataRef dta, ErrorRef *err )
{ return (CFArrayRef)[CNContactVCardSerialization contactsWithData:(NSData *)dta error:err]; }

CNKeyDescriptorRef CNContactVCardSerializationDescriptorForRequiredKeys( void )
{ return [CNContactVCardSerialization descriptorForRequiredKeys]; }


#pragma mark - CNContainer
///////////////////////////////////////////////////
//                 CNContainer                   //
///////////////////////////////////////////////////
// Properties
CFStringRef CNContainerIdentifier( CNContainerRef ref )
{ return (CFStringRef)[ref identifier]; }

CFStringRef CNContainerName( CNContainerRef ref )
{ return (CFStringRef)[ref name]; }

CNContainerType cnContainerType( CNContainerRef ref )
{ return [ref type]; }

// Predicate
PredicateRef CNContainerPredicateForContainerOfContact( CFStringRef contactIdentifier )
{ return [CNContainer predicateForContainerOfContactWithIdentifier:(NSString *)contactIdentifier]; }

PredicateRef CNContainerPredicateForContainers( CFArrayRef identifiers )
{ return [CNContainer predicateForContainersWithIdentifiers:(NSArray *)identifiers]; }

PredicateRef CNContainerPredicateForContainerOfGroup( CFStringRef groupIdentifier )
{ return [CNContainer predicateForContainerOfGroupWithIdentifier:(NSString *)groupIdentifier]; }


#pragma mark - CNGroup
///////////////////////////////////////////////////
//                   CNGroup                     //
///////////////////////////////////////////////////
// Properties
CFStringRef CNGroupIdentifier( CNGroupRef ref )
{ return (CFStringRef)[ref identifier]; }

CFStringRef CNGroupName( CNGroupRef ref )
{ return (CFStringRef)[ref name]; }

// Predicate
PredicateRef CNGroupPredicateForGroups( CFArrayRef groupIdentifiers )
{ return [CNGroup predicateForGroupsWithIdentifiers:(NSArray *)groupIdentifiers]; }

PredicateRef CNGroupPredicateForGroupsInContainer( CFStringRef containerIdentifier )
{ return [CNGroup predicateForGroupsInContainerWithIdentifier:(NSString *)containerIdentifier]; }


#pragma mark - CNInstantMessageAddress
///////////////////////////////////////////////////
//          CNInstantMessageAddress              //
///////////////////////////////////////////////////
// Message service
CNInstantMessageAddressRef CNInstantMessageAddressWithUsername( CFStringRef username, CFStringRef service )
{ return [[[CNInstantMessageAddress alloc] initWithUsername:(NSString *)username service:(NSString *)service] autorelease]; }

CFStringRef CNInstantMessageAddressService( CNInstantMessageAddressRef ref )
{ return (CFStringRef)[ref service]; }

CFStringRef CNInstantMessageAddressUsername( CNInstantMessageAddressRef ref )
{ return (CFStringRef)[ref username]; }

// Localization
CFStringRef CNInstantMessageAddressLocalizedStringForKey( CFStringRef key )
{ return (CFStringRef)[CNInstantMessageAddress localizedStringForKey:(NSString *)key]; }

CFStringRef CNInstantMessageAddressLocalizedStringForService( CFStringRef service )
{ return (CFStringRef)[CNInstantMessageAddress localizedStringForService:(NSString *)service]; }


#pragma mark - CNLabeledValue
///////////////////////////////////////////////////
//                CNLabeledValue                 //
///////////////////////////////////////////////////
// Ideentifier
CFStringRef CNLabeledValueIdentifier( CNLabeledValueRef ref )
{ return (CFStringRef)[ref identifier]; }

// Settinglabels and values
CNLabeledValueRef CNLabeledValueWithLabel( CFStringRef label, CFTypeRef value )
{ return [CNLabeledValue labeledValueWithLabel:(NSString *)label value:(id)value]; }

CNLabeledValueRef CNLabeledValueBySettingLabel( CNLabeledValueRef ref, CFStringRef label )
{ return [ref labeledValueBySettingLabel:(NSString *)label]; }

CNLabeledValueRef CNLabeledValueBySettingLabelAndValue( CNLabeledValueRef ref, CFStringRef label, CFTypeRef value )
{ return [ref labeledValueBySettingLabel:(NSString *)label value:(id)value]; }

CNLabeledValueRef CNLabeledValueBySettingValue( CNLabeledValueRef ref, CFTypeRef value )
{ return [ref labeledValueBySettingValue:(id)value]; }

// Labels and values
CFStringRef CNLabeledValueLabel( CNLabeledValueRef ref )
{ return (CFStringRef)[ref label]; }

CFTypeRef CNLabeledValueValue( CNLabeledValueRef ref )
{ return (CFTypeRef)[ref value]; }

// Localization
CFStringRef CNLabeledValueLocalizedStringForLabel( CFStringRef label )
{ return (CFStringRef)[CNLabeledValue localizedStringForLabel:(NSString *)label]; }


#pragma mark - CNContaCNMutableContactct
///////////////////////////////////////////////////
//                 CNMutableContact              //
///////////////////////////////////////////////////
// Type
CNContactType CNMutableContactType( CNMutableContactRef ref )
{ return [ref contactType]; }

void CNMutableContactSetType( CNMutableContactRef ref, CNContactType type )
{ [ref setContactType:type]; }

// Dates
CFArrayRef CNMutableContactDates( CNMutableContactRef ref )
{ return (CFArrayRef)[ref dates]; }

void CNMutableContactSetDates( CNMutableContactRef ref, CFArrayRef dates )
{ [ref setDates:(NSArray *)dates]; }

DateComponentsRef CNMutableContactNonGregorianBirthday( CNMutableContactRef ref )
{ return [ref nonGregorianBirthday]; }

void CNMutableContactSetNonGregorianBirthday( CNMutableContactRef ref, DateComponentsRef components )
{ [ref setNonGregorianBirthday:components]; }

DateComponentsRef CNMutableContactBirthday( CNMutableContactRef ref )
{ return [ref birthday]; }

void CNMutableContactSetBirthday( CNMutableContactRef ref, DateComponentsRef components )
{ [ref setBirthday:components]; }

// Name
CFStringRef CNMutableContactNamePrefix( CNMutableContactRef ref )
{ return (CFStringRef)[ref namePrefix]; }

void CNMutableContactSetNamePrefix( CNMutableContactRef ref, CFStringRef prefix )
{ [ref setNamePrefix:(NSString *)prefix]; }

CFStringRef CNMutableContactGivenName( CNMutableContactRef ref )
{ return (CFStringRef)[ref givenName]; }

void CNMutableContactSetGivenName( CNMutableContactRef ref, CFStringRef name )
{ [ref setGivenName:(NSString *)name]; }

CFStringRef CNMutableContactMiddleName( CNMutableContactRef ref )
{ return (CFStringRef)[ref middleName]; }

void CNMutableContactSetMiddleName( CNMutableContactRef ref, CFStringRef name )
{ [ref setMiddleName:(NSString *)name]; }

CFStringRef CNMutableContactFamilyName( CNMutableContactRef ref )
{ return (CFStringRef)[ref familyName]; }

void CNMutableContactSetFamilyName( CNMutableContactRef ref, CFStringRef name )
{ [ref setFamilyName:(NSString *)name]; }

CFStringRef CNMutableContactPreviousFamilyName( CNMutableContactRef ref )
{ return (CFStringRef)[ref previousFamilyName]; }

void CNMutableContactSetPreviousFamilyName( CNMutableContactRef ref, CFStringRef name )
{ [ref setPreviousFamilyName:(NSString *)name]; }

CFStringRef CNMutableContactNameSuffix( CNMutableContactRef ref )
{ return (CFStringRef)[ref nameSuffix]; }

void CNMutableContactSetNameSuffix( CNMutableContactRef ref, CFStringRef suffix )
{ [ref setNameSuffix:(NSString *)suffix]; }

CFStringRef CNMutableContactNickname( CNMutableContactRef ref )
{ return (CFStringRef)[ref nickname]; }

void CNMutableContactSetNickname( CNMutableContactRef ref, CFStringRef name )
{ [ref setNickname:(NSString *)name]; }

CFStringRef CNMutableContactPhoneticGivenName( CNMutableContactRef ref )
{ return (CFStringRef)[ref phoneticGivenName]; }

void CNMutableContactSetPhoneticGivenName( CNMutableContactRef ref, CFStringRef name )
{ [ref setPhoneticGivenName:(NSString *)name]; }

CFStringRef CNMutableContactPhoneticMiddleName( CNMutableContactRef ref )
{ return (CFStringRef)[ref phoneticMiddleName]; }

void CNMutableContactSetPhoneticMiddleName( CNMutableContactRef ref, CFStringRef name )
{ [ref setPhoneticMiddleName:(NSString *)name]; }

CFStringRef CNMutableContactPhoneticFamilyName( CNMutableContactRef ref )
{ return (CFStringRef)[ref phoneticFamilyName]; }

void CNMutableContactSetPhoneticFamilyName( CNMutableContactRef ref, CFStringRef name )
{ [ref setPhoneticFamilyName:(NSString *)name]; }

CFStringRef CNMutableContactOrganizationName( CNMutableContactRef ref )
{ return (CFStringRef)[ref organizationName]; }

void CNMutableContactSetOrganizationName( CNMutableContactRef ref, CFStringRef name )
{ [ref setOrganizationName:(NSString *)name]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
CFStringRef CNMutableContactPhoneticOrganizationName( CNMutableContactRef ref )
{ return (CFStringRef)[ref phoneticOrganizationName]; }

void CNMutableContactSetPhoneticOrganizationName( CNMutableContactRef ref, CFStringRef name )
{ [ref setPhoneticOrganizationName:(NSString *)name]; }
#endif

CFStringRef CNMutableContactDepartmentName( CNMutableContactRef ref )
{ return (CFStringRef)[ref departmentName]; }

void CNMutableContactSetDepartmentName( CNMutableContactRef ref, CFStringRef name )
{ [ref setDepartmentName:(NSString *)name]; }

CFStringRef CNMutableContactJobTitle( CNMutableContactRef ref )
{ return (CFStringRef)[ref jobTitle]; }

void CNMutableContactSetJobTitle( CNMutableContactRef ref, CFStringRef title )
{ [ref setJobTitle:(NSString *)title]; }

// Social
CFArrayRef CNMutableContactSocialProfiles( CNMutableContactRef ref )
{ return (CFArrayRef)[ref socialProfiles]; }

void CNMutableContactSetSocialProfiles( CNMutableContactRef ref, CFArrayRef profiles )
{ [ref setSocialProfiles:(NSArray *)profiles]; }

// Phone numbers
CFArrayRef CNMutableContactPhoneNumbers( CNMutableContactRef ref )
{ return (CFArrayRef)[ref phoneNumbers]; }

void CNMutableContactSetPhoneNumbers( CNMutableContactRef ref, CFArrayRef numbers )
{ [ref setPhoneNumbers:(NSArray *)numbers]; }

// Online addresses
CFArrayRef CNMutableContactEmailAddresses( CNMutableContactRef ref )
{ return (CFArrayRef)[ref emailAddresses]; }

void CNMutableContactSetEmailAddresses( CNMutableContactRef ref, CFArrayRef addresses )
{ [ref setEmailAddresses:(NSArray *)addresses]; }

CFArrayRef CNMutableContactURLAddresses( CNMutableContactRef ref )
{ return (CFArrayRef)[ref urlAddresses]; }

void CNMutableContactSetURLAddresses( CNMutableContactRef ref, CFArrayRef addresses )
{ [ref setUrlAddresses:(NSArray *)addresses]; }

// Postal addresses
CFArrayRef CNMutableContactPostalAddresses( CNMutableContactRef ref )
{ return (CFArrayRef)[ref postalAddresses]; }

void CNMutableContactSetPostalAddresses( CNMutableContactRef ref, CFArrayRef addresses )
{ [ref setPostalAddresses:(NSArray *)addresses]; }

// Image
CFDataRef CNMutableContactImageData( CNMutableContactRef ref )
{ return (CFDataRef)[ref imageData]; }

void CNMutableContactSetImageData( CNMutableContactRef ref, CFDataRef imageData )
{ [ref setImageData:(NSData *)imageData]; }

// Labeled value properties
CFArrayRef CNMutableContactRelations( CNMutableContactRef ref )
{ return (CFArrayRef)[ref contactRelations]; }

void CNMutableContactSetRelations( CNMutableContactRef ref, CFArrayRef relations )
{ [ref setContactRelations:(NSArray *)relations]; }

CFArrayRef CNMutableContactInstantMessageAddresses( CNMutableContactRef ref )
{ return (CFArrayRef)[ref instantMessageAddresses]; }

void CNMutableContactSetInstantMessageAddresses( CNMutableContactRef ref, CFArrayRef addresses )
{ [ref setInstantMessageAddresses:(NSArray *)addresses]; }


#pragma mark - CNMutableGroup
///////////////////////////////////////////////////
//                 CNMutableGroup                //
///////////////////////////////////////////////////
// zTaskGroup
CFStringRef CNMutableGroupName( CNMutableGroupRef ref )
{ return (CFStringRef)[ref name]; }

void CNMutableGroupSetName( CNMutableGroupRef ref, CFStringRef name )
{ [ref setName:(NSString *)name]; }


#pragma mark - CNMutablePostalAddress
///////////////////////////////////////////////////
//            CNMutablePostalAddress             //
///////////////////////////////////////////////////
// Init
CNMutablePostalAddressRef CNMutablePostalAddressInit( void )
{ return [[[CNMutablePostalAddress alloc] init] autorelease]; }

// Parts
CFStringRef CNMutablePostalAddressStreet( CNMutablePostalAddressRef ref )
{ return (CFStringRef)[ref street]; }

void CNMutablePostalAddressSetStreet( CNMutablePostalAddressRef ref, CFStringRef string )
{ [ref setStreet:(NSString *)string]; }

CFStringRef CNMutablePostalAddressCity( CNMutablePostalAddressRef ref )
{ return (CFStringRef)[ref city]; }

void CNMutablePostalAddressSetCity( CNMutablePostalAddressRef ref, CFStringRef string )
{ [ref setCity:(NSString *)string]; }

CFStringRef CNMutablePostalAddressState( CNMutablePostalAddressRef ref )
{ return (CFStringRef)[ref state]; }

void CNMutablePostalAddressSetState( CNMutablePostalAddressRef ref, CFStringRef string )
{ [ref setState:(NSString *)string]; }

CFStringRef CNMutablePostalAddressPostalCode( CNMutablePostalAddressRef ref )
{ return (CFStringRef)[ref postalCode]; }

void CNMutablePostalAddressSetPostalCode( CNMutablePostalAddressRef ref, CFStringRef string )
{ [ref setPostalCode:(NSString *)string]; }

CFStringRef CNMutablePostalAddressCountry( CNMutablePostalAddressRef ref )
{ return (CFStringRef)[ref country]; }

void CNMutablePostalAddressSetCountry( CNMutablePostalAddressRef ref, CFStringRef string )
{ [ref setCountry:(NSString *)string]; }

CFStringRef CNMutablePostalAddressISOCountryCode( CNMutablePostalAddressRef ref )
{ return (CFStringRef)[ref ISOCountryCode]; }

void CNMutablePostalAddressSetISOCountryCode( CNMutablePostalAddressRef ref, CFStringRef string )
{ [ref setISOCountryCode:(NSString *)string]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101204
CFStringRef CNMutablePostalAddressSubAdministrativeArea( CNMutablePostalAddressRef ref )
{ return (CFStringRef)[ref subAdministrativeArea]; }

void CNMutablePostalAddressSetSubAdministrativeArea( CNMutablePostalAddressRef ref, CFStringRef string )
{ [ref setSubAdministrativeArea:(NSString *)string]; }

CFStringRef CNMutablePostalAddressSubLocality( CNMutablePostalAddressRef ref )
{ return (CFStringRef)[ref subLocality]; }

void CNMutablePostalAddressSetSubLocality( CNMutablePostalAddressRef ref, CFStringRef string )
{ [ref setSubLocality:(NSString *)string]; }
#endif







#pragma mark - CNPhoneNumber
///////////////////////////////////////////////////
//                 CNPhoneNumber                 //
///////////////////////////////////////////////////
// Methods
CNPhoneNumberRef CNPhoneNumberWithStringValue( CFStringRef string )
{ return [CNPhoneNumber phoneNumberWithStringValue:(NSString *)string]; }

CFStringRef CNPhoneNumberStringValue( CNPhoneNumberRef ref )
{ return (CFStringRef)[ref stringValue]; }



#pragma mark - CNPostalAddress
///////////////////////////////////////////////////
//               CNPostalAddress                 //
///////////////////////////////////////////////////
// Parts
CFStringRef CNPostalAddressStreet( CNPostalAddressRef ref )
{ return (CFStringRef)[ref street]; }

CFStringRef CNPostalAddressCity( CNPostalAddressRef ref )
{ return (CFStringRef)[ref city]; }

CFStringRef CNPostalAddressState( CNPostalAddressRef ref )
{ return (CFStringRef)[ref state]; }

CFStringRef CNPostalAddressPostalCode( CNPostalAddressRef ref )
{ return (CFStringRef)[ref postalCode]; }

CFStringRef CNPostalAddressCountry( CNPostalAddressRef ref )
{ return (CFStringRef)[ref country]; }

CFStringRef CNPostalAddressISOCountryCode( CNPostalAddressRef ref )
{ return (CFStringRef)[ref ISOCountryCode]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101204
CFStringRef CNPostalAddressSubAdministrativeArea( CNPostalAddressRef ref )
{ return (CFStringRef)[ref subAdministrativeArea]; }

CFStringRef CNPostalAddressSubLocality( CNPostalAddressRef ref )
{ return (CFStringRef)[ref subLocality]; }
#endif

// Localized info
CFStringRef CNPostalAddressLocalizedStringForKey( CFStringRef key )
{ return (CFStringRef)[CNPostalAddress localizedStringForKey:(NSString *)key]; }


#pragma mark - CNSaveRequest
///////////////////////////////////////////////////
//                 CNSaveRequest                 //
///////////////////////////////////////////////////
// Saving contact changes
void CNSaveRequestAddContact( CNSaveRequestRef ref, CNMutableContactRef contact, CFStringRef containerIdentifier )
{ [ref addContact:contact toContainerWithIdentifier:(NSString *)containerIdentifier]; }

void CNSaveRequestUpdateContact( CNSaveRequestRef ref, CNMutableContactRef contact )
{ [ref updateContact:contact]; }

void CNSaveRequestDeleteContact( CNSaveRequestRef ref, CNMutableContactRef contact )
{ [ref deleteContact:contact]; }

// Saving group changes
void CNSaveRequestAddGroup( CNSaveRequestRef ref, CNMutableGroupRef group, CFStringRef containerIdentifier )
{ [ref addGroup:group toContainerWithIdentifier:(NSString *)containerIdentifier]; }

void CNSaveRequestUpdateGroup( CNSaveRequestRef ref, CNMutableGroupRef group )
{ [ref updateGroup:group]; }

void CNSaveRequestDeleteGroup( CNSaveRequestRef ref, CNMutableGroupRef group )
{ [ref deleteGroup:group]; }

void CNSaveRequestAddMemberToGroup( CNSaveRequestRef ref, CNContactRef contact, CNGroupRef group )
{ [ref addMember:contact toGroup:group]; }

void CNSaveRequestRemoveMemberFromGroup( CNSaveRequestRef ref, CNContactRef contact, CNGroupRef group )
{ [ref removeMember:contact fromGroup:group]; }

// Instance
void CNSaveRequestAddSubgroupToGroup( CNSaveRequestRef ref, CNGroupRef subgroup, CNGroupRef group )
{ [ref addSubgroup:subgroup toGroup:group]; }

void CNSaveRequestRemoveSubgroupFromGroup( CNSaveRequestRef ref, CNGroupRef subgroup, CNGroupRef group )
{ [ref removeSubgroup:subgroup fromGroup:group]; }


#pragma mark - CNSocialProfile
///////////////////////////////////////////////////
//               CNSocialProfile                 //
///////////////////////////////////////////////////
// Init
CNSocialProfileRef CNSocialProfileWithURLString( CFStringRef urlString, CFStringRef username, CFStringRef userIdentifier, CFStringRef service )
{ return [[[CNSocialProfile alloc] initWithUrlString:(NSString *)urlString username:(NSString *)username userIdentifier:(NSString *)userIdentifier service:(NSString *)service] autorelease]; }

// Properties
CFStringRef CNSocialProfileService( CNSocialProfileRef ref )
{ return (CFStringRef)[ref service]; }

CFStringRef CNSocialProfileURLString( CNSocialProfileRef ref )
{ return (CFStringRef)[ref urlString]; }

CFStringRef CNSocialProfileUserIdentifier( CNSocialProfileRef ref )
{ return (CFStringRef)[ref userIdentifier]; }

CFStringRef CNSocialProfileUsername( CNSocialProfileRef ref )
{ return (CFStringRef)[ref username]; }

// Localization
CFStringRef CNSocialProfileLocalizedStringForKey( CFStringRef key )
{ return (CFStringRef)[CNSocialProfile localizedStringForKey:(NSString *)key]; }

CFStringRef CNSocialProfileLocalizedStringForService( CFStringRef service )
{ return (CFStringRef)[CNSocialProfile localizedStringForService:(NSString *)service]; }


#endif// #ifdef CONTACTS_EXTERN
#endif// #if __LP64__

