/*
 ContactsUI.h
 
 Bernie Wylde 20190222
 */

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100

#import <Contacts/Contacts.h>
#import <ContactsUI/ContactsUI.h>
#import "Contacts.h"
#import "CocoaUI.h"

#if __LP64__

typedef CNContactPicker *CNContactPickerRef;
typedef CNContactViewController *CNContactViewControllerRef;


#pragma mark - CNContactPicker
///////////////////////////////////////////////////
//               CNContactPicker                 //
///////////////////////////////////////////////////
// dialog events
enum {
    contactPickerDidSelectContact = 3200,
    contactPickerDidSelectContactProperty,
    contactPickerWillClose,
    contactPickerDidClose
};

@interface CocoaCNContactPickerDelegate : NSObject <CNContactPickerDelegate>
@end

CocoaCNContactPickerDelegate *CocoaCNContactPickerDelegateObj( void );

// Init
CNContactPickerRef CNContactPickerInit( void );

// Displaying keys
CFArrayRef CNContactPickerDisplayedKeys( CNContactPickerRef ref );
void CNContactPickerSetDisplayedKeys( CNContactPickerRef ref, CFArrayRef keys );

// Position picker popover
void CNContactPickerShowRelativeToRect( CNContactPickerRef ref, CGRect r, NSInteger viewTag, CGRectEdge preferredEdge );

// Close popover
void CNContactPickerClose( CNContactPickerRef ref );


#pragma mark - CNContactViewController
///////////////////////////////////////////////////
//          CNContactViewController              //
///////////////////////////////////////////////////
// Required keys
CNKeyDescriptorRef CNContactViewControllerDescriptorForRequiredKeys( void );

// Properties
CNContactRef CNContactViewControllerContact( CNContactViewControllerRef ref );
void CNContactViewControllerSetContact( CNContactViewControllerRef ref, CNContactRef contact );

#endif// #if __LP64__

#endif// #if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
