/*
 ContactsUI.m
 
 Bernie Wylde 20190222
 */

#import "ContactsUI.h"

#if __LP64__

#pragma mark - CNContactPicker
///////////////////////////////////////////////////
//               CNContactPicker                 //
///////////////////////////////////////////////////
@implementation CocoaCNContactPickerDelegate
- (void)contactPicker:(CNContactPicker *)aPicker didSelectContact:(CNContact *)contact {
    NSBeep();
    CallUserDefinedOnDialogFunction( contactPickerDidSelectContact, 0, 0, contact );
}

- (void) contactPicker:(CNContactPicker *)aPicker didSelectContactProperty:(CNContactProperty *)contactProperty {
    CallUserDefinedOnDialogFunction( contactPickerDidSelectContactProperty, 0, 0, contactProperty );
}

- (void)contactPickerWillClose:(CNContactPicker *)aPicker {
    CallUserDefinedOnDialogFunction( contactPickerWillClose, 0, 0, aPicker );
}

- (void)contactPickerDidClose:(CNContactPicker *)aPicker {
    CallUserDefinedOnDialogFunction( contactPickerDidClose, 0, 0, aPicker );
}
@end

CocoaCNContactPickerDelegate *CocoaCNContactPickerDelegateObj( void )
{
    static CocoaCNContactPickerDelegate *sCocoaCNContactPickerDelegate = nil;
    if ( !sCocoaCNContactPickerDelegate ) sCocoaCNContactPickerDelegate = [[CocoaCNContactPickerDelegate alloc] init];
    return sCocoaCNContactPickerDelegate;
}


// Init
CNContactPickerRef CNContactPickerInit( void )
{
    CNContactPicker *picker = [[[CNContactPicker alloc] init] autorelease];
    [picker setDelegate:CocoaCNContactPickerDelegateObj()];
    return picker;
}

// Displaying keys
CFArrayRef CNContactPickerDisplayedKeys( CNContactPickerRef ref )
{ return (CFArrayRef)[ref displayedKeys]; }

void CNContactPickerSetDisplayedKeys( CNContactPickerRef ref, CFArrayRef keys )
{ [ref setDisplayedKeys:(NSArray *)keys]; }

// Position picker popover
void CNContactPickerShowRelativeToRect( CNContactPickerRef ref, CGRect r, NSInteger viewTag, CGRectEdge preferredEdge )
{
    NSView *view = CocoaViewWithTag( viewTag );
    if ( view ) {
        [ref showRelativeToRect:NSRectFromCGRect(r) ofView:view preferredEdge:(NSRectEdge)preferredEdge];
    }
}

// Close popover
void CNContactPickerClose( CNContactPickerRef ref )
{ [ref close]; }


#pragma mark - CNContactViewController
///////////////////////////////////////////////////
//          CNContactViewController              //
///////////////////////////////////////////////////
// Required keys
CNKeyDescriptorRef CNContactViewControllerDescriptorForRequiredKeys( void )
{ return [CNContactViewController descriptorForRequiredKeys]; }

// Properties
CNContactRef CNContactViewControllerContact( CNContactViewControllerRef ref )
{ return [ref contact]; }

void CNContactViewControllerSetContact( CNContactViewControllerRef ref, CNContactRef contact )
{ [ref setContact:contact]; }

#endif// #if __LP64__

