/*
 CocoaUI_UserNotifications.m
 
 Bernie Wylde 20181027
 */

#import "UserNotifications.h"

#if __LP64__
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101400 && __MAC_OS_X_VERSION_MIN_REQUIRED >= 101400




#pragma mark - UNUserNotificationCenterDelegate
///////////////////////////////////////////////////
//       UNUserNotificationCenterDelegate        //
///////////////////////////////////////////////////
@implementation CocoaUNUserNotificationCenterDelegate

- (void)userNotificationCenter:(UNUserNotificationCenter *)center didReceiveNotificationResponse:(UNNotificationResponse *)response withCompletionHandler:(void (^)(void))completionHandler {
    
    NSBeep();
    
}

- (void)userNotificationCenter:(UNUserNotificationCenter *)center willPresentNotification:(UNNotification *)notification withCompletionHandler:(void (^)(UNNotificationPresentationOptions options))completionHandler {
    
    NSBeep();

}

- (void)userNotificationCenter:(UNUserNotificationCenter *)center openSettingsForNotification:(UNNotification *)notification {
    
}


@end

CocoaUNUserNotificationCenterDelegate *CocoaUNUserNotificationCenterDelegateGet( void )
{
    static CocoaUNUserNotificationCenterDelegate *sCocoaUNUserNotificationCenterDelegate = nil;
    if ( !sCocoaUNUserNotificationCenterDelegate ) sCocoaUNUserNotificationCenterDelegate = [[CocoaUNUserNotificationCenterDelegate alloc] init];
    return sCocoaUNUserNotificationCenterDelegate;
}








#pragma mark - UNNotification
///////////////////////////////////////////////////
//                UNNotification                 //
///////////////////////////////////////////////////
// Details
UNNotificationRequestRef UNNotificationrequest( UNNotificationRef ref )
{ return [ref request]; }

CFDateRef UNNotificationDate( UNNotificationRef ref )
{ return (CFDateRef)[ref date]; }




#pragma mark - UNCalendarNotificationTrigger
///////////////////////////////////////////////////
//        UNCalendarNotificationTrigger          //
///////////////////////////////////////////////////
// Create
UNCalendarNotificationTriggerRef UNCalendarNotificationTriggerWithDateMatchingComponents( DateComponentsRef components, Boolean repeats )
{ return [UNCalendarNotificationTrigger triggerWithDateMatchingComponents:components repeats:repeats]; }

// Info
CFDateRef UNCalendarNotificationTriggerNextTriggerDate( UNCalendarNotificationTriggerRef ref )
{ return (CFDateRef)[ref nextTriggerDate]; }

DateComponentsRef UNCalendarNotificationTriggerDateComponents( UNCalendarNotificationTriggerRef ref )
{ return [ref dateComponents]; }





#pragma mark - UNMutableNotificationContent
///////////////////////////////////////////////////
//       UNMutableNotificationContent            //
///////////////////////////////////////////////////
// Init
UNMutableNotificationContentRef UNMutableNotificationContentInit( void )
{ return [[[UNMutableNotificationContent alloc] init] autorelease]; }

// Data
void UNMutableNotificationContentSetTitle( UNMutableNotificationContentRef ref, CFStringRef title )
{ [ref setTitle:(NSString *)title]; }

void UNMutableNotificationContentSetSubtitle( UNMutableNotificationContentRef ref, CFStringRef subtitle )
{ [ref setSubtitle:(NSString *)subtitle]; }

void UNMutableNotificationContentSetBody( UNMutableNotificationContentRef ref, CFStringRef body )
{ [ref setBody:(NSString *)body]; }

void UNMutableNotificationContentSetBadge( UNMutableNotificationContentRef ref, CFNumberRef badge )
{ [ref setBadge:(NSNumber *)badge]; }

void UNMutableNotificationContentSetSound( UNMutableNotificationContentRef ref, UNNotificationSoundRef snd )
{ [ref setSound:snd]; }

void UNMutableNotificationContentSetUserInfo( UNMutableNotificationContentRef ref, CFDictionaryRef userInfo )
{ [ref setUserInfo:(NSDictionary *)userInfo]; }

void UNMutableNotificationContentSetAttachments( UNMutableNotificationContentRef ref, CFArrayRef attachments )
{ [ref setAttachments:(NSArray *)attachments]; }

// Summary
void UNMutableNotificationContentSetSummaryArgument( UNMutableNotificationContentRef ref, CFStringRef argument )
{ [ref setSummaryArgument:(NSString *)argument]; }

void UNMutableNotificationContentSetSummaryArgumentCount( UNMutableNotificationContentRef ref, NSUInteger count )
{ [ref setSummaryArgumentCount:count]; }

// Content
void UNMutableNotificationContentSetCategoryIdentifier( UNMutableNotificationContentRef ref, CFStringRef identifier )
{ [ref setCategoryIdentifier:(NSString *)identifier]; }

void UNMutableNotificationContentSetThreadIdentifier( UNMutableNotificationContentRef ref, CFStringRef identifier )
{ [ref setThreadIdentifier:(NSString *)identifier]; }




#pragma mark - UNTimeIntervalNotificationTrigger
///////////////////////////////////////////////////
//    UNTimeIntervalNotificationTrigger          //
///////////////////////////////////////////////////
UNTimeIntervalNotificationTriggerRef UNTimeIntervalNotificationTriggerWithTimeInterval( CFTimeInterval ti, Boolean repeats )
{ return [UNTimeIntervalNotificationTrigger triggerWithTimeInterval:(NSTimeInterval)ti repeats:repeats]; }

CFDateRef UNTimeIntervalNotificationTriggerNextTriggerDate( UNTimeIntervalNotificationTriggerRef ref )
{ return (CFDateRef)[ref nextTriggerDate]; }

CFTimeInterval UNTimeIntervalNotificationTriggerTimeInterval( UNTimeIntervalNotificationTriggerRef ref )
{ return (CFTimeInterval)[ref timeInterval]; }




#pragma mark - UNNotificationCategory
///////////////////////////////////////////////////
//          UNNotificationCategory               //
///////////////////////////////////////////////////
// Create
UNNotificationCategoryRef UNNotificationCategoryWithIdentifier( CFStringRef identifier, CFArrayRef actions, CFArrayRef intentIdentifiers, UNNotificationCategoryOptions options )
{ return [UNNotificationCategory categoryWithIdentifier:(NSString *)identifier actions:(NSArray *)actions intentIdentifiers:(NSArray *)intentIdentifiers options:options]; }

UNNotificationCategoryRef UNNotificationCategoryWithHiddenPreviews( CFStringRef identifier, CFArrayRef actions, CFArrayRef intentIdentifiers, CFStringRef hiddenPreviews, UNNotificationCategoryOptions options )
{ return [UNNotificationCategory categoryWithIdentifier:(NSString *)identifier actions:(NSArray *)actions intentIdentifiers:(NSArray *)intentIdentifiers hiddenPreviewsBodyPlaceholder:(NSString *)hiddenPreviews options:options]; }

UNNotificationCategoryRef UNNotificationCategoryWithSummaryFormat( CFStringRef identifier, CFArrayRef actions, CFArrayRef intentIdentifiers, CFStringRef hiddenPreviews, CFStringRef summaryFormat, UNNotificationCategoryOptions options )
{ return [UNNotificationCategory categoryWithIdentifier:(NSString *)identifier actions:(NSArray *)actions intentIdentifiers:(NSArray *)intentIdentifiers hiddenPreviewsBodyPlaceholder:(NSString *)hiddenPreviews categorySummaryFormat:(NSString *)summaryFormat options:options]; }

// Info
CFStringRef UNNotificationCategoryIdentifier( UNNotificationCategoryRef ref )
{ return (CFStringRef)[ref identifier]; }

CFArrayRef UNNotificationCategoryActions( UNNotificationCategoryRef ref )
{ return (CFArrayRef)[ref actions]; }

CFArrayRef UNNotificationCategoryIntentIdentifiers( UNNotificationCategoryRef ref )
{ return (CFArrayRef)[ref intentIdentifiers]; }

CFStringRef UNNotificationCategoryHiddenPreviewsBodyPlaceholder( UNNotificationCategoryRef ref )
{ return (CFStringRef)[ref hiddenPreviewsBodyPlaceholder]; }

CFStringRef UNNotificationCategorySummaryFormat( UNNotificationCategoryRef ref )
{ return (CFStringRef)[ref categorySummaryFormat]; }

// Options
UNNotificationCategoryOptions UNNotificationCategoryoptions( UNNotificationCategoryRef ref )
{ return [ref options]; }



#pragma mark - UNNotificationRequest
///////////////////////////////////////////////////
//          UNNotificationRequest                //
///////////////////////////////////////////////////
// Create
UNNotificationRequestRef UNNotificationRequestWithIdentifier( CFStringRef identifier, UNNotificationContentRef content, UNNotificationTriggerRef trigger )
{ return [UNNotificationRequest requestWithIdentifier:(NSString *)identifier content:content trigger:trigger]; }

// Details
CFStringRef UNNotificationRequestIdentifier( UNNotificationRequestRef ref )
{ return (CFStringRef)[ref identifier]; }

UNNotificationContentRef UNNotificationRequestContent( UNNotificationRequestRef ref )
{ return [ref content]; }

UNNotificationTriggerRef UNNotificationRequestTrigger( UNNotificationRequestRef ref )
{ return [ref trigger]; }



#pragma mark - UNNotificationResponse
///////////////////////////////////////////////////
//         UNNotificationResponse                //
///////////////////////////////////////////////////
// Info
CFStringRef UNNotificationResponseActionIdentifier( UNNotificationResponseRef ref )
{ return (CFStringRef)[ref actionIdentifier]; }

UNNotificationRef UNNotificationResponseNotification( UNNotificationResponseRef ref )
{ return [ref notification]; }



#pragma mark - UNNotificationServiceExtension
///////////////////////////////////////////////////
//      UNNotificationServiceExtension           //
///////////////////////////////////////////////////
// Processing notifications
void UNNotificationServiceExtensionDidReceiveNotificationRequest( UNNotificationServiceExtensionRef ref, UNNotificationRequestRef request, UNNotificationServiceExtensionNotificationHandlerType handler, void *userData )
{
    [ref didReceiveNotificationRequest:request withContentHandler:^(UNNotificationContent *contentToDeliver) {
        if ( handler ) (*handler)(contentToDeliver,userData);
    }];
}



#pragma mark - UNNotificationSettings
///////////////////////////////////////////////////
//              UNNotificationSettings           //
///////////////////////////////////////////////////
// Authorization status
UNAuthorizationStatus UNNotificationSettingsAuthorizationStatus( UNNotificationSettingsRef ref )
{ return [ref authorizationStatus]; }

// Device-specific settings
UNNotificationSetting UNNotificationSettingsNotificationCenterSetting( UNNotificationSettingsRef ref )
{ return [ref notificationCenterSetting]; }

UNNotificationSetting UNNotificationSettingsLockScreenSetting( UNNotificationSettingsRef ref )
{ return [ref lockScreenSetting]; }

UNNotificationSetting UNNotificationSettingsAlertSetting( UNNotificationSettingsRef ref )
{ return [ref alertSetting]; }

UNNotificationSetting UNNotificationSettingsBadgeSetting( UNNotificationSettingsRef ref )
{ return [ref badgeSetting]; }

UNNotificationSetting UNNotificationSettingsSoundSetting( UNNotificationSettingsRef ref )
{ return [ref soundSetting]; }

UNNotificationSetting UNNotificationSettingsCriticalAlertSetting( UNNotificationSettingsRef ref )
{ return [ref criticalAlertSetting]; }

// Interface settings
UNAlertStyle UNNotificationSettingsAlertStyle( UNNotificationSettingsRef ref )
{ return [ref alertStyle]; }

UNShowPreviewsSetting UNNotificationSettingsShowPreviewsSetting( UNNotificationSettingsRef ref )
{ return [ref showPreviewsSetting]; }

Boolean UNNotificationSettingsProvidesAppNotificationSettings( UNNotificationSettingsRef ref )
{ return [ref providesAppNotificationSettings]; }



#pragma mark - UNNotificationSound
///////////////////////////////////////////////////
//              UNNotificationSound              //
///////////////////////////////////////////////////
// Notification sounds
UNNotificationSoundRef UNNotificationSoundDefault( void )
{ return [UNNotificationSound defaultSound]; }

UNNotificationSoundRef UNNotificationSoundNamed( CFStringRef name )
{ return [UNNotificationSound soundNamed:(NSString *)name]; }

// Critical sounds
UNNotificationSoundRef UNNotificationSoundDefaultCritical( void )
{ return [UNNotificationSound defaultCriticalSound]; }

UNNotificationSoundRef UNNotificationSoundDefaultCriticalWithAudioVolume( float volume )
{ return [UNNotificationSound defaultCriticalSoundWithAudioVolume:volume]; }

UNNotificationSoundRef UNNotificationSoundCriticalNamed( CFStringRef name )
{ return [UNNotificationSound criticalSoundNamed:(NSString *)name]; }

UNNotificationSoundRef UNNotificationSoundCriticalNamedWithAudioVolume( CFStringRef name, float volume )
{ return [UNNotificationSound criticalSoundNamed:(NSString *)name withAudioVolume:volume]; }



#pragma mark - UNUserNotificationCenter
///////////////////////////////////////////////////
//         UNUserNotificationCenter              //
///////////////////////////////////////////////////
// Get
UNUserNotificationCenterRef UNUserNotificationCenterCurrent( void )
{
    UNUserNotificationCenter *center = [UNUserNotificationCenter currentNotificationCenter];
    CocoaUNUserNotificationCenterDelegate *delegate = CocoaUNUserNotificationCenterDelegateGet();
    [center setDelegate:delegate];
    return center;
}

// Settings and authorization
void UNUserNotificationCenterRequestAuthorization( UNUserNotificationCenterRef ref, UNAuthorizationOptions options, UNNotificationCenterRequestAuthorizationCompletionHandlerType completionHandler, void *userData )
{
    [ref requestAuthorizationWithOptions:options completionHandler:^(BOOL granted,NSError *err) {
        if ( completionHandler ) (*completionHandler)(granted,err,userData);
    }];
}

void UNUserNotificationCenterGetNotificationSettings( UNUserNotificationCenterRef ref, UNNotificationCenterGetNotificationSettingsCompletionHandlerType completionHandler, void *userData )
{
    [ref getNotificationSettingsWithCompletionHandler:^(UNNotificationSettings *settings) {
        if ( completionHandler ) (*completionHandler)(settings,userData);
    }];
}

Boolean UNUserNotificationCenterSupportsContentExtensions( UNUserNotificationCenterRef ref )
{ return [ref supportsContentExtensions]; }

// Registering categories
void UNUserNotificationCenterSetNotificationCategories( UNUserNotificationCenterRef ref, CFSetRef categories )
{ [ref setNotificationCategories:(NSSet *)categories]; }

void UNUserNotificationCenterGetNotificationCategories( UNUserNotificationCenterRef ref, UNNotificationCenterGetNotificationCategoriesCompletionHandlerType completionHandler, void *userData )
{
    [ref getNotificationCategoriesWithCompletionHandler:^(NSSet *categories) {
        if ( completionHandler ) (*completionHandler)(categories,userData);
    }];
}

// Scheduling and canceling
void UNUserNotificationCenterAddNotificationRequest( UNUserNotificationCenterRef ref, UNNotificationRequestRef request, UNNotificationCenterAddNotificationRequestCompletionHandlerType completionHandler, void *userData )
{
    CocoaUNUserNotificationCenterDelegate *delegate = CocoaUNUserNotificationCenterDelegateGet();
    [ref setDelegate:delegate];

    [ref addNotificationRequest:request withCompletionHandler:^(NSError *err) {
        if ( completionHandler ) (*completionHandler)(err,userData);
    }];
}

void UNUserNotificationCenterGetPendingNotificationRequests( UNUserNotificationCenterRef ref, UNNotificationCenterGetPendingNotificationRequestsCompletionHandlerType completionHandler, void *userData )
{
    [ref getPendingNotificationRequestsWithCompletionHandler:^(NSArray *requests) {
        if ( completionHandler ) (*completionHandler)(requests,userData);
    }];
}

void UNUserNotificationCenterRemovePendingNotificationRequests( UNUserNotificationCenterRef ref, CFArrayRef identifiers )
{ [ref removePendingNotificationRequestsWithIdentifiers:(NSArray *)identifiers]; }

void UNUserNotificationCenterRemoveAllPendingNotificationRequests( UNUserNotificationCenterRef ref )
{ [ref removeAllPendingNotificationRequests]; }

// Delivered notifications
void UNUserNotificationCenterGetDeliveredNotifications( UNUserNotificationCenterRef ref, UNNotificationCenterGetDeliveredNotificationsCompletionHandlerType completionHandler, void *userData )
{
    [ref getDeliveredNotificationsWithCompletionHandler:^(NSArray *notifications) {
        if ( completionHandler ) (*completionHandler)(notifications,userData);
    }];
}

void UNUserNotificationCenterRemoveDeliveredNotifications( UNUserNotificationCenterRef ref, CFArrayRef identifiers )
{ [ref removeDeliveredNotificationsWithIdentifiers:(NSArray *)identifiers]; }

void UNUserNotificationCenterRemoveAllDeliveredNotifications( UNUserNotificationCenterRef ref )
{ [ref removeAllDeliveredNotifications]; }







#endif// #if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101400 && __MAC_OS_X_VERSION_MIN_REQUIRED >= 101400
#endif// #if __LP64__
